# C 语言程序设计教程

> 原文：<https://www.javatpoint.com/c-programming-language-tutorial>

![C Programming](img/49ebf943f07cecd1f5937fae4fc7ce8a.png)

**C 语言**教程用编程的方式面向初学者和专业人士，帮助你轻松理解 C 语言教程。我们的 C 教程用程序解释了每个主题。

C 语言由丹尼斯·里奇开发，用于创建与硬件设备(如驱动程序、内核等)直接交互的系统应用程序。

c 编程被认为是其他编程语言的基础，这就是为什么它被称为母语的原因。

它可以通过以下方式定义:

1.  母语
2.  系统编程语言
3.  面向过程的编程语言
4.  结构化编程语言
5.  中级编程语言

* * *

## 1) C 作为母语

c 语言被认为是所有现代编程语言的母语，因为**大多数编译器、JVM、Kernels 等。都是用 C 语言**编写的，大多数编程语言都遵循 C 语法，例如 C++、Java、C#等。

它提供了核心概念，如[数组](c-array)、[字符串](c-strings)、[函数](functions-in-c)、[文件处理](file-handling-in-c)等。在许多语言中使用，如 [C++](cpp-tutorial) 、 [Java](java-tutorial) 、 [C#](c-sharp-tutorial) 等。

* * *

## 2)作为系统编程语言的 C 语言

系统编程语言用于创建系统软件。c 语言是一种系统编程语言，因为它**可以用来做低级编程(比如驱动和内核)**。它通常用于创建硬件设备、操作系统、驱动程序、内核等。比如 Linux 内核就是用 c 写的。

它不能像 Java 一样用于互联网编程。Net、PHP 等。

* * *

## 3)作为程序语言的 C 语言

过程被称为函数、方法、例程、子例程等。程序语言**规定了程序解决问题的一系列步骤**。

过程语言将程序分解成函数、数据结构等。

c 是一种过程语言。在 C 语言中，变量和函数原型在使用前必须声明。

* * *

## 4) C 作为一种结构化编程语言

结构化编程语言是过程语言的一个子集。 **Structure 是指把一个程序分解成几个部分或者几个块**这样可能比较容易理解。

在 C 语言中，我们使用函数将程序分成几部分。它使程序更容易理解和修改。

* * *

## 5) C 作为一种中级编程语言

c 被认为是一种中级语言，因为它**支持低级和高级语言**的特性。c 语言程序被转换成汇编代码，它支持指针算法(低级)，但它与机器无关(高级的一个特性)。

一种**低级语言**是特定于一台机器的，即依赖于机器。它依赖于机器，运行速度快。但这并不容易理解。

一种**高级语言**并不特定于一台机器，即机器无关。这很容易理解。

* * *

## c 程序

在本教程中，所有的 C 程序都是用 C 编译器给出的，这样你就可以快速更改 C 程序代码。

文件:main.c

```
#include int main() {
printf("Hello C Programming\n");
return 0;
} 
```

上述程序的详细描述将在接下来的章节中给出。

* * *

## 编程索引

* * *

**C 教程**

*   [什么是 C 语言](c-programming-language-tutorial)
*   [C 的历史](history-of-c-language)
*   [C](features-of-c-language)的特征
*   [如何安装 C](how-to-install-c)
*   [第一个 C 程序](first-c-program)
*   [C 程序流程](flow-of-c-program)
*   [打印扫描](printf-scanf)
*   [C 中的变量](variables-in-c)
*   [c 中的数据类型](data-types-in-c)
*   [c 中的关键词](keywords-in-c)
*   [C 操作员](c-operators)
*   [C 注释](comments-in-c)
*   [C 转义序列](escape-sequence-in-c)
*   [C 中的常数](constants-in-c)
*   [C 基础测试](/test/c-fundamental-1)

**C 控制报表**

*   [C if-else](c-if-else)
*   [C 开关](c-switch)
*   [循环](c-loop)
*   [C 边做边循环](do-while-loop-in-c)
*   [C 同时循环](while-loop-in-c)
*   [循环的 C](for-loop-in-c)
*   [C 断](c-break)
*   [C 继续](c-continue)
*   [C 转到](c-goto)
*   [型铸造](type-casting-in-c)
*   [C 控制语句测试](/test/c-control-statements-1)

**C 功能**

*   [什么是功能](functions-in-c)
*   [通话:价值&参考](call-by-value-and-call-by-reference-in-c)
*   [c 中的递归](recursion-in-c)
*   [存储类别](storage-classes-in-c)
*   [C 功能测试](/test/c-functions-1)

**C 阵**

*   [一维阵列](c-array)
*   [二维阵列](two-dimensional-array-in-c)
*   [阵列至功能](passing-array-to-function-in-c)
*   [C 阵测试](/test/c-array-1)

**C 指针**

*   [C 指针](c-pointers)
*   [C 指针指向指针](c-pointer-to-pointer)
*   [C 指针算法](pointer-arithmetic-in-c)
*   [C 指针测试](/test/c-pointers-1)

**C 动态存储器**

*   [动态记忆](dynamic-memory-allocation-in-c)

**C 弦**

*   [串入 C](c-strings)
*   [C get()&put()](c-gets-puts)
*   [字符串函数](c-string-functions)
*   [C strlen()](c-strlen)
*   [C strcpy（）](c-strcpy)
*   [C strcat()](c-strcat)
*   [C strcmp()](c-strcmp)
*   [C strrev()](c-strrev)
*   [C strlwr()](c-strlwr)
*   [C strupr()](c-strupr)
*   [C strstr()](c-strstr)
*   [C 弦测试](/test/c-string-1)

**C 数学**

*   [C 数学函数](c-math)

**碳结构联合**

*   [C 结构](structure-in-c)
*   [C 结构阵列](array-of-structures-in-c)
*   [C 嵌套结构](nested-structure-in-c)
*   [C 联](c-union)
*   [C 结构试验](/test/c-structure-union-enums-1)

**C 文件处理**

*   [C 文件处理](file-handling-in-c)
*   [C fprintf（） fscanf（）](fprintf-fscanf-in-c)
*   [C fputc() fgetc()](fputc-fgetc-in-c)
*   [C fputs() fgets()](fputs-fgets-in-c)
*   [C fseek（）](fseek-in-c)
*   [C 倒带()](rewind-in-c)
*   [C ftell()](ftell-in-c)

**C 预处理器**

*   [C 预处理器](c-preprocessor)
*   [C 宏](c-macros)
*   [C #包括](c-preprocessor-include)
*   [C #定义](c-preprocessor-define)
*   [c # un FFE](c-preprocessor-undef)
*   [C #ifdef](c-preprocessor-ifdef)
*   [C #ifndef](c-preprocessor-ifndef)
*   [C #if](c-preprocessor-if)
*   [C #else](c-preprocessor-else)
*   [C #错误](c-preprocessor-error)
*   [C #pragma](c-preprocessor-pragma)
*   [C 预处理器测试](/test/c-preprocessor-1)

**C 命令行**

*   [命令行参数](command-line-arguments-in-c)

**C 编程测试**

*   [C 编程测试](test/c-programming)

**C 程序**

*   [前 10 名+ C 程序](c-programs)
*   [斐波那契数列](fibonacci-series-in-c)
*   [质数](prime-number-program-in-c)
*   [回文号](palindrome-program-in-c)
*   [因子](factorial-program-in-c)
*   [阿姆斯特朗号](armstrong-number-in-c)
*   [位数之和](sum-of-digits-program-in-c)
*   [反转编号](c-program-to-reverse-number)
*   [交换号](c-program-to-swap-two-numbers-without-using-third-variable)
*   [无打印“你好”；](c-program-to-print-hello-without-semicolon)
*   [C](assembly-program-in-c)中的装配代码
*   [C 程序无主](c-program-without-main)
*   [矩阵乘法](matrix-multiplication-in-c)
*   [十进制到二进制](c-program-to-convert-decimal-to-binary)
*   [字符数](c-program-to-convert-number-in-characters)
*   [字母三角](c-program-to-print-alphabet-triangle)
*   [数字三角形](c-program-to-print-number-triangle)
*   [斐波那契三角](c-program-to-generate-fibonacci-triangle)

**C 编程测试**

*   [C 编程测试](/test/c-programming)

**C 基础测试**

*   [C 基波 1](/test/c-fundamental-1)
*   [C 基波 2](/test/c-fundamental-2)
*   [C 基波 3](/test/c-fundamental-3)
*   [C 基波 4](/test/c-fundamental-4)

**温度控制测试**

*   [C 控制报表 1](/test/c-control-statements-1)
*   [C 控制报表 2](/test/c-control-statements-2)
*   [C 控制声明 3](/test/c-control-statements-3)
*   [C 控制报表 4](/test/c-control-statements-4)

**C 功能测试**

*   [C 功能 1](/test/c-functions-1)
*   [C 功能 2](/test/c-functions-2)
*   [C 功能 3](/test/c-functions-3)
*   [C 功能 4](/test/c-functions-4)

**C 阵测试**

*   [C 阵 1](/test/c-array-1)
*   [C 阵 2](/test/c-array-2)
*   [C 阵 3](/test/c-array-3)
*   [C 阵 4](/test/c-array-4)

**C 指针测试**

*   [C 指针 1](/test/c-pointers-1)
*   [C 指针 2](/test/c-pointers-2)
*   [C 指针 3](/test/c-pointers-3)
*   [C 指针 4](/test/c-pointers-4)

**C 弦测试**

*   [C 弦 1](/test/c-string-1)
*   [C 弦 2](/test/c-string-2)
*   [C 弦 3](/test/c-string-3)
*   [C 弦 4](/test/c-string-4)

**C 结构试验**

*   [C 结构 1](/test/c-structure-union-enums-1)
*   [C 结构 2](/test/c-structure-union-enums-2)
*   [C 结构 3](/test/c-structure-union-enums-3)
*   [C 结构 4](/test/c-structure-union-enums-4)

**C 预处理器测试**

*   [C 预处理器 1](/test/c-preprocessor-1)
*   [C 预处理器 2](/test/c-preprocessor-2)
*   [C 预处理器 3](/test/c-preprocessor-3)
*   [C 预处理器 4](/test/c-preprocessor-4)

**C 面试**

*   [C 面试问题](c-interview-questions)

* * *

## 先决条件

在学习 C 程序设计之前，你必须具备计算机基础的基础知识。

## 观众

我们的 C 编程教程旨在帮助初学者和专业人士。

## 问题

我们保证您不会在本 C 语言教程中发现任何错误。但是如果有任何错误，请在联系表格中发布问题。