# C 语言中的变量

> 原文：<https://www.javatpoint.com/variables-in-c>

一个**变量**是内存位置的名称。它用于存储数据。它的值可以改变，并且可以多次重用。

这是一种通过符号来表示内存位置的方法，以便于识别。

让我们看看声明变量的语法:

```
type variable_list;

```

下面给出了声明变量的示例:

```
int a;
float b;
char c;

```

这里，a，b，c 是变量。int、float、char 是数据类型。

我们还可以在声明变量时提供值，如下所示:

```
int a=10,b=20;//declaring 2 variable of integer type
float f=20.8;
char c='A';

```

## 定义变量的规则

*   变量可以有字母、数字和下划线。
*   变量名可以以字母开头，只能以下划线开头。不能以数字开头。
*   变量名中不允许有空格。
*   变量名不能是任何保留字或关键字，例如 int、float 等。

**有效变量名:**

```
int a;
int _ab;
int a30;

```

**无效变量名:**

```
int 2;
int a b;
int long;

```

## C 语言中变量的类型

c 语言中有许多类型的变量:

1.  局部变量
2.  全局变量
3.  静态变量
4.  自动变量
5.  外变量

### 局部变量

在函数或块内部声明的变量称为局部变量。

它必须在块的开头声明。

```
void function1(){
int x=10;//local variable
}

```

在使用局部变量之前，必须对其进行初始化。

### 全局变量

在函数或块外部声明的变量称为全局变量。任何函数都可以改变全局变量的值。它适用于所有功能。

它必须在块的开头声明。

```
int value=20;//global variable
void function1(){
int x=10;//local variable
}

```

### 静态变量

用 static 关键字声明的变量称为静态变量。

它在多个函数调用之间保持其值。

```
void function1(){
int x=10;//local variable
static int y=10;//static variable
x=x+1;
y=y+1;
printf("%d,%d",x,y);
}

```

如果多次调用此函数，**局部变量将为每次函数调用打印相同的值**，如 11，11，11 等。但是**静态变量将在每个函数调用中打印递增的值**，例如 11、12、13 等等。

### 自动变量

默认情况下，C 语言中所有在块内声明的变量都是自动变量。我们可以使用 **auto 关键字**显式声明一个自动变量。

```

void main(){
int x=10;//local variable (also automatic)
auto int y=20;//automatic variable
}

```

### 外变量

我们可以通过使用一个外部变量在多个 C 源文件中共享一个变量。要声明一个外部变量，需要使用 **extern 关键字**。

myfile.h

```
extern int x=10;//external variable (also global)

```

program1.c

```
#include "myfile.h"
#include <stdio.h>
void printValue(){
    printf("Global variable: %d", global_variable);
}

```

* * *