# C 语言中的常数

> 原文：<https://www.javatpoint.com/constants-in-c>

常量是程序中不能改变的值或变量，例如:10，20，' a '，3.4，" c 编程"等。

C 编程中有不同类型的常量。

## C 语言中的常数列表

| 常数 | 例子 |
| 十进制常数 | 10、20、450 等。 |
| 实数或浮点常数 | 10.3、20.2、450.6 等。 |
| 八进制常数 | 021，033，046 等。 |
| 十六进制常数 | 0x2a、0x7b、0xaa 等。 |
| 字符常数 | a '，' b '，' x '等。 |
| 串常数 | “c”、“c 程序”、“javatpoint 中的 c”等。 |

## 用 C 语言定义常数的 2 种方法

在 [C 编程](https://www.javatpoint.com/c-programming-language-tutorial)中定义常数有两种方式。

1.  const 关键字
2.  #定义预处理器

## 1) C const 关键字

在 C 编程中，const 关键字用于定义常量。

```
const float PI=3.14;

```

现在，PI 变量的值不能改变。

```
#include int main(){  
	const float PI=3.14;  
	printf("The value of PI is: %f",PI);  
	return 0;
} 
```

**输出:**

```
The value of PI is: 3.140000

```

如果你试图改变圆周率的值，它将呈现编译时错误。

```
#include int main(){  
const float PI=3.14;   
PI=4.5;  
printf("The value of PI is: %f",PI);  
	return 0;
} 
```

**输出:**

```
Compile Time Error: Cannot modify a const object

```

## 2)c#定义预处理器

#define 预处理器也用于定义常量。稍后我们将学习#define 预处理器指令。

访问此处获取:[#定义预处理器指令](https://www.javatpoint.com/c-preprocessor-define)。

* * *