# C 语言中的记号

> 原文：<https://www.javatpoint.com/tokens-in-c>

C 中的 token 是在 C 中创建程序时要使用的最重要的元素。我们可以将 token 定义为 C 中最小的单个元素。例如,`我们不能在不使用单词的情况下创建句子；同样，我们在 C 语言中创建程序也不能不使用 C 语言中的令牌，因此，我们可以说 C 语言中的令牌是创建 C 语言[程序的构造块或基本组件](https://www.javatpoint.com/c-programs)。

**C 中令牌的分类**

[C 语言](https://www.javatpoint.com/c-programming-language-tutorial)中的代币可以分为以下几类:

![Tokens in C](img/2f8e9774bfa9f61cee804266f3125674.png)

*   C 语言中的关键词
*   C 语言中的标识符
*   C 语言中的字符串
*   C 语言中的运算符
*   以摄氏度表示的常数
*   C 语言中的特殊字符

让我们一个一个地了解每个令牌。

**C 中的关键词**

C 中的[关键词可以定义为**预定义的**或**保留词**各有其重要性，每个关键词都有其功能性。因为关键字是编译器使用的预定义词，所以它们不能用作变量名。如果关键字被用作变量名，这意味着我们给关键字赋予了不同的含义，这是不允许的。c 语言支持下面给出的 32 个关键词:](https://www.javatpoint.com/keywords-in-c)

| **自动** | **加倍** | **int** | **结构** |
| **断开** | **否则** | **长** | **开关** |
| **情况** | **枚举** | **注册** | 类型定义 |
| **充电** | **外接** | **返回** | **工会** |
| **常量** | **浮动** | **短** | **无符号** |
| **继续** | **为** | **签名** | **作废** |
| **默认** | **转到** | 审裁处 | **挥发性** |
| **做** | **如果** | **静态** | **而** |

**C 中的标识符**

[C](https://www.javatpoint.com/c-identifiers)中的标识符用于命名变量、函数、数组、结构等。C 中的标识符是用户定义的单词。它可以由大写字母、小写字母、下划线或数字组成，但起始字母应该是下划线或字母表。标识符不能用作关键字。在 C 语言中构造标识符的规则如下:

*   标识符的第一个字符应该是字母或下划线，其后可以是任何字符、数字或下划线。
*   它不应该以任何数字开头。
*   在标识符中，大写字母和小写字母是不同的。因此，我们可以说标识符区分大小写。
*   标识符中不能指定逗号或空格。
*   关键字不能表示为标识符。
*   标识符的长度不应超过 31 个字符。
*   标识符应该以有意义、简短和易于阅读的方式书写。

**C 中的字符串**

[C](https://www.javatpoint.com/c-strings)中的字符串始终表示为字符串末尾有空字符' \0 '的字符数组。这个空字符表示字符串的结尾。C 语言中的字符串用双引号括起来，而字符用单个字符括起来。字符串的大小是字符串包含的字符数。

现在，我们用不同的方式描述字符串:

char a[10]= " javatpoint "；//编译器将这 10 个字节分配给“a”数组。

char a[]= " javatpoint "；//编译器在运行时分配内存。

char a[10] = {'j '，' a '，' v '，' a '，' t '，' p '，' o '，' I '，' n '，' t '，' \ 0 ' }；//字符串以字符的形式表示。

**操作员在 C**

[C](https://www.javatpoint.com/c-operators)中的运算符是用于执行功能的特殊符号。应用运算符的数据项称为操作数。运算符应用于操作数之间。根据操作数的数量，运算符分类如下:

**一元运算符**

一元运算符是应用于单个操作数的运算符。例如:递增运算符(++)、递减运算符(-)、sizeof、(type)*。

**二进制运算符**

二元运算符是应用于两个操作数之间的运算符。以下是二进制运算符的列表:

*   算术运算符
*   关系运算符
*   移位运算符
*   逻辑运算符
*   按位运算符
*   条件运算符
*   赋值运算符
*   杂项操作员

**C 中的常数**

常量是分配给变量的值，在整个程序中保持不变，即常量值不能改变。

声明常量有两种方式:

*   使用 const 关键字
*   使用#定义预处理器

**C 中[常数的类型](https://www.javatpoint.com/constants-in-c)**

| **恒定** | **例** |
| **整数常数** | **10、11、34 等。** |
| **浮点常数** | **45.6、67.8、11.2 等。** |
| **八进制常数** | **011、088、022 等。** |
| **十六进制常量** | **0x1a、0x4b、0x6b 等。** |
| **字符常量** | **‘a’、‘b’、‘c’等。** |
| **弦常数** | **“Java”、“c++”、“”。网”等。** |

**C**中的特殊字符

C 语言中使用了一些特殊的字符，它们有一种特殊的含义，不能用于其他目的。

*   **方括号[ ]:** 左右括号分别代表单个和多维下标。
*   **简单括号():**用于函数声明和函数调用。例如，printf()是一个预定义的函数。
*   **花括号{ }:** 用于代码的开、闭。它用于打开和关闭循环。
*   **逗号(，:**用于分隔多个语句，例如，分隔函数调用中的函数参数，在使用单个 printf 语句打印多个变量的值时分隔变量。
*   **哈希/预处理器(#):** 用于预处理器指令。它基本上表示我们正在使用头文件。
*   **星号(*):** 此符号用于表示指针，也用作乘法运算符。
*   **Tilde (~):** 用作析构函数释放内存。
*   **期间(。):**用于访问结构或联盟的成员。

* * *