# C 布尔值

> 原文：<https://www.javatpoint.com/c-boolean>

在 C 语言中，布尔是一种包含两种类型值的数据类型，即 0 和 1。基本上，bool 类型值代表两种类型的行为，要么是真，要么是假。这里，“0”代表假值，而“1”代表真值。

在 C Boolean 中，“0”存储为 0，另一个整数存储为 1。在 [C++](https://www.javatpoint.com/cpp-tutorial) 中我们不要求使用任何头文件来使用布尔数据类型，但是在 C 中，我们必须使用头文件，即 stdbool.h .如果我们不使用头文件，那么程序将不会编译。

### 句法

```

bool variable_name;

```

在上面的语法中， **bool** 是变量的数据类型， **variable_name** 是变量的名称。

**我们通过一个例子来了解一下。**

```

#include <stdio.h>
#include<stdbool.h>
int main()
{
bool x=false; // variable initialization.
if(x==true) // conditional statements
{
printf("The value of x is true");
}
else
printf("The value of x is FALSE");
return 0;
}

```

在上面的代码中，我们使用了 **< stdbool.h >** 头文件，这样我们就可以在程序中使用 bool 类型的变量。在头文件声明之后，我们创建 bool 类型变量“ **x** ，并为其分配一个“ **false** 值。然后，我们添加条件语句，即 **if..否则**，判断‘x’的值是否为真。

**输出**

```
The value of x is FALSE

```

## 布尔数组

现在，我们创建一个布尔型数组。布尔数组可以包含真值或假值，数组的值可以在索引的帮助下访问。

**我们通过一个例子来理解这个场景。**

```

#include <stdio.h>
#include<stdbool.h>
int main()
{
bool b[2]={true,false}; // Boolean type array
for(int i=0;i<2;i++) // for loop
{
printf("%d,",b[i]); // printf statement
}
return 0;
}

```

在上面的代码中，我们已经声明了一个包含两个值的布尔类型数组，即 true 和 false。

**输出**

```
1,0,

```

## typedef(类型定义)

还有一种使用布尔值的方式，即 **typedef** 。基本上，typedef 是 C 语言中的一个[关键字](https://www.javatpoint.com/keywords-in-c)，用于为已经存在的数据类型分配名称。

**我们来看一个 typedef 的简单例子。**

```

#include <stdio.h>
typedef enum{false,true} b;
int main()
{
b x=false; // variable initialization
if(x==true) // conditional statements
{
printf("The value of x is true");
}
else
{
printf("The value of x is false");
}
return 0;
}

```

在上面的代码中，我们使用了布尔值，即 true 和 false，但是我们没有使用 bool 类型。我们通过创建“布尔”类型的新名称来使用布尔值。为了实现这一点，在程序中使用了**typedef**关键字。

```

typedef enum{false,true} b;

```

上面的语句为“ **bool** 类型创建了一个新名称，即作为“b”的“b”可以包含真值或假值。我们在程序中使用“b”类型，并创建“b”类型的“x”变量。

**输出**

```
The value of x is false

```

## 逻辑运算符的布尔运算

布尔类型值与逻辑运算符相关联。 [C 语言](https://www.javatpoint.com/c-programming-language-tutorial)中有三种类型的逻辑运算符:

**& & (AND 运算符):**是取两个操作数的逻辑运算符。如果两个操作数的值都为真，则该运算符返回真，否则返回假

**||(OR 运算符):**是一个取两个操作数的逻辑运算符。如果两个操作数的值都为假，则返回假，否则返回真。

**！(非运算符):**它是一个取一个操作数的非运算符。如果操作数的值为假，则返回真，如果操作数的值为真，则返回假。

**我们通过一个例子来了解一下。**

```

#include <stdio.h>
#include<stdbool.h>
int main()
{
bool x=false;
bool y=true;
printf("The value of x&&y is %d", x&&y);
printf("\nThe value of x||y is %d", x||y);
printf("\nThe value of !x is %d", !x);
}

```

**输出**

```
The value of x&&y is 0 
The value of x||y is 1 
The value of !x is 1 

```

* * *