# 循环

> 原文：<https://www.javatpoint.com/c-loop>

循环可以定义为多次重复相同的过程，直到满足特定的条件。C 语言中使用了三种类型的循环。在教程的这一部分，我们将学习 C 循环的所有方面。

## 为什么在 C 语言中使用循环？

循环将复杂的问题简化为简单的问题。它使我们能够改变程序的流程，这样我们就可以在有限的时间内重复相同的代码，而不是一次又一次地编写相同的代码。例如，如果我们需要打印前 10 个自然数，那么我们可以在最多运行 10 次迭代的循环中打印，而不是使用 printf 语句 10 次。

### C 语言中循环的优势

1)它提供了代码可重用性。

2)使用循环，我们不需要反复编写相同的代码。

3)使用循环，我们可以遍历数据结构的元素(数组或链表)。

## 循环的类型

在下面给出的 [C 语言](https://www.javatpoint.com/c-programming-language-tutorial)中有三种类型的循环:

1.  做什么
2.  正在…
3.  为

### C 语言中的边做边循环

do-while 循环一直持续到给定条件满足为止。它也被称为后测试循环。当需要至少执行一次循环时使用(主要是菜单驱动程序)。

c 语言中 [do-while 循环](https://www.javatpoint.com/do-while-loop-in-c)的语法如下:

```
do{
//code to be executed
}while(condition);

```

[边做边循环的流程图和示例](do-while-loop-in-c)

### 当在 C 中循环时

c 语言中的 while 循环将用于我们事先不知道迭代次数的场景。语句块在 while 循环中执行，直到满足 while 循环中指定的条件。它也被称为预测试循环。

c 语言中 while 循环的语法如下:

```
while(condition){
//code to be executed
}

```

[while 循环的流程图和示例](while-loop-in-c)

### 对于 C 中的循环

for 循环用于我们需要执行部分代码直到满足给定条件的情况。for 循环也称为经过测试的循环。如果迭代次数事先已知，最好使用 for 循环。

c 语言中 for 循环的语法如下:

```
for(initialization;condition;incr/decr){
//code to be executed
}

```

[形成循环的流程图和示例](for-loop-in-c)

* * *