# 对于 C 中的循环

> 原文：<https://www.javatpoint.com/for-loop-in-c>

C 语言中的 **for 循环**用于多次迭代语句或程序的一部分。它经常用于遍历数组和链表等数据结构。

### C 语言中 for 循环的语法

c 语言中 for 循环的语法如下:

```
for(Expression 1; Expression 2; Expression 3){
//code to be executed
}

```

### C 语言中 for 循环的流程图

![for loop in c language flowchart](img/fa3f100d4c57f57611766540446b1414.png)

### 循环示例

让我们看看 for 循环的简单程序，它打印了表 1。

```
#include int main(){
int i=0;      
for(i=1;i<=10;i++){    
printf("%d \n",i);    
}   
return 0;
} 
```

**输出**

```
1
2
3
4
5
6
7
8
9
10

```

### C 程序:用 C 为循环打印给定数字的表格

```
#include int main(){
int i=1,number=0;    
printf("Enter a number: ");  
scanf("%d",&number);  
for(i=1;i<=10;i++){    
printf("%d \n",(number*i));  
}  
return 0;
} 
```

**输出**

```
Enter a number: 2
2
4
6
8
10
12
14
16
18
20

```

```
Enter a number: 1000
1000
2000
3000
4000
5000
6000
7000
8000
9000
10000

```

### 表达式 1 的属性

*   表达式表示循环变量的初始化。
*   我们可以在表达式 1 中初始化多个变量。
*   表达式 1 是可选的。
*   在 C 语言中，我们不能声明表达式 1 中的变量。然而，在某些编译器中，这可能是一个例外。

**例 1**

```
#include <stdio.h>
int main()
{
    int a,b,c;
    for(a=0,b=12,c=23;a<2;a++)
    {
        printf("%d ",a+b+c);
    }
}

```

**输出**

```
35 36

```

**例 2**

```
#include <stdio.h>
int main()
{
    int i=1;
    for(;i<5;i++)
    {
        printf("%d ",i);
    }
}

```

**输出**

```
1 2 3 4

```

### 表达式 2 的性质

*   表达式 2 是一个条件表达式。它检查是否满足特定条件。如果不是，循环终止。
*   表达式 2 可以有多个条件。但是，循环将迭代，直到最后一个条件变为假。其他条件将被视为陈述。
*   表达式 2 是可选的。
*   表达式 2 可以执行表达式 1 和表达式 3 的任务。也就是说，我们可以初始化变量以及更新表达式 2 本身中的循环变量。
*   我们可以在表达式 2 中传递零或非零值。但是，在 C 语言中，任何非零值都是真的，默认情况下零是假的。

**例 1**

```
#include <stdio.h>
int main()
{
    int i;
    for(i=0;i<=4;i++)
    {
        printf("%d ",i);
    }
}

```

**输出**

```
0 1 2 3 4

```

**例 2**

```
#include <stdio.h>
int main()
{
    int i,j,k;
    for(i=0,j=0,k=0;i<4,k<8,j<10;i++)
    {
        printf("%d %d %d\n",i,j,k);
        j+=2;
        k+=3;
    }
}

```

**输出**

```
0 0 0
1 2 3
2 4 6
3 6 9
4 8 12  

```

**例 3**

```
#include <stdio.h>
int main()
{
    int i;
    for(i=0;;i++)
    {
        printf("%d",i);
    }
}

```

**输出**

```
infinite loop

```

#### 表达式 3

*   Property expression 3 of is used to update loop variables.
*   We can update multiple variables at the same time.
*   3 optional expression.

**例 1**

```
#include<stdio.h>
void main ()
{
    int i=0,j=2;
    for(i = 0;i<5;i++,j=j+2)
    {
        printf("%d %d\n",i,j);
    }
}

```

**输出**

```
0 2
1 4
2 6
3 8
4 10    

```

### 循环本体

大括号{}用于定义循环的范围。但是，如果循环只包含一条语句，那么我们就不需要使用大括号。没有身体的循环是可能的。大括号充当块分隔符，即在循环内部声明的值变量只对该块有效，对外部无效。考虑下面的例子。

```
#include<stdio.h>
void main ()
{
    int i;
    for(i=0;i<10;i++)
    {
        int i = 20;
        printf("%d ",i);
    }
}

```

**输出**

```
20 20 20 20 20 20 20 20 20 20   

```

### C 中循环的不定式

为了使 for 循环无限，我们不需要在语法中给出任何表达式。相反，我们需要提供两个分号来验证 for 循环的语法。这将作为一个无限 for 循环。

```
#include<stdio.h>
void main ()
{
    for(;;)
    {
        printf("welcome to javatpoint");
    }
}

```

如果你运行这个程序，你会看到上面的语句无限次。

* * *