# 中断语句

> 原文：<https://www.javatpoint.com/c-break>

break 是 C 语言中的一个关键字，用于将程序控制带出循环。break 语句用在循环或 switch 语句中。break 语句逐个中断循环，即在嵌套循环的情况下，它首先中断内部循环，然后继续到外部循环。C 语言中的 break 语句可用于以下两种情况:

1.  带开关盒
2.  带循环

### 语法:

```
//loop or switch case 
break;

```

### c 中断点的流程图

![c language break statement flowchart](img/97717d9bb913ad49c95fc3eb53d846de.png)

### 例子

```
#include<stdio.h>
#include<stdlib.h>
void main ()
{
	int i;
	for(i = 0; i<10; i++)
	{
		printf("%d ",i);
		if(i == 5)
		break;
	}
	printf("came outside of loop i = %d",i);

}

```

**输出**

```
0 1 2 3 4 5 came outside of loop i = 5

```

### 带开关盒的 C 中断语句示例

点击此处查看 [C 与开关语句](c-switch)断开的例子。

## 带有嵌套循环的中断语句

在这种情况下，它只会破坏内环，而不会破坏外环。

```
#include int main(){
int i=1,j=1;//initializing a local variable  
for(i=1;i<=3;i++){    
for(j=1;j<=3;j++){  
printf("%d &d\n",i,j);  
if(i==2 && j==2){  
break;//will break loop of j only  
}  
}//end of for loop  
return 0;
} 
```

**输出**

```
1 1
1 2
1 3
2 1
2 2
3 1
3 2
3 3

```

正如您在控制台上看到的输出，没有打印 2 ^ 3，因为在打印 i==2 和 j==2 之后有一个 break 语句。但是会打印 3 1、3 2 和 3 3，因为 break 语句仅用于中断内部循环。

## 使用 while 循环中断语句

考虑下面的例子，在 while 循环中使用 break 语句。

```
#include<stdio.h>
void main ()
{
    int i = 0;
    while(1)
    {
        printf("%d  ",i);
        i++;
        if(i == 10)
        break; 
    }
    printf("came out of while loop");
}

```

**输出**

```
0  1  2  3  4  5  6  7  8  9  came out of while loop	

```

## 带有 do-while 循环的 break 语句

考虑以下示例，将 break 语句与 do-while 循环一起使用。

```
#include<stdio.h>
void main ()
{
   int n=2,i,choice;
   do
   {
       i=1;
       while(i<=10)
       {
           printf("%d X %d = %d\n",n,i,n*i);
           i++;
       }
       printf("do you want to continue with the table of %d , enter any non-zero value to continue.",n+1);
       scanf("%d",&choice);
	if(choice == 0)
       {
           break;
       }
       n++;
   }while(1);
}

```

**输出**

```
2 X 1 = 2
2 X 2 = 4
2 X 3 = 6
2 X 4 = 8
2 X 5 = 10
2 X 6 = 12
2 X 7 = 14
2 X 8 = 16
2 X 9 = 18
2 X 10 = 20
do you want to continue with the table of 3 , enter any non-zero value to continue.1
3 X 1 = 3
3 X 2 = 6
3 X 3 = 9
3 X 4 = 12
3 X 5 = 15
3 X 6 = 18
3 X 7 = 21
3 X 8 = 24
3 X 9 = 27
3 X 10 = 30
do you want to continue with the table of 4 , enter any non-zero value to continue.0

```

* * *