# 继续陈述

> 原文：<https://www.javatpoint.com/c-continue>

C 语言中的 **continue 语句**用于将程序控制带到循环的开始。continue 语句跳过循环中的一些代码行，并继续下一次迭代。它主要用于一个条件，这样我们就可以跳过特定条件的一些代码。

### 语法:

```
//loop statements
continue;
//some lines of the code which is to be skipped

```

## 继续语句示例 1

```
#include<stdio.h>
void main ()
{
	int i = 0; 
	while(i!=10)
	{
		printf("%d", i); 
		continue; 
		i++;
	}
}

```

**输出**

```
infinite loop

```

## 继续语句示例 2

```
#include int main(){
int i=1;//initializing a local variable     
//starting a loop from 1 to 10  
for(i=1;i<=10;i++){    
if(i==5){//if value of i is equal to 5, it will continue the loop  
continue;  
}  
printf("%d \n",i);  
}//end of for loop  
return 0;
} 
```

**输出**

```
1
2
3
4
6
7
8
9
10

```

如您所见，控制台上没有打印 5，因为循环在 i==5 处继续。

## 带内部循环的继续语句

在这种情况下，C continue 语句只继续内部循环，而不继续外部循环。

```
#include int main(){
int i=1,j=1;//initializing a local variable  
for(i=1;i<=3;i++){    
for(j=1;j<=3;j++){  
if(i==2 && j==2){  
continue;//will continue loop of j only  
}  
printf("%d %d\n",i,j);  
}  
}//end of for loop  
return 0;
} 
```

**输出**

```
1 1
1 2
1 3
2 1
2 3
3 1
3 2
3 3

```

如您所见，控制台上没有打印 2 2，因为内部循环在 i==2 和 j==2 处继续。

* * *