# C goto 语句

> 原文：<https://www.javatpoint.com/c-goto>

goto 语句在 c 语言中被称为跳转语句，顾名思义，goto 用于将程序控制转移到预定义的标签。goto 语句可用于针对特定条件重复代码的某些部分。它还可以用来中断多个循环，这是使用一个 break 语句无法完成的。然而，现在避免使用 goto，因为它会降低程序的可读性和完整性。

语法:

```
label: 
//some part of the code; 
goto label;

```

## 转到示例

让我们看一个在 C 语言中使用 goto 语句的简单例子。

```
#include <stdio.h>
int main() 
{
  int num,i=1; 
  printf("Enter the number whose table you want to print?"); 
  scanf("%d",&num);
  table: 
  printf("%d x %d = %d\n",num,i,num*i);
  i++;
  if(i<=10)
  goto table;  
}

```

**输出:**

```
Enter the number whose table you want to print?10
10 x 1 = 10
10 x 2 = 20
10 x 3 = 30
10 x 4 = 40
10 x 5 = 50
10 x 6 = 60
10 x 7 = 70
10 x 8 = 80
10 x 9 = 90
10 x 10 = 100

```

## 我们应该什么时候使用 goto？

使用 goto 更好的唯一条件是我们需要同时使用一条语句来中断多个循环。考虑下面的例子。

```
#include <stdio.h>
int main() 
{
  int i, j, k;  
  for(i=0;i<10;i++)
  {
    for(j=0;j<5;j++)
    {
      for(k=0;k<3;k++)
      {
        printf("%d %d %d\n",i,j,k);
        if(j == 3)
        {
          goto out; 
        }
      }
    }
  }
  out: 
  printf("came out of the loop"); 
}

```

```
0 0 0
0 0 1
0 0 2
0 1 0
0 1 1
0 1 2
0 2 0
0 2 1
0 2 2
0 3 0
came out of the loop

```