# C 语言中的二维数组

> 原文：<https://www.javatpoint.com/two-dimensional-array-in-c>

二维数组可以定义为数组的数组。2D 阵列被组织成矩阵，可以表示为行和列的集合。但是，创建 2D 数组是为了实现类似关系数据库的数据结构。它提供了一次性保存大量数据的便利，这些数据可以在任何需要的地方传递给任何数量的函数。

## C 语言中二维数组的声明

下面给出了声明 2D 数组的语法。

```
data_type array_name[rows][columns];

```

考虑下面的例子。

```
int twodimen[4][3];

```

这里，4 是行数，3 是列数。

## 2D 阵列的 C 语言初始化

在 1D 数组中，如果声明和初始化同时进行，我们不需要指定数组的大小。但是，这不适用于 2D 阵列。我们至少要定义数组的第二维度。二维数组可以通过以下方式声明和定义。

```
int arr[4][3]={{1,2,3},{2,3,4},{3,4,5},{4,5,6}};

```

### C 语言中的二维数组示例

```
#include<stdio.h>
int main(){    
int i=0,j=0;  
int arr[4][3]={{1,2,3},{2,3,4},{3,4,5},{4,5,6}};   
//traversing 2D array  
for(i=0;i<4;i++){  
 for(j=0;j<3;j++){  
   printf("arr[%d] [%d] = %d \n",i,j,arr[i][j]);  
 }//end of j  
}//end of i  
return 0;
}  

```

**输出**

```
arr[0][0] = 1
arr[0][1] = 2
arr[0][2] = 3
arr[1][0] = 2
arr[1][1] = 3
arr[1][2] = 4
arr[2][0] = 3
arr[2][1] = 4
arr[2][2] = 5
arr[3][0] = 4
arr[3][1] = 5
arr[3][2] = 6

```

### 2D 数组示例:将元素存储在矩阵中并打印出来。

```
#include <stdio.h>  
void main ()  
{  
    int arr[3][3],i,j;   
    for (i=0;i<3;i++)  
    {  
        for (j=0;j<3;j++)  
        {  
            printf("Enter a[%d][%d]: ",i,j);              
            scanf("%d",&arr[i][j]);  
        }  
    }  
    printf("\n printing the elements ....\n");   
    for(i=0;i<3;i++)  
    {  
        printf("\n");  
        for (j=0;j<3;j++)  
        {  
            printf("%d\t",arr[i][j]);  
        }  
    }  
}  

```

**输出**

```
Enter a[0][0]: 56   
Enter a[0][1]: 10   
Enter a[0][2]: 30  
Enter a[1][0]: 34  
Enter a[1][1]: 21 
Enter a[1][2]: 34    

Enter a[2][0]: 45
Enter a[2][1]: 56
Enter a[2][2]: 78   

 printing the elements .... 

56      10      30  
34      21      34  
45      56      78

```

* * *