# C 语言中的动态内存分配

> 原文：<https://www.javatpoint.com/dynamic-memory-allocation-in-c>

C 语言中**动态内存分配的概念** *使 C 程序员能够在运行时*分配内存。c 语言中的动态内存分配可以通过 stdlib.h 头文件的 4 个函数来实现。

1.  malloc()
2.  卡洛克（）
3.  realloc()
4.  免费()

在学习上述函数之前，让我们先了解一下静态内存分配和动态内存分配的区别。

| 静态内存分配 | 动态存储分配 |
| 内存在编译时分配。 | 内存在运行时分配。 |
| 执行程序时不能增加内存。 | 执行程序时可以增加内存。 |
| 用于数组。 | 用于链表。 |

现在让我们快速了解一下用于动态内存分配的方法。

| **malloc()** | 分配单个请求内存块。 |
| **愈伤组织()** | 分配多个请求内存块。 |
| **真 oc()** | 重新分配 malloc()或 calloc()函数占用的内存。 |
| **自由()** | 释放动态分配的内存。 |

## C 语言中的 malloc()函数

malloc()函数分配单个请求内存块。

它在执行时不初始化内存，所以最初有垃圾值。

如果内存不足，它将返回空值。

malloc()函数的语法如下:

```

ptr=(cast-type*)malloc(byte-size)

```

让我们看看 malloc()函数的例子。

```

#include #include <stdlib.h>int main(){
  int n,i,*ptr,sum=0;  
    printf("Enter number of elements: ");  
    scanf("%d",&n);  
    ptr=(int*)malloc(n*sizeof(int));  //memory allocated using malloc  
    if(ptr==NULL)                       
    {  
        printf("Sorry! unable to allocate memory");  
        exit(0);  
    }  
    printf("Enter elements of array: ");  
    for(i=0;i</stdlib.h>
```

**输出**

```
Enter elements of array: 3
Enter elements of array: 10
10
10
Sum=30

```

## 胼胝体()功能在 C

calloc()函数分配多个请求的内存块。

它最初将所有字节初始化为零。

如果内存不足，它将返回空值。

calloc()函数的语法如下:

```

ptr=(cast-type*)calloc(number, byte-size)

```

让我们看看 calloc()函数的例子。

```

#include #include <stdlib.h>int main(){
 int n,i,*ptr,sum=0;  
    printf("Enter number of elements: ");  
    scanf("%d",&n);  
    ptr=(int*)calloc(n,sizeof(int));  //memory allocated using calloc  
    if(ptr==NULL)                       
    {  
        printf("Sorry! unable to allocate memory");  
        exit(0);  
    }  
    printf("Enter elements of array: ");  
    for(i=0;i</stdlib.h>
```

**输出**

```
Enter elements of array: 3
Enter elements of array: 10
10
10
Sum=30

```

## C 语言中的 realloc()函数

如果内存不足以容纳 malloc()或 calloc()，可以通过 realloc()函数重新分配内存。简而言之，它改变了内存大小。

让我们看看 realloc()函数的语法。

```

ptr=realloc(ptr, new-size)

```

## C 语言中的 free()函数

malloc()或 calloc()函数占用的内存必须通过调用 free()函数来释放。否则，它将消耗内存，直到程序退出。

让我们看看 free()函数的语法。

```

free(ptr)

```

* * *