# C 获取()和 put()函数

> 原文：<https://www.javatpoint.com/c-gets-puts>

get()和 put()在头文件 stdio.h 中声明。这两个函数都涉及字符串的输入/输出操作。

## C gets()函数

get()函数允许用户输入一些字符，后跟 enter 键。用户输入的所有字符都存储在一个字符数组中。将空字符添加到数组中，使其成为字符串。get()允许用户输入以空格分隔的字符串。它返回用户输入的字符串。

**申报**

```
char[] gets(char[]);

```

#### 使用 get()读取字符串

```
#include void main ()
{
	char s[30];
	printf("Enter the string? ");
	gets(s);
	printf("You entered %s",s);
} 
```

#### 输出

```
Enter the string? 
javatpoint is the best
You entered javatpoint is the best

```

get()函数使用起来有风险，因为它不执行任何数组绑定检查，并且在遇到新行(enter)之前一直读取字符。它存在缓冲区溢出问题，这可以通过使用 fgets()来避免。fgets()确保读取的字符不超过最大限制。考虑下面的例子。

```
#include void main() 
{ 
   char str[20]; 
   printf("Enter the string? ");
   fgets(str, 20, stdin); 
   printf("%s", str); 
} 
```

#### 输出

```
Enter the string? javatpoint is the best website
javatpoint is the b

```

## C puts()函数

puts()函数与 printf()函数非常相似。puts()函数用于在控制台上打印先前使用 get()或 scanf()函数读取的字符串。puts()函数返回一个整数值，代表控制台上打印的字符数。因为它会在字符串中打印一个附加的换行符，将光标移动到控制台上的新行，所以 puts()返回的整数值将始终等于字符串中的字符数加上 1。

**申报**

```
int puts(char[])

```

让我们看一个使用 get()读取字符串并使用 puts()在控制台上打印它的示例。

```
#include #include <string.h>int main(){  
char name[50];  
printf("Enter your name: ");  
gets(name); //reads string from user  
printf("Your name is: ");  
puts(name);  //displays string  
return 0;  
}</string.h> 
```

#### 输出:

```
Enter your name: Sonoo Jaiswal
Your name is: Sonoo Jaiswal

```