# C fprintf()和 fscanf()

> 原文：<https://www.javatpoint.com/fprintf-fscanf-in-c>

* * *

## 正在写入文件:fprintf()函数

fprintf()函数用于将字符集写入文件。它将格式化的输出发送到流中。

**语法:**

```
int fprintf(FILE *stream, const char *format [, argument, ...])

```

**示例:**

```
#include main(){
   FILE *fp;
   fp = fopen("file.txt", "w");//opening file
   fprintf(fp, "Hello file by fprintf...\n");//writing data into file
   fclose(fp);//closing file
} 
```

* * *

## 正在读取文件:fscanf()函数

函数的作用是:从文件中读取一组字符。它从文件中读取一个字，并在文件末尾返回 EOF。

**语法:**

```
int fscanf(FILE *stream, const char *format [, argument, ...])

```

**示例:**

```
#include main(){
   FILE *fp;
   char buff[255];//creating char array to store data of file
   fp = fopen("file.txt", "r");
   while(fscanf(fp, "%s", buff)!=EOF){
   printf("%s ", buff );
   }
   fclose(fp);
} 
```

输出:

```
Hello file by fprintf...

```

* * *

## c 文件示例:存储员工信息

让我们看一个文件处理示例，它存储用户从控制台输入的员工信息。我们将存储员工的 id、姓名和工资。

```
#include 
void main()
{
    FILE *fptr;
    int id;
    char name[30];
    float salary;
    fptr = fopen("emp.txt", "w+");/*  open for writing */
    if (fptr == NULL)
    {
        printf("File does not exists \n");
        return;
    }
    printf("Enter the id\n");
    scanf("%d", &id);
    fprintf(fptr, "Id= %d\n", id);
    printf("Enter the name \n");
    scanf("%s", name);
    fprintf(fptr, "Name= %s\n", name);
    printf("Enter the salary\n");
    scanf("%f", &salary);
    fprintf(fptr, "Salary= %.2f\n", salary);
    fclose(fptr);
}
```

输出:

```
Enter the id 
1
Enter the name 
sonoo
Enter the salary
120000 

```

现在从当前目录打开文件。对于 windows 操作系统，转到 TC\bin 目录，会看到 emp.txt 文件。它将包含以下信息。

**emp.txt**

```
Id= 1
Name= sonoo
Salary= 120000 

```