# 宏

> 原文：<https://www.javatpoint.com/c-macros>

宏是由宏的值替换的一段代码。宏由#define 指令定义。有两种类型的宏:

1.  类似对象的宏
2.  类似函数的宏

## 类似对象的宏

类似对象的宏是一个被值替换的标识符。它被广泛用于表示数字常数。例如:

```
#define PI 3.14

```

这里，PI 是将被值 3.14 替换的宏名。

## 类似函数的宏

类似函数的宏看起来像函数调用。例如:

```
#define MIN(a,b) ((a)
```

这里，MIN 是宏名。

访问 [#define](c-preprocessor-define) 查看类对象和类函数宏的完整示例。

* * *

## 预定义的宏

ANSI C 定义了许多可以在 C 程序中使用的预定义宏。

| 号码 | 巨 | 描述 |
| one | _DATE_ | 以“MMM DD YYYY”格式表示当前日期。 |
| Two | _ 时间 _ | 以“时:分:秒”格式表示当前时间。 |
| three | _FILE_ | 表示当前文件名。 |
| four | _LINE_ | 表示当前行号。 |
| five | _STDC_ | 当编译器符合 ANSI 标准时，它被定义为 1。 |

## 预定义宏示例

文件:simple.c

```
#include int main(){  
   printf("File :%s\n", __FILE__ );  
   printf("Date :%s\n", __DATE__ );  
   printf("Time :%s\n", __TIME__ );  
   printf("Line :%d\n", __LINE__ );  
   printf("STDC :%d\n", __STDC__ );    
   return 0;
 } 
```

输出:

```
File :simple.c
Date :Dec 6 2015
Time :12:28:46
Line :6
STDC :1

```