# c#包括

> 原文：<https://www.javatpoint.com/c-preprocessor-include>

#include 预处理器指令用于将给定文件的代码粘贴到当前文件中。它用于包含系统定义和用户定义的头文件。如果未找到包含的文件，编译器会呈现错误。

通过使用#include 指令，我们向预处理器提供了在哪里查找头文件的信息。使用#include 指令有两种变体。

1.  #包括<filename></filename>
2.  #包含“文件名”

**#include <文件名>** 告诉编译器寻找保存系统头文件的目录。在 UNIX 中，它是\usr\include 目录。

**#包含“文件名”**告诉编译器从程序运行的当前目录中查找。

## #包含指令示例

让我们看一个简单的#include 指令的例子。在这个程序中，我们包含 stdio.h 文件，因为 printf()函数是在这个文件中定义的。

```
#include int main(){  
   printf("Hello C");    
   return 0;
 } 
```

输出:

```
Hello C

```

## #包含注释:

**注 1:** 在#include 指令中，注释不被识别。所以在#include < a//b >的情况下，a//b 被视为文件名。

**注 2:** 在#include 指令中，反斜杠被认为是正常文本而不是转义序列。所以在#include < a\nb >的情况下，a\nb 被视为文件名。

**注 3:** 只能在文件名后使用注释，否则会出错。