# C 语言中的命令行参数

> 原文：<https://www.javatpoint.com/command-line-arguments-in-c>

从命令行传递的参数称为命令行参数。这些参数由 main()函数处理。

为了支持命令行参数，您需要更改 main()函数的结构，如下所示。

```
int main(int argc, char *argv[] )

```

这里， **argc** 统计参数个数。它将文件名作为第一个参数。

**argv[]** 包含参数的总数。第一个参数总是文件名。

## 例子

让我们看看命令行参数的例子，其中我们传递一个带有文件名的参数。

```
#include void main(int argc, char *argv[] )  {

   printf("Program name is: %s\n", argv[0]);

   if(argc < 2){
      printf("No argument passed through command line.\n");
   }
   else{
      printf("First argument is: %s\n", argv[1]);
   }
} 
```

在 Linux 中运行该程序，如下所示:

```
./program hello

```

从命令行在窗口中按如下方式运行该程序:

```
program.exe hello

```

**输出:**

```
Program name is: program
First argument is: hello

```

如果您传递许多参数，它将只打印一个。

```
./program hello c how r u

```

**输出:**

```
Program name is: program
First argument is: hello

```

但是如果您在双引号内传递许多参数，所有参数都将被视为单个参数。

```
./program "hello c how r u"

```

**输出:**

```
Program name is: program
First argument is: hello c how r u

```

您可以编写程序来打印所有参数。在这个程序中，我们只打印 argv[1]，这就是为什么它只打印一个参数。

* * *