# C 语言中 getch()是什么？

> 原文：<https://www.javatpoint.com/what-is-getch-in-c>

**getch** ()是预定义的非标准函数，在 **conio.h** 头文件中定义。它主要由 Dev [C](https://www.javatpoint.com/c-programming-language-tutorial) / [C++](https://www.javatpoint.com/cpp-tutorial) 使用，MS- DOS 的编译器像 **Turbo** C 一样按住屏幕，直到用户传递一个值退出控制台屏幕。它也可以用来从键盘上读取单字节字符或字符串，然后打印。它不包含任何参数。它没有缓冲区来存储程序中的输入字符。

### 为什么我们使用 getch()函数？

我们在 C/ C++ 程序中使用 **getch** ()函数来保持输出屏幕一段时间，直到用户通过键盘上的一个键退出控制台屏幕。使用 getch()函数，我们可以将用户提供的输入字符隐藏在 ATM PIN、密码等中。

**语法:**

```

int getch(void);

```

**参数**:getch()函数不接受用户的任何参数。

**返回值**:返回用户按下按键的 ASCII 值作为输入。

编写一个简单的程序来显示用户使用 c 语言中的 getch()函数输入的字符。

**程序代码**

```

#include #include <conio.h>int main()
{
       printf(" Passed value by the User is: %c", getch()); // print a character entered by the user
	return 0;
}</conio.h> 
```

**输出:**

```
Passed value by the User is: P

```

要在控制台上打印任何字符，请按相应的键。

编写一个简单的程序来按住控制台屏幕，直到用户给出一个退出键。

**程序 2.c**

```

#include #include <conio.h>int main()
{
   printf("Enter a key to exit the console screen.\n");
   getch(); 
   return 0;
}</conio.h> 
```

**输出:**

```
Enter a key to exit the console screen.

```

编写一个程序，使用 getch()函数接受来自用户的字符串。

**user getch . c .**

```

#include #include <conio.h>int main() {    
    char ch[6] = {0}; int x;
    for ( x = 0; x < 5; x++) {
        ch[x] = getch(); // getch() function to take input
    }
    printf("Received 5 character Input: %s\n", ch);
    return 0;
}</conio.h> 
```

**输出:**

```
Received 5 character Input: hello

```

编写一个程序，使用 getch()函数接受用户隐藏的密码。

**程序 3.c**

```

#include #include <string.h>#include <dos.h>#include <conio.h>void main()
{
	char pw[10];
	int x;
	printf(" Enter password: ");
	for (x = 0; x < 10; x++)
	{
		// accepts the hidden password using the getch() function
		pw[x] = getch();
		printf("*"); // print the input chartered in the form of *
	}
	pw[x] = '\0';
	printf( "\n" );
printf(" You have passed the hidden password: ");
	for (x = 0; pw[x] != '\0'; x++)
	{
		printf("%c", pw[x]);
}
getch();
}</conio.h></dos.h></string.h> 
```

**输出:**

```
Enter password: **********
You have passed the hidden password: [email protected]

```

* * *