# C 语言中的字符串连接

> 原文：<https://www.javatpoint.com/strings-concatenation-in-c>

字符串串联是将两个字符串组合成一个字符串的过程。如果有两个字符串，则在第一个字符串的末尾添加第二个字符串。

**例如**，Hello+javaTpoint = Hello javaTpoint

**我们可以通过以下三种方式连接字符串:**

*   **使用循环**连接两个字符串
*   **使用指针**连接两个字符串
*   **使用 strcat()函数**连接两个字符串

### 使用循环连接两个字符串

```

#include <stdio.h>
int main()
{
    char first_string[20]; // declaration of char array variable
    char second_string[20]; // declaration of char array variable
    int i;  // integer variable declaration
    printf("Enter the first string");
    scanf("%s",first_string);
    printf("\nEnter the second string");
    scanf("%s",second_string);
    for(i=0;first_string[i]!='\0';i++); 

    for(int j=0;second_string[j]!='\0';j++)
    {

        first_string[i]=second_string[j];
        i++;
    }
    first_string[i]='\0';
   printf("After concatenation, the string would look like: %s", first_string);
return 0;

```

**以上程序分析**

*   在上面的程序中，我们声明了两个字符串，即**第一个 _ 字符串**和**第二个 _ 字符串**。用户将这两个字符串的值作为输入。
*   我们将连接这两个字符串，并将连接结果存储在 **first_string** 中
*   我们声明一个名为“ **i** 的新整数变量。声明之后，我们将运行一个循环，从 **i=0** 开始迭代，直到遇到 **first_string** 的空字符。当循环执行完成时，那么“ **i** 的值等于字符串的长度加 1。
*   我们将定义另一个新的循环，它基本上用于连接两个字符串。该循环从 **j=0** 开始，一直执行到遇到**第二个 _ 字符串**的空字符。在每次迭代中，位于**第二 _ 字符串**中 **j <sup>第</sup>T7】位置的字符被存储在**第一 _ 字符串**的**I<sup>t</sup>**<sup>h</sup>位置。这样，两个字符串组合在一起形成一个字符串。**

**输出**

![Strings Concatenation in C](img/7aeced34081ac6007e0483dc24298d41.png)

### 使用指针连接两个字符串

```

#include <stdio.h>
int main()
{
  char string1[20]; // char array declaration
  char string2[20]; // char array declaration
  int i=0,j=0; // declaration of integer variables
  char *str1; // declaration of char pointer
  char *str2;  // declaration of char pointer
  str1=string1;
  str2=string2;
  printf("Enter the first string");
  scanf("%s",string1);
  printf("\nEnter the second string");
  scanf("%s", string2);
  while(string1[i]!='\0')
  {

     ++str1;
     i++;
  }
  while(string2[j]!='\0')
  {
      *str1=*str2;
      str1++;
      str2++;
      j++;
  }
  printf("The concatenated string is %s",string1);

    return 0;
}

```

**以上程序分析**

*   在上面的程序中，我们已经声明了字符数组变量，即 **string1** 和 **string2** 。我们将这两个字符串作为用户输入，并将它们存储在变量 **string1** 和 **string2、**中
*   我们声明两个字符指针 str1 和 str2。str1 包含 string1 的地址，str2 包含 string2 的地址。
*   我们创建一个循环，循环迭代直到遇到 string1 的空字符。当循环执行完成时，指针 str1 指向最后一个字符位置之后的位置。
*   我们定义了另一个 while 循环，它迭代直到遇到 string2 的空字符。在每次迭代中，通过使用语句 ***str1=*str2，存储在字符串 2 中第 j <sup>个</sup>位置的字符被追加到字符串 1 中。**

**输出**

![Strings Concatenation in C](img/b1b410c3d23f9557eb0b070e45e41868.png)

### 使用 strcat()串联两个字符串

现在我们将看到如何使用 **strcat()** 函数连接两个字符串。 **strcat()** 是在**字符串. h** 头文件中定义的内置函数。

**我们来看一下例子。**

```

#include <stdio.h>
#include<string.h>
int main()
{
  char s1[20]; // declaration of char array
  char s2[20]; // declaration of char array
printf("Enter the first string : ");
scanf("%s", s1);
printf("\nEnter the second string :");
scanf("%s",s2);
strcat(s1,s2);
printf("The concatenated string is : %s",s1);
    return 0;
}

```

在上面的代码中，我们使用 strcat()函数来连接两个字符串。它将两个字符串作为参数，然后在第一个字符串的末尾追加第二个字符串。

**输出**

![Strings Concatenation in C](img/e5685476e63e10b0123cdb3a5d205f44.png)

* * *