# C 语言中的阿姆斯特朗数

> 原文：<https://www.javatpoint.com/armstrong-number-in-c>

在准备写 c 程序查号是不是阿姆斯特朗号之前，先来了解一下什么是阿姆斯特朗号。

**阿姆斯壮数**是*一个等于其数字*的立方之和的数。例如，0、1、153、370、371 和 407 是阿姆斯特朗数。

让我们试着理解为什么 **153** 是一个阿姆斯特朗数。

```
153 = (1*1*1)+(5*5*5)+(3*3*3)
where:
(1*1*1)=1
(5*5*5)=125
(3*3*3)=27
So:
1+125+27=153

```

让我们试着理解为什么 **371** 是一个阿姆斯特朗数。

```
371 = (3*3*3)+(7*7*7)+(1*1*1)
where:
(3*3*3)=27
(7*7*7)=343
(1*1*1)=1
So:
27+343+1=371

```

让我们看看用 c 语言检查阿姆斯特朗数的 c 程序

```
#include int main()  
{  
int n,r,sum=0,temp;  
printf("enter the number=");  
scanf("%d",&n);  
temp=n;  
while(n>0)  
{  
r=n%10;  
sum=sum+(r*r*r);  
n=n/10;  
}  
if(temp==sum)  
printf("armstrong  number ");  
else  
printf("not armstrong number");  
return 0;
} 
```

**输出:**

```
enter the number=153
armstrong number

enter the number=5
not armstrong number

```

* * *