# C 语言中的十六进制到十进制

> 原文：<https://www.javatpoint.com/hexadecimal-to-decimal-in-c>

## 什么是十六进制？

十六进制也称为 base-16，它是一个数字系统，使用 16 个符号来表示特定的值，这些符号来自(0-9 和 A-F)。

## 什么是十进制？

十进制是代表整数和非整数的数字系统。这个数字系统也被称为基数-10 系统，它使用(0-9)中的 10 个符号来表示一个特定的值。

**十六进制到二进制数的转换**

我们知道十六进制数包含 16 个符号，即 0，1，2，3，4，5，6，7，8，9，A，B，C，D，E，F 其中 A，B，C，D，E，F 代表(10，11，12，13，14，15)个值。我们可以通过从十六进制数中提取数字，并从数字的最右边的数字开始，来找到十进制数。十六进制数的每个数字都乘以基数 16。我们将把乘法的结果存储在一个特定的变量中。

**让？让我们通过一个例子来理解。**

如果十六进制数是 5A，那么它的十进制值将是:

**十进制 _ 值**= 5 * 16<sup>1</sup>+10 * 16<sup>0</sup>
= 90

现在，我们用图解法理解十六进制数到十进制数的转换:

![Hexadecimal to Decimal in C](img/a7ef027035045d2e6805517365c88271.png)

在上图中，我们将 **2AB** 视为十六进制数，并计算其十进制值。

2AB(十六进制值)= 2*16 <sup>2</sup> + 10*16 <sup>1、</sup> + 11*16 <sup>0</sup>
= 683(十进制值)

**让？我们通过程序来理解。**

```

#include <stdio.h>
#include <math.h>
#include <string.h>
int main()
{
    char hex[17];                        // declaration of character array.
    long long decimal, place;
    int i = 0, val, len;                  // variables declaration
    decimal = 0;
   /* Input hexadecimal number from user */
    printf("Enter any hexadecimal number: ");
    gets(hex);
/* Find the length of total number of hex digit */
    len = strlen(hex);
    len--;

    /*
     * Iterate over each hex digit
     */
    while(hex[i]!='\0')
    {

        /* To find the decimal representation of hex[i] */
        if(hex[i]>='0' && hex[i]<='9')
        {
            val = hex[i] - 48;
        }
        else if(hex[i]>='a' && hex[i]<='f')
        {
            val = hex[i] - 97 + 10;
        }
        else if(hex[i]>='A' && hex[i]<='F')
        {
            val = hex[i] - 65 + 10;
        }

        decimal += val * pow(16, len);

```

在上面的程序中，我们找到了给定十六进制数的十进制数。在上述情况下，我们从用户处获取输入，并将其值存储在**十六进制**变量中。从用户处检索输入后，我们计算输入的长度并将其存储在**透镜**变量中。我们已经迭代了十六进制数的每个数字，并将最终结果存储在 **decimal_value** 变量中

**输出**

![Hexadecimal to Decimal in C](img/11c35156f3d645a780b63fec778f6656.png)

* * *