# C 语言中的星形模式程序

> 原文：<https://www.javatpoint.com/star-program-in-c>

在本主题中，我们将学习如何使用 C 语言创建模式。我们将通过使用星号或其他字符来创建模式。我们将创建不同的图案或几何形状，如三角形、正方形等。

**我们将涵盖以下模式。您可以通过点击模式来查看下面给出的任何模式的代码。**

![Star Program in C](img/40629406605758dbe5f5a66eb5d733ac.png) ![Star Program in C](img/67d1718e3bb007deb9886a8291a16f7d.png) ![Star Program in C](img/b5ca8e81dbb1f51f98f957108daff7e9.png) ![Star Program in C](img/077047ea22416ebbf4efe542d662ca14.png) ![Star Program in C](img/53445a659c8a2930f0015382d06233a0.png) ![Star Program in C](img/1d8af0870ab190f772321a07ac685f97.png) ![Star Program in C](img/20c3db395d12579a1e08ea631ea68100.png) ![Star Program in C](img/0e6c6d8c14b7e808a04d739016616c53.png) ![Star Program in C](img/5c8a716de4585e18400cc00035511926.png) ![Star Program in C](img/5f724f6cca32eef081313c452603b896.png) ![Star Program in C](img/ee89ac1747340b4b5c48b0e5d0e5eba5.png) ![Star Program in C](img/e7c4f3bb7b5e83d407a10daadaa0de80.png) ![Star Program in C](img/1dfef406d5502dfbeacc211afaee2030.png) ![Star Program in C](img/b9dda28fdf115a1bd82611e25013f3cb.png) ![Star Program in C](img/1370352d24ff712a3e2e7d6f1a515bea.png) ![Star Program in C](img/8fd20797398b2ee2620f45dbe1dcf9e9.png) ![Star Program in C](img/6563989377738d1a17807b56fc7fee29.png) ![Star Program in C](img/780d5a4a4b3b176d38c1cdd4b3eb3190.png) ![Star Program in C](img/1108e90a0f8e01d689694fb42a5fd7ad.png) ![Star Program in C](img/81bfa53e0d199e4d616cf45c1bff34cd.png) ![Star Program in C](img/4fcc6518556637ba58300991e8c7f61b.png) ![Star Program in C](img/ab0a4473d5820d15e73a3d7b8a92564f.png) ![Star Program in C](img/f54bec5b05f8eaabce9ce583e6fad970.png) ![Star Program in C](img/59dffda10afdc525769891668e9ebefe.png) ![Star Program in C](img/c9d9aa7bb7e7638f1c2d5ced5e345f36.png)

* * *

## 方形星形图案

创建方形星形图案的代码如下所示:

```

#include <stdio.h>
 int main()
{
    int n;
    printf("Enter the number of rows");
    scanf("%d",&n);
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<n;j++)
        {
            printf("*");
        }
        printf("\n");
    }

    return 0;
}

```

**输出**

![Star Program in C](img/fa0c71410de7edb53e1b7111bfd9976a.png)

## 空心方形星形图案

现在，我们创建空心方形星形图案。该模式的源代码如下:

```

int main()
{
    int n;
    printf("Enter the number of rows");
    scanf("%d",&n);
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            if(i==1 ||i==n||j==1||j==n)
            {
            printf("*");
            }
            else
            printf(" ");
        }
        printf("\n");
    }

    return 0;
}

```

**输出**

![Star Program in C](img/6bd642140a2a834674398ee1af542899.png)

## 对角线空心方形图案

空心方形星形图案的代码如下所示:

```

#include <stdio.h>
int main()
{
    int n;
    printf("Enter the number of rows");
    scanf("%d",&n);
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=n;j++)
        {
            if(i==1 ||i==n||j==1||j==n-i+1||i==j||j==n)
            {
            printf("*");
            }
            else
            {

                      printf(" ");
                  }

            }      
        printf("\n");
    }

    return 0;
}

```

**输出**

![Star Program in C](img/e3f230136edf9e6f235dc93b9e0adf68.png)

## 菱形星形图案

菱形星形图案的代码如下所示:

```

#include <stdio.h>

int main()
{
    int n;
    printf("Enter the number of rows");
    scanf("%d",&n);
    for(int i=n;i>=1;i--)
    {
        for(int j=1;j<=i-1;j++)
        {
            printf(" ");
        }
        for(int k=1;k<=n;k++)
        {
            printf("*");
        }
        printf("\n");
    }
    return 0;
}

```

**输出**

![Star Program in C](img/3e9867915320b7787f1a0b61aad6e4ff.png)

## 空心菱形星形图案

空心菱形星形图案的代码如下所示:

```

#include <stdio.h>

int main()
{
    int n;
    printf("Enter the number of rows");
    scanf("%d",&n);
    for(int i=n;i>=1;i--)
    {
        for(int j=1;j<=i-1;j++)
        {
            printf(" ");
        }
        for(int k=1;k<=n;k++)
        {
           if(i==1 || i==n || k==1 || k==n)
            printf("*");
            else
            printf(" "); 
        }
        printf("\n");
    }
    return 0;
}

```

**输出**

![Star Program in C](img/68cd7e442e0bf7761f2eba3a988f79d0.png)

## 镜像菱形星形图案

镜像菱形星形图案的代码如下所示:

```

#include <stdio.h>
int main()
{
    int n;
    printf("Enter the number of rows");
    scanf("%d",&n);
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<i;j++)
        {
            printf(" ");
        }
        for(int k=1;k<=n;k++)
        {
           printf("*");

        }
        printf("\n");
    }
    return 0;
}

```

**输出**

![Star Program in C](img/be6a655ae1d9bf00421a72e1014296a8.png)

## 中空镜面菱形星形图案

中空镜像菱形星形图案的代码如下所示:

```

#include <stdio.h>
int main()
{
    int n;
    printf("Enter the number of rows");
    scanf("%d",&n);
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<i;j++)
        {
            printf(" ");
        }
        for(int k=1;k<=n;k++)
        {
         if(i==1 || i==n || k==1 || k==n)
           printf("*");
            else
            printf(" ");
        }
        printf("\n");
    }
    return 0;
}

```

**输出**

![Star Program in C](img/5e34b7e502076699270312f4038f4f5d.png)

## 直角三角形星形图案

直角三角形星形图案的代码如下所示:

```

#include <stdio.h>

int main()
{
    int n;
    printf("Enter the number of rows");
    scanf("%d",&n);
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=i;j++)
        {
            printf("* ");
        }
        printf("\n");
    }
    return 0;
}

```

**输出**

![Star Program in C](img/3b59a00ca9eab626ed1d7956ac2e011f.png)

## 空心直角三角形星形图案

空心直角三角形星形图案的代码如下所示:

```

#include <stdio.h>

int main()
{
    int n;
    printf("Enter the number of rows");
    scanf("%d",&n);
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=i;j++)
        {
        if(j==1|| i==j || i==n )
        {
            printf("*");
        }
        else
        printf(" ");
        }
        printf("\n");
    }
    return 0;
}

```

**输出**

![Star Program in C](img/b38fb751fbb960829792afc229c65283.png)

## 镜像直角三角形星形图案

镜像直角三角形星形模式的代码如下所示:

```

#include <stdio.h>

int main()
{
    int n,m=1;
    printf("Enter the number of rows");
    scanf("%d",&n);
    for(int i=n;i>=1;i--)
    {
        for(int j=1;j<=i-1;j++)
        {
          printf(" ");
        }
        for(int k=1;k<=m;k++)
        {
            printf("*");
        }
        printf("\n");
        m++;
    }
    return 0;
}

```

**输出**

![Star Program in C](img/bce098a20045ba5d151a280a1a219fa9.png)

## 中空镜像直角三角形星形图案

中空镜像直角三角形星形图案的代码如下所示:

```

#include <stdio.h>

int main()
{
    int n,m=1;
    printf("Enter the number of rows");
    scanf("%d",&n);
    for(int i=n;i>=1;i--)
    {
        for(int j=1;j<=i-1;j++)
        {
          printf(" ");
        }
        for(int k=1;k<=m;k++)
        {
           if(k==1 || k==m || m==n)
            printf("*");
            else
            printf(" ");
        }
        printf("\n");
        m++;
    }
    return 0;
}

```

**输出**

![Star Program in C](img/c402428a3e9fdbc145029567bcd7befb.png)

## 倒直角三角形星形图案

倒直角三角形星形图案的代码如下所示:

```

#include <stdio.h>

int main()
{
    int n,m=1;
    printf("Enter the number of rows");
    scanf("%d",&n);
    for(int i=n;i>=1;i--)
    {
      for(int j=1;j<=i;j++)
      {
          printf("*");
      }
      printf("\n");
    }
    return 0;
}

```

**输出**

![Star Program in C](img/6ab7d66952dd72c46b05afd58eb36603.png)

## 空心倒直角三角形星形图案

空心倒直角三角形星形图案的代码如下所示:

```

#include <stdio.h>

int main()
{
    int n,m=1;
    printf("Enter the number of rows");
    scanf("%d",&n);
    for(int i=n;i>=1;i--)
    {
      for(int j=1;j<=i;j++)
      {
         if(j==1 || j==i || i==n)
          printf("*");
          else
          printf(" ");
      }
      printf("\n");
    }
    return 0;
}

```

**输出**

![Star Program in C](img/aca897e98141dd2e437cda86197dbef8.png)

## 倒置镜像直角三角形星形图案

倒置镜像直角三角形星形模式的代码如下所示:

```

#include <stdio.h>

int main()
{
    int n,m;
    printf("Enter the number of rows");
    scanf("%d",&n);
    m=n;
   for(int i=1;i<=n;i++)
   {
       for(int j=1;j<i;j++)
       {
           printf(" ");
       }
       for(int k=1;k<=m;k++)
       {
           printf("*");
       }
       m--;

      printf("\n");
    }
    return 0;
}

```

**输出**

![Star Program in C](img/d770220a9e4867315be9c32965f7f368.png)

## 空心倒镜直角三角形星形图案

空心倒镜像直角三角形星形图案的代码如下所示:

```

#include <stdio.h>

int main()
{
    int n,m;
    printf("Enter the number of rows");
    scanf("%d",&n);
    m=n;
   for(int i=1;i<=n;i++)
   {
       for(int j=1;j<i;j++)
       {
           printf(" ");
       }
       for(int k=1;k<=m;k++)
       {
          if(i==1 || k==1 || k==m)
           printf("*");
           else
           printf(" ");
       }
       m--;

      printf("\n");
    }
    return 0;
}

```

**输出**

![Star Program in C](img/327847ff098b56618de4457e0f07c749.png)

## 金字塔星形图案

金字塔星形图案的代码如下所示:

```

#include <stdio.h>
int main()
{
    int n,m;
    printf("Enter the number of rows");
    scanf("%d",&n);
    m=n;
   for(int i=1;i<=n;i++)
   {
       for(int j=1;j<=m-1;j++)
       {
           printf(" ");
       }
       for(int k=1;k<=2*i-1;k++)
       {
         printf("*");
       }
       m--;

      printf("\n");
    }
    return 0;
}

```

**输出**

![Star Program in C](img/e4a8e8cd34cc628bc4cee991e2eaecd2.png)

## 空心金字塔星形图案

空心金字塔星形图案的代码如下所示:

```

#include <stdio.h>

int main()
{
    int n,m;
    printf("Enter the number of rows");
    scanf("%d",&n);
    m=n;
   for(int i=1;i<=n;i++)
   {
       for(int j=1;j<=m-1;j++)
       {
           printf(" ");
       }
       for(int k=1;k<=2*i-1;k++)
       {
          if(k==1 || k==2*i-1 || i==n)
         printf("*");
         else
         printf(" ");
       }
       m--;

      printf("\n");
    }
    return 0;
}

```

**输出**

![Star Program in C](img/0aabce2cc97ab9f084b6f32c242438f0.png)

## 倒金字塔星形图案

倒金字塔的代码如下:

```

#include <stdio.h>

int main()
{
    int n,m=1;
    printf("Enter the number of rows");
    scanf("%d",&n);

   for(int i=n;i>=1;i--)
   {
       for(int j=1;j<m;j++)
       {
           printf(" ");
       }
       for(int k=1;k<=2*i-1;k++)
       {
           printf("*");
       }
       m++;

      printf("\n");
    }
    return 0;
}

```

**输出**

![Star Program in C](img/63c3839c5950230a6cc417d9b478e868.png)

## 空心金字塔星形图案

空心金字塔星形图案的代码如下所示:

```

#include <stdio.h>

int main()
{
    int n,m=1;
    printf("Enter the number of rows");
    scanf("%d",&n);

   for(int i=n;i>=1;i--)
   {
       for(int j=1;j<m;j++)
       {
           printf(" ");
       }
       for(int k=1;k<=2*i-1;k++)
       {
          if(k==1 || k==2*i-1 || i==n)
           printf("*");
           else
           printf(" ");
       }
       m++;

      printf("\n");
    }
    return 0;
}

```

**输出**

![Star Program in C](img/6293099a6261edd631d118ba8052e1b4.png)

## 半菱形星形图案

半菱形星形图案的代码如下所示:

```

#include <stdio.h>

int main()
{
    int n,m=1;
    printf("Enter the number of columns");
    scanf("%d",&n);
for(int i=1;i<=n;i++)
{
  for(int j=1;j<=i;j++)
  {
    printf("*");
  }
  printf("\n");
}
 for(int i=n-1;i>=1;i--)
 {
   for(int j=1;j<=i;j++)
   {
     printf("*");
   }
   printf("\n");
 }  

    return 0;
}

```

**输出**

![Star Program in C](img/626163f6981e25585928fe5dba047760.png)

## 钻石星形图案

钻石星形图案的代码如下:

```

#include <stdio.h>
int main(void) {
  int n;
  printf("Enter the number of rows\n");
  scanf("%d",&n);
  int spaces=n-1;
  int stars=1;
  for(int i=1;i<=n;i++)
  {
    for(int j=1;j<=spaces;j++)
    {
      printf(" ");
    }
    for(int k=1;k<=stars;k++)
    {
      printf("*");
    }
    if(spaces>i)
    {
      spaces=spaces-1;
      stars=stars+2;
    }
    if(spaces<i)
    {
      spaces=spaces+1;
      stars=stars-2;
    }
    printf("\n");
  }
  return 0;}

```

**输出**

![Star Program in C](img/727fc504e26e7013d34c35350bf205e3.png)

## 右箭头星形图案

右箭头星形图案的代码如下所示:

```

#include <stdio.h>

int main(void) {

  int n;
  printf("Enter the number of columns");
  scanf("%d",&n);
  //printing the upper part of the pattern..
 for(int i=0;i<n;i++)
 {
   for(int j=0;j<i;j++)
   {
       printf(" ");
   }
   for(int k=1;k<=n-i;k++)
   {
     printf("*");
   }
   printf("\n");
 }
for(int i=1;i<n;i++)
{
  for(int j=1;j<n-i;j++)
  {
    printf(" ");
  }
  for(int k=1;k<=i+1;k++)
  {
    printf("*");
  }
  printf("\n");
}
  return 0;
}

```

**输出**

![Star Program in C](img/350687ecd485254e2e2739f64d336e78.png)

## 左箭头星形图案

左箭头星形模式的代码如下所示:

```

#include <stdio.h>

int main(void) {

  int n;
  printf("Enter the number of columns");
  scanf("%d",&n);
  //printing the upper part of the pattern..
 for(int i=1;i<=n;i++)
 {
   for(int j=1;j<=n-i;j++)
   {
       printf(" ");
   }
   for(int k=0;k<=n-i;k++)
   {
     printf("*");
   }
   printf("\n");
 }
for(int i=1;i<n;i++)
{
  for(int j=1;j<i+1;j++)
  {
    printf(" ");
  }
  for(int k=1;k<=i+1;k++)
  {
    printf("*");
  }
  printf("\n");
}
  return 0;
}

```

**输出**

![Star Program in C](img/a81fdde223f0af0a777fd6988072c8c4.png)

## 加号星形图案

加号星形模式的代码如下所示:

```

#include <stdio.h>

int main(void) {
  int n;
  printf("Enter the odd number only");
  scanf("%d", &n);
  for(int i=1;i<=n;i++)
  {
    if(i==((n/2)+1))
    {
      for(int j=1;j<=n;j++)
      {
        printf("+");
      }

    }
    else
    {
    for(int j=1;j<=n/2;j++)
    {
      printf(" ");
    }
    printf("+");
    }
    printf("\n");
  }
  return 0;
}

```

**输出**

![Star Program in C](img/d5b3c53640a045880ade6f35cb44ea9f.png)

## x 星图案

X 星形模式的代码如下所示:

```

#include <stdio.h>

int main(void) {
  int n,m;
  printf("Enter the number");
  scanf("%d",&n);
  m=2*n-1;
  for(int i=1;i<=m;i++)
  {
    for(int j=1;j<=m;j++)
    {
       if(i==j || j==(m-i+1))
       {
         printf("*");
       }
       else
       {
         printf(" ");
       }
    }
    printf("\n");
  }
  return 0;
}

```

**输出**

![Star Program in C](img/ef7ab2eb84d52165de3074e7257b97bb.png)

* * *