# C 语言的闰年程序

> 原文：<https://www.javatpoint.com/leap-year-program-in-c>

首先，知道什么是闰年很重要？一般来说，一年有 365 天，但闰年有 366 天，是在四年之后。以下是与闰年相关的几点:

*   闰年是一年，不同于正常年份的 365 天，而是 366 天。
*   闰年四年一次，其中二月有 29 天。有了 2 月的这一天，一年就变成了**闰年**。
*   一些闰年的例子是- 1600 年、1988 年、1992 年、1996 年和 2000 年。
*   虽然 1700 年、1800 年、1900 年是世纪年，不是闰年。

以下条件用于检查该年是否为闰年。

1.  年份必须能被 4 整除
2.  年可以被 400 整除，但不能被 100 整除。

通过将这些条件放入代码中，您可以检查年份是否是闰年。如果满足以上条件，那一年就是闰年。这些条件可以放在 [if-else](https://www.javatpoint.com/c-if-else) 或& & (and)和|| (Or)中。

### 如何用 C 编程找到闰年？

借助一个 [C 程序](https://www.javatpoint.com/c-programs)，我们会很容易找到闰年。

**例**

请参见下面的示例，在该示例中，我们通过接收用户的输入来检查闰年:

```

#include<stdio.h>
#include<conio.h>
void main() {
	int year;
	printf("Enter a year: ");
	scanf("%d", &year);
	if(((year%4==0) && ((year%400==0) || (year%100!==0))
	{
		printf("%d is a leap year", &year);
	} else {
		printf("%d is not a leap year", &year);
	}
	getch();
}

```

**输出**

不同输入值见以下输出:

**测试 1:**

```
Enter a year: 2004
2004 is a leap year

```

**测试 2:**

```
Enter a year: 1700
1700 is not a leap year

```

**例**

在下面这个例子中，我们会发现闰年介于 2000 年到 2020 年之间。请参见下面的示例:

```

#include<stdio.h>
#include<conio.h>
void main() {
	int startYear, endyear, i;
	printf ("Enter a year to start searching the leap years: ");
	scanf ("%d", &startYear);
	printf ("Enter a year to end the search of leap years: ");
	scanf ("%d", &endyear);
	printf ("Leap Years between %d to %d are: \n", &startYear, &endYear);
	for (i= startYear; i<= endYear, i++) 
	{
	     if(((i%4==0) && ((i%400==0) || (i%100!==0))
	     {
		  printf("%d \n", &i);
	     } 
	}
	getch();
}

```

**输出**

请参见以下输出:

```
Enter a year to start searching the leap years: 1950
Enter a year to end the search of leap years: 2020
Leap years between 1990 to 2020 are:
1992
1996
2000
2004
2008
2012
2016
2020

```

* * *