# 求二次方程根的 c 程序

> 原文：<https://www.javatpoint.com/c-program-to-find-the-roots-of-quadratic-equation>

二次方程是二次多项式方程。表示为 **ax <sup>2</sup> + bx +c = 0** ，其中 a、b、c 为方程的系数变量。二次方程的普遍规律定义‘a’的值不能为零，用 x 的值求二次方程(a，b)的根。一个二次方程的根有三种定义:实与异、实与等、实与虚。

![C Program to find the roots of quadratic equation](img/4e5c50ae9cb17d7e9d56e052bed73fa5.png)

## 根的性质

根的性质取决于**判别式(D)** ，其中 D 为。

1.  如果 D > 0，根是真实的和不同的(不相等)
2.  如果 D = 0，则根是实的且相等的。
3.  如果 D < 0，则根是实根和虚根。

### 求二次方程平方根的步骤

1.  初始化二次方程中使用的所有变量。
2.  从用户处获取所有系数变量 x、y 和 z 的输入。
3.  然后，用公式求出二次方程的判别式:
    判别式= (y * y) - (4 * x *z)。
4.  根据二次方程判别式的性质计算根。
5.  如果判别式> 0，那么
    root 1 =(-y+sqrt(det))/(2 * x)
    root 2 =(-y+sqrt(det))/(2 * x)
    **打印出来的根都是真实且分明的。**
6.  否则如果(判别式= 0)，那么，
    Root1 = Root2 = -y / (2 * x)。
    **印刷体两个词根都是真实平等的。**
7.  Else(判别式< 0), the roots are distinct complex where,
    根的实部为:Root1 = Root2 = -y / (2 * x)或 real = -y / (2 * x)。
    根的虚部为:sqrt(-判别式)/ (2 * x)。
    **打印两个根都是虚数，其中第一个根是(r + i) img，第二个根是(r - i) img。**
8.  退出或终止程序。

### 二次方程的伪码

1.  开始
2.  输入系数变量 x、y 和 z。
3.  D
4.  R1
5.  R2
6.  打印根 R1 和 R2。
7.  停止

让我们在一个 C 程序中实现上面的步骤来寻找二次方程的根。

```

/* C Program to Find the Roots of the Quadratic Equation */
#include<stdio.h>
#include<math.h>  // it is used for math calculation
#include<conio.h>
void main()
{
	float x, y, z, det, root1, root2, real, img;
	printf("\n Enter the value of coefficient x, y and z: \n ");
	scanf("%f %f %f", &x, &y, &z);
	// define the quadratic formula of the nature of the root
	det = y * y - 4 * x * z;	
	// defines the conditions for real and different roots of the quadratic equation
	if (det > 0)
	{
	root1 = (-y + sqrt(det)) / (2 * x);
	root2 = (-y + sqrt(det)) / (2 * x);
	printf("\n Value of root1 = %.2f and value of root2 = %.2f", root1, root2);
	}
	// elseif condition defines both roots ( real and equal root) are equal in the quadratic equation
	else if (det == 0)
	{
		root1 = root2 = -y / (2 * x); // both roots are equal;
		printf("\n Value of root1 = %.2f and Value of root2 = %.2f", root1, root2);
	}
	// if det < 0, means both roots are real and imaginary in the quadratic equation.
	else {
		real = -y / (2 * x);
		img = sqrt(-det) / (2 * x);
		printf("\n value of root1 = %.2f + %.2fi and value of root2 = %.2f - %.2fi ", real, img, real, img);
	}
	getch();
	}

```

**输出:**

![C Program to find the roots of quadratic equation](img/089b0c29d5738d0adacdda6a25fb35d5.png)

让我们创建另一个使用函数的 C 程序。

```

#include<stdio.h>
#include<conio.h>
#include<stdlib.h>
#include<math.h>

// use function to check the nature of the roots in the quadratic equation
void R_Quadratic( int x, int y, int z)
{
	if (x == 0) // Checks the vakue of x, if x = 0, the equation is not quadratic equation.
	{
		printf(" The value of x cannot be zero");
		return;
	}
	int det = y * y - 4 * x * z;
	double sqrt_det = sqrt(abs (det));
	if (det > 0)
	{
	printf("\n Both roots are real and different \n ");
	printf("%.2f\n %.2f", (double) (-y + sqrt_det) / (2 * x), (double) (-y - sqrt_det) / (2 * x));
		}
else if (det == 0)
{
	printf("\n Both roots are real and same ");
	printf("%.2f", -(double)y / (2 * x));
}
else
{
	printf("\n Both roots are complex");
	printf("\n %.2f + %.2fi \n%.2f - %.2fi", -(double)y / (2 * x), sqrt_det, -(double)y / (2 * x), sqrt_det);

}
}
void main()
{
	int x, y, z; // declare variables x, y and z
	printf("\n Enter the value of coefficient x, y and z: ");
	scanf("%d %d %d", &x, &y, &z);
	R_Quadratic(x, y, z);  // call function R_Quadratic()
	getch();
}

```

**输出:**

![C Program to find the roots of quadratic equation](img/bbbd792443daf2514b2a1709a4db4d74.png)

* * *