# 如何在 Visual Studio 代码中运行一个 C 程序？

> 原文：<https://www.javatpoint.com/how-to-run-a-c-program-in-visual-studio-code>

visual studio 代码是一个轻量级软件应用程序，具有运行在桌面上的强大源代码编辑器。是微软为 [Windows](https://www.javatpoint.com/windows) 、Mac OS、 [Linux](https://www.javatpoint.com/linux-tutorial) 开发的免费源代码编辑器。是一款对 [C++](https://www.javatpoint.com/cpp-tutorial) 、C++、 [C](https://www.javatpoint.com/c-programming-language-tutorial) 、 [Java](https://www.javatpoint.com/java-tutorial) 、 [Python](https://www.javatpoint.com/python-tutorial) 、 [PHP](https://www.javatpoint.com/php-tutorial) 、 [Go](https://www.javatpoint.com/go-tutorial) 等多种语言都有丰富扩展的软件编辑器。和运行时语言扩展，如[。NET](https://www.javatpoint.com/net-framework) 和 Unity。编辑、构建、语法突出显示、代码片段、代码重构和调试都很容易。在 visual studio 代码中，我们可以更改应用程序的背景主题、在首选项上设置的键盘快捷键、安装扩展并添加附加功能。

## 在 Visual Studio 代码中运行 C 程序的先决条件

1.  我们应该对 C 编程有一个基本的了解。
2.  系统中必须安装 Visual Studio 代码编辑器。
3.  下载 C/C++ 扩展。它是微软提供的支持 visual studio 代码的扩展。它有助于 visual studio 中编程代码的智能感知、调试和代码浏览。
4.  下载 C/C++ 编译器。有一些流行的编译器是:
    1.  Linux 上的 GCC
    2.  在视窗系统上通过明威 w64 进行通信
    3.  windows 上的 Microsoft C++ 编译器
    4.  MacOS 上 XCode 的叮当声

我们已经在系统中安装了 Visual Studio 代码。VS 代码的用户界面如下所示:

![How to run a C program in Visual Studio Code](img/9db5faf9ca3440b7cecba5485a19da88.png)

### 下载并安装 C/C++ 扩展

1.我们需要点击扩展按钮，该按钮显示了一个边栏，用于在 visual studio 代码中下载和安装 C/C++ 扩展。在侧栏中，键入 **C 扩展**。

![How to run a C program in Visual Studio Code](img/5fe81d9d5fac26f9ebeb47fe388ae821.png)

2.之后，点击 **C/C++**

![How to run a C program in Visual Studio Code](img/85558964bdf2ef10d0e5d071e9d0a371.png)

在此图中，点击**安装**按钮安装 C/C++ 扩展。

3.单击“安装”按钮后，会显示下图。

![How to run a C program in Visual Studio Code](img/43436356587227bb7dc0bfa613968de1.png)

在这张图片中，我们可以看到它显示了**卸载**按钮，这意味着 **C/C++** 扩展已经在 visual studio 代码中成功下载。

在这张图片中，我们可以看到它显示了**卸载**按钮，这意味着 **C/C++** 扩展已经在 visual studio 代码中成功下载。

## 下载并安装编译器扩展

A **MinGW** 是一款用于编译执行代码的高级 GCC 编译软件。它是只支持窗口操作系统的软件。

## 下载 MinGW-w64 编译器

1.转到**https://sourceforge.net/projects/mingw**我们在下一页着陆。

![How to run a C program in Visual Studio Code](img/99867f2be28537b60d14e26cf5836779.png)

2.然后点击**下载**按钮，开始下载 **MinGW GCC 编译器**，如下图所示。

![How to run a C program in Visual Studio Code](img/a4b6f92969b224cc131a099e00cd0c4e.png)

3. **MinGW** 软件已成功下载至系统。

![How to run a C program in Visual Studio Code](img/a6c986efbcdcfe8c05ae841332bbfc7b.png)

4.现在我们双击 **MinGW** 设置安装编译器。

![How to run a C program in Visual Studio Code](img/ccd1148232ec4a8c55845bd0fc47e41d.png)

如我们所见，显示是有害文件点击**运行**按钮继续安装设置。

5.点击**安装**

![How to run a C program in Visual Studio Code](img/31f2a2d3be8c60a13c4c227195f59525.png)

6.设置默认值，或者我们可以更改设置的存储位置。之后，点击**继续**

![How to run a C program in Visual Studio Code](img/18e9f3c1e97eeaf724ffc73dec825987.png)

7.点击继续按钮后，显示 **MinGW** 安装管理器的第二步。

![How to run a C program in Visual Studio Code](img/b018488b21797a53a296b554510284ab.png)

8.当我们点击**继续**时，会显示下图。在 **MinGW 安装管理器**中，我们需要检查 **Mingw32 基包**和 **Ming32-gcc-g++ 包**才能在 visual studio 代码编辑器中运行和编译 C/ C++ 程序。

![How to run a C program in Visual Studio Code](img/d61ac8d1d2223745d4f4dfe8a68829de.png)

9.选中复选框后，点击**安装**选项卡(在对话框的左上角)。

![How to run a C program in Visual Studio Code](img/cfb945c89badda82cf0e3979de992d90.png)

在这里我们点击**应用更改**来设置软件包在 **MinGW** 的安装，如下所示。

![How to run a C program in Visual Studio Code](img/8bf16d482235d73f8c959c51150fd548.png)

10.点击应用按钮后，显示如下图。

![How to run a C program in Visual Studio Code](img/e3b0ddd105da13eeb7ba36853f573bf5.png)

11.下载软件包后，它显示了软件包的安装过程，如下所示。

![How to run a C program in Visual Studio Code](img/46552794aa37b131ffdf2e799975f814.png)

在这里我们可以看到所有的更改已经成功应用，然后点击**关闭**按钮。

## 为 MinGW 设置设置环境路径

下载并安装 MinGW 编译器后，我们现在将环境路径设置为包含 C/C++ 编译器目录。

1.转到 **MinGW** 设置的安装目录。这里我们在 c 盘安装了设置，如下所示。

![How to run a C program in Visual Studio Code](img/da89edabac40104c76e691413fc8c5d7.png)

2.双击 MinGW 文件夹。它显示了下图。

![How to run a C program in Visual Studio Code](img/c332a9ec1cd768708d567ee5947fdea0.png)

3.然后点击 **bin** 文件夹，复制目录路径，如下图。

![How to run a C program in Visual Studio Code](img/4cefdf84f3f2e916bc275a4975ab66e9.png)

这里是 MinGW 文件夹路径的路径: **C:\MinGW\bin**

4.复制目录路径后，转到这台电脑->右键点击这台电脑->选择/点击**属性**。它显示了下图。

![How to run a C program in Visual Studio Code](img/c8c41aa5f27a6dd85b5c2ae3a01b0d46.png)

5.之后，点击**高级系统设置**显示系统属性弹出框，如下图。

![How to run a C program in Visual Studio Code](img/3fd4a4cdd1fccfdee74f38bc49215081.png)

6.点击**环境变量**设置目录路径，如下图。

![How to run a C program in Visual Studio Code](img/7f1a51ed716e24b42186e1b0ebb40786.png)

首先我们要点击**系统变量路径**，然后点击**编辑**按钮，如上图所示。

7.当我们点击编辑按钮时，它会显示一个弹出窗口来设置新的路径，如下所示。

在上图中，首先点击**新建**按钮，然后粘贴 **C:\MinGW\bin** 路径；之后，点击**确定**按钮。

![How to run a C program in Visual Studio Code](img/6d8b4d3e39d14ed448f7cd0f05abfb23.png)

8.同样，点击**确定**按钮到环境变量和系统属性。

9.如果要检查系统中 **MinGW** 是否安装成功:进入**命令提示符**或 **cmd，**写**gcc-版本**，按**进入**

![How to run a C program in Visual Studio Code](img/c1c92ad4ff67bead342ba6817425d483.png)

## 在 Visual Studio 代码编辑器中开始编码

1.这里我们创建了一个 **C 程序**文件夹来存储所有的程序代码。我们可以在任何目录下创建任何名称的文件夹。

![How to run a C program in Visual Studio Code](img/4da1b842d989c6bfadce31cb4b743979.png)

2.进入 VS 代码，点击**添加文件夹**。

![How to run a C program in Visual Studio Code](img/fd87a904158ac5eb739d14464754f262.png)

3.当我们点击添加文件夹时，它会显示一个弹出对话框来选择存储程序的文件夹。

![How to run a C program in Visual Studio Code](img/d9bfdd557829a8c4d03f8585c4ad51f1.png)

4.选择文件夹后，点击**添加**所选文件夹出现在浏览器部分，如下图所示。

![How to run a C program in Visual Studio Code](img/9cca157391de5519754eedbf5c6a167f.png)

5.将鼠标移到 **C 程序**文件夹上；显示一个 **+** 点击按钮，文件名写为**JavaPoint . c**，如下图。

![How to run a C program in Visual Studio Code](img/11c64cda3be4a04fb2e9fe5fbfbb8f17.png)

现在在 VS 代码编辑器中编写并理解简单的 C 编程。

**JavaTpoint.c**

```

#include // define the header file
void main()   // define the main function
{
    printf("Welcome to JavaTpoint");  // print the statement.
} 
```

![How to run a C program in Visual Studio Code](img/c1526bf1af88559a3a867fbccb4ab4f6.png)

编写完代码后，右键单击程序，如下所示。

![How to run a C program in Visual Studio Code](img/25812fd33152b6efab3f08050c3bc2de.png)

点击**运行代码**选项或按下按钮中的 **Ctrl + Alt + N** 。它显示了以下输出。

```

Welcome to JavaTpoint

```

让我们编写一个程序，在 VS Code 编辑器中计算矩形的面积和周长。

**矩形 c**

```

#include // header files
#include <conio.h>void main()
{   // initialize the local variables.
    int l =5, b=10, ar, pr;
    printf("Length & Breadth of the rectangle is: %d & %d",l, b);
    ar = l * b; // calculate area of rectangle.
    pr = 2 * (l + b); // calculate perimeter of rectangle.
    printf("\n Area of Rectangle is: %d", ar);
    printf("\n Perimeter of Rectangle is: %d", pr);  
}</conio.h> 
```

我们可以点击**运行**按钮或者从键盘上按下 **Ctrl + Alt + N** 。它显示以下输出。

![How to run a C program in Visual Studio Code](img/147a5dc69e465a387ee21c8be7d0749b.png)

让我们编写另一个 C 程序，在 Visual Studio 代码编辑器中接受用户的输入。

**矩形 2.c**

```

#include int main()
{   // initialize the local variables.
    int l, b, ar, pr;
    printf("Enter the length of the rectangle");
    scanf("%d", l); // take input from the user
    printf("Enter the breadth of the rectangle");
    scanf("%d", b); 
    ar = l * b; // calculate the area of rectangle.
    pr = 2 * (l + b); // calculate the perimeter of rectangle.
    printf("\n Area of Rectangle is: %d", ar);
    printf("\n Perimeter of Rectangle is: %d", pr);  
} 
```

当我们点击**运行**按钮或按下 **Ctrl + Alt + N** 时，显示如下输出。

在上面的程序中，我们把长度和宽度作为键盘的输入。当程序被编译时，它产生下面的语句。

![How to run a C program in Visual Studio Code](img/6f12cbe2ea5be769018be9db6fe83829.png)

这里**输出**标签是只读的，因此我们不能接受用户的任何输入。因此，我们需要在代码编辑器中添加一些步骤，以便从控制台/用户获取用户输入。

以下是接受用户输入的步骤。

1.  首先，我们需要通过从键盘上按下 **Alt + Ctrl + M** 来停止后台运行 **c** 程序。
2.  停止 C 文件后，转到并点击 Visual Studio 代码编辑器左上角的**文件**按钮，通过**首选项**选择**设置**，如下图所示。
    ![How to run a C program in Visual Studio Code](img/0d1c9428bdc5bcc061f87e2d71368c21.png)
3.  点击**设置**后，显示下图。
    ![How to run a C program in Visual Studio Code](img/f050f50873326e76162ca55307f3572e.png)
    在此图中，选择**扩展**按钮来设置 C 编译器的设置。
4.  点击扩展按钮，滚动下拉框选择**运行代码配置**。
    T3】
5.  现在滚动右侧窗格，在**运行终端上打勾。**
    ![How to run a C program in Visual Studio Code](img/869f0de40d989c29b526b90618b5f524.png)
6.  转到 **c** ，点击**运行**再次执行程序，产生如下结果，如下图所示。
    ![How to run a C program in Visual Studio Code](img/8f6a528b61f78483c0668545bbb4e8ce.png)

* * *