# C 语言中 while 循环和 do-while 循环的区别？

> 原文：<https://www.javatpoint.com/while-loop-vs-do-while-loop-in-c>

在本文中，我们学习了 C 语言中 while 循环和 do-while 循环结构之间的比较。在本文的开始，我们了解了 C 语言中 while 循环和 do-while 循环的概念，之后，我们学习了 C 语言编程中 while 和 do-while 循环的比较。

![while loop vs do-while loop in C](img/c2d210fc94a7b5befc8d63544b9aced3.png)

## While 循环语句:

[While 循环语句](https://www.javatpoint.com/while-loop-in-c)是 [C 编程语言](https://www.javatpoint.com/c-programming-language-tutorial)中最简单、使用最广泛的循环构造之一。

在此语句中，虽然它是保留字或关键字，但条件可以是任何常量、变量、表达式，语句可以是单个语句或一组语句。在 while 循环中，我们必须执行三个步骤:

*   初始化
*   试验条件
*   增量和减量

**初始值:**在 while 循环中，第一步是初始化，用于设置循环计数器的初始值。循环计数器可以是 while 循环中的增量计数器或减量计数器。

**例如:**I = 1；

**测试条件:**初始化步骤后，while 循环的下一步是检查测试条件是否执行循环。如果 while 循环中的条件为真，则执行循环的主体；否则，没有循环执行。

**例如:**而(i < =10)

**递增和递减:**在 while 循环中检查测试条件后，递增和递减用于递增和递减循环计数器的值。

**例如:**I = I+1；

### while 循环的语法:

```

Initialization;
while (condition)
{
Block of statements;
}
Statement-x;

```

在 while 循环语句中，while 关键字被使用，后面跟有任何需要测试的良好条件，这些条件包含在括号中，并且它可以包含任何逻辑运算符。条件后面是一对花括号，指定条件为真时要执行的语句集。

### 示例:

```

#include #include <conio.h>Void main ()
{
int i;
clrscr();
i = 1;
while (i<=10)
{
print ("hello");
i = i + 1;
}
getch();
}</conio.h> 
```

### while 循环语句的流程图:

![while loop vs do-while loop in C](img/ea1a804192b436c22c95ad892876a9a1.png)

## do-while 循环语句:

在 C 编程语言中， [do-while 循环语句](https://www.javatpoint.com/do-while-loop-in-c)也类似于 C 编程语言中的 while 循环。在这种情况下，首先执行循环体，然后检查条件。在边做边循环中，我们必须执行三个步骤:

*   初始化
*   试验条件
*   增量和减量

**初始值:**在 do-while 循环中，第一步是初始化，用于设置循环计数器的初始值。循环计数器可以是增量计数器或减量计数器。

**例如:**I = 1；

**测试条件:**初始化步骤后，边做边循环的下一步是检查测试条件是否执行循环。

**例如:**而(I<= 10)；

**递增和递减:**在边做边循环中检查测试条件后，下一步是递增和递减循环计数器的值。

**例如:**I = I+1；

### 边做边循环的语法:

```

do
{
Statements;
}
while (condition);
Statement-x;

```

这里，do-while 循环语句使用了两个关键字:do 和 while。如果条件在 do-while 循环中为真，语句将再次执行，如果条件返回 false，执行将停止，控制将传递给下一条语句。

### 示例:

```

#include #include <conio.h>Void main ()
{
int i;
clrscr();
i = 1;
do
{
printf("hello");
i = i + 1;
}
while(i<=10);
getch();
}</conio.h> 
```

### 边做边循环语句的流程图:

![while loop vs do-while loop in C](img/0276a749ad6007865b19ae57e82fb6f6.png)

## C 语言中的 while 循环与 do-while 循环

让我们来看看 C 语言中 while 循环和 do-while 循环之间的一些比较

| SR.NO | while 循环 | 边做边循环 |
| 1. | 虽然循环是入口控制循环，因为首先检查条件，然后执行循环的主体。 | do-while 循环是一个退出控制循环，因为在这种情况下，首先执行循环的主体，然后检查条件是真还是假。 |
| 2. | while 循环的语句可能根本不会执行。 | do-while 循环的语句必须至少执行一次。 |
| 3. | 当条件变为假时，while 循环终止。 | 只要条件为真，编译器就会在 do-while 循环中继续执行循环。 |
| 4. | 在 while 循环中，必须首先初始化测试条件变量，以检查循环中的测试条件。 | 在边做边循环中，循环中测试条件的变量也被初始化。 |
| 5. | 在 while 循环中，在条件的末尾，没有分号。
**语法:**

```
while (condition)
```

 | 在这个条件的末尾，有一个分号。
**语法:**

```
while (condition);
```

 |
| 6. | 而循环不用于创建菜单驱动的程序。 | 它主要用于创建菜单驱动的程序，因为至少有一次；无论条件为真或假，都将执行循环。 |
| 7. | 在 while 循环中，执行次数取决于 while 块中定义的条件。 | 在 do-while 循环中，不管提到的条件如何，最少执行 1 次。 |
| 8. | **while 循环的语法:**

```
while (condition)
{
Block of statements;
}
Statement-x;
```

 | **边做边循环的语法:**

```
do
{
statements;
}
while (condition);
Statement-x;
```

 |
| 9. | **while 循环的程序:**

```
Program of while loop:

#include 
#include <conio.h>
Void main()
{
int i;
clrscr();
i = 1;
while(i<=10)
{
printf("hello");
i = i + 1;
}
getch();
}</conio.h>
```

 | **边做边循环程序:**

```
#include 
#include <conio.h>
Void main()
{
int i;
clrscr();
i = 1;
do
{
printf("hello");
i = i + 1;
}
while(i<=10);
getch();
}</conio.h>
```

 |
| 10. | **while 循环流程图:**
![while loop vs do-while loop in C](img/ea1a804192b436c22c95ad892876a9a1.png) | **边做边循环流程图:**
![while loop vs do-while loop in C](img/0276a749ad6007865b19ae57e82fb6f6.png) |

* * *