# C 语言中的平衡括号

> 原文：<https://www.javatpoint.com/balanced-parenthesis-in-c>

在这个主题中，我们将学习如何检查 c 语言中的平衡括号。首先，我们将看到什么是括号。括号由下面显示的括号表示:

```
( )
Where, (   →	Opening bracket
             )     →    Closing bracket

```

这些圆括号用来表示数学表示。平衡括号意味着当左括号等于右括号时，它就是一个平衡括号。

**我们通过例子来了解一下。**

**例 1: ( 2+5 ) * 4**

在上面的表达式中，有一个左括号和一个右括号意味着左括号和右括号相等；因此，上面的表达式是一个平衡的括号。

**例 2:2 *(4/2)+5)**

上面的表达式有两个左括号和两个右括号，这意味着上面的表达式是一个平衡括号。

**例 3:2 *(4/2)+5**

上面的表达式有两个左括号和一个右括号，这意味着左括号和右括号不相等；因此，上述表述是不平衡的。

**检查平衡括号的算法**

现在，我们将使用一个变量来检查平衡括号。该变量用于确定平衡系数。让我们考虑变量“x”。检查平衡括号的算法如下:

**第一步:**将 x 设置为 0。

**第二步:**从左到右扫描表情。

对于每个左括号“(”，将 x 增加 1。

对于每一个右括号“)”，将 x 减 1。

此步骤将继续扫描，直到 x<0。

**步骤 3:** 如果 x 等于 0，那么

“表情很平衡。”

其他

“表情不平衡。”

**我们通过一个例子来了解一下上面的算法。**

假设表达式为 2 * ( 6 + 5)

![Balanced Parenthesis in C](img/68537c288bfb0564ba389acc14f2cded.png)

解决方法:首先，用 0 初始化 x 变量。扫描从变量“2”开始，当它遇到“(”时，“x”变量递增 1，当 x 到达表达式的最后一个符号，即“)”时，“x”变量递减 1，它的最终值变为 0。我们在上面的算法中了解到，如果 x 等于 0，则表示表达式是平衡的；因此，上面的表达式是一个平衡表达式。

C 语言中的实现

```
// C program  to check the balanced parenthesis.
#include int main()
{
    char expression[50]; // declaration of char type array
    int x=0, i=0; // declaration of two integer type variables
    printf("\nEnter an expression");
    scanf("%s", expression);
// Scanning the expression until we reach the end of the expression.   
 while(expression[i]!= '\0')
    {
    // Condition to check the symbol is '('   
     if(expression[i]=='(')
        {
            x++;    // incrementing 'x' variable 
        }
     // condition to check the symbol is ')'   
     else if(expression[i]==')')
        {
            x--;   // decrementing 'x' variable
            if(x<0)
            break;
        }
    i++;       // incrementing 'i' variable.
    }
    // Condition to check whether x is equal to 0 or not.
    if(x==0)
    {
        printf("Expression is balanced");
    }

    else
    {
        printf("Expression is unbalanced");
    }
    return 0;
} 
```

输出

![Balanced Parenthesis in C](img/800abd3cfef28ce3cf987be7ba6316dd.png)

* * *