# C 编程语言中的流程图

> 原文：<https://www.javatpoint.com/flowchart-in-c-programming-language>

在本文中，我们将借助各种示例了解如何用 C 编程语言创建流程图。

![flowchart in C](img/0377fd9cc9158af0b991b1e02c727c90.png)

## 你说的流程图是什么意思？

流程图是算法和程序设计工作流最广泛使用的图形表示。它使用各种符号来表示程序中要遵循的操作和决策。它按顺序流动。

## 流程图的类型

下面给出了流程图的各种类型。

*   水平流程图
*   全景流程图
*   垂直流程图
*   架构流程图

## 流程的规则或指南

## 图表:

绘制流程图的各种规则或指南

如下所示。

*   只能使用传统的流程图符号。
*   流程图中名称和变量的正确使用。
*   如果流程图变得又大又复杂，请使用连接器符号。
*   流程图应该有起点和终点。

## 流程图符号:

不同的流程图符号具有不同的常规含义。

**流程图设计中使用的各种符号如下。**

*   **终点符号:**在流程图中，用圆圈表示起点和终点符号。下面给出的符号用于表示终端符号。
    T3】
*   **输入/输出符号:**输入符号用于表示输入数据，输出符号用于显示输出操作。下面给出的符号用于表示输入/输出符号。
    T3】
*   **处理符号:**在流程图中借助矩形框表示，用于表示算术和数据移动指令。下面给出的符号用于表示处理符号。
    T3】
*   **决策符号:**菱形符号用于表示决策语句。下面给出的符号用于表示决策符号。
    T3】
*   **连接器符号:**如果流量在某个点中断，在另一个点继续，则使用连接器符号。以下符号是连接器符号的表示。
    T3】
*   **流程线:**表示指令执行的确切顺序。箭头用于表示流程图中的流程线。下面给出的符号用于表示流线:
    ![flowchart in C](img/2bd5fc0f3ab63a9b1664041802adfaa4.png)
*   **六边形符号(平面):**用于创建包含循环设置语句的准备框。下面给出的符号用于表示六边形符号。
    T3】
*   **页面上的参考符号:**该符号内部包含一个字母，表示流程在匹配的符号上继续，该符号在同一页面的其他地方包含相同的字母。下面给出的符号用于表示页面上的参考符号。
    T3】
*   **离页引用:**该符号内部包含一个字母，表示流程在匹配的符号上继续，该符号在不同页面的其他地方包含相同的字母。下面给出的符号用于表示离页参考符号。
    T3】
*   **延迟或瓶颈:**该符号用于识别流程图中的延迟。延迟的替代名称是瓶颈。下面给出的符号用于表示延迟或瓶颈符号。
    T3】
*   **文件符号:**该符号在流程图中用于表示文件或报告。下面给出的符号用于表示文件符号。
    T3】
*   **内部存储符号:**下面给出的符号用于表示内部存储符号。
    T3】

## 流程图的优点:

**流程图的各种优点如下:**

*   **沟通:**流程图是沟通程序逻辑的更好方式。
*   **综合:**流程图作为设计新程序和软件系统的工作模型。
*   **高效编码:**流程图是程序员用高级语言编写实际代码的指南。
*   **正确调试:**流程图有助于调试过程。
*   **有效分析:**借助相关流程图，可以轻松完成逻辑程序的有效分析。
*   **适当的文档:**流程图提供更好和适当的文档。它包括各种活动，如收集、组织、存储和维护所有相关的程序记录。
*   **测试:**流程图有助于测试过程。
*   **高效的程序维护:**借助流程图，程序的维护变得容易。

## 流程图的缺点:

**流程图的各种缺点如下:**

*   **耗时:**设计**一个**流程图是一个非常耗时的过程。
*   **复杂:**对于大型复杂的程序，绘制流程图并不容易。
*   **流程图中没有标准**；没有标准来确定细节的数量。
*   **修改困难:**修改现有流程图非常困难。

## 流程图示例:

流程图的各种示例如下:

### 例 1:

设计一个流程图，将用户输入的两个数字相加。

![flowchart in C](img/e95574eca584f3eca4d5c227036a5b2d.png)

### 例 2:

设计一个流程图，找出用户输入的三个数字中最大的一个。

![flowchart in C](img/49d7dfc78087e30b577ae15bf6012f5a.png)

### 例 3:

根据用户输入的数值设计一个计算损益的流程图。

![flowchart in C](img/134c24f8fbac845a70ca98db9f574e12.png)

### 例 4:

画一个流程图来计算两个数字的平均值。

![flowchart in C](img/8046e4809a5b32228a365194f9299bb4.png)

### 例 5:

设计一个用户输入的三个数相乘的流程图。

![flowchart in C](img/7dbfcc0cfaa0714fd30a8cd1a50c9937.png)

### 示例 6:

设计一个计算矩形面积的流程图。

![flowchart in C](img/a34dbaf63b1f3c2c41082db2127a4b10.png)

### 例 7:

根据用户输入的值，设计一个计算简单利息的流程图。

![flowchart in C](img/8d3317ddf33b495200d0cb89c4f9901a.png)

### 例 8:

设计一个流程图，根据用户输入的数字检查数字是正数还是负数。

![flowchart in C](img/532df51d14a4a098c78a810ec78bb64f.png)

* * *