# 弗洛伊德的 C 中三角形

> 原文：<https://www.javatpoint.com/floyds-triangle-in-c>

弗洛伊德三角形是一个包含连续自然数的直角三角形。在弗洛伊德的三角形中，数字从左上角的 1 开始，然后通过数字连续填充定义的行。

例如:假设我们在弗洛伊德的三角形中定义了 5 行，它会以递增的顺序生成以下模式:

```

1
2 3
4 5 6
7 8 9 10
11 12 13 14 15

```

### 算法

1.  创建将行和列值保存为 I 和 j 的变量。取一个数字将行显示为 num，并将变量 k 设置为 1as 作为初始值。
2.  对循环使用嵌套:
    *   Outer for 循环开始迭代 i = 1 到 n 行。
    *   内部 for 循环从 j = 1 到(j <=i)开始迭代。
3.  打印 k 的值。
4.  将 k 增加 1 或 k = k + 1。
5.  每次迭代内部 for 循环后跳转到换行符。
6.  停止

现在我们用 C 语言编写几个用于循环的弗洛伊德三角形程序。

### 使用 for 循环打印弗洛伊德三角形的程序

让我们考虑一个例子来打印弗洛伊德的三角形，用于 c 中的循环。

**弗洛伊德。c**

```

#include <stdio.h>
#include <conio.h>
void main()
{
	int num, i, j, k = 1; 

	printf( " Enter a number to define the rows in Floyd's triangle: \n");
	scanf( "%d", &num);
	// use nested for loop
	// outer for loop define the rows and check rows condition
	for (i = 1; i <= num; i++)
	{
		// inner loop check j should be less than equal to 1 and print the data.
		for (j = 1; j <= i; j++)
		{
			printf(" %2d", k++); // print the number
		}
		printf( "\n");
		}   
		getch(); 
}

```

**输出**

```
Enter a number to define the rows in Floyd's triangle:
6
  1
  2  3
  4  5  6
  7  8  9 10
 11 12 13 14 15
 16 17 18 19 20 21

```

**2<sup>2</sup>程序执行时间:**

```
Enter a number to define the rows in Floyd's triangle:
5
  1
  2  3
  4  5  6
  7  8  9 10
 11 12 13 14 15

```

在上面的程序中，我们已经使用嵌套 for 循环打印了弗洛伊德的三角形。外部循环用于定义行，内部循环用于表示弗洛伊德三角形的列。其中外部循环从(i = 1)到三角形的第 n 行开始执行。内部循环从(j = 1)开始执行，并且将小于等于 I。在这个循环中，我们使用了由 1 赋值的 k 变量，并打印了由 1 递增的值。

### 使用 while 循环打印弗洛伊德三角形的程序

让我们考虑一个在 c 语言中使用 while 循环打印弗洛伊德三角形的例子。

**program.c**

```

#include <stdio.h>
#include <conio.h>
void main()
{
	int num, temp = 1, temp1 = 1, k; 

	printf( " Enter a number to define the rows in Floyd's triangle: \n");
	scanf( "%d", &num);

	while(temp1 <= num)
	{
		k = 1;

		// inner loop check k should be less than equal to temp1 
		while (k <= temp1)
		{
			printf(" %2d", temp); // print the number
			temp++;
			k++;
		}
		temp1++;
		printf( "\n");
		}   
		getch(); 
}

```

**输出**

```
Enter a number to define the rows in Floyd's triangle:
6
  1
  2  3
  4  5  6
  7  8  9 10
 11 12 13 14 15
 16 17 18 19 20 21

```

### 使用递归函数打印弗洛伊德三角形的程序

让我们考虑一个用递归函数打印 C 语言中弗洛伊德三角形的程序。

**递归**

```

#include <stdio.h>
// declaration of global variables
int row = 1;
int k = 1;
int main()
{
	int num; // declare the variable
	printf( " Enter a number to define the rows in Floyd's triangle: \n");
	scanf (" %d", &num);
	Floyd_triangle( num); // call the Floyd_triangle function
	return 0;		
}

void Floyd_triangle (int num) // function definition
{
	int i;
	if (num <= 0) // if num should be less than 0, it returns return.
		return;

	// use for loop to define the rows
	for ( i = 1; i <= row; i++)

		printf( " %d", k++);

		printf ("\n");
		row++; // increment row by 1.
		Floyd_triangle (num - 1);
}

```

**输出**

```
Enter a number to define the rows in Floyd's triangle:
6
 1
 2 3
 4 5 6
 7 8 9 10
 11 12 13 14 15
 16 17 18 19 20 21

```

### 使用 for 循环反转弗洛伊德三角形的程序

让我们考虑一个程序来打印 C 中的反向弗洛伊德三角形，用于循环。

**倒档**

```

#include <stdio.h>
int main()
{
	int num, i, j; // declare the variables
	printf ("Enter a number to define the rows in Floyd's triangle: \n");
	scanf (" %d", & num); 

	// initialize k and define the formula to get the reverse Floyd's triangle number
	int k = num * ( num + 1) / 2;

	// outer loop 
	for (i = num; i >= 0; i--)
	{
		// inner loop check the i condition 
		for (j = 1; j <= i; j++)
		{
			// print the decremented value of k by 1.
			printf (" %d", k--); /* at each iteration the value of k is decrement by 1\. */
		}
		printf ("\n");
	}
	return 0;
	}

```

**输出**

```
Enter a number to define the rows in Floyd's triangle:
6
 21 20 19 18 17 16
 15 14 13 12 11
 10 9 8 7
 6 5 4
 3 2
 1

```

### 用于循环打印星形弗洛伊德三角形的程序

让我们考虑一个例子来打印弗洛伊德的三角形，用于 c 中的循环。

**程序 2.c**

```

#include <stdio.h>
#include <conio.h>
void main()
{
	int num, i, j, k = 1; 

	printf( " Enter a number to define the rows in Floyd's triangle: \n");
	scanf( "%d", &num);
	// use nested for loop
	// outer for loop define the rows and check rows condition
	for (i = 1; i <= num; i++)
	{
		// inner loop check j should be less than equal to 1 and print the data.
		for (j = 1; j <= i; j++)
		{
			printf(" *"); // print the star

		}
		printf( "\n");
		}   
		getch(); 
}

```

**输出**

```
Enter a number to define the rows in Floyd's triangle:
6
 *
 * *
 * * *
 * * * *
 * * * * *
 * * * * * *

```

### 用循环打印字母弗洛伊德三角形的程序

让我们考虑一个例子来打印弗洛伊德的三角形，用于 c 中的循环。

**程序 5.c**

```

#include <stdio.h>
#include <conio.h>
void main()
{
	int num, i, j, k = 'A'; 

	printf( " Enter a number to define the rows in Floyd's triangle: \n");
	scanf( "%d", &num);
	// use nested for loop
	// outer for loop define the rows and check rows condition
	for (i = 1; i <= num; i++)
	{
		// inner loop check j should be less than equal to 1 and print the data.
		for (j = 1; j <= i; j++)
		{
			printf(" %c", k); // print the Alphabets
			k++;
		}
		printf( "\n");
		}   
		getch(); 
}

```

**输出**

```
Enter a number to define the rows in Floyd's triangle:
6
 A
 B C
 D E F
 G H I J
 K L M N O
 P Q R S T U

```

* * *