# C 中的 abs()功能

> 原文：<https://www.javatpoint.com/abs-function-in-c>

在本主题中，我们将讨论 C 编程语言中的 abs 函数。abs()函数是 stdlib.h 头文件中的预定义函数，用于返回给定整数的绝对值。所以，如果要返回给定数字的绝对值，需要在 C 程序中实现 **stdlib.h** 头文件。abs()函数只返回正数。例如:假设我们有一个整数-5，我们想要得到绝对数字，我们使用 abs()函数将正数返回为 5。此外，如果我们传递任何正数，它将返回相同的数字。

![abs() function in C](img/594c22e49f7432c3141f1c6a754abf82.png)

**语法**

```

int abs (int x);

```

在上面的语法中，x 是一个整数数据类型，它保存负数或正数，并在 abs()函数中传递以返回正值，因为该函数具有整数数据类型。

#### 注意:abs()函数总是返回一个正数，即使给定的数字是负数或正数。

### 使用 abs()函数获取一个数的绝对值的程序

让我们考虑一个在 C 程序中使用 abs()函数打印绝对数字的例子。

**Prog.c**

```

#include #include <stdlib.h>// use stdlib.h header file to use abs() function.

int main()
{
	int num, n; // declare the local variable
	printf (" Enter a number to display the absolute value: ");
	scanf ("%d", &num);

        /* define the abs() function to convert the given number into the absolute value. */
	n = abs (num);

	printf ("\n The absolute value of %d is %d. ", num, n);
	return 0;
}</stdlib.h> 
```

**输出**

```
Enter a number to display the absolute value: -35

 The absolute value of -35 is 35.

```

### 使用 abs()函数打印给定整数绝对值的程序

让我们创建一个程序，使用 c 语言中的 abs()函数打印给定数字的绝对值。

**绝对值**

```

#include #include <stdlib.h>// use stdlib.h header file to use abs() function.
#include <math.h>int main()
{ 
	printf (" The absolute value of 27 is %d ", abs (27)); 
	printf (" \n The absolute value of -16 is %d ", abs (-16));
	printf (" \n The absolute value of -125 is %d ", abs (-125));

	printf (" \n The absolute value of 18 is %d ", abs (18));
	printf (" \n The absolute value of -29 is %d ", abs (-29));
	printf (" \n The absolute value of 0 is %d ", abs (0));

	return 0;
}</math.h></stdlib.h> 
```

**输出**

```
The absolute value of 27 is 27
 The absolute value of -16 is 16
 The absolute value of -125 is 125
 The absolute value of 18 is 18
 The absolute value of -29 is 29
 The absolute value of 0 is 0

```

### 使用 for 循环打印两个整数之间的绝对值的程序

让我们考虑一个在 C 程序中使用[进行循环打印两个整数之间的绝对值的例子。](https://www.javatpoint.com/for-loop-in-c)

**Abs2.c**

```

#include <stdio.h>
#include <stdlib.h>  
#include <math.h>
int main()
{	
	int i, num, last;
	printf (" Enter the first number: \n ");
	scanf (" %d", &num); 

	printf ("\n Enter the last number from which you want to get the absolute number: ");
	scanf (" %d", &last); 

	// use for loop to print the absolute number
	for (i = num; i <= last; i++)
	{
		// abs() function convert a negative number to positive number
		printf( "\n The absolute value of %d is %d. ", i, abs( i));
	}

	return 0;
}

```

**输出**

```
Enter the first negative number:
 -5
 Enter the last number from which you want to get the absolute number:
 5

 The absolute value of -5 is 5.
 The absolute value of -4 is 4.
 The absolute value of -3 is 3.
 The absolute value of -2 is 2.
 The absolute value of -1 is 1.
 The absolute value of 0 is 0.
 The absolute value of 1 is 1.
 The absolute value of 2 is 2.
 The absolute value of 3 is 3.
 The absolute value of 4 is 4.
 The absolute value of 5 is 5.

```

### 不使用 abs()函数获取绝对值的程序

让我们创建一个 C 程序来获取一个数字的绝对值，而不使用 abs()函数。

**防抱死制动系统**

```

#include <stdio.h>
#include <stdlib.h>  // use stdlib.h header file to use abs() function.

int getAbsolute (int num) 
{
	/* if the passed value (num) is less than 0 (zero), 
	the number multiplied by (-1) to return an absolute value. */
	if (num < 0)
	{
		num = ( -1 ) * num; // given negative number multiplied by (-1)
		printf (" The absolute value is: %d", num);
	}
	else
	{

		printf (" The absolute value is: %d", num);
	}
	return num;
}

int main()
{
	int num;
	printf (" Enter a number to display the absolute value: ");
	scanf ("%d", &num);

	// call the functon
	getAbsolute(num);
	return 0;
}

```

**输出**

```
Enter a number to display the absolute value: -8
 The absolute value is: 8

```

正如我们在上面的程序中看到的，我们已经从用户那里传递了一个整数。如果给定的数字是负数，将乘以(-1)返回正数。如果这个数字是正数，它会返回相同的数字。

* * *