# C 语言中的 sprintf()

> 原文：<https://www.javatpoint.com/sprintf-in-c>

sprintf 代表“字符串打印”。在 [C 编程语言](https://www.javatpoint.com/c-programming-language-tutorial)中，它是一个文件处理函数，用于向字符串发送格式化输出。函数不是在控制台上打印，而是将输出存储在 sprintf 中指定的字符缓冲区上。

### 句法

```

int sprintf(char *str, const char *format, ...)

```

### 参数值

sprintf()函数接受如下定义的一些参数值

**str:** 它是指向存储结果字符串的字符元素数组的指针。它是存放数据的缓冲区。

**格式:**是 [C 字符串](https://www.javatpoint.com/c-strings)用于描述输出以及要插入格式化字符串中的整数参数的占位符。它是指包含要写入缓冲区的文本的字符串。它由字符以及以%开头的可选格式说明符组成。

现在，让我们看一些在 c 语言中使用 sprintf()函数的例子。

### 示例 1

这是一个简单的例子，演示了 sprintf()函数在 c 语言中的使用。这里，我们使用了 sprintf()函数的多个参数。

```

#include <stdio.h>
int main()
{
    char buffer[50];
    int a = 15, b = 25, res;
    res = a + b;
    sprintf(buffer, "The Sum of %d and %d is %d", a, b, res);
    printf("%s", buffer);
    return 0;
}

```

**输出:**

```
The Sum of 15 and 25 is 40

```

### 示例 2

这是在 c 语言中演示 sprintf()函数的另一个简单例子。在这个例子中，有一个浮点数类型的变量 num。函数的作用是:将 num 变量的数据转换成字符串，得到的字符串将存储在缓冲区中。

```

#include int main() {
  float num = 9.9;
  printf("Before using sprintf(), data is float type: %f\n", num);
  char buffer[50]; //for storing the converted string
  sprintf(buffer, "%f", num);
  printf("After using sprintf() data is string type: %s", buffer);
} 
```

**输出:**

```
Before using sprintf(), data is float type: 9.900000
After using sprintf() data is string type: 9.900000

```

### 示例 3

这是在 c 语言中使用 sprintf()函数的另一个例子。

```

#include #include <math.h>int main () {
   char buffer[20];
   sprintf(buffer, "Value of Pi = %f", M_PI);
   printf("%s", buffer);
   return(0);
}</math.h> 
```

**输出:**

```
Value of Pi = 3.141593

```

* * *