# 将 24 小时时间转换为 12 小时时间的程序

> 原文：<https://www.javatpoint.com/c-program-to-convert-24-hour-time-to-12-hour-time>

在本教程中，我们将编写一个程序，将 24 小时格式的给定时间转换为 12 小时格式。

时间将以- **小时:分:秒**的格式给出

**例如-**

**输入:** 20:35:20

**输出:**晚上 8:35:20

**输入:** 00:15:40

**输出:**上午 12:15:40

## 算法

24 小时制的午夜是 00:00:00，12 小时制的午夜是 12:00:00。现在我们需要观察两个观测值中的分和秒是相同的。只有当子午线发生变化时，小时数才会发生变化。

为了检查小时，我们首先将输入的小时字符串转换为整数。在把它变成整数后，我们会用 12 对小时取模，这将是 12 小时的格式。

小时中有 00 的情况将作为单独的情况计算。

## c 代码实现

```

#include #include <string.h>void convert12(char* str) // Take the time array
{
    int h1 = (int)str[0] - '0'; // Get the first digit of hour in 24 hour format
    int h2 = (int)str[1] - '0'; // Get the second digit of hour in 24 hour format
    int hh = h1 * 10 + h2; // Caluclate hour as an integer value
    char Meridien[2]; // Make the AM or PM array
    if (hh < 12) { // If the time is less than 12 hour it is AM
        Meridien[0] = 'A';
        Meridien[1] = 'M';
    }
    else {
        Meridien[0] = 'P'; // When the time is 24 hour it is PM
        Meridien[1] = 'M';
    }

    hh %= 12; // Calculate the 12 hour time

    // Handle 00 and 12 case separately
    if (hh == 0) {
        printf("12"); // Base format as 00 in 24-hour is 12 in 12-hour

        // Printing minutes and seconds
        for (int i = 2; i < 8; ++i) {
            printf("%c", str[i]);
        }
    }
    else {
        printf("%d", hh);
        // Printing minutes and seconds
        for (int i = 2; i < 8; ++i) {
            printf("%c", str[i]);
        }
    }

    // After time is printed Meridien
    printf(" %c%c", Meridien[0], Meridien[1]);
}

int main()
{

    char str[8] = "17:35:20"; // array containing the time

    convert12(str); // Call the function

    return 0;
}</string.h> 
```

**输出:**

![C Program to convert 24 Hour time to 12 Hour time](img/0d3a9ca0a1640d1173eff0b02b3d66d7.png)

## 代码解释

*   将 char **str** 带入功能。
*   从 24 小时格式字符串中获取小时的第一个数字和第二个数字。“0”将字符串值转换为整数。

```

int h1 = (int)str[0] - '0'; // Get the first digit of hour in 24 hour format
int h2 = (int)str[1] - '0'; // Get the second digit of hour in 24 hour format

```

*   当我们得到小时的个位数时，我们将转换成一个数字。

```

int hh = h1 * 10 + h2; // Caluclate hour as an integer value

```

*   使用 if-else 检查 hh 是 12 小时制还是 24 小时制，并将子午线设置为上午或下午。

```

if (hh < 12) { // If the time is less than 12 hour it is AM
       Meridien[0] = 'A';
       Meridien[1] = 'M'
}
else {
       Meridien[0] = 'P'; // When the time is 24 hour it is PM
        Meridien[1] = 'M';
          }

```

*   以 hh 和 12 为模，将时间转换为 12 小时格式。

```

hh %= 12; // Calculate the 12 hour time

```

*   我们将在 24 小时内单独处理 00，因为它与 12 小时格式的 12 相同。
*   打印小时后，打印分和秒
*   如果不是 00，则打印分钟和秒钟
*   打印 12 小时格式的子午线。

* * *