# C 语言的计算器程序

> 原文：<https://www.javatpoint.com/calculator-program-in-c>

在本主题中，我们将讨论如何用 C 编程语言编写计算器程序。计算器是一种小型电子设备，用于执行各种算术运算，如加法、减法、乘法、除法、百分比等。它使我们的计算更容易和更快。它是一种便携式设备，可以在任何地方使用来执行简单的数学运算。在某些情况下，我们使用科学或复杂的计算器，需要解决复杂的计算，如三角函数、指数运算符、度数、弧度、对数函数、双曲函数等。让我们讨论用 C 语言创建计算器程序的各种方法。

![Calculator Program in C](img/6b6fc0e26c48967c6b1d69497e7c427a.png)

## 计算器程序的算法

**步骤 1:** 声明局部变量 n1、n2、res、opt。例如，n1 和 n2 取两个数值，res 将存储结果，opt 变量定义运算符符号。

**第二步:**打印选项(加减乘除等。

**第三步:**进入选择

**第四步:**取两个数，n1 和 n2

**第 5 步:**切换案例跳转到用户选择的操作员

**步骤 6:** 将结果存储到 res 变量中。

**步骤 7:** 显示操作结果

**第 8 步:**退出程序。

### 用 C 语言创建计算器程序的不同方法

以下是用 C 语言编写计算器程序的不同方法。

1.  用 C 语言编写计算器程序，使用开关语句
2.  使用 if 语句的 C 语言计算器程序
3.  计算器程序在 C 语言中使用边做边循环和开关语句
4.  使用函数和开关语句的 C 语言计算器程序

### 示例 1:使用 switch 语句的 C 语言计算器程序

让我们编写一个程序，使用 switch 语句创建一个计算器程序

**program.c**

```

#include int main()
{
	// declare local variables
	char opt;
	int n1, n2; 
	float res;
	printf (" Choose an operator(+, -, *, /) to perform the operation in C Calculator \n ");
	scanf ("%c", &opt); // take an operator
	if (opt == '/' )
	{
		printf (" You have selected: Division");
	}
	else if (opt == '*')
	{
		printf (" You have selected: Multiplication");
	 }

	else if (opt == '-')
	{
		printf (" You have selected: Subtraction");
	 }
	 	else if (opt == '+')
	{
		printf (" You have selected: Addition");
	 }   
	printf (" \n Enter the first number: ");
	scanf(" %d", &n1); // take fist number
	printf (" Enter the second number: ");
	scanf (" %d", &n2); // take second number

	switch(opt)
	{
		case '+':
			res = n1 + n2; // add two numbers
			printf (" Addition of %d and %d is: %.2f", n1, n2, res);
			break;

		case '-':
			res = n1 - n2; // subtract two numbers
			printf (" Subtraction of %d and %d is: %.2f", n1, n2, res);
			break;

		case '*':
			res = n1 * n2; // multiply two numbers
			printf (" Multiplication of %d and %d is: %.2f", n1, n2, res);
			break;			

		case '/':
			if (n2 == 0)   // if n2 == 0, take another number
			{
				printf (" \n Divisor cannot be zero. Please enter another value ");
				scanf ("%d", &n2);		
				}
			res = n1 / n2; // divide two numbers
			printf (" Division of %d and %d is: %.2f", n1, n2, res);
			break;
		default:  /* use default to print default message if any condition is not satisfied */
			printf (" Something is wrong!! Please check the options ");				
	}
	return 0;
} 
```

**输出:**

![Calculator Program in C](img/f7df6b5cabade7e9a6442fa27f481276.png)

### 示例 2:用 if 语句用 C 语言编写计算器程序

让我们考虑一个例子，使用 if else if 语句用 C 语言编写一个简单的计算器程序。

**程序 2.c**

```

#include int main()
{
	// declare local variables
	char opt;
	int n1, n2; 
	float res;
	printf (" Select an operator (+, -, *, /) to perform an operation in C calculator \n ");
	scanf ("%c", &opt); // take an operator
	printf (" Enter the first number: ");
	scanf(" %d", &n1); // take fist number
	printf (" Enter the second number: ");
	scanf (" %d", &n2); // take second number

	if (opt == '+')
	{
		res = n1 + n2; // add two numbers
		printf (" Addition of %d and %d is: %f", n1, n2, res);
	}

	else if (opt == '-')
	{
		res = n1 - n2; // subtract two numbers
		printf (" Subtraction of %d and %d is: %f", n1, n2, res);
	}

	else if (opt == '*')
	{
		res = n1 * n2; // multiply two numbers
		printf (" Multiplication of %d and %d is: %f", n1, n2, res);
	}

	else if (opt == '/')
	{
		if (n2 == 0)   // if n2 == 0, take another number
		{
			printf (" \n Divisor cannot be zero. Please enter another value ");
			scanf ("%d", &n2);		
		}
		res = n1 / n2; // divide two numbers
		printf (" Division of %d and %d is: %.2f", n1, n2, res);
	}
	else
	{
		printf(" \n You have entered wrong inputs ");
	}
	return 0;
} 
```

**输出:**

![Calculator Program in C](img/bf0a338ef6600f6228f6292462f76ae0.png)

### 示例 3:使用 do while 循环和开关语句的 C 语言计算器程序

让我们用 C 语言中的 do while 循环和开关语句创建一个计算器程序

**程序 3.c**

```

#include #include <math.h>#include <stdlib.h>int main()
{
	// declaration of local variable op;
	int op, n1, n2;
	float res;
	char ch;
	do
	{
		// displays the multiple operations of the C Calculator
		printf (" Select an operation to perform the calculation in C Calculator: ");
		printf (" \n 1 Addition  \t \t 2 Subtraction \n 3 Multiplication \t 4 Division \n 5 Square \t \t 6 Square Root \n 7 Exit \n \n Please, Make a choice ");	

		scanf ("%d", &op); // accepts a numeric input to choose the operation

	// use switch statement to call an operation
	switch (op)
	{
		case 1:
			// Add two numbers
			printf (" You chose: Addition");
			printf ("\n Enter First Number: ");
			scanf (" %d", &n1);
			printf (" Enter Second Number: ");
			scanf (" %d", &n2);
			res = n1 + n2; // Add two numbers
			printf (" Addition of two numbers is: %.2f", res);
			break; // break the function

		case 2:
			// Subtract two numbers
			printf (" You chose: Subtraction");
			printf ("\n Enter First Number: ");
			scanf (" %d", &n1);
			printf (" Enter Second Number: ");
			scanf (" %d", &n2);
			res = n1 - n2; // subtract two numbers
			printf (" Subtraction of two numbers is: %.2f", res);
			break; // break the function

		case 3:
			// Multiplication of the numbers
			printf (" You chose: Multiplication");
			printf ("\n Enter First Number: ");
			scanf (" %d", &n1);
			printf (" Enter Second Number: ");
			scanf (" %d", &n2);
			res = n1 * n2; // multiply two numbers
			printf (" Multiplication of two numbers is: %.2f", res);
			break; // break the function

		case 4:
			// Division of the numbers
			printf (" You chose: Division");
			printf ("\n Enter First Number: ");
			scanf (" %d", &n1);
			printf (" Enter Second Number: ");
			scanf (" %d", &n2);
			if (n2 == 0)
				{
					printf (" \n Divisor cannot be zero. Please enter another value ");
					scanf ("%d", &n2);		
				}
			res = n1 / n2; // divide two numbers
			printf (" Division of two numbers is: %.2f", res);
			break; // break the function

		case 5:
			// getting square of a number
			printf (" You chose: Square");
			printf ("\n Enter First Number: ");
			scanf (" %d", &n1);

			res = n1 * n1; // get square of a number
			printf (" Square of %d number is: %.2f", n1, res);
			break; // break the function

		case 6:
			// getting the square root of the number
			printf (" You chose: Square Root");
			printf ("\n Enter First Number: ");
			scanf (" %d", &n1);

			res = sqrt(n1); // use sqrt() function to find the Square Root 
			printf (" Square Root of %d numbers is: %.2f", n1, res);
			break; // break the function

		case 7:
			printf (" You chose: Exit");
			exit(0); 
			break; // break the function

		default:
			printf(" Something is wrong!! ");
			break; 						
	}
	printf (" \n \n ********************************************** \n ");
	} while (op != 7);

	return 0;      
}</stdlib.h></math.h> 
```

**输出:**

![Calculator Program in C](img/50d0945c7ead819c68611111ac060840.png)

### 示例 4:使用函数和开关语句的 C 语言计算器程序

让我们用 C 语言的函数和开关语句创建一个计算器程序

**程序 4.c**

```

#include #include <conio.h>#include <math.h>#include <stdlib.h>// function declarations 
int addition();
int subtract();
int multiply();
int divide();
int sq();
int sqrt1();
void exit();

int main()
{
	// declaration a local variable op;
	int op;
	do
	{
		// displays the multiple operations of the C Calculator
		printf (" Select an operation to perform the calculation in C Calculator: ");
		printf (" \n 1 Addition  \t \t 2 Subtraction \n 3 Multiplication \t 4 Division \n 5 Square \t \t 6 Square Root \n 7 Exit \n \n Please, Make a choice ");	

		scanf ("%d", &op); // accepts a numeric input to choose the operation

	// use switch statement to call an operation
	switch (op)
	{
		case 1:
			addition(); /* It call the addition() function  to add the given numbers */
			break; // break the function

		case 2:
			subtract(); /* It call the subtract() function  to subtract the given numbers */
			break; // break the function

		case 3:
			multiply(); /* It call the multiply() function  to multiply the given numbers */
			break; // break the function

		case 4:
			divide(); // It call the divide() function  to divide the given numbers
			break; // break the function

		case 5:
			sq(); // It call the sq() function  to get the square of given numbers
			break; // break the function

		case 6:
			sqrt1(); /* It call the sqrt1() function  to get the square root of given numbers */
			break; // break the function

		case 7:
			exit(0); // It call the exit() function  to exit from the program
			break; // break the function

		default:
			printf(" Something is wrong!! ");
			break; 						
	}
	printf (" \n \n ********************************************** \n ");
	} while (op != 7);

	return 0;      
}

// function definition
int addition()
{
	int i, sum = 0, num, f_num; // declare a local variable	
	printf (" How many numbers you want to add: ");
	scanf ("%d", &num);
	printf (" Enter the numbers: \n ");
	for (i = 1; i <= num; i++)
	{
		scanf(" %d", &f_num);
		sum = sum + f_num;
	}
	printf (" Total Sum of the numbers = %d", sum);
	return 0;
}

// use subtract() function to subtract two numbers
int subtract()
{
	int n1, n2, res;
	printf (" The first number is: ");
	scanf ("  %d", &n1);
	printf (" The second number is: ");
	scanf ("  %d", &n2);
	res = n1 - n2;	
	printf (" The subtraction of %d - %d is: %d", n1, n2, res);
}

// use multiply() function to multiply two numbers
int multiply()
{
	int n1, n2, res;
	printf (" The first number is: ");
	scanf ("  %d", &n1);
	printf (" The second number is: ");
	scanf ("  %d", &n2);
	res = n1 * n2;	
	printf (" The multiply of %d * %d is: %d", n1, n2, res);
}

// use divide() function to divide two numbers
int divide()
{
	int n1, n2, res;
	printf (" The first number is: ");
	scanf ("  %d", &n1);
	printf (" The second number is: ");
	scanf ("  %d", &n2);

	if (n2 == 0)
	{
		printf (" \n Divisor cannot be zero. Please enter another value ");
		scanf ("%d", &n2);		
	}
	res = n1 / n2;	
	printf (" \n The division of %d / %d is: %d", n1, n2, res);
}

// use sq() function to get the square of the given number
int sq()
{
	int n1, res;
	printf (" Enter a number to get the Square: ");
	scanf ("  %d", &n1);

	res = n1 * n1;	
	printf (" \n The Square of %d is: %d", n1, res);
}

// use sqrt1() function to get the square root of the given number 
int sqrt1()
{
	float res;
	int n1;
	printf (" Enter a number to get the Square Root: ");
	scanf ("  %d", &n1);

	res = sqrt(n1);	
	printf (" \n The Square Root of %d is: %f", n1, res);
}</stdlib.h></math.h></conio.h> 
```

**输出:**

![Calculator Program in C](img/2a92e6bfcfe9c76bae275b19c668f139.png)

* * *