# 用 C 语言反转一个字符串

> 原文：<https://www.javatpoint.com/reverse-a-string-in-c>

本主题将讨论在 C 编程语言中反转字符串的几种方法。**反转字符串**是反转或改变给定字符串顺序的技术，使字符串的最后一个字符成为字符串的第一个字符，以此类推。此外，我们还可以通过反转原始字符串来检查给定字符串的回文。

例如，我们输入一个字符串“ **APPLE** ，然后使用反向算法。反向算法返回字符串“ **ELPPA** ，这与原始字符串完全相反。

![Reverse a String in C](img/012c7a825561df6ab8d7e4c86389ad6a.png)

### 在 C 语言中寻找字符串反义词的不同方法

以下是在 C 编程语言中查找字符串反义词的各种方法:

1.  使用 strrev()函数反转字符串
2.  不使用库函数反转字符串
3.  使用递归函数反转字符串
4.  使用 for 循环反转字符串
5.  使用 while 循环反转字符串
6.  使用指针反转字符串
7.  反转字符串以检查回文

### 程序 1:使用 strrev()函数打印字符串的反串

让我们考虑一个使用 strrev()函数打印字符串反面的例子。

**程序 1.c**

```

#include #include <string.h>int main()
{
	char str[40]; // declare the size of character string
	printf (" \n Enter a string to be reversed: ");
	scanf ("%s", str);

	// use strrev() function to reverse a string
	printf (" \n After the reverse of a string: %s ", strrev(str));
	return 0;
}</string.h> 
```

**输出**

```
Enter a string to be reversed: AMBULANCE
 After the reverse of a string: ECNALUBMA

```

### 程序 2:不使用库函数打印字符串的反面

让我们考虑一个使用用户定义函数打印字符串的反义词的例子。

**程序 2.c**

```

#include #include <string.h>// function definition of the revstr()
void revstr(char *str1)
{
	// declare variable
	int i, len, temp;
	len = strlen(str1); // use strlen() to get the length of str string

	// use for loop to iterate the string 
	for (i = 0; i < len/2; i++)
	{
		// temp variable use to temporary hold the string
		temp = str1[i];
		str1[i] = str1[len - i - 1];
		str1[len - i - 1] = temp;
	}
}

	int main()
	{
		char str[50]; // size of char string
		printf (" Enter the string: ");
		gets(str); // use gets() function to take string

		printf (" \n Before reversing the string: %s \n", str);

		// call revstr() function 
		revstr(str);
		printf (" After reversing the string: %s", str);
	}</string.h> 
```

**输出**

```
Enter the string: Welcome Friends

 Before reversing the string: Welcome Friends
 After reversing the string: sdneirF emocleW

```

### 程序 3:使用递归函数打印字符串的反义词

让我们考虑一个使用递归函数打印字符串反义词的例子。

**递归函数:**递归函数是不使用循环语句连续调用同一函数的函数。

**程序 3.c**

```

#include #include <string.h>// use recursion function 
void revstr(char *str1)
{
	// declare static variable
	static int i, len, temp;
	len = strlen(str1); // use strlen() to get the length of str string

	if (i < len/2){
		// temp variable use to temporary hold the string
		temp = str1[i];
		str1[i] = str1[len - i - 1];
		str1[len - i - 1] = temp;
		i++;
		revstr(str1); // recusively calls the revstr() function
	}
}

	int main()
	{
		char str1[50]; // size of char string
		printf (" Enter the string: ");
		gets(str1); // use gets() function to take string

		printf (" \n Before reversing the string: %s \n", str1);

		// call revstr() function 
		revstr(str1);
		printf (" After reversing the string: %s", str1);
	}</string.h> 
```

**输出**

```
Enter the string: LIFE INSURANCE

 Before reversing the string: LIFE INSURANCE
 After reversing the string: ECNARUSNI EFIL

```

### 程序 4:使用 for 循环打印字符串的反面

让我们考虑一个在 C 编程语言中使用 for 循环打印字符串的反义词的例子。

**程序 4.c**

```

#include #include <conio.h>#include <string.h>void main()
{
	char str[50], temp; // define the size of str[] array
	int i, left, right, len;
	printf (" \n Display a reverse string in the C: \n");
	printf (" ----------------------- ");
	printf (" \n Enter a string to reverse order: ");
	scanf( "%s", &str);
	len = strlen(str); // get the length of the string
	left = 0; // set left index at 0
	right = len - 1; // set right index len - 1
	// use for loop to store the reverse string
	for (i = left; i</string.h></conio.h> 
```

**输出**

```
Display a reverse string in the C:
 -----------------------
 Enter a string to reverse order: APPLE
 The reverse of the original string is: ELPPA

```

### 程序 5:使用 while 循环打印字符串的反面

让我们考虑一个在 C 编程语言中使用 while 循环打印字符串的反义词的例子。

**程序 5.c**

```

#include #include <string.h>int main()
{
char str1[50], temp; // declare and initialize the size of string array.
int i = 0, j =0;
printf (" Enter a string to be reversed: ");
scanf( "%s", str1);
j = strlen (str1) - 1;  // get the length of the string
// use while loop to define the condition
while ( i < j) 
{
// use temp variable to store the characters of str1
temp = str1[j];
str1[j] = str1[i];
str1[i] = temp;
i++; // i incremented by 1
j--; // j is decremented by 1
}
printf (" The reversed of the string: %s", str1);
return 0;
}</string.h> 
```

**输出**

```
Enter a string to be reversed: JAVATPOINT
 The reversed of the string: TNIOPTAVAJ

```

### 程序 6:用指针打印字符串的反串

让我们考虑一个例子，用 C 编程语言中的指针打印字符串的反义词。

**程序 6.c**

```

#include #include <string.h>int str_len( char *st);
void revstr( char *st);
int main()
{
	char st[50];
	printf (" Enter a string to be reversed: ");
	scanf( "%s", st);

	revstr(st);	

	printf (" The reverse string is: %s", st);
	return 0;
}

void revstr (char *st)
{
	int len, i;
	char *start, *end, temp;

	len = str_len (st);
	start = st;
	end = st;

	for (i = 0; i < len - 1; i++)
	end++;

	for (i = 0; i < len/2; i++)
	{
		temp = *end;
		*end = *start;
		*start = temp;

		start++;
		end--;
	}
}

int str_len (char *ptr)
{
	int i = 0;
	while ( *(ptr + i) != '\0')
	i++;
	return i;
}</string.h> 
```

**输出**

```
Enter a string to be reversed: JAVATPOINT
 The reverse string is: TNIOPTAVAJ

```

### 程序 7:检查反串是否是回文的程序

考虑一个程序来检查给定的字符串在 C 编程语言中是否是回文。

**程序 7.c**

```

#include #include <string.h>int main ()
{	
	// declare variables
	char str1[30];
	int i, len, flag = 0;

	printf (" Enter a string: ");
	scanf ("%s", str1);
	len = strlen( str1 ); // get the string length

	for ( i = 0; i < len; i++)
	{	
		// str1[i] is not equal to str1[len-i-1]
		if (str1[i] != str1[len - i - 1])
		{
			flag = 1; 
			break; // exit from if statement
		}
	}
	if (flag)
	{
		printf (" %s is not a palindrome string", str1);
	}
	else
	{
		printf (" %s is a palindrome", str1);
	}
	return 0;
}</string.h> 
```

**输出**

```
Enter a string: madam
madam is a palindrome string.

```

* * *