# C 语言中的幂函数

> 原文：<https://www.javatpoint.com/power-function-in-c>

本文将讨论 C 语言中的幂函数及其各种例子。幂函数用于求任意给定数的幂。power 函数是 **math.h** 头文件的预定义库函数，我们需要在使用 power()函数的同时在程序中导入 **math.h** 头文件。换句话说，幂()函数用于通过将(y)的幂提高为(**x<sup>y</sup>T7)来计算基数(x)的幂。**

例如，我们取基数为 2，幂为 5，一个数的幂使用幂(2，5)函数返回值为 32。类似地，我们将 3 作为基数，将 4 作为指数，使用幂(3，4)来提高基数的幂，这将返回结果 81。

![Power Function in C](img/3a0b7c218a50f4f249340f7bcad5df15.png)

### 句法

```

int pow (int x, int y);

```

pow()函数有两个整数参数，用于将基值(x)的幂乘以指数(y)。

### 参数:

1.  x:x 变量代表要计算其幂的基值。
2.  y:y 变量代表幂或指数值。

### 使用幂()函数计算整数幂的程序

让我们考虑一个例子，使用 C 编程语言中的 pow()函数获得一个整数的幂。

**程序 2.c**

```

#include #include <math.h>int main ()
{
// declare base and exp variable 
int base, exp;
int result; // store the result
printf (" Enter the base value from the user: ");
scanf (" %d", &base); // get base from user
printf (" Enter the power value for raising the power of base: ");
scanf (" %d", &exp); // get exponent from user

// use pow() function to pass the base and the exp value as arguments
result = pow ( base, exp);
printf (" %d to the power of %d is = %d ", base, exp, result);
return 0;
}</math.h> 
```

**输出**

```
Enter the base value from the user: 7
 Enter the power value for raising the power of base: 5
 7 to the power of 5 is = 16807  

```

### 使用 power()函数计算双倍数据值的幂的程序

让我们考虑一个用 C 编程语言中的双数据值演示 pow()函数的例子。

**程序 2.c**

```

#include #include <math.h>int main ()
{
// declare base and exp variable 
double base, exp;
double result; // store the result
printf (" Enter the base value: ");
scanf (" %lf", &base); // get base from user
printf (" Enter the power value: ");
scanf (" %lf", &exp); // get exponent from user

// use pow() function to pass the base and the exp value as arguments
result = pow ( base, exp);
printf (" %.1lf to the power of %.1lf is = %.2lf ", base, exp, result);
return 0;
}</math.h> 
```

**输出**

```
  Enter the base value from the user: 2.9
 Enter the power value for raising the power of base: 8.3
 2.9 to the power of 8.3 is = 6884.99

```

### 使用用户定义的函数计算一个数的幂的程序

让我们考虑一个例子，用 C 编程语言创建一个用户定义的函数来获得一个数的幂。

**程序 1.c**

```

#include #include <math.h>int main ()
{
	// declare local variable
	long int base, exp;	
	printf (" Enter the base value: ");
	scanf (" %d", &base); // take a number from user

	printf (" Enter the power value: ");
	scanf (" %d", &exp); // take a number from user

	// use pow() function to pass the base and exp variable
	printf (" %d to the power %d is = %d ", base, exp, pow_num (base, exp));
}

// definition of the function
int pow_num (int x, int y)
{
	int power = 1, i; // declare variables
	for (i = 1; i <= y; ++i)
	{
		power = power * x;

	}
	return power;
}</math.h> 
```

**输出**

```
Enter the base value: 25
 Enter the power value: 6
 25 to the power 6 is = 244140625

```

### 使用递归函数和幂()函数计算一个数的幂的程序

让我们考虑一个例子，用 C 编程语言中的递归函数和 pow()函数来求一个数的幂。

**程序代码**

```

#include #include <math.h>int main ()
{
	// declare local variable
	long int base, exp;	
	printf (" Enter the base value from the user ");
	scanf (" %d", &base); // take a number from user

	printf (" Enter the power value from the user ");
	scanf (" %d", &exp); // take a number from user

	// use pow() function to pass the base and exp variable
	printf (" %d to the power of %d is = %d ", base, exp, pow_num (base, exp));
}

// definition of the function
int pow_num (int x, int y)
{
	if ( y == 0)
	{
		return 1;
		}	
	else
		return pow_num (x, y - 1) * x;	
}</math.h> 
```

**输出**

```
Enter the base value from the user 5
 Enter the power value from the user 6
 5 to the power of 6 is = 15625

```

## 结论

幂函数用于使用 pow()函数求任何数值数据(int、float、double)的幂。幂函数有两个参数:基数和指数。基数代表要计算的幂，指数定义基值的幂。

* * *