# 表格程序

> 原文：<https://www.javatpoint.com/table-program-in-c>

本文将使用 C 编程语言中的循环(for、do-while 和 while 循环)和函数(用户定义函数和递归函数)编写表程序。

数字表(或乘法表)是通过将一个常数乘以一个从 1 到 10 的迭代数得到的。换句话说，我们可以通过给定的数字乘以从 1，2，3，4，5，..., 9, 10.每次迭代时，计数值增加 1，增加到 10，以打印一个完整的表格。

例如，假设我们想用 C 语言写 5 的表。因此，首先，我们将 5 作为用户的输入，然后，我们使用一个循环或函数，将数字 5 乘以 1 (5 * 1)，然后(5 * 2)，(5 * 3)，直到最后一个(5 * 10)数字，以获得给定数字的完整表格。

![Table Program in C](img/fb207d3e656fb8c2bc39fffd9ea71dd4.png)

### 生成表格程序的不同方法

下面是用 C 编程语言生成表程序的各种方法。

1.  用于循环
2.  使用 while 循环
3.  使用边做边循环
4.  使用用户定义的函数
5.  使用递归函数
6.  使用 if 和 goto 语句
7.  用于循环和指针
8.  使用嵌套 for 循环

### 使用 for 循环生成给定数目的表的程序

让我们考虑一个在 C 编程语言中使用 for 循环打印特定数字表的例子。

**程序 1.c**

```

#include int main()
{
	int num, i; // declare a variable
	printf (" Enter a number to generate the table in C: ");
	scanf (" %d", &num); // take a positive number from the user

	printf ("\n Table of %d", num);
	// use for loop to iterate the number from 1 to 10
	for ( i = 1; i <= 10; i++)
	{
		printf ("\n %d * %d = %d", num, i, (num*i));
	}
	return 0;
} 
```

**输出**

```
Enter a number to generate the table in C: 7
 Table of 7
 7 * 1 = 7
 7 * 2 = 14
 7 * 3 = 21
 7 * 4 = 28
 7 * 5 = 35
 7 * 6 = 42
 7 * 7 = 49
 7 * 8 = 56
 7 * 9 = 63
 7 * 10 = 70

```

在上面的代码中，for 循环从 1 到 10 执行，给定的数字乘以 1，下一次迭代乘以 2，过程继续，直到它将数字乘以 10。最后，它在屏幕上打印表格。

### 使用 while 循环生成数字表的程序

让我们考虑一个在 C 编程语言中使用 while 循环打印数字表的例子。

**程序 2.c**

```

#include int main()
{
	int num, i = 1; // declare a variable
	printf (" Enter a number to generate the table in C: ");
	scanf (" %d", &num); // take a positive number from the user

	printf ("\n Table of %d \n ", num);

	// use while loop to evaluate the condition
	while (i <= 10)
	{
		// print the table
		printf (" %d x %d = %d \n", num, i, (num * i));
		i++; // incremented by 1 
	}
	return 0;
} 
```

**输出**

```
Enter a number to generate the table in C: 8
 Table of 8
  8 x 1 = 8
 8 x 2 = 16
 8 x 3 = 24
 8 x 4 = 32
 8 x 5 = 40
 8 x 6 = 48
 8 x 7 = 56
 8 x 8 = 64
 8 x 9 = 72
 8 x 10 = 80

```

### 使用 do-while 循环生成数字表的程序

让我们考虑一个用 C 编程语言中的 do-while 循环打印数字表的例子。

**程序 3.c**

```

#include int main()
{
	int num, i = 1; // declare a variable
	printf (" Enter a number to generate the table in C: ");
	scanf (" %d", &num); // take a positive number from the user

	printf ("\n Table of %d \n", num);

	// use do-while loop to evaluate the condition
	do
	{
		// print the table
		printf (" %d x %d = %d \n", num, i, (num * i));
		i++; // incremented by 1 
	} while (i <= 10); // check condition

	return 0;
} 
```

**输出**

```
Enter a number to generate the table in C: 3
 Table of 3
 3 x 1 = 3
 3 x 2 = 6
 3 x 3 = 9
 3 x 4 = 12
 3 x 5 = 15
 3 x 6 = 18
 3 x 7 = 21
 3 x 8 = 24
 3 x 9 = 27
 3 x 10 = 30

```

### 使用 for 循环和用户定义函数生成表的程序

让我们考虑一个例子，在 C 编程语言中使用用户定义的函数和 for 循环来打印特定数字的表。

**程序 4.c**

```

#include void tab_num (int x);
int main ()
{
	int number;
	printf (" Enter a number to get the table: ");
	scanf (" %d", &number); // accept a number

	printf ("\n The multiplication table of %d \n", number);
	tab_num (number); // call tab_num function
	return 0;
}
void tab_num (int number)
{
	int i; // declare variable
	// use for loop to iterate the number from 1 to 10 
	for ( i = 1; i <= 10; i++)
	{
		printf (" %d x %d = %d \n", number, i, number * i);
	}
} 
```

**输出**

```
Enter a number to get the table: 23
 The multiplication table of 23
 23 x 1 = 23
 23 x 2 = 46
 23 x 3 = 69
 23 x 4 = 92
 23 x 5 = 115
 23 x 6 = 138
 23 x 7 = 161
 23 x 8 = 184
 23 x 9 = 207
 23 x 10 = 230

```

### 用递归函数生成数表的程序

让我们写一个例子，用 C 编程语言中的递归函数打印数字表。

**程序 5.c**

```

#include int main()
{
	int num, i = 0; // declare a variable
	printf (" Enter a number to generate the table in C: ");
	scanf (" %d", &num); // take a positive number from the user

	printf ("\n Table of %d", num);
	Multiply_tab (num, 1); // call function
}
// definition of Multiply_tab()
void Multiply_tab (int num, int i)
{
	printf (" \n");
	printf (" %d x %d = %d ", num, i, (num * i));

	// If block checks the condition
	if (i < 10)
		return Multiply_tab (num, i + 1);
} 
```

**输出**

```
Enter a number to generate the table in C: 9
 Table of 9
 9 x 1 = 9
 9 x 2 = 18
 9 x 3 = 27
 9 x 4 = 36
 9 x 5 = 45
 9 x 6 = 54
 9 x 7 = 63
 9 x 8 = 72
 9 x 9 = 81
 9 x 10 = 90

```

### 使用 goto 语句生成数字表的程序

让我们考虑一个用 C 编程语言中的 goto 语句打印数字表的例子。

**程序 6.c**

```

#include int main ()
{
	int n, i = 1; // declare variable
	printf (" Enter a number to get the table: ");
	scanf (" %d", &n); // take a positive number	 
	table:  // It is a label 
	// display table
	printf (" %d * %d = %d \n", n, i, (n * i));
	i++; // incremented by 1	
	/* if statement check the value of i should not be greater than 10\. */
	if ( i <= 10)	
		goto table; // use goto statement to jump to the table label	 
} 
```

**输出**

```
Enter a number to get the table: 5
 5 * 1 = 5
 5 * 2 = 10
 5 * 3 = 15
 5 * 4 = 20
 5 * 5 = 25
 5 * 6 = 30
 5 * 7 = 35
 5 * 8 = 40
 5 * 9 = 45
 5 * 10 = 50

```

### 使用指针生成数字表的程序

让我们考虑一个用 C 编程语言中的指针打印数字表的例子。

**程序 7.c**

```

#include int main ()
{
	int n, i; // declare integer variables
	int *ptr; // integer pointer variable	
	printf (" Enter a number to print the table: ");
	scanf (" %d", &n); // take a number	
	ptr = &n; // store the address of n to ptr
	printf (" \n Table of %d: \n", n);
	for ( i = 1; i <= 10; i++)
	{
		printf (" %d * %d = %d \n", n, i, (n*i));
	}
	return 0;
} 
```

**输出**

```
Enter a number to print the table: 17
 Table of 17:
 17 * 1 = 17
 17 * 2 = 34
 17 * 3 = 51
 17 * 4 = 68
 17 * 5 = 85
 17 * 6 = 102
 17 * 7 = 119
 17 * 8 = 136
 17 * 9 = 153
 17 * 10 = 170

```

### 使用嵌套 for 循环生成从 2 到 10 的表的程序

让我们考虑一个在 C 编程语言中使用嵌套 for 循环打印从 2 到 10 的表的例子。

**程序 8.c**

```

#include int main ()
{
	int i, j; /* Here, the i variable is used for the outer loop, and j is used for the inner loop. */	
	int num1, num2; 	
	printf (" Enter the first number from to get the table: ");
	scanf (" %d", &num1);
	printf (" Enter the last number: ");
	scanf (" %d", &num2);
	// use for loop to iterate the value of 1 up to 10
	for (i = num1; i <= num2; i++)
	{
		num1 = i; /* Here the value of i is incremented by 1 and assigned to num variable on completion of each table. */
		// inner for loop
		printf (" Table of %d => ", num1);
		for (j = 1; j <=10; j++)
		{
			printf(" | %3d |", num1 * j);
		}		
		printf (" \n");
	 }
	 return 0; 

} 
```

**输出**

```
Enter the first number from to get the table: 2
 Enter the last number: 10
 Table of 2 =>  |   2 | |   4 | |   6 | |   8 | |  10 | |  12 | |  14 | |  16 | |  18 | |  20 |
 Table of 3 =>  |   3 | |   6 | |   9 | |  12 | |  15 | |  18 | |  21 | |  24 | |  27 | |  30 |
 Table of 4 =>  |   4 | |   8 | |  12 | |  16 | |  20 | |  24 | |  28 | |  32 | |  36 | |  40 |
 Table of 5 =>  |   5 | |  10 | |  15 | |  20 | |  25 | |  30 | |  35 | |  40 | |  45 | |  50 |
 Table of 6 =>  |   6 | |  12 | |  18 | |  24 | |  30 | |  36 | |  42 | |  48 | |  54 | |  60 |
 Table of 7 =>  |   7 | |  14 | |  21 | |  28 | |  35 | |  42 | |  49 | |  56 | |  63 | |  70 |
 Table of 8 =>  |   8 | |  16 | |  24 | |  32 | |  40 | |  48 | |  56 | |  64 | |  72 | |  80 |
 Table of 9 =>  |   9 | |  18 | |  27 | |  36 | |  45 | |  54 | |  63 | |  72 | |  81 | |  90 |
 Table of 10 =>  |  10 | |  20 | |  30 | |  40 | |  50 | |  60 | |  70 | |  80 | |  90 | | 100 |

```

* * *