# C 语言中的大写转换为小写

> 原文：<https://www.javatpoint.com/convert-uppercase-to-lowercase-in-c>

本节将讨论在 C 编程语言中将大写字母(字符或字符串)转换为小写字母的不同程序。大写字母是字母表中的大写字母。例如，大写字母是 A、B、C、D、…、X、Y、z。同样，小写字母由字母表中的小写字母表示。例如，小写字母是 a，b，c，d，e…，w，x，y，z

当我们使用 ASCII 码将大写字母或字符串转换成小写时，这个过程在 C 编程中将大写字母转换成小写字母。大写字母(A -Z)的 ASCII 值范围为 65 到 90，小写字母(a -z)的 ASCII 值范围为 97 到 122。

例如，我们有大写字母“A”并想将其转换为小写字母“A”，我们需要在返回字符“A”的 A (65)的 ASCII 值上加上 32，字符“A”的 ASCII 值为 97 (65 + 32)。同样，我们可以将大写字符串“hello”转换为小写字符串“HELLO”。

![Convert Uppercase to Lowercase in C](img/d471a37644c16eaeb63e785d22724078.png)

### 将大写字符转换成小写字符的程序

让我们编写一个程序，用 C 编程语言将大写字符转换成小写字符。

**程序 1.c**

```

#include #include <conio.h>int main ()
{
	char upr, lwr; // declare variables
	int ascii;

	// convert in lower case
	printf (" Enter the Upper Case Character: ");
	scanf (" %c", &upr);
	ascii = upr + 32;
	printf (" %c character in Lower case is: %c", upr, ascii);

	// convert in upper case
	printf (" \n Enter the Lower Case Character: ");
	scanf (" %c", &lwr);
	ascii = lwr - 32;
	printf (" %c character in the Upper case is: %c", lwr, ascii);

	return 0;
}</conio.h> 
```

**输出**

```
Enter the Upper Case Character: A
 A character in Lower case is: a
 Enter the Lower Case Character: z
 z character in the Upper case is: Z

```

### 使用 for 循环将大写字符串转换为小写的程序

让我们编写一个简单的程序，在 C 编程中使用 for 循环将大写字符串转换为小写。

**程序 2.c**

```

#include #include <conio.h>int main ()
{
char str[30];
int i;
printf (" Enter the string: ");
scanf (" %s", &str); // take a string

 // use for loop to change string from upper case to lower case
 for ( i = 0; i <= strlen (str); i++)
 {
// The ASCII value of A is 65 and Z is 90
 if (str[i] >= 65 && str[i] <= 90)
 str[i] = str[i] + 32; /* add 32 to string character to convert into lower case. */
 }
printf (" \n Upper Case to Lower case string is: %s", str);
return 0;
}</conio.h> 
```

**输出**

```
Enter the string: WELCOME

 Upper Case to Lower case string is: welcome

```

### 使用 while 循环将大写字符串转换为小写的程序

让我们考虑一个在 C 编程中使用 while 循环将小写字符串从大写打印出来的例子。

**程序 3.c**

```

#include #include <conio.h>int main ()
{
	char upr[50], lwr[50]; // declare character array
	int i = 0;

	printf (" Enter an upper case string: ");
	gets (upr); // use gets() function to take string

	/* use while loop to iterate the character array string until '\0' not occur. */
	while (upr [i] != '\0')
	{
	lwr [i] = upr[i] + 32; // Add 32 to string character to convert into lower case.		i++;
		}	

		printf (" \n The lowercase string is: %s", lwr);

	return 0;

}</conio.h> 
```

**输出**

```
Enter an upper case string: CPROGRAMMING

 The lowercase string is: cprogramming

```

### 使用 strlwr()函数将大写字符串转换为小写的程序

**Strlwr()函数**:Strlwr()函数是字符串库的预定义函数，用于通过将给定字符串作为参数传递来返回小写字符串，从而将大写字符串转换为小写字符串。

**语法**

```

strlwr (upr);

```

strlwr()函数有一个表示大写字符串的 upr 参数，strlwr()函数使用 upr 参数返回一个小写字符串。

让我们创建一个程序，使用 C 编程中内置的 strlwr()函数将大写字符串转换为小写。

**程序 4.c**

```

#include #include <conio.h>int main ()
{
	char upr[50]; // declare character array

	printf (" Enter the upper case string: ");
	gets (upr); // use gets() function to take string

	// use strlwr() function to change upper case into lower string	
	printf (" \n The lowercase string is: %s", strlwr(upr));

	return 0;
}</conio.h> 
```

**输出**

```
Enter the upper case string: GOOD BYE

 The lowercase string is: good bye

```

### 使用用户定义函数将大写字符串转换为小写的程序

让我们考虑一个在 C 编程中使用用户定义函数将大写字符串转换成小写的例子。

**程序 5.c**

```

#include #include <conio.h>// create a function
void upr_lwr (char *str)
{
	int i;
	// use for loop to iterate the length of the string
	for ( i = 0; str[i]; i++)
	{
		if ( str [i] >= 65 && str [i] <= 90)
		str[i] = str[i] + 32; /* add 32 to string character to change into lowercase */
	}
}
int main ()
{
	char str[100]; // declare the size of character array

	printf (" Enter the upper case string: ");
	gets (str); // use gets() function to take string

	// call upr_lwr() function 
	upr_lwr (str);

	printf (" \n The lowercase string is: %s", str);

	return 0;

}</conio.h> 
```

**输出**

```
Enter the upper case string: JAVATPOINT

 The lowercase string is: javatpoint

```

### 使用递归函数将大写字符串转换为小写的程序

让我们考虑一个使用 C 编程中的递归函数将小写字符串从大写打印出来的例子。

**程序 6.c**

```

#include #include <conio.h>#include <string.h>int upr_lwr (char *str)
{
	static int i = 0;
	if (str[i])
	{

	/* If statement check the enter character's ASCII value is more than 65 and less than equal to 90\. */
		if ( str[i] >= 65 && str[i] <= 90)
		str[i] = str[i] + 32; // add 32 to string character to change into lowercase
		i++;
		upr_lwr(str); 
	}
}
int main ()
{
	char str[100]; // declare the size of character array

	printf (" Enter the upper case string: ");
	gets (str); // use gets() function to take string

	// call upr_lwr() function 
	upr_lwr (str);

	printf (" \n The lowercase string is: %s", str);
}</string.h></conio.h> 
```

**输出**

```
Enter the upper case string: C PROGRAMMING LANGUAGE

The lowercase string is: c programming language

```

* * *