# C 语言中的算术运算符

> 原文：<https://www.javatpoint.com/arithmetic-operator-in-c>

运算符是 C 编程语言中的特殊符号，用于对给定的操作数执行各种数学和逻辑运算，以返回适当的结果。C 编程语言中有各种运算符，如算术运算符、关系运算符、移位运算符、逻辑运算符、按位运算符、三元或条件运算符以及赋值运算符。但是在这里，我们将只理解 C 编程语言中的算术运算符。

![Arithmetic Operator in C](img/113bed351fdeef771977c650d8fe0c57.png)

**算术运算符**用于执行加、减、乘、除、模等数学运算。，取决于给定的操作数。

比如:5 + 3 = 8，5 - 3 = 2，2 * 4 = 8 等等。是算术运算符的例子。让我们讨论一下 C 程序设计中不同类型的算术运算符。

### 加号运算符

它是一个简单的加号(+)运算符，用于将两个给定的操作数相加。我们可以对不同的数据类型(如整数、浮点、长、双、枚举和字符串类型的数据)使用 Plus 运算符来添加给定的操作数。

**语法**

```

C = A + B;

```

例如，有两个操作数，5 和 6，我们想得到这些数的和。因此，我们在返回整数数据 11 的给定数字之间使用“+”运算符。

**程序 1.c**

```

#include #include <conio.h>int main ()
{
// declare integer variables
int num1, num2, res; 
// declare float data type number
float f1, f2, res1;
// declare double variables
double d1, d2, res2;
printf (" Enter two integer numbers: ");
scanf ("%d %d", &num1, &num2);
res = num1 + num2; // use + operator

printf (" Enter two float numbers: \n ");
scanf ("%f %f", &f1, &f2);
res1 = f1 + f2; // use + operator

printf (" Enter two double data type numbers: \n ");
scanf ("%lf %lf", &d1, &d2);
res2 = d1 + d2; // use + operator
printf (" The sum of two integer numbers: %d \n", res);
printf (" The sum of two float numbers: %f \n ", res1);
printf (" The sum of two double numbers: %lf", res2);
return 0;
}</conio.h> 
```

**输出**

```
Enter two integer numbers: 25
35
 Enter two float numbers:
 79.21
67.79
 Enter two double data type numbers:
 234.123
345.341
 The sum of two integer numbers: 60
 The sum of two float numbers: 147.000000
The sum of two double numbers: 579.464000

```

### 减运算符

减号运算符由减号(-)表示。它用于返回第一个数字与第二个数字的减法。给定数字的数据类型可以是不同的类型，如 int、float、double、long double 等。，在编程语言中。

**语法**

```

C = A - B;

```

例如，有两个操作数，15 和 6，我们想要它们的减法结果。因此，我们在返回数据 9 的给定数字之间使用“-”运算符。

**程序 2.c**

```

/* program to subtract the two numbers using minus operator */
#include #include <conio.h>int main ()
{
// declare integer variables
int num1, num2, res; 
// declare float data type number
float f1, f2, res1;
// declare double variables
double d1, d2, res2;
printf (" Enter two integer numbers: ");
scanf ("%d %d", &num1, &num2);
res = num1 - num2; // use + operator

printf (" Enter two float numbers: \n ");
scanf ("%f %f", &f1, &f2);
res1 = f1 - f2; // use + operator

printf (" Enter two double data type numbers: \n ");
scanf ("%lf %lf", &d1, &d2);
res2 = d1 - d2; // use + operator
printf (" The subtraction of two integer numbers: %d \n", res);
printf (" The subtraction of two float numbers: %f \n ", res1);
printf (" The subtraction of two double numbers: %lf", res2);
return 0;
}</conio.h> 
```

**输出**

```
Enter two integer numbers: 56
11
 Enter two float numbers:
 78.98
56.45
 Enter two double data type numbers:
 47789.7149
1234.7987
 The subtraction of two integer numbers: 45
 The subtraction of two float numbers: 22.530003
  The subtraction of two double numbers: 46554.916200

```

### 乘法运算符

乘法运算符表示为星号(*)，用于返回 n1 和 n2 的乘积。给定数字的数据类型可以是不同的类型，如 C 编程语言中的 int、float 和 double。

**语法**

```

C = A * B;

```

例如，有两个操作数 15 和 6，我们想得到它们的乘积。因此，我们可以在返回 int 数据 90 的给定数字之间使用“*”运算符。

**程序 3.c**

```

/* program to multiply two numbers using astrisk (*) operator. */
#include #include <conio.h>int main ()
{
// declare integer variables
int num1, num2, res; 
// declare float data type number
float f1, f2, res1;
// declare double variables
double d1, d2, res2;
printf (" Enter two integer numbers: ");
scanf ("%d %d", &num1, &num2);
res = num1 * num2; // use * operator

printf (" Enter two float numbers: \n ");
scanf ("%f %f", &f1, &f2);
res1 = f1 * f2; // use * operator

printf (" Enter two double data type numbers: \n ");
scanf ("%lf %lf", &d1, &d2);
res2 = d1 * d2; // use * operator
printf (" The multiplication of two integer numbers: %d \n", res);
printf (" The multiplication of two float numbers: %f \n ", res1);
printf (" The multiplication of two double numbers: %lf", res2);
return 0;
}</conio.h> 
```

**输出**

```
Enter two integer numbers: 15
12
 Enter two float numbers:
 2.5
3.5
 Enter two double data type numbers:
 234.324
798.124
 The multiplication of two integer numbers: 180
 The multiplication of two float numbers: 8.750000
  The multiplication of two double numbers: 187019.608176

```

### 除法算符

除法运算符是将第一个(n1)数除以第二个(n2)数的算术运算符。使用除法运算符(/)，我们可以划分 int、float、double 和 long 数据类型变量。

**语法**

```

C = A / B;

```

例如，有两个操作数，25.5 和 5.0，我们想得到它们的除法结果。因此，我们在返回浮点数据 5.1 的给定数字之间使用“/”运算符。

**程序 4.c**

```

/* program to divide the first number by second number using division (/) operator. */
#include #include <conio.h>int main ()
{
// declare integer variables
int num1, num2, res; 
// declare float data type number
float f1, f2, res1;
// declare double variables
double d1, d2, res2;
printf (" Enter two integer numbers: ");
scanf ("%d %d", &num1, &num2);
res = num1 / num2; // use / operator

printf (" Enter two float numbers: \n ");
scanf ("%f %f", &f1, &f2);
res1 = f1 / f2; // use / operator

printf (" Enter two double data type numbers: \n ");
scanf ("%lf %lf", &d1, &d2);
res2 = d1 / d2; // use / operator
printf (" The division of two integer numbers: %d \n", res);
printf (" The division of two float numbers: %f \n ", res1);
printf (" The division of two double numbers: %lf", res2);
return 0;
}</conio.h> 
```

**输出**

```
Enter two integer numbers: 125
15
 Enter two float numbers:
 214.32
248.56
 Enter two double data type numbers:
 4243.7691
687.434
 The division of two integer numbers: 8
 The division of two float numbers: 0.862247
  The division of two double numbers: 6.173348

```

### 模数运算符

模数运算符由百分比符号(%)表示，用于通过第一个数字除以第二个数字来返回余数。

**语法**

```

C = A % B;

```

例如，有两个操作数 25 和 4，我们想得到它们的模结果。因此，我们在返回余数 1 的给定数字之间使用“%”运算符。

**程序 5.c**

```

/* program to return the remainder of two numbers using modulus (%) operator. */
#include #include <conio.h>int main ()
{
// declare integer variables
int num1, num2, res; 

printf (" Enter two integer numbers: ");
scanf ("%d %d", &num1, &num2);
res = num1 % num2; // use % operator

printf (" The modulus of two integer numbers: %d \n", res);

return 0;
}</conio.h> 
```

**输出**

```
Enter two integer numbers: 35
3
 The modulus of two integer numbers: 2

```

### 增量运算符

增量运算符是算术运算符的类型，用双加号(++)运算符表示。它用于将整数值增加 1。

**语法**

```

B = A++;

```

例如，假设 A 的整数值为 10，增量运算符将操作数值增加 1，返回 11。

**程序 6.c**

```

/* program to demonstrate the increment (++) operator. */
#include #include <conio.h>int main ()
{
// declare integer variables
int num1, res; 

printf (" Enter the positive number: ");
scanf ("%d", &num1);
res = num1++; // use increment operator

printf (" The incremented value is: %d ", num1);
return 0;
}</conio.h> 
```

**输出**

```
Enter the positive number: 10
 The incremented value is: 11

```

### 递减运算符

递减运算符由双减号(-)表示，它将操作数值减少 1。

**语法**

```

B = A--;

```

例如，假设 A 的整数值为 10，递减运算符将操作数值减少 1，返回 9。

**程序 7.c**

```

/* program to demonstrate the decrement operator (--) in the Arithmetic Operator. */
#include #include <conio.h>int main ()
{
// declare integer variables
int num1, res; 

printf (" Enter the positive number: ");
scanf ("%d", &num1);
res = num1--; // use decrement operator

printf (" The decremented value is: %d ", num1);
return 0;
}</conio.h> 
```

**输出**

```
Enter the positive number: 10
 The decremented value is: 9

```

* * *