# C 语言中的天花板函数

> 原文：<https://www.javatpoint.com/ceil-function-in-c>

本节将讨论 C 编程语言中的 Ceil 函数。Ceil 函数是 **math.h** 头文件的预定义函数。它返回最近的整数，该整数大于或等于作为参数传递的数字。例如，我们传递浮点数 3.4，ceil()函数返回最大的数字 4。

![Ceil Function in C](img/9668f975a98a7338cd7b4c7809224746.png)

### 句法

```

double ceil ( double x);

```

### 因素

这里，x 是天花板函数的一个参数。

### 返回

函数的作用是:返回一个尽可能小的整数值，对传递的数字 x 取整。

### 天花板函数的性质

*   这是 math.h 头文件的内置方法。
*   使用 ceil()函数返回大于或等于参数数的最小数。
*   如果传递的数字是 0，ceil()函数将返回 0。
*   如果数字等于数学整数，ceil()函数生成的结果将与指定的数字相同。
*   如果数字小于 0 但大于-1.0，结果将为零。

#### 注意:ceil()函数只能用于浮点正数和负数，以舍入给定的数字。如果传递的正数和负数是整数，该函数将返回相同的数字，不设上限或舍入最近的给定数字。

### 示例 1:使用 ceil()函数给一个数字加上限的程序

```

#include #include <math.h>int main ()
{
// declare local variables
double num = 9.37;
int result;

// use ceil () function to round up the nearest value. 
result = ceil (num);

printf ( " \n The ceiling integer of %.2f = %d ", num, result);
return 0;	
}</math.h> 
```

**输出**

```
The ceiling integer of 9.37 = 10

```

如程序所示，变量 num 9.37 的值被传递给 ceil()函数，该函数将舍入到最接近的整数值 10。

### 示例 2:使用 ceil()函数对浮点数进行上限编程

```

#include #include <math.h>int main ()
{
// declare local variables
float f1, f2, f3, f4, f5;
f1 = 2.3;
f2 = -2.7;
f3 = 5.1;
f4 = 56.4;
f5 = 2.8;

// use ceil() function to return the nearest number
printf (" The ceiling value of %.2f is %.2f \n ", f1, ceil (f1));
printf (" The ceiling value of %.2f is %.2f \n ", f2, ceil (f2));
printf (" The ceiling value of %.2f is %.2f \n ", f3, ceil (f3));
printf (" The ceiling value of %.2f is %.2f \n ", f4, ceil (f4));
printf (" The ceiling value of %.2f is %.2f \n ", f5, ceil (f5));
return 0;
}</math.h> 
```

**输出**

```
The ceiling value of 2.30 is 3.00
  The ceiling value of -2.70 is -2.00
  The ceiling value of 5.10 is 6.00
  The ceiling value of 56.40 is 57.00
  The ceiling value of 2.80 is 3.00

```

### 示例 3:使用 ceil()函数对浮点数进行舍入的程序

```

#include #include <math.h>int main ()
{
// declare local variables
float num;
float result;

printf (" Enter the float number: ");
scanf ( "%f", &num); 

// use ceil () function
result = ceil (num);

printf ( " The ceil of %.2f is %f ", num, result);
return 0;
}</math.h> 
```

**输出**

```
Enter the float number: 55.6
 The ceil of 55.60 is 56.000000

```

### 示例 4:使用 ceil()函数对正数和负数进行舍入的程序

```

#include #include <math.h>int main ()
{

int num, result, num2, result2;

printf (" Enter the positive integer: ");
scanf (" %d", &num);

printf (" Enter the negative integer: ");
scanf (" %d", &num2);

// use ceil () function to round up the nearest value of the given number. */
result = ceil (num);
result2 = ceil (num2);

printf ( " \n The ceiling integer of %d = %d ", num, result);
printf ( " \n The ceiling integer of %d = %d ", num2, result2);
return 0;
}</math.h> 
```

**输出**

```
Enter the positive integer: 56
 Enter the negative integer: -24

 The ceiling integer of 56 = 56
 The ceiling integer of -24 = -24

```

* * *