# C 语言中的关系运算符

> 原文：<https://www.javatpoint.com/relational-operator-in-c>

运算符是用于对给定操作数执行数学和逻辑运算的特殊符号。C 语言中有各种类型的运算符，如算术、逻辑、按位、关系、条件或三元等。

![Relational Operator in C](img/9be33e29ef0c13c676e1fd550adf2f41.png)

**关系运算符**是用于创建关系和比较两个操作数的值的运算符。

例如，有两个数字，5 和 15，我们可以使用大于运算符(>)获得最大的数字，该运算符将 15 作为 5 的最大或更大的数字返回。

## 关系运算符的类型

下面是 c 语言中各种类型的关系运算符。

### 等于运算符(==)

它用于比较两个操作数，如果两个操作数相等或相同，则返回 1，0 表示不相等的操作数。

**语法**

```

Opr1 == Opr2

```

让我们创建一个程序，使用 double 等号运算符(==)来比较 c 语言中的操作数值。

**程序 1.c**

```

#include #include <math.h>int main ()
{
	int a = 5;
	int b = 10;

	// Use Equal To Operator
	printf (" a == b : %d", (a == b));
	if (a == b)
		printf ("\n %d is equal to %d", a, b);
	else
		printf (" \n %d is not equal to %d", a, b);

	int x = 5;
	int y = 5;

	// Use Equal To Operator
	printf (" \n x == y : %d", (x == y));
	if (a == b)
		printf (" \n %d is equal to %d", x, y);
	else
		printf ("\n %d is not equal to %d", x, y);
	return 0;	
}</math.h> 
```

**输出**

```
a == b : 0
 5 is not equal to 10
 x == y : 1
 5 is not equal to 5

```

### 不等于运算符(！=)

不等于运算符与等于运算符相反，表示为(！=)运算符。不等于运算符比较两个操作数，如果两个操作数不相同，则返回 1；否则，它返回 0。

**语法:**

```

Opr1 != Opr2;

```

让我们创建一个简单的程序来使用不等于(！=)比较 c 中变量值的运算符。

**程序 2.c**

```

#include #include <math.h>int main ()
{
	int a = 5;
	int b = 10;

	// Use Not Equal To (!=) Operator
	printf (" a != b : %d", (a != b));
	if (a != b)
		printf ("\n %d is equal to %d", a, b);
	else
		printf (" \n %d is not equal to %d", a, b);

	int x = 5;
	int y = 5;

	// Use Not Equal To (!=) Operator
	printf (" \n x != y : %d", (x != y));
	if (a != b)
		printf (" \n %d is equal to %d", x, y);
	else
		printf ("\n %d is not equal to %d", x, y);
	return 0;	
}</math.h> 
```

**输出**

```
a != b : 1
 5 is equal to 10
 x != y : 0
 5 is equal to 5

```

### 小于运算符(

它用于检查左操作数的值是否小于右操作数，如果语句为真，该运算符称为小于运算符。

**语法:**

```

A < B;

```

这里操作数 A 小于操作数 b。

让我们创建一个程序，使用小于运算符(

**程序 3.c**

```

#include 

int main ()
{
	int num1, num2;
	printf (" Enter the value of num1: ");
	scanf (" %d", &num1);

	printf (" \n Enter the value of num2: ");
	scanf (" %d", &num2);

	// use less than operator (
```

**输出**

```
Enter the value of num1: 45

 Enter the value of num2: 89

 The value of num1 is less than num2.

```

### 大于运算符(>)

运算符检查左操作数的值是否大于右操作数，如果语句为真，则该运算符称为“大于运算符”。

**语法:**

```

A > B;

```

这里，操作数 A 大于操作数 b。

让我们创建一个程序，使用大于运算符(>)来比较 c 语言中的操作数值。

**程序 4.c**

```

#include int main ()
{
	int num1, num2;
	printf (" Enter the value of num1: ");
	scanf (" %d", &num1);

	printf (" \n Enter the value of num2: ");
	scanf (" %d", &num2);

	// use greater than operator (>) 
	if (num1 > num2)
	{
		printf (" \n The value of num1 is greater than num2.");
	}
	else
	{
		printf (" \n The value of num2 is greater than num1.");
	}
	return 0;
} 
```

**输出**

```
Enter the value of num1: 20

 Enter the value of num2: 30

 The value of num2 is greater than num1.

```

### 小于等于运算符(< =)

运算符检查左操作数的值是否小于或等于右操作数，如果语句为真，则该运算符称为小于等于运算符。

**语法:**

```

A <= B;

```

这里，操作数 A 小于或等于操作数 b。因此，它是小于等于运算符。

让我们创建一个程序，使用小于等于运算符(< =)来比较 c 语言中的操作数值

**程序 5.c**

```

#include int main ()
{
	int num1, num2;
	printf (" Enter the value of num1: ");
	scanf (" %d", &num1);

	printf (" \n Enter the value of num2: ");
	scanf (" %d", &num2);

	// use less than equal to operator (<=) 
	if (num1 < num2)
	{
		printf (" \n The value of num1 is less than num2.");
	}
	else if (num1 <= num2 )
	{
		printf (" \n The value of num1 is equal to num2.");
	}
	else 
	{
		printf (" \n The value of num2 is less than num1.");
	}
	return 0;
} 
```

**输出**

```
Enter the value of num1: 45

 Enter the value of num2: 45

 The value of num1 is equal to num2.

```

### 大于等于运算符(> =)

运算符检查左操作数的值是否大于或等于右操作数。如果该语句为真，则该运算符称为大于等于运算符。

**语法:**

```

A >= B;

```

这里，操作数 A 大于等于右操作数 b。因此，它是大于等于运算符。

让我们创建一个程序，使用大于等于运算符来比较 c 中的操作数值

**程序 6.c**

```

#include int main ()
{
	int num1, num2;
	printf (" Enter the value of num1: ");
	scanf (" %d", &num1);

	printf (" \n Enter the value of num2: ");
	scanf (" %d", &num2);

	// use greater than equal to operator (>=) 
	if (num1 > num2)
	{
		printf (" \n The value of num1 is greater than num2.");
	}
	else if (num1 >= num2 )  // greater than operator (>=)
	{
		printf (" \n The value of num1 is equal to num2.");
	}
	else 
	{
		printf (" \n The value of num2 is greater than num1.");
	}
	return 0;
} 
```

**输出**

```
Enter the value of num1: 28

 Enter the value of num2: 79

 The value of num2 is greater than num1.

```

* * *