# C 语言中的赋值运算符

> 原文：<https://www.javatpoint.com/assignment-operator-in-c>

运算符有不同的种类，如算术、关系、按位、赋值等。，在 C 编程语言中。赋值运算符用于将值、变量和函数赋给另一个变量。让我们讨论各种类型的赋值运算符，如=、+=、-=、/=、*=和%=。

**赋值运算符示例:**

```

A = 5; // use Assignment symbol to assign 5 to the operand A
B = A; // Assign operand A to the B
B = &A; // Assign the address of operand A to the variable B
A = 20 \ 10 * 2 + 5; // assign equation to the variable A

```

![Assignment Operator in C](img/0ec20db7e54f57e6473fb14914f80190.png)

### 简单赋值运算符(=):

它是用于将右侧操作数或变量分配给左侧变量的运算符。

**语法**

```

int a = 5;
or int b = a;
ch = 'a';

```

让我们创建一个程序来使用 c 语言中的简单赋值运算符。

**程序 1.c**

```

#include #include <conio.h>int main ()
{
	// initialize variables
	int n1, n2, c, x, y;
	n1 = 5;
	n2 = n1;
	c = n1 + n2;
	x = 20 / 4 * 2 + 5;
	printf (" \n The value of n1: %d", n1);
	printf (" \n The value of n2: %d", n2);
	printf (" \n The value of c: %d", c);
	printf (" \n The value of x: %d", x);
	return 0;
}</conio.h> 
```

**输出**

```
 The value of n1: 5
 The value of n2: 5
 The value of c: 10
 The value of x: 15

```

### 加号和赋值运算符(+=):

运算符用于将左侧操作数与左侧操作数相加，然后将结果赋给左侧操作数。

**语法**

```

A += B;
Or 
A = A + B;

```

让我们创建一个程序来使用 c 语言中的加号和赋值运算符。

**程序 2.c**

```

#include #include <conio.h>int main ()
{
	// initialize variables
	int n1, n2, c;
	n1 = 5;
	n2 = 10;
	n2 += n1;
	printf (" \n The value of n1: %d", n1);
	printf (" \n The value of n2: %d", n2);

	return 0;
}</conio.h> 
```

**输出**

```
The value of a: 5
 The value of b: 15

```

### 减法和赋值运算符(-=):

运算符用于用右操作数减去左操作数，然后将结果赋给左操作数。

**语法**

```

A -= B;
Or 
A = A - B;

```

让我们创建一个程序，在 c 语言中使用减法和赋值(-=)运算符

**程序 3.c**

```

#include #include <conio.h>int main ()
{
	// initialize variables
	int n1, n2, c;
	n1 = 5;
	n2 = 10;
	n2 -= n1; // Use Subtract and Equal operator (b = b - a)
	printf (" \n The value of n1: %d", n1);
	printf (" \n The value of n2: %d", n2);

	return 0;
}</conio.h> 
```

**输出**

```
 The value of n1: 5
 The value of n2: 5

```

### 乘法和赋值运算符(*=)

运算符用于将左操作数与右操作数相乘，然后将结果赋给左操作数。

**语法**

```

A *= B;
Or 
A = A * B;

```

让我们创建一个程序来使用 c 语言中的乘法和赋值运算符(*=)

**程序 4.c**

```

#include #include <conio.h>int main ()
{
	// initialize variables
	int n1, n2, c;
	n1 = 5;
	n2 = 10;
	n2 *= n1; // Use Multiply and Equal operator (b = b * a)
	printf (" \n The value of n1: %d", n1);
	printf (" \n The value of n2: %d", n2);

	return 0;
}</conio.h> 
```

**输出**

```
The value of n1: 5
 The value of n2: 50

```

### 除法和赋值运算符(/=):

在左操作数和右操作数之间使用一个运算符，该运算符将第一个数除以第二个数，以返回左操作数中的结果。

**语法**

```

A /= B;
Or 
A = A / B;

```

让我们创建一个程序来使用 c 语言中的除法和赋值运算符(/=)

**程序 5.c**

```

#include #include <conio.h>int main ()
{
	// initialize variables
	int n1, n2, c;
	n1 = 5;
	n2 = 10;
	n2 /= n1; // Use divide and Equal operator (b = b / a)
	printf (" \n The value of n1: %d", n1);
	printf (" \n The value of n2: %d", n2);

	return 0;
}</conio.h> 
```

**输出**

```
The value of n1: 5
 The value of n2: 2

```

### 模数和赋值运算符(%)=:

在左操作数和右操作数之间使用的运算符将第一个数(n1)除以第二个数(n2)，并返回左操作数中的余数。

**语法**

```

A %= B;
Or 
A = A % B;

```

让我们创建一个程序来使用 c 语言中的除法和赋值运算符(%)=。

**程序 6.c**

```

#include #include <conio.h>int main ()
{
	// initialize variables
	int n1, n2, c;

	printf (" Enter the value of n1: ");
	scanf ("%d", &n1);

	printf (" \n Enter the value of n2: ");
	scanf ("%d", &n2);
	n1 %= n2; // Use modulus and Equal operator (a = a % b)
	printf (" \n The modulus value of n1: %d", n1);

	return 0;
}</conio.h> 
```

**输出**

```
Enter the value of n1: 23

 Enter the value of n2: 5

 The modulus value of n2: 3

```

* * *