# C 中的字谜

> 原文：<https://www.javatpoint.com/anagram-in-c>

本节将讨论字谜及其程序，以检查给定的字符串是否是字谜。字符串的字谜是在两个字符串中包含相同字符的字符串，只是字符串中字符的顺序可能不同。换句话说，字谜是一种 C 编程技术，它检查给定的字符串是否包含相同数量的字符，只是两个字符串中的字符序列可以改变。

例如，假设我们有两个字符串:“CAB”和“ABC”。这两个字符串都包含相同的字符，但是第一个字符串的字符排列不同于第二个字符串，这个过程称为字符串的字谜。

![Anagram in C](img/501255db52efa7b236e278873b006e54.png)

### 字谜字符串的算法

以下是 C 语言中字谜字符串的算法，如下所示:

1.  从用户输入两个字符串。
2.  检查每个字符串的长度。如果第一个字符串的长度不等于第二个字符串，则这些字符串不是字谜。
3.  如果两个字符串的长度相等，请将字符串的字符转换为小写字母，以便于比较字符串。
4.  之后，使用 C 库的内置函数对字符串的字符进行排序，从而对字符串进行排序。如果没有内置函数，我们将字符串转换为字符数组。
5.  我们必须将转换后的字符串排序为字符数组。
6.  最后，我们检查字符串是否相等。

**例 1:使用用户自定义函数**检查字符串字谜的程序

```

#include // function definition
int get_anagrm (char [],char []);

int main ()
{
	// declaration of the array
	char arr1 [50], arr2 [50];
	int count;

	printf (" Enter the first string: \n ");
	scanf (" %s", arr1);

	printf (" Enter the second string: \n ");
	scanf (" %s", arr2);

	// call function
	count = get_anagrm (arr1, arr2);

	// use if-else statement to validate both strings are anagram or not.

	if (count == 1)
	{
		printf (" %s and %s strings are an anagram of each other. \n", arr1, arr2);
	}
	else
	{
		printf (" %s and %s strings are not an anagram of each other. \n", arr1, arr2);
	}

	return 0;
}

// function defnition
int get_anagrm (char arr1[], char arr2[])
{
	// create two num arrays and initialize their value as 0
	int num1[20] = {0}, num2[20] = {0}, i = 0;

	// use while loop to check arr1 is not null
	while (arr1[i] != '\0')
	{
		num1[arr1[i] -'a']++;
		i++;
	}

	i = 0;

	// use while loop to check arr2 is not null
	while (arr2[i] != '\0')
	{
		num2[arr2[i] -'a']++;
		i++;
	}

	for ( i = 0;i <20; i++)
	{
		if ( num1[i] != num2[i])
			return 0;
	}
	return 1;
} 
```

**输出**

```
Enter the first string:
pine
Enter the second string
nipe
pine and nipe strings are an anagram of each other.

2nd time run:
Enter the first string:
pine
Enter the second string
nip
pine and nip strings are not an anagram of each other.

```

**示例 2:使用嵌套 for 循环检查字符串的字谜的程序**

```

#include #include <stdbool.h>#include <string.h>// define the no. of characters
#define No_Character 30

// use bool function to check the strings are anagrams
bool strAna (char *st1, char *st2)
{
	// create two arrays and initialized with 0
	int arr1[No_Character] = {0};
	int arr2[No_Character] = {0};

	int n = 0;
	// check the length of each string
	if (strlen (st1) != strlen (st2))
		return false;

	// use for loopto incremnet the array index
	for ( n = 0; st1[n] && st2[n]; n++)
	{
		// increment the string character
		// ascii value of a is 97
		arr1[st1[n]-97]++;
		arr2[st2[n]-97]++;
		}	

	// 	arr1 is compared using the assigned value
	for (n = 0; n < No_Character; n++)
	{
		if (arr1[n] != arr2[n])
			return false;
		return true;	
	}
}

int main ()
{
	char st1[50], st2[50];

	printf (" Input the first string: ");
	gets(st1);

	printf (" Input the second string: ");
	gets(st2);
	// call strAna function to check the anagram of the string
	if (strAna (st1, st2))
	{
		printf (" \n The first string is an anagram of the second string. ");
	}
	else
	{
		printf (" \n The first string is not an anagram of the second string. ");
	}
	return 0;
}</string.h></stdbool.h> 
```

**输出**

```
Input the first string: triangle
Input the second string: agtrinle
The first string is an anagram of the second string.

```

**示例 3:使用 for 和 if 语句检查字符串的字谜的程序**

```

#include #include <string.h>int main ()
{
	// declare the character type array
	char arr1[30], arr2[30];
	int len1, len2, num, i, j, found = 0, not_found = 0;

	printf (" Input the first string: ");
	scanf ("%s", arr1);

	printf (" Input the second string: ");
	scanf ("%s", arr2);

	// get the length of the strings
	len1 = strlen (arr1);
	len2 = strlen (arr2);

	// use if statement to check the length is equal or not
	if (len1 == len2)
	{
		num = len1; // assign the length to num variable
		for ( i = 0; i < num; i++)
		{
			found = 0;
			for ( j = 0; j < num; j++)
			{
				// check string is equal or not
				if (arr1[i] == arr2[j])
				{
					found = 1;
					break;
				}
			}

			if (found == 0)
			{
				not_found = 1; // assign 1 to not_found
				break;
			}
		}
		if (not_found == 1)
			printf (" \n The first string is not an anagram of the second string. ");
		else
			printf (" \n The first string is an anagram of the second string. ");	
	}
	else
		printf (" \n Both string must contains same number of character to be the anagram of string. ");

	return 0;	
}</string.h> 
```

**输出**

```
Input the first string: SILENCE
Input the second string: LENSICE
The first string is an anagram of the second string.

```

**例 4:对字符串进行排序并检查字符串字谜的程序**

```

#include #include <conio.h>#include <string.h>// declaration of the functions
void cnvt_to_lwr (char []);
void sortArr (char []);

int main ()
{
	char str1[] = "course", str2[] = "source";
	int x, y = 0;

	// check the length of each string
	if (strlen (str1) != strlen (str2))
	{
		printf(" The given strings are not anagram of each other. ");
		return 0;
	}

	else
	{
		// convert string into lowercase
		cnvt_to_lwr (str1);
		cnvt_to_lwr (str2);

		// call sortArr() function to sort the arrays
		sortArr (str1);
		sortArr (str2);
		for (x = 0; x < strlen (str1); x++)
		{
			// check string is equal or not
			if (str1[x] != str2[x])
			{
				printf (" The given strings are not an anagram of each other.");
				return 0;
			}
		}
		printf ( " Both strings are an anagram of each other. ");
	}
		return 0;

	}

// function definition here
void cnvt_to_lwr (char a1[])
{
	int num;
	for ( num = 0; num < strlen(a1) -1; num++)
	{
		a1[num] = a1[num] + 32;
	}
}

// sorting here
void sortArr (char a1[])
{
	int temp = 0, i, l;

	for (i = 0; i <strlen i="" for="" l="i+1;" strlen="" if="">a1[l])
			{
				temp = a1[i];
				a1[i] = a1[l];
				a1[l] = temp;

			}
		}
	}	

}</strlen></string.h></conio.h> 
```

**输出**

```
Both strings are an anagram of each other.

```

* * *