# C 语言中的递增和递减运算符

> 原文：<https://www.javatpoint.com/increment-and-decrement-operators-in-c>

运算符是 C/C++ 库的预定义符号，用于对操作数执行逻辑和数学运算。C 编程语言中有各种类型的运算符，如算术、逻辑、按位、递增或递减运算符等。

![Increment and Decrement Operators in C](img/dbef657af37b7f1e5aa79dfcf1aaa4cf.png)

## 增量运算符

增量运算符是用于对操作数值进行增量或加 1 的一元运算符。增量操作数由双加号(++)表示。它有两种类型，前增量运算符和后增量运算符。

### 预增量运算符

在将操作数赋值给表达式之前，预递增运算符用于将操作数的原始值增加 1。

**语法**

```

X = ++A;

```

在上面的语法中，操作数“A”的值增加 1，然后给变量“B”分配一个新值。

**例 1:在 C** 中使用预增量运算符的程序

```

#include #include <conio.h>int main ()
{
 // declare integer variables
int x, y, z;
printf (" Input the value of X: ");
scanf (" %d", &x);      
printf ("  Input the value of Y: ");
scanf (" %d", &y);
printf (" Input the value of Z: ");
scanf (" %d", &z);
// use pre increment operator to update the value by 1
++x;
++y;
++z;

printf (" \n The updated value of the X: %d ", x);
printf (" \n The updated value of the Y: %d ", y);
printf (" \n The updated value of the Z: %d ", z); 
return 0;
}</conio.h> 
```

**输出**

```
Input the value of X: 10
Input the value of Y: 15
Input the value of Z: 20

The updated value of the X: 11
The updated value of the Y: 16
The updated value of the Z: 21

```

### 后增量运算符

后递增运算符用于在将操作数赋值给表达式后，将操作数的原始值递增 1。

**语法**

```

X = A++;

```

在上面的语法中，操作数“A”的值被赋给变量“X”。之后，变量“A”的值增加 1。

**例 2:在 C** 中使用后递增运算符的程序

```

#include #include <conio.h>int main ()
{
 // declare integer variables
int x, y, z, a, b, c;
printf (" Input the value of X: ");
scanf (" %d", &x);      
printf (" Input the value of Y: ");
scanf (" %d", &y);
printf (" Input the value of Z: ");
scanf (" %d", &z);
// use post-increment operator to update the value by 1
a = x++;
b = y++;
c = z++;

printf (" \n The original value of a: %d", a);
printf (" \n The original value of b: %d", b);
printf (" \n The original value of c: %d", c);

printf (" \n\n The updated value of the X: %d ", x);
printf (" \n The updated value of the Y: %d ", y);
printf (" \n The updated value of the Z: %d ", z); 
return 0;
}</conio.h> 
```

**输出**

```
Input the value of X: 10
Input the value of Y: 15
Input the value of Z: 20

The original value of a: 10
The original value of b: 15
The original value of c: 20

The updated value of the X: 11
The updated value of the Y: 16
The updated value of the Z: 21

```

## 递减运算符

递减运算符是一元运算符，用于将操作数的原始值减少 1。减量运算符表示为双减号(-)。它有两种类型，预递减运算符和后递减运算符。

### 预递减运算符

预递减运算符在将操作数值赋给数学表达式之前，先将其减少 1。换句话说，操作数的原始值首先减少，然后给另一个变量分配一个新值。

**语法**

```

B = --A;

```

在上面的语法中，操作数“A”的值减 1，然后给变量“B”赋值。

**例 3:用 C** 演示预减量运算符的程序

```

#include #include <conio.h>int main ()
{
 // declare integer variables
int x, y, z;
printf (" Input the value of X: ");
scanf (" %d", &x);      
printf (" \n Input the value of Y: ");
scanf (" %d", &y);
printf ("n Input the value of Z: ");
scanf (" %d", &z);
// use pre decrement operator to update the value by 1
--x;
--y;
--z;

printf (" \n The updated value of the X: %d ", x);
printf (" \n The updated value of the Y: %d ", y);
printf (" \n The updated value of the Z: %d ", z); 
return 0;
}</conio.h> 
```

**输出**

```
Input the value of X: 5
Input the value of Y: 6
Input the value of Z: 7

The updated value of the X: 6
The updated value of the Y: 7
The updated value of the Z: 8

```

### 后减量运算符:

后递减运算符用于在赋值给表达式后将操作数的原始值减少 1。

**语法**

```

B = A--;

```

在上面的语法中，操作数“A”的值被赋给变量“B”，然后 A 的值减 1。

**例 4:C**中使用后减量运算符的程序

```

#include #include <conio.h>int main ()
{
 // declare integer variables
int x, y, z, a, b, c;
printf (" Input the value of X: ");
scanf (" %d", &x);      
printf (" Input the value of Y: ");
scanf (" %d", &y);
printf (" Input the value of Z: ");
scanf (" %d", &z);
// use post-decrement operator to update the value by 1
a = x--;
b = y--;
c = z--;

printf (" \n The original value of a: %d", a);
printf (" \n The original value of b: %d", b);
printf (" \n The original value of c: %d", c);

printf (" \n\n The updated value of the X: %d ", x);
printf (" \n The updated value of the Y: %d ", y);
printf (" \n The updated value of the Z: %d ", z); 
return 0;
}</conio.h> 
```

**输出**

```
Input the value of X: 6
Input the value of Y: 12
Input the value of Z: 18

The original value of a: 6
The original value of b: 12
The original value of c: 18

The updated value of the X: 5
The updated value of the Y: 11
The updated value of the Z: 17

```

**例 5:执行预增预减运算符的程序**

```

#include #include <conio.h>int main ()
{
// declare integer data type variable
int i, j, x, y;
printf (" Enter the value of i " );
scanf (" %d", &i); 
printf (" Enter the value of j " );
scanf (" %d", &j);

// use pre increment operator to update original value by 1
x = ++i; 
printf (" After using the pre-incrementing, the value of i is %d \n", i);
printf (" The value of x is %d \n", x);

// use pre decrement operator to decrease original value by 1
y = --j; 
printf (" After using the pre-decrementing, the value of j is %d \n", j);
printf (" The value of y is %d \n", y);
return 0;
}</conio.h> 
```

**输出**

```
Enter the value of i
5
Enter the value of j
10
After using the pre-incrementing, the value of i is 6
The value of x is 6
After using the pre-decrementing, the value of j is 9
The value of y is 9

```

**例 6:打印后增后减运算符的程序**

```

#include #include <conio.h>int main ()
{
// declare integer data type variable
int i, j, x, y;
printf (" Enter the value of i " );
scanf (" %d", &i); 
printf (" Enter the value of j " );
scanf (" %d", &j);

// use post increment operator to update original value by 1
x = i++; 
printf (" After using the post-incrementing, the value of i is  %d \n", i);
printf (" The value of x is %d \n", x);

// use post decrement operator to decrease original value by 1
y = j--; 
printf (" After using the post-decrementing, the value of j is  %d \n", j);
printf (" The value of y is %d \n", y);
return 0;
}</conio.h> 
```

**输出**

```
Enter the value of i 10
Enter the value of j 20
After using the post-incrementing, the value of i is 11
The value of x is 10
After using the post-decrementing, the value of j is 19
The value of y is 20

```

## C 语言中递增和递减运算符的区别

| 增量运算符 | 递减运算符 |
| 它用于将变量值增加 1。 | 它用于将操作数值减少 1。 |
| 增量运算符表示为双加号(++)。 | 减量运算符表示为双减号(-)符号。 |
| 它有两种类型:前增量运算符和后增量运算符。 | 同样，它有两种类型:前减量运算符和后减量运算符。 |
| 预递增运算符意味着运算符的值先递增，然后在表达式中使用。
后递增运算符是指先在表达式中使用操作数，然后对初始值执行 1 的递增运算。 | 预递减意味着运算符的值先递减，然后在表达式中赋值。
而后递减运算符意味着操作数首先在表达式中使用，然后对操作数的原始值执行递减操作 1。 |
| 预增量运算符的语法:X = +++a；
后递增运算符的语法:X = a++； | 预递减运算符的语法:X =-a；
后递减运算符的语法:X = a-； |
| 这两个运算符只对单个操作数起作用，对值不起作用。 | 这两个运算符只对单个操作数起作用，对值不起作用。 |

* * *