# C 语言中的移位运算符

> 原文：<https://www.javatpoint.com/shift-operators-in-c>

本节将讨论 c 编程语言中的按位移位运算符。按位移位运算符用于根据程序要求向左或向右移位二进制位。

![Shift Operators in C](img/22ecb1df6d917629595d438f7de1fe8d.png)

移位运算符根据位的移位位置分为两种类型。

1.  左移位运算符
2.  右移位运算符

### 左移位运算符

左移位运算符是一种按位移位运算符，它对二进制位执行运算。它是一个二进制运算符，需要两个操作数来移动或向左移动位的位置，并在移动位后向右侧创建的空白空间添加零。

**语法**

```

var_name << no_of_position

```

在上面的语法中，var_name 表示整数变量名，将对其执行左移位(<

例如，整数变量 num 的值是 22，其二进制形式是 10110。现在我们使用左移位操作符来移位二进制位 2，num = num << 2 等于 num = num * (2^2).num 的新值是 22* (2 ^ 2) = 88，等于二进制形式 1011000。

**示例 1:演示在 C** 中使用左移位运算符的程序

```

#include int main ()
{
// declare local variable
int num;
printf (" Enter a positive number: ");
scanf (" %d", &num);
// use left shift operator to shift the bits
num = (num << 2); // It shifts two bits at the left side
printf (" \n After shifting the binary bits to the left side. ");
printf (" \n The new value of the variable num = %d", num);
return 0;
} 
```

**输出**

```
Enter a positive number: 25
After shifting the binary bits to the left side.
The new value of the variable num = 100 

```

**例 2:在 C** 的无符号整数数据中使用左移运算符的程序

```

#include int main ()
{
// declare local variable
unsigned int num = 0xff;
// use left shift operator to shift the bits
num = (num << 2);
printf (" \n After shifting the binary bits to the left side. ");
printf (" \n The new value of the unsigned variable num = %d", num);
return 0;
} 
```

**输出**

```
After shifting the binary bits to the left side.
The new value of the unsigned variable num = 1020 

```

**例 3:用户输入正数执行左移操作的程序**

```

#include int main ()
{
// declare local variable
int num, bit;
printf (" Enter a positive number: ");
scanf (" %d", &num);

printf (" No. of binary bits shifted to the left side: ");
scanf (" %d", &bit);
// use left shift operator to shift the bits
num = (num << bit);
printf (" \n After shifting the bits to the left side. ");
printf (" \n The new value of the num = %d", num);
return 0;
} 
```

**输出**

```
Enter a positive number: 40
No. of binary bits shifted to the left side: 4
After shifting the bits to the left side.
The new value of the num = 640   

```

在上面的例子中，用户定义的正数 40 的二进制位是 101000。之后，我们以 4 为数字，对左边的二进制位进行移位。然后，左移位运算符在左侧移位 4 个二进制位，然后在右侧创建一个空格，在右侧填充或添加 4 个零，返回二进制值 1010000000，相当于十进制数 640。

### 右移位运算符

右移位运算符是一种按位移位运算符，用于移动右侧的位，它表示为双(>>)箭头符号。像左移位运算符一样，右移位运算符也需要两个操作数来移位右侧的位，然后在移位位后在左侧创建的空白位置插入零。

**语法**

```

var_name >> no_of_position

```

在上面的语法中，var_name 表示整数变量，将对该变量执行右移(>>)操作以移动右侧的二进制位。并且 no_of_position 变量表示要放置或移到右侧的位数。换句话说，右移位运算符通过定义第二个操作数的总位数，将右侧第一个操作数的二进制位移位。

**示例 1:演示在 C** 中使用右移运算符的程序

```

#include int main ()
{
// declare local variable
int num;
printf (" Enter a positive number: ");
scanf (" %d", &num);
// use right shift operator to shift the bits
num = (num >> 2); // It shifts two bits at the right side
printf (" \n After shifting the binary bits to the right side. ");
printf (" \n The new value of the variable num = %d", num);
return 0;
} 
```

**输出**

```
Enter a positive number: 25

After shifting the binary bits to the right side.
The new value of the variable num = 6 

```

**例 2:在 C** 的无符号整数数据中使用右移位运算符的程序

```

#include int main ()
{
// declare local variable
unsigned int num = 0xff;
// use right shift operator to shift the bits
num = (num >> 2);
printf (" \n After shifting the binary bits to the right side. ");
printf (" \n The new value of the unsigned variable num = %d", num);
return 0;
} 
```

**输出**

```
After shifting the binary bits to the right side.
The new value of the unsigned variable num = 63 

```

**例 3:从用户输入正数执行右移操作的程序**

```

#include int main ()
{
// declare local variable
int num, bit;
printf (" Enter a positive number: ");
scanf (" %d", &num);

printf (" No. of binary bits shifted to the right side: ");
scanf (" %d", &bit);
// use right shift operator to shift the bits
num = (num >> bit);
printf (" \n After using the right shift operator to shift the bits at the right side. ");
printf (" \n New value of the num = %d", num);
return 0;
} 
```

**输出**

```
Enter a positive number: 40
No. of binary bits shifted to the right side: 4
After using the right shift operator to shift the bits to the right. 
The new value of the num = 2 

```

* * *