# 从 C 语言的数组中删除重复元素

> 原文：<https://www.javatpoint.com/remove-duplicate-elements-from-an-array-in-c>

本节将讨论在 C 编程语言中从数组中删除重复的元素。当相同数量的元素出现在排序或未排序的数组中时，该数组的元素称为重复元素。我们需要从一个数组中删除这些重复的元素或相同的数字，以使结果数组由唯一的元素组成。

例如，有一个包含{ 5，8，3，3，5，9}个元素的整数类型数组 arr[10]。在这个数组中，3 和 5 出现两次。因此，这些元素是重复的元素。因此，从数组 arr[]中删除重复的元素后，我们得到 5，8，3，9 个元素。

**从未排序数组中删除重复元素的步骤**

步骤 1:从用户输入数组的大小，并存储到大小变量中。

步骤 2:使用 for 循环读取数组的元素并存储在 arr[i]变量中。

步骤 3:要从数组中获取重复的元素，我们需要使用两个循环。其中第一个循环从 0 开始到大小。而循环的结构是:for(I = 0；I

另一个循环选择数组的每个元素，并与相应的元素进行比较，以获得重复的元素。而内环的结构是:for(j = I+1；j

步骤 4:如果遇到任何重复的元素，从数组中删除重复的元素，数组的大小减 1，这样，大小= size - 1。

第五步:之后，打印一个数组的唯一元素，代码是:

```

for (i = 0; i < size; i++)
{
printf ("%d \t" , arr[i]);
}

```

**示例 1:从数组中删除重复元素的程序**

让我们考虑一个在 C 编程语言中从数组中删除相同数量或重复元素的例子。

```

#include #include <conio.h>int main ()
{
	// declare local variables 
	int arr[20], i, j, k, size;

	printf (" Define the number of elements in an array: ");
	scanf (" %d", &size);

	printf (" \n Enter %d elements of an array: \n ", size);
	// use for loop to enter the elements one by one in an array
	for ( i = 0; i < size; i++)
	{
		scanf (" %d", &arr[i]);
	}

	// use nested for loop to find the duplicate elements in array
	for ( i = 0; i < size; i ++)
	{
		for ( j = i + 1; j < size; j++)
		{
			// use if statement to check duplicate element
			if ( arr[i] == arr[j])
			{
				// delete the current position of the duplicate element
				for ( k = j; k < size - 1; k++)
				{
					arr[k] = arr [k + 1];
				}
				// decrease the size of array after removing duplicate element
				size--;

			// if the position of the elements is changes, don't increase the index j
				j--;	
			}
		}
	}

	/* display an array after deletion or removing of the duplicate elements */
	printf (" \n Array elements after deletion of the duplicate elements: ");

	// for loop to print the array
	for ( i = 0; i < size; i++)
	{
		printf (" %d \t", arr[i]);
	}
	return 0;
}</conio.h> 
```

**当我们在 C 编译器中执行上述程序时，它会在控制台屏幕中产生下面给出的输出。**

```
Define the number of elements in an array: 10

 Enter 10 elements of an array:
 57
12
89
32
62
12
89
35
67
75

 Array elements after deletion of the duplicate elements:  57    12      89      32      62      35      67      75

```

**从排序的数组中移除重复的元素**

假设我们有一个给定的排序数组，任务是从数组中移除相同数量的元素。例如，有一个整数类型的数组，其大小为 5，包含 arr[] = {2，2，3，3，5}个元素。在这个排序的数组中，2 和 3 出现两次。因此，这些元素是重复的元素。因此，从数组 arr[]中删除重复的元素后，我们得到 2，3，5 个元素，数组的新大小是 3。

**从排序数组中删除重复元素的算法**

下面是在 C 编程语言中从排序数组中删除重复数组元素的算法。

1.  定义数组元素的大小。
2.  从用户处读取数组元素。
3.  从 i = 1 到 num 重复。
    1.  如果！= arr [i + 1]
    2.  temp [j++] = arr[i]
    3.  temp [j++] = arr[n- 1]
    4.  从 i = 1 到 j 重复
    5.  arr[i] =温度
    6.  arr [i] =温度
    7.  返回 j。
4.  打印数组的唯一元素。

**示例 2:使用用户定义函数**从排序数组中删除重复元素的程序

让我们考虑一个在 C 编程语言中从排序数组中删除相同数量或重复元素的例子。

```

/* program to delete the duplicate elements from sorted array in C. */
#include int duplicate_element ( int arr[], int num)
{
	// check num is equal to 0 and num == 1
	if (num == 0 || num == 1)
		return num;

	// create temp array to store same number	
	int temp [num];	

	// declare variable
	int i, j = 0;

	// use for loop to check duplicate element
	for (i = 0; i < num - 1; i++)
	{
		// check the element of i is not equal to (i + 1) next element
		if (arr [i] != arr[i + 1])
			temp[j++] = arr[i];
	}
	temp[j++] = arr[ num - 1];

	// check the original array's elements with temporary array's elements
	for (i = 0; i < j; i++)
	{
		arr[i] = temp[i];
		}	

	return j;	
}

int main ()
{
	int num;
	printf (" Define the no. of elements of the array: ");
	scanf (" %d", &num);

	int arr[num], i;

	printf (" Enter the elements: ");
	// use loop to read elements one by one
	for ( i = 0; i < num; i++)
	{
		scanf (" %d", &arr[i]);
	}

	printf (" \n Elements before removing duplicates: ");
	for ( i = 0; i < num; i++)
	{
		printf (" %d", arr[i]);
	}

	num = duplicate_element (arr, num);

	// print array after removing duplicates elements
	printf (" \n Display array's elements after removing duplicates: ");
	for ( i = 0; i < num; i++)
	{
		printf (" %d", arr[i]);
		}	

	return 0;	

} 
```

**当我们在 C 编译器中执行上述程序时，它会在控制台屏幕中产生下面给出的输出。**

```
Define the no. of elements of the array: 10
 Enter the elements: 5
6
6
7
8
8
9
10
11
11

 Elements before removing duplicates:  5 6 6 7 8 8 9 10 11 11
 Display array's elements after removing duplicates:  5 6 7 8 9 10 11

```

**示例 3:使用指针**删除重复数组元素的程序

让我们考虑一个例子，通过使用 C 编程语言中的指针删除重复的元素来打印唯一的数组元素。

```

/* program to delete the duplicate elements from sorted array using pointers in C. */
#include #include <stdlib.h>// declare variable
int i, j;

// definition of the function
int remove_element ( int *ptr, int num)
{
int temp;

// use for loop 

for ( i = 0; i < num-1; i++)
{
	for (j = i + 1; j < num; j++)
	{
		// if statement to check the same number int sorted array
		if ( *(ptr+i) == *(ptr+j))
		{
			temp = *(ptr + j);
			*(ptr + j) = *(ptr + num - 1);
			*(ptr + num - 1) = temp;
			num--;
		}
	}
}	

    printf (" After removing the duplicate elements: ");
	for ( i = 0; i < num; i++)
	{
		printf (" %d \t", *(ptr+i));
	}
	return 0;
}

int main ()
{
	// declare local variable
	int num, *ptr;
	printf (" Define the size of the array element: ");
	scanf (" %d", &num);

	ptr = (int *) malloc (num * sizeof(int));

	printf (" \n Enter the elements of the array: \n");
	// use for loop to read elements
	for ( i = 0; i < num; i++)
	{
		scanf (" %d", (ptr+i));
	}

	// call function to print the unique elements
	remove_element (ptr, num);
	return 0;
}</stdlib.h> 
```

**当我们在 C 编译器中执行上述程序时，它会在控制台屏幕中产生下面给出的输出。**

```
Define the size of the array element: 10

 Enter the elements of the array:
5
5
6
7
7
8
8
9
10
11
 After removing the duplicate elements:  5       11      6       7       10      8       9

```

**示例 4:通过为相同元素创建单独的索引来删除排序数组中的重复元素**

让我们考虑一个例子，通过在 C 编程语言中为相同数量的元素/索引创建额外的空间来显示排序数组中的唯一元素。

```

#include #include <conio.h>/* deleteDuplicate() function to remove same elements
and return new array size. */
int deleteDuplicate (int arr[], int num)
{

	if (num == 0 || num == 1)
		return num;

// store index of next unique element
int i, j = 0;

// use for loop to find and remove the duplicate elements
for (i = 0; i < num - 1; i++)
{
	if ( arr[i] != arr[i+1])
	{
		arr[j++] = arr[i];
	}	

}
arr[j++] = arr[num -1];
return j;
}

int main ()
{
	int i;
	// initialize sorted array
	int arr[] = {5, 10, 10, 15, 15, 20, 25, 25, 30, 30};

	// get the size of the array
	int num = sizeof(arr) / sizeof(arr[0]);

	/* call deleteDuplicate() function to 
	delete duplicate element and return new size. */
	num = deleteDuplicate(arr, num);

	printf (" Display the unique elements from the sorted array: \n ");
	// display the updated element of the sorted array
	for ( i = 0; i < num; i++)
	{
		printf (" %d \t", arr[i]);
	}
	return 0;
}</conio.h> 
```

**当我们在 C 编译器中执行上述程序时，它会在控制台屏幕中产生下面给出的输出。**

```
Display the unique elements from the sorted array:
  5      10      15      20      25      30

```

* * *