# C 语言中的 isalnum()函数

> 原文：<https://www.javatpoint.com/isalnum-function-in-c>

本节将讨论 C 编程语言中的 isalnum()函数，以检查作为参数传递的字符是否是有效的字母数字字符。isalnum()函数在 ctype.h 头文件中声明。isalnum()函数接受一个参数，并测试数字和字母表的字符。如果给定的字符是数字(0 - 9)或字母(a - z 或 A 到 Z)，它将返回真或非零值。否则，它返回 false 或零。

例如，如果给定的字符是“a”，isalnum()函数将返回一个非零值。同样，我们输入 5 作为 isalnum()函数的数字，该函数返回非零值。如果给定的数字既不是字母(A 到 Z 或 A 到 Z)也不是从 0 到 9 的数字，它将返回零。

![isalnum() function in C](img/2008f74523fc31d9d53c8574339937e3.png)

### isalnum()函数的语法

下面是 C 编程语言中 isalnum()函数的语法，如下所示:

```

int isalnum (int ch);

```

这里，isalnum 函数以 ch 为参数，检查给定的参数是否是字母数字。

### 参数:

**ch** :表示要检查的字母或数字。

### 返回值:

当传递的“ch”字符是数字或字母时，它返回非零值。否则，显示 0。

**示例 1:演示 C** 中 isalnum()函数用法的程序

让我们考虑一个例子，检查给定的字符在 C 编程语言中是否是字母数字。

```

/* get the alphanumeric number using the isalnum() function in C. */
#include #include <conio.h>int main ()
{
	// declaration of the variables
	int ch1 = 'A';
	int ch2 = 'e';
	int ch3 = '/conio.h>;
	int ch4 = '7'; 
	int ch5 = ' ';
	int ch6 = '0';

	/* use isalnum () function to check the given number is alphanumeric. */
	if ( isalnum (ch1) )
	{
		printf (" '%c' is an alphanumeric character. \n", ch1);
	}
	else
	{
		printf ("'%c' is not an alphabetic or numeric character. \n", ch1);
	}

	if ( isalnum (ch2) )
	{
		printf (" '%c' is an alphanumeric character. \n", ch2);
	}
	else
	{
		printf ("'%c' is not an alphabetic or numeric character. \n", ch2);
	}

	if ( isalnum (ch3) )
	{
		printf (" '%c' is an alphanumeric character. \n", ch3);
	}
	else
	{
		printf ("'%c' is not an alphabetic or numeric character. \n", ch3);
	}

	if ( isalnum (ch4) )
	{
		printf (" '%c' is an alphanumeric character. \n", ch4);
	}
	else
	{
		printf (" '%c' is not an alphabetic or numeric character. \n", ch4);
	}

	if ( isalnum (ch5) )
	{
		printf (" '%c' is an alphanumeric character. \n", ch5);
	}
	else
	{
		printf (" '%c' is not an alphabetic or numeric character. \n", ch5);
	}

	if ( isalnum (ch6) )
	{
		printf (" '%c' is an alphanumeric character. \n", ch6);
	}
	else
	{
		printf (" '%c' is not an alphabetic or numeric character. \n", ch6);
	}

	return 0;
}</conio.h> 
```

**输出:**

```
'A' is an alphanumeric character.
'e' is an alphanumeric character.
'$' is not an alphabetic or numeric character.
'7' is an alphanumeric character.
 ' ' is not an alphabetic or numeric character.
'0' is an alphanumeric character.

```

在上面的程序中，isalnum()函数检查每个变量的值，传递的字符是否是字母数字值。如果给定的字符是字母数字，它返回%c 是字母数字字符；否则，它会显示%c 不是字母数字字符。

**示例 2:使用 isalnum()功能输入字符并检查字母数字的程序**

让我们考虑一个从用户输入字符的例子，并检查给定的字符在 C 编程语言中是否是字母数字。

```

#include #include <ctype.h>int main ()
{
	// declare char data type variable 
	char ch;

	printf (" \n Enter a valid character: ");
	scanf (" %c", &ch);

	/* use isalnum() function to check the valid alphabets (a to z or A to Z) or numeric (0 to 9) character */
	if (isalnum (ch))
	{
		printf (" \n '%c' is a valid alphanumeric character. ", ch);
	}
	else
	{
		printf (" \n %c is not an alphanumeric character. ", ch);
		printf (" \n Please, enter a valid alphanumeric character ('a' to 'z' or 'A' to 'Z' and (0 to 9)). " );
	}
	return 0;
}</ctype.h> 
```

**输出:**

```
Enter a valid character: t
't' is a valid alphanumeric character.

```

在这里，我们从用户输入“t”字符，然后使用 isalnum()函数检查给定的字符是否是字母数字。

**2<sup>2</sup>执行:**

```

Enter a valid character: 7
'7' is a valid alphanumeric character.

```

类似地，我们从用户输入 7，并检查给定的数字是否是数字。如果数字包含 0 到 9 个数字，isalnum()函数返回给定的数字是数字。

**3 <sup>路</sup>执行:**

```

Enter a valid character: +
'+' is not an alphanumeric character.
Please, enter a valid alphanumeric character ('a' to 'z' or 'A' to 'Z' and (0 to 9)).

```

这里，我们输入“+”字符，并使用 isalnum()函数检查字母数字字符。我们得到给定的字符不是字母数字，这意味着该字符既不是字母，也不是从 0 到 9 的数字。

**示例 3:为 C 语言中的字母数字字符返回非零值的程序**

让我们考虑一个例子来验证字母数字字符，并使用 C 编程语言中的 isalnum()函数返回非零值。

```

#include #include <ctype.h>int main ()
{
	// declare character type variable 
	char ch;

	ch = 'C';
	// use isalnum() function to check uppercase alphabet
	printf (" \n The result of valid uppercase alphanumeric is passed: %d ", isalnum (ch));

	ch = 'h';
	// use isalnum() function to check lowercase alphabet
	printf (" \n The result of valid lowercase alphanumeric is passed: %d ", isalnum (ch));

	ch = '05';
	// use isalnum() function to check alphanumeric character
	printf (" \n The result of valid alphanumeric character is passed: %d ", isalnum (ch));

	ch = '91';
	// use isalnum() function to check uppercase alphabet
	printf (" \n The result of valid alphanumeric character is passed: %d ", isalnum (ch));

	ch = '&';
	// use isalnum() function to check alphanumeric character
	printf (" \n The result of non-alphanumeric character is passed: %d ", isalnum (ch));

	return 0;
}</ctype.h> 
```

**输出:**

```
The result of valid uppercase alphanumeric is passed: 1
The result of valid lowercase alphanumeric is passed: 2
The result of valid alphanumeric character is passed: 4
The result of valid alphanumeric character is passed: 4
The result of non-alphanumeric character is passed: 0

```

**示例 4:使用 isalnum()函数检查数组中所有字母数字字符的程序**

让我们考虑一个例子，用 C 编程语言中的 isalnum()函数检查所有数组字符是否是字母数字

```

#include #include <stdlib.h>#include <ctype.h>int main() 
{ 
    // declaration of the character type array
	char str[7] = {'#','&','@','9','Z','o', '!'};  
	// place 0 as the return values of all character stored in str array.
	int arr[7] = {0, 0, 0, 0, 0, 0, 0};  
	int i;

	// use for loop to assign the result of the isalnum() function
    for (i = 0; i < 7; i++)
    {
      arr[i] = isalnum (str[i]);
    }
    for (i = 0; i < 7; i++)
    {
      printf( "\n '%c'", str[i]); // print character

      // check array element is not equal to 0
	  if (arr[i] != 0)
	  {
	  	printf( " is an Alphanumeric character. ");	
	  }
      else  
	  {
	  	printf( " is NOT an alphabet or numeric character. ");	
	  }
    }
    return 0; 
}</ctype.h></stdlib.h> 
```

**输出:**

```
'#' is NOT an alphabet or numeric character.
'&' is NOT an alphabet or numeric character.
'@' is NOT an alphabet or numeric character.
'9' is an Alphanumeric character.
'Z' is an Alphanumeric character.
'0' is an Alphanumeric character.
'!' is NOT an alphabet or numeric character.

```

* * *