# C 语言中的 isalpha()函数

> 原文：<https://www.javatpoint.com/isalpha-function-in-c>

本节将讨论 C 编程语言的 isalpha()函数。islpha()函数是 ctype.h 头文件的预定义库函数，它将参数作为字符类型，并验证有效的字母。如果给定的字符是字母(a - z 或 A 到 Z)，它将返回一个非零值；否则，它返回 0。

![isalpha() function in C](img/ab487b61ffe19995c4e27364a3702ef5.png)

#### 注意:在使用 islpha()函数时，我们必须在程序中添加 ctype.h 头文件。

例如，如果给定的字符是从“A”到“Z”和从“A”到“Z”，则 isalpha()函数返回一个非零值。如果给定的字符不是字母表中的字母，它会为其他字符(“@”、“$”、“&”等)返回零。).

```

Input character: 'b'
Function returns 1

Input character: '&'
Function returns 0

```

### isalpha 函数的语法

下面是 C 编程中 isalpha()函数的语法，如下所示。

```

int isalpha (char Ch);

```

这里，isalpha()函数将 ch 作为字符类型参数来检查字母。

### 参数:

**Ch** :表示要检查的字符类型变量。

### 返回值:

当“ch”字符是字母时，isalpha()函数返回非零值。否则，它显示零。

**示例 1:使用 islpha()函数检查字母字符的程序**

让我们考虑一个例子，在 C 编程中使用 islpha()函数检查给定的字符是否是字母表。

```

#include #include <ctype.h>// use ctype.h header file

int main (int argc, const char *argv [])
{
	// define unsigned variable
	unsigned char ch;

	// assign character to the ch
	ch = 'a';

	/* use isalpha () function to check the alphabet character */
	if (isalpha (ch) != 0) 
	{
		printf (" \n '%c' is a valid alphabetic character. ", ch);
	}
	else
	{
		printf (" '%c' is not the valid alphabetic character. ", ch);
	}

	// assign a non alphabetic character to the ch variable
	ch = '&';

	/* use isalpha () function to check the alphabet character */
	if (isalpha (ch) != 0) 
	{
		printf (" \n '%c' is a valid alphabetic character. ", ch);
	}
	else
	{
		printf (" \n '%c' is not a valid alphabetic character. ", ch);
	}

	return 0;
}</ctype.h> 
```

**输出:**

```
'a' is a valid alphabetic character.
'&' is not a valid alphabetic character.

```

**示例 2:使用 isalpha()函数验证给定字符的程序**

让我们考虑一个使用 isalpha()函数的例子，并检查在 C 编程中各种给定的字符是否是字母。

```

#include #include <ctype.h>// use ctype.h header file

int main ()
{

	// check character 'e'		
	/* use isalpha () function to check the alphabet character */
	if (isalpha ( 'e') == 0) 
	{
		printf (" \n 'e' is not an alphabetic character. ");
	}
	else
	{
		printf ("\n 'e' is an alphabetic character. ");
	}

	// check character 'Z'
	if (isalpha ('Z') == 0) 
	{
		printf (" \n 'Z' is not an alphabetic character. ");
	}
	else
	{
		printf (" \n 'Z' is an alphabetic character. ");
	}

	// check character '@'
	if (isalpha ('@') == 0) 
	{
		printf (" \n '@' is not an alphabetic character. ");
	}
	else
	{
		printf (" \n '@' is an alphabetic character. ");
	}

	// check character '5'
	if (isalpha ('5') == 0) 
	{
		printf (" \n '5' is not an alphabetic character. ");
	}
	else
	{
		printf (" \n '5' is an alphabetic character. ");
	}

	return 0;
}</ctype.h> 
```

**输出:**

```
 'e' is an alphabetic character.
'Z' is an alphabetic character.
'@' is not an alphabetic character.
'5' is not an alphabetic character.

```

**例 3:从用户处获取一个字符并检查该字符是否为有效字符的程序**

让我们考虑一个在 C 编程语言中使用 isalpha 函数检查有效字符的例子。

```

#include #include <ctype.h>int main ()
{
	// declare character type variable
	char ch;

	printf (" \n Enter a valid character: ");
	scanf (" %c", &ch);

	// use isalpha() function to check the valid character
	if (isalpha (ch))
	{
		printf (" \n You entered a valid alphabet. ");
	}
	else
	{
		printf (" \n %c is not an alphabet. ");
		printf (" \n Please, enter a valid alphabet character ('a' to 'z' or 'A' to 'Z'). " );
	}
	return 0;
}</ctype.h> 
```

**输出:**

```
Enter a valid character: g
You entered a valid alphabet.

```

在上面的程序中，我们从用户那里获取‘g’字符，然后使用 isalpha()函数来检查输入的字符是否是字母表。如果字符是字母表，它会打印“您输入了有效的字符”。

**2<sup>2</sup>执行:**

```

Enter a valid character: $
$ is not an alphabet.
Please, enter a valid alphabet character ('a' to 'z' or 'A' to 'Z').

```

在第二次执行中，我们输入“$”字符，并使用 isalpha()函数检查该字符是否是字母表。这里的“$”字符不是字母表。所以，它返回“$不是字母表。请输入有效的字母字符(“A”到“Z”或“A”到“Z”)。

**示例 4:使用 isalpha()函数为字母字符返回非 0 值的程序**

让我们考虑一个例子来验证字母字符，并使用 C 编程语言中的 isalpha()函数返回非零值。

```

#include #include <ctype.h>int main ()
{
	// declare character type
	char ch;

	ch = 'C';
	// use isalpha() function to check uppercase alphabet
	printf (" \n The result of valid uppercase alphabetic character is passed: %d ", isalpha (ch));

	ch = 'h';
	// use isalpha() function to check lowercase alphabet
	printf (" \n The result of valid lowercase alphabetic character is passed: %d ", isalpha (ch));

	ch = '+';
	// use isalpha() function to check non-alphabetic character
	printf (" \n The result of non-alphabetic character is passed: %d ", isalpha (ch));

	return 0;
}</ctype.h> 
```

**输出:**

```
The result of valid uppercase alphabetic character is passed: 1
The result of valid lowercase alphabetic character is passed: 2
The result of non-alphabetic character is passed: 0

```

在上面的程序中，当字母字符被传递给 isalpha()函数时，我们得到了不同的非零值。但是，当我们将非字母字符传递给 isalpha()函数时，它总是返回 0。

**示例 5:使用 isalpha()函数检查数组所有有效字符的程序**

让我们创建一个例子，使用 isalpha 函数来检查 C 编程语言中的数组字符。

```

#include #include <stdlib.h>#include <ctype.h>int main() 
{ 

    // declaration of the character type array
	char str[7] = {'*','/ctype.h>,'@','7','Z','p', '!'}; 

	// insert 0 as the return values to all character type array in str .
	int arr[7] = {0, 0, 0, 0, 0, 0, 0};  

	int i;

	// use for loop to assign the result of the isalpha() function
    for (i = 0; i < 7; i++)
    {
      arr[i] = isalpha (str[i]);
    }

    for (i = 0; i < 7; i++)
    {
      printf( " \n '%c'", str[i]); // print character

      // check array element is not equal to 0
	  if (arr[i] != 0)
	  {
	  	printf( " is an Alphabetic character. ");	
	  }

      else  
	  {
	  	printf( " is NOT an Alphabetic character. ");	
	  }
    }
    return 0; 
}</ctype.h></stdlib.h> 
```

**输出:**

```
 '*' is NOT an Alphabetic character.
'$' is NOT an Alphabetic character.
 '@' is NOT an Alphabetic character.
 '7' is NOT an Alphabetic character.
 'Z' is an Alphabetic character.
 'p' is an Alphabetic character.
 '!' is NOT an Alphabetic character.

```

* * *