# C 语言中的 snprintf()函数

> 原文：<https://www.javatpoint.com/snprintf-function-in-c>

在本节中，我们将讨论 C 编程语言中的 snprintf()函数。snprintf 是 stdio.h 头文件的预定义库函数，它将标准 printf()函数的输出重定向到其他缓冲区。

snprint()函数用于将给定的字符串格式化为缓冲区中的一系列字符或值。snprintf()函数包含一个“n”参数，表示缓冲区中存储的最大字符数，包括空字符。

snprintf 函数还返回插入或写入缓冲区的字符数。但是，这些字符由 printf()函数在 print 语句中返回或显示，或者由 stdout 头文件中的字符返回或显示。

![snprintf() function in C](img/f045e618483a75a8d915ebc2e49dd738.png)

#### 注意:snprintf()函数在结果输出的末尾插入一个空字符，该字符也算作缓冲区的大小。此外，缓冲区是一个只存储字符类型元素的数组，而不是字符串类型。

### C 语言中 snprintf()函数的语法

下面是 c 编程语言中 snprintf()函数的语法。

```

int snprintf (char *str, size_t size, const char *format, ?);

```

### 参数:

**字符串**:是字符型数组缓冲区。

**大小**:定义缓冲区可以存储的最大字符数。

**格式**:在 C 语言中，字符串定义的格式包含的规格类型与 printf()函数在 stdio.h 头文件中定义的规格类型相同。

…:它是可选的(…)参数或参数。

### 返回值:

函数的作用是:返回一个足够大的缓冲区中已经写入或存储的字符或值的数量，不包括空终止字符。如果写入的字符大于缓冲区大小，则返回负值。如果缓冲区太小，给定的字符串将被截断或缩小到缓冲区大小。

**例 1:演示 C** 中 snprintf()函数的程序

让我们创建一个程序来检查缓冲区大小，并使用 c 语言中的 snprintf()函数返回输入缓冲区的字符数。

```

/* create an example to use the snprintf function in c. */
#include #include <conio.h>int main ()
{
	// declare and initialize the char variable
	char *r = "Javatpoint.com";
	char buf[100]; // define the size of character type buffer 

	/* use the snprintf() function to return the no. of character founded in the buffer area */
     int n = snprintf (buf, 34, "%s \n", r); // 34 represents the size of buffer to store max characters

	// display the string stored in the buffer and count each character of the buffer area.
	printf (" The given string is: %s \n Count the stored character: %d \n", buf, n);

	return 0; 	 
}</conio.h> 
```

**当我们执行上述程序时，它在控制台屏幕上产生给定的输出。**

```
The given string is: Javatpoint.com

Count the stored character: 16

```

**2<sup>2</sup>执行**

```
The given string is: Javatpoint.com
Count the stored character: -1

```

现在我们将最大输入字符从 34 减少到 14，这一次，它返回一个负数，表示缓冲区大小小于给定的字符串。

**例 2:C**中使用 snprintf()函数的程序

让我们创建一个示例，使用 C 编程语言中的 snprintf()函数将字符插入缓冲区并从中返回。

```

#include #include <conio.h>int main ()
{
	char buf[200]; // define the size of character type buffer 

	int ret_val, buf_size = 55;
	char name[] = "David"; // define string
	int age = 19;

	// use the snprintf() function to return the no. of character found in buffer area
	ret_val = snprintf (buf, buf_size, "Hello friend, My name is %s, and I am %d years old.", name, age);

	/* check ret_value should be greater than 0 and less than the size of the buffer (buf_size). */
	if ( ret_val > 0 && ret_val < buf_size)
	{
		printf (" Buffer is written successfully! \n ");
		printf (" %s\n", buf);
		printf (" No. of characters read: %d", ret_val);
	}
	else
	{
		printf (" Buffer is not completely filled or written. \n ");
		printf (" %s \n", buf);
		printf (" The return value: %d", ret_val);
	}

	return 0; 

}</conio.h> 
```

**当我们执行上述程序时，它在控制台屏幕上产生给定的输出。**

```
Buffer is written successfully!
Hello friend, My name is David, and I am 19 years old.
No. of characters read: 53

```

在上面的程序中，我们声明了字符类型缓冲 buf[200]，buf_size 变量可以插入的最大字符数是 55。如果给定的语句在定义的范围内，snprintf()函数返回从缓冲区读取的字符总数。

**2<sup>2</sup>执行**

```
Buffer is not completely filled or written.
Hello friend, My name is David and
The return value: -1

```

当我们将 buf_size 定义为 35 时，给定的语句会被 snprintf()函数自动截断，该函数返回一个负数(-1)并显示“缓冲区未完全填充或写入”。

* * *