# 从 C 语言的数组中移除元素

> 原文：<https://www.javatpoint.com/remove-an-element-from-an-array-in-c>

在本主题中，我们将学习如何在 C 编程语言中删除或移除数组中的特定元素。数组是存储在连续内存块中的相同数据类型元素或项的集合。在 C 编程中，数组是存储像 int、char、float 等基本数据类型值的派生数据。

要从数组中删除特定元素，用户必须定义应该从哪个位置删除数组元素。删除元素不会影响数组的大小。此外，我们还应该检查数组中的删除是否可能。

![Remove an element from an array in C](img/59c5bdfd0bd7e62351cecb2ce4fcc0ad.png)

例如，假设一个数组包含七个元素，arr[] = {10，25，14，8，12，15，5)；并且用户想要删除元素 8。因此，首先，用户必须定义第 8 个<sup>元素的位置，即第 4 个<sup>，然后检查删除是否可能。特定元素的位置不应超过数组的所有元素。这里，我们在一个数组中有 7 个元素，用户想要删除第 8 个<sup>位置元素，这是不可能的。</sup></sup></sup>

### 从数组中移除元素的步骤

下面是在 C 编程中从数组中移除特定元素的步骤。

**第一步:**用 num 输入数组 arr[]的大小，然后声明 pos 变量定义位置，I 代表计数器值。

**步骤 2:** 使用循环将元素插入数组，直到满足(i <数)。

**步骤 3:** 现在，输入用户或程序员想要从数组中删除的特定元素的位置。

**第 4 步:**将元素(pos)的位置与元素总数(num+1)进行比较。如果 pos 大于 num+1，则不可能删除该元素，并跳至步骤 7。

**第 5 步:**否则移除特定元素，并将其余元素的位置移到数组的左侧。

**步骤 6:** 显示从数组中删除或移除元素后的结果数组。

**步骤 7:** 终止或退出程序。

### 示例 1:使用 for 循环从数组中移除元素的程序

让我们创建一个程序，使用 C 编程语言中的 for 循环从数组中删除一个元素。

```

/* program to remove the specific elements from an array in C. */
#include #include <conio.h>int main ()
{
	// declaration of the int type variable
	int arr[50];
	int pos, i, num; // declare int type variable
	printf (" \n Enter the number of elements in an array: \n ");
	scanf (" %d", &num);

	printf (" \n Enter %d elements in array: \n ", num);

	// use for loop to insert elements one by one in array
	for (i = 0; i < num; i++ )
	{	printf (" arr[%d] = ", i);
		scanf (" %d", &arr[i]);
	}

	// enter the position of the element to be deleted
	printf( " Define the position of the array element where you want to delete: \n ");
	scanf (" %d", &pos);

	// check whether the deletion is possible or not
	if (pos >= num+1)
	{
		printf (" \n Deletion is not possible in the array.");
	}
	else
	{
		// use for loop to delete the element and update the index
		for (i = pos - 1; i < num -1; i++)
		{
			arr[i] = arr[i+1]; // assign arr[i+1] to arr[i]
		}

		printf (" \n The resultant array is: \n");

		// display the final array
		for (i = 0; i< num - 1; i++)
		{
			printf (" arr[%d] = ", i);
			printf (" %d \n", arr[i]);
		}
	}
	return 0;
}</conio.h> 
```

**输出:**

```
Enter the number of elements in an array:
8

Enter 8 elements in array:
arr[0] = 3
arr[1] = 6
arr[2] = 2
arr[3] = 15
arr[4] = 10
arr[5] = 5
arr[6] = 8
arr[7] = 12
Define the position of the array element where you want to delete:
5

The resultant array is:
arr[0] = 3
arr[1] = 6
arr[2] = 2
arr[3] = 15
arr[4] = 5
arr[5] = 8
arr[6] = 12

```

在上面的程序中，我们从用户输入了数组 arr[]的 8 个元素。之后，用户输入特定元素的位置是 5。然后，我们检查了 If 语句定义的位置(If(pos > num+1))；这里，5 小于(num+1)。所以条件为假，它执行 else 块来移除元素的第 5 个<sup>位置，用于循环，然后打印结果数组。</sup>

### 示例 2:使用 for 循环从数组中移除特定字符的程序

让我们考虑一个例子，使用 C 编程语言中的 for 循环从数组中删除定义字符的特定位置。

```

/* program to remove the specific elements from an array in C. */
#include #include <conio.h>int main ()
{
	// declaration of the int type variable
	int arr[50];
	int pos, i, num; // declare int type variable
	printf (" \n Enter the number of elements in an array: \n ");
	scanf (" %d", &num);

	printf (" \n Enter %d elements in array: \n ", num);

	// use for loop to insert elements one by one in array
	for (i = 0; i < num; i++ )
	{	printf (" arr[%d] = ", i);
		scanf (" %c", &arr[i]);
	}

	// enter the position of the element to be deleted
	printf( " Define the position of the array element where you want to delete: \n ");
	scanf (" %d", &pos);

	// check whether the deletion is possible or not
	if (pos >= num+1)
	{
		printf (" \n Deletion is not possible in the array.");
	}
	else
	{
		// use for loop to delete the element and update the index
		for (i = pos - 1; i < num -1; i++)
		{
			arr[i] = arr[i+1]; // assign arr[i+1] to arr[i]
		}

		printf (" \n The resultant array is: \n");

		// display the final array
		for (i = 0; i< num - 1; i++)
		{
			printf (" arr[%d] = ", i);
			printf (" %c \n", arr[i]);
		}
	}
	return 0;
}</conio.h> 
```

**输出:**

```
Enter the number of elements in an array:
8
Enter 8 elements in array:
arr[0] = a
arr[1] = b
arr[2] = f
arr[3] = h
arr[4] = e
arr[5] = k
arr[6] = w
arr[7] = p
Define the position of the array element where you want to delete:
4

The resultant array is:
arr[0] = a
arr[1] = b
arr[2] = f
arr[3] = e
arr[4] = k
arr[5] = w
arr[6] = p

```

### 示例 3:使用用户定义的函数从数组中删除特定元素的程序

让我们考虑一个例子来演示使用 C 编程语言中的用户定义函数删除特定元素。

```

/* program to delete a particular element from an array using user defined function in c. */
#include #include <conio.h>// create user defined function update elements
addElement (int *arr, int num, int pos)
{
	int i;
	// use for loop to update the index
	for (i = pos-1; i < num - 1; i++)
	{
		arr[i] = arr[i+1]; // 
	}
}

// create disp() function to print the input array elements
disp( int arr[], int num)
{
	int i;
	// use for loop to print the resultant array
	for ( i = 0; i < num; i++)
	{
		printf( "\n arr[%d] = %d", i, arr[i]);
	}
}

int main ()
{
	// declaration of the array
	int arr[100];
	int i, num, pos, result;

	printf (" Enter the size of the array: ");
	scanf (" %d", &num);

	printf (" \n Enter the %d elements in an array: \n", num);
	// use for loop to input the elements one by one
	for (i = 0; i < num; i++)
	{
		printf (" arr[%d] = ", i);
		scanf (" %d", &arr[i]);
	}

	// define the position of the element to be deleted from an array
	printf (" Enter the position of the element you want to delete from an array: ");
	scanf (" %d", &pos);

// check whether thr defined pos is less than equal to size of array (num) and larger than 0
	if (pos <= num && pos > 0)
	{
		printf (" Array before deletion: \n");

		// call disp() function print the array
		disp (arr, num);
		// call addElement() function
		addElement(arr, num, pos);

		printf (" \n Array after deletion: \n");
		// disp() function to print the updated array
		disp( arr, num-1);
	}
	return 0;	
}</conio.h> 
```

**输出:**

```
Enter the size of the array: 8
Enter the 8 elements in an array:
arr[0] = 2
arr[1] = 4
arr[2] = 6
arr[3] = 8
arr[4] = 10
arr[5] = 3
arr[6] = 9
arr[7] = 12
Enter the position of the element you want to delete from an array: 4
Array before deletion:

arr[0] = 2
arr[1] = 4
arr[2] = 6
arr[3] = 8
arr[4] = 10
arr[5] = 3
arr[6] = 9
arr[7] = 12
Array after deletion:

arr[0] = 2
arr[1] = 4
arr[2] = 6
arr[3] = 10
arr[4] = 3
arr[5] = 9
arr[6] = 12

```

### 示例 4:使用指针从数组中移除特定元素的程序

让我们考虑一个使用指针和 C 编程语言中的用户定义函数从数组中删除特定元素的例子。

```

/* create a program to delete a specific element from an array using pointers in C. */
#include #include <conio.h>// create a function to delete the specific element
void del (int num, int *arr, int index);

int main ()
{
	// declaration of the variables
	int *arr, num, i, index;
	printf (" Define the size of the array: ");
	scanf (" %d", &num);

	// use malloc function to dynamic create space for an array
	arr = (int *) malloc (sizeof(int) *num);

	printf (" \n Enter %d elements in an array: ", num);
	// use for loop to insert element one by one
	for (i = 0; i < num; i++)
	{
		printf (" \n arr[%d] = ", i);
		scanf (" %d", (arr + i));
	}

	// position of the element to be deleted
	printf (" Enter the position of the element to be deleted from an array: ");
	scanf (" %d", &index);
	del (num, arr, index); /* call delete function to delete the position of element and print the resultant array. */
	return 0;
}

// function definition
void del (int num, int *arr, int index)
{
	int i, j;
	// check position of the index
	if (index <= num)
	{
		// use for loop to delete the position of the defined index
		for (i = index - 1; i < num; i++)
		{
			j = i + 1; // assign the elments to j
			*(arr + i) = *(arr + j);
		}

		// display the resultant array after deletion of the specific element
		printf (" \n The resultant array after deletion of the array elements are: \n");
		for (i = 0; i < num - 1; i++)
		{
			printf (" arr[%d] = %d \n", i, ( *(arr + i)));
		}
	 } 
	 else
	 {
	 	printf (" \n Please enter correct position.");
	 }
}</conio.h> 
```

**输出:**

```
Define the size of the array: 8
Enter 8 elements in an array:
arr[0] = 5
arr[1] = 10
arr[2] = 15
arr[3] = 20
arr[4] = 25
arr[5] = 30
arr[6] = 35
arr[7] = 40
Enter the position of the element to be deleted from an array: 4
The resultant array after deletion of the array elements are:
arr[0] = 5
arr[1] = 10
arr[2] = 15
arr[3] = 25
arr[4] = 30
arr[5] = 35
arr[6] = 40

```

* * *