# C 语言中的 isprint()函数

> 原文：<https://www.javatpoint.com/isprint-function-in-c>

本节将讨论 C 编程语言中的 isprint()函数。isprint()函数是 C 语言的预定义库函数，用于检查输入字符是否是屏幕上的可打印字符(包括空格字符)。它在 ctype.h 头文件中定义。所以，在用 C 语言编写程序时，我们必须添加 ctype.h 头文件。

![isprint() function in C](img/970a950ef3656c0980a7f2bf3dced080.png)

该函数从用户处获取字符类型参数，并验证字符是否可打印。如果传递的字符是可打印的，函数返回一个非零正值；否则，它显示零(0)。

例如，假设用户输入“g”字符作为 isprint()函数的参数；该函数检查输入字符是否可打印。如果是，则返回非零值。同样，如果我们向 isprint 函数输入一个新的 line (\n)或 tab (\t)字符，它将返回零，因为它不是可打印字符。

### isprint()函数的语法

以下是 C 语言中 isprint()函数的语法，如下所示:

```

int isprint (char c);

```

**参数:**

**c:** 表示字符类型值传递给 isprint()函数。

**返回值:**

isprint()函数检查传递的参数，如果字符是可打印的，它将返回一个非零值。否则，它返回零。

**示例 1:使用 isprint()函数找到可打印字符的程序**

让我们编写一个简单的程序，使用 C 语言中的 isprint()函数在屏幕上找到可打印的字符。

```

/* program to check the printable character using the isprint() function in C. */
#include #include <conio.h>#include <ctype.h>int main ()
{
	// declaration of the character type variables
	int ch1 = 'b';
	int ch2 = '@';
	int ch3 = ' ';
	int ch4 = '%'; 
	int ch5 = '\n';
	int ch6 = '\t';

	/* use isprint () function to check the printable character. */
	if ( isprint (ch1) )
	{
		printf (" '%c' is a printable character. \n", ch1);
	}
	else
	{
		printf ("'%c' is not a printable character. \n", ch1);
	}

	if ( isprint (ch2) )
	{
		printf (" '%c' is a printable character. \n", ch2);
	}
	else
	{
		printf ("'%c' is not a printable character. \n", ch2);
	}

	if ( isprint (ch3) )
	{
		printf (" '%c' is a printable character. \n", ch3);
	}
	else
	{
		printf ("'%c' is not a printable character. \n", ch3);
	}

	if ( isprint (ch4) )
	{
		printf (" '%c' is a printable character. \n", ch4);
	}
	else
	{
		printf ("'%c' is not a printable character. \n", ch4);
	}	

	if ( isprint (ch5) )
	{
		printf (" '%c' is a printable character. \n", ch5);
	}
	else
	{
		printf ("'%c' is not a printable character. \n", ch5);
	}	

	if ( isprint (ch6) )
	{
		printf (" '%c' is a printable character. \n", ch6);
	}
	else
	{
		printf ("'%c' is not a printable character. \n", ch6);
	}

	return 0;
}</ctype.h></conio.h> 
```

**输出:**

```
'b' is a printable character.
'@' is a printable character.
' ' is a printable character.
'%' is a printable character.
' ' is not a printable character.
'	' is not a printable character.

```

在上面的程序中，我们定义了各种字符(' b '、' @ '、' '、' % '、新行(\n)和' \t '(制表符空格))来检查可打印字符。然后，isprint()函数检查并打印唯一可打印的字符，如果有任何字符不可打印，它将返回“%c 是不可打印的字符”。

**示例 2:从用户处获取一个字符并检查该字符是否可打印的程序**

让我们编写一个程序，从用户那里获取一个字符，并使用 C 语言中的 isprint()函数显示它。

```

#include #include <ctype.h>int main ()
{
	// declaration of the variables 
	char c;

	printf (" \n Input a printable character: ");
	scanf (" %c", &c); // get a character

	/* use the isprint() function to print only printable character */
	if (isprint (c))
	{
		printf (" \n '%c' is a correct printable character. ", c);
	}
	else
	{
		printf (" \n '%c' is not a printable character. ", c);
		printf (" \n Input only printable character. " );
	}
	return 0;
}</ctype.h> 
```

**输出:**

```
Input a printable character: j
'j' is a correct printable character.

```

在上面的程序中，我们从用户输入字符“j”，然后使用 isprint()函数验证返回“j”的可打印字符是否是正确的可打印字符。

**2<sup>2</sup>执行:**

```
Input a printable character: 8
'8' is a correct printable character.

```

同样，我们从用户那里获取另一个字符或数字“8”，然后 isprint()函数检查给定的可打印字符。之后，isprint()函数打印“8”是一个正确的可打印字符。如果输入新行(\n)或\t，isprint()函数返回%c 不是可打印字符。

**示例 3:使用 isprint()函数和 while 循环检查可打印字符串的程序**

让我们写一个例子，用 c 语言中的 while 循环和 isprint()函数打印可打印的字符串。

```

#include #include <ctype.h>int main ()
{
	// declare a character type string
	char str[] = "Zb. \n2 \t*.";
	int i = 0;

	// use while loop to iterate string character one by one 
	while (str[i] != '\0')
	{
	/* use the isprint() function to check the valid printable string character */
	if (isprint (str[i]))
	{
		printf (" \n '%c' is a printable character. ", str[i]);
	}
	else
	{
		printf (" \n %c is not a printable character. ", str[i]);
	}
	i++;	
	}
	return 0;
}</ctype.h> 
```

**输出:**

```
'Z' is a printable character.
'b' is a printable character.
'.' is a printable character.

is not a printable character.
'2' is a printable character.
' ' is a printable character. 
	is not a printable character.
'*' is a printable character.
'.' is a printable character.

```

在上面的程序中，我们声明了一个字符串“Ab。\n2 \t*，”然后使用 isprint()函数检查给定的字符串是否可打印。因此，首先，我们使用 while 循环迭代字符串的每个字符，直到字符串不等于 null。在 while 循环中，条件检查并使用 isprint()函数打印每个有效字符，包括空格。如果字符不可打印，它会打印“它不是可打印的字符。”。

**示例 4:使用 isprint()函数**在 C 中查找所有可打印字符的程序

让我们创建一个程序来找到 C 编程语言中可打印字符的完整列表。

```

#include #include <ctype.h>#include <conio.h>int main ()
{
	// declaration of the variables
	int i = 0;
	int count = 0; // count printable characters

	// use while loop to iterate till defined condition
	while ( i < 256)
	{
		/// use isprint() function to check printable character
		if ( isprint(i) != 0)
		{
			printf (" %c", i); // it prints only printable character
			++count; // count total printable character and update the count by 1
		}	
		++i; 
	}
	printf (" \n There are total %d printable characters. \n", count);

	getch();
}</conio.h></ctype.h> 
```

**输出:**

```
   ! " # $ % & ' ( ) * + , - . / 0 1 2 3 4 5 6 7 8 9 : ; < = > ? @ A B C D E F G H I J K L M N O P Q R S T U V W X Y Z [ \ ] ^ _ ` a b c d e f g h i j k l m n o p q r s t u v w x y z { | } ~ 
 There are total 95 printable characters.

```

**示例 5:使用 isprint()函数打印数组中所有可打印字符的程序**

让我们创建一个程序，使用 C 编程语言中的 isprint()函数打印所有字符类型的数组元素。

```

#include #include <stdlib.h>#include <ctype.h>int main() 
{ 
           // declare a character type array
	char str[8] = {'G', '&', ' ', '6', '\n', 'e',  '!', '\t'};  

	// It includes 0 as the return values of all defined character in str array.
	int arr[8] = {0, 0, 0, 0, 0, 0, 0};  
	int i; // declare 'i' as int type variable

// iterate all elements of the array using the for loop
    for (i = 0; i < 8; i++)
    {
      arr[i] = isprint (str[i]); /* the isprint() function check printable character and assign character to arr[i] */
    }

    // iterate to display characters
    for (i = 0; i < 8; i++)
    {
      printf( "\n '%c'", str[i]); 

      // if statement checks all the characters of the array that is not equal to 0.
	  if (arr[i] != 0)
	  {
	  	printf( " is a printable character. ");	
	  }
      else     
	  {
	  	printf( " is NOT a printable character. ");	
	  }
    }
    return 0; 
}</ctype.h></stdlib.h> 
```

**输出:**

```
'G' is a printable character.
'&' is a printable character.
' ' is a printable character.
'6' is a printable character.
'
' is NOT a printable character.
'e' is a printable character.
'!' is a printable character.
'	' is NOT a printable character.

```

* * *