# C 语言中的 isdigit()函数

> 原文：<https://www.javatpoint.com/isdigit-function-in-c>

本主题将讨论 C 语言中的 isdigit()函数。isdigit()函数是 C 库的预定义函数，用于检查字符是否为 0 到 9 之间的数字字符。如果给定的字符是一个数字或数字，它将返回一个真布尔值或非零值；否则，它返回零或假值。isdigit 函数在 ctype.h 头文件中声明，所以我们必须添加到 C 程序中。

例如，假设我们在 isdigit()函数中输入字符' h '；该函数检查输入字符是否是数字。这里的字符不是数字。因此 isdigit()函数返回零(0)或假值。同样，我们再次向 isdigit()函数输入数字字符“5”。这一次，函数返回真或非零值，因为“5”是 0 到 9 位的数字字符。

### isdigit()函数的语法

下面是 C 语言中 isdigit()函数的语法。

```

int isdigit (int ch);

```

### 参数:

**Ch** -它定义了要在 isdigit()函数中传递的数字字符。

### 返回值:

isdigit()函数检查“ch”参数，如果传递的字符是数字，它将返回一个非零值。否则，它会显示一个零或假的布尔值。

### 示例 1:检查给定字符是否是数字的程序

让我们创建一个程序来检查给定的字符是否是数字，在 C 编程中使用 isdigit()函数。

```

/* Check whether the given characters are digits or not in C. */
#include #include <ctype.h>int main ()
{

	// Use the isdigit() function to check the character is digit or not. */
	if (isdigit ( 'P' ) == 0)  //check 'P' is digit 
	{
		printf (" \n The given character 'P' is not digit'. ");
	}
	else
	{
		printf ("\n The given character 'P' is a digit. ");
	}

	if (isdigit ( '3' ) == 0)  //check for '3'  
	{
		printf (" \n The given character '3' is not digit'. ");
	}
	else
	{
		printf ("\n The given character '3' is a digit. ");
	}

	if (isdigit ( '!' ) == 0)  //check for '!' character 
	{
		printf (" \n The given character '!' is not digit'. ");
	}
	else
	{
		printf ("\n The given character '!' is a digit. ");
	}

	if (isdigit ( '$4' ) == 0)  //check for '44'  
	{
		printf (" \n The given character '$4' is not digit'. ");
	}
	else
	{
		printf ("\n The given character '$4' is a digit. ");
	}

	if (isdigit ( '0' ) == 0)  //check for '0' 
	{
		printf (" \n The given character '0' is not a digit. ");
	}
	else
	{
		printf ("\n The given character '0' is a digit. ");
	}

	return 0;
}</ctype.h> 
```

**输出:**

```
The given character 'P' is not a digit.
The given character '3' is a digit.
The given character '!' is not a digit.
The given character '$4' is not a digit.
The given character '0' is not a digit.

```

在上面的程序中，我们定义了不同的字符，如“P”、“3”、“1！”“$4”，0，使用 isdigit()函数检查这些字符是否有效。然后，我们使用 isdigit()函数检查并返回字符' P '，' 1 '，$4 不是数字。

### 示例 2:检查用户输入的字符是否是数字的程序

让我们编写一个程序，使用 c 语言中的 isdigit()函数来查找输入字符是否有效。

```

/* Check whether the given characters are digits or not in C. */
#include #include <ctype.h>int main ()
{

	char n; // declare an integer type variable n

	printf (" Enter a number to check for valid digits: ");
	scanf ("%c", &n);

	// use the isdigit() function to check the digit
	if (isdigit (n))                                              
	{
		printf (" \n It is a digit. ");
	}
	else
	{
		printf (" \n It is not a digit. ");
	}
	return 0;
}</ctype.h> 
```

**输出:**

```
Enter a number to check for valid digits: 5
It is a digit.

```

在上面的程序中，我们从用户输入‘5’字符，然后使用 isdigit 函数检查传递的参数是否是数字。这里，传递的字符是一个数字，因此 isdigit()函数返回语句“它是一个数字。”

**2<sup>2</sup>执行**

```
Enter a number to check for valid digits: A
It is not a digit.

```

同样，当我们向 isdigit()函数输入字符“A”时，该函数会检查有效字符，我们可以看到字符“A”不是数字。因此，该函数返回语句“它不是数字”

### 示例 3:为 C 语言中传递的字符打印零和非零数字的程序

让我们编写一个程序来检查所有给定的字符，并根据传递给 c 中 isdigit()函数的字符返回 0 和非 0 值。

```

/* create a simple program to return zeroes and non-zeroes values based on the given characters. */
#include #include <ctype.h>int main ()
{
	char num; // declare num as the character type variable

	num = '0';
	// check character 0 using the isdigit() function
	printf (" \n The isdigit() function returns result based on character (0) passed: %d ", isdigit (num));

	num = 'o';
	// check character o using the isdigit() function
	printf (" \n The isdigit() function returns result based on character (o) passed: %d ", isdigit (num));

	num = '08';
	// check character 08 using the isdigit() function
	printf (" \n The isdigit() function returns result based on character (08) passed: %d ", isdigit (num));

	num = '+';
	// check character + using the isdigit() function
	printf (" \n The isdigit() function returns result based on character (+) passed: %d ", isdigit (num));

	num = '%';
	// check character % using the isdigit() function
	printf (" \n The isdigit() function returns result based on character ('%') passed: %d ", isdigit (num));

	return 0;
}</ctype.h> 
```

**输出:**

```
The isdigit() function returns result based on character (0) passed: 1 
The isdigit() function returns result based on character (o) passed: 0
The isdigit() function returns result based on character (08) passed: 1
The isdigit() function returns result based on character (+) passed: 0
The isdigit() function returns result based on character (%) passed: 0

```

在上面的程序中，我们使用 isdigit()函数测试有效的给定数字字符。isdigit()函数对数字字符返回 1，对程序中定义的非数字的字母或特殊符号返回 0。

### 示例 4:使用 isdigit()函数检查所有数组元素的程序

让我们编写一个程序，使用 c 语言中的 isdigit()函数来查找数组元素的所有有效数字。

```

#include #include <conio.h>#include <ctype.h>int main ()
{
	int i;
	// declare and initialize the character type array
	char arr[8] = {'E', '08', '@', '-', '3', '/', '007', '/ctype.h>};

	int arr2[8] = {0, 0, 0, 0, 0, 0, 0, 0}; // initialize arr2 with containing all zeroes element

	// use for loop to iterate all elements
	for (i = 0; i < 8; i++)
	{
		// check and assign digits to the arr2[i] using the isdigit() function
		arr2[i] = isdigit (arr[i]); 
	}

	for (i = 0; i < 8; i++)
	{
	// display array characters
	printf (" \n '%c'", arr[i]);

	// check array elements
	if (arr2[i] != 0)
	{
		printf (" is a digit character. ");
	}
	else
	{
		printf (" is not a valid digit character. ");
	}
}
return 0;
}</ctype.h></conio.h> 
```

**输出:**

```
'E' is not a valid digit character.
'8' is a digit character.
'@' is not a valid digit character.
'-' is not a valid digit character.
'3' is a digit character.
'/' is not a valid digit character.
'7' is a digit character.
'$' is not a valid digit character.

```

我们在上面的程序中用一些元素声明并初始化了 arr[]变量。然后，我们创建另一个包含零(0)的数组 arr2[]，将结果赋给那些不是有效数字的元素。isdigit()函数检查所有 arr[]数组元素，并将非零值返回给有效的数字元素。否则，它会将零(0)返回给非数字元素。

* * *