# C++ 教程

> 原文：<https://www.javatpoint.com/cpp-tutorial>

![C++ Programming](img/21438a028d16a8b1a9255b4121c10c4a.png)

C++ 教程提供了 C++ 的基本概念和高级概念。我们的 C++ 教程是为初学者和专业人士设计的。

C++ 是一种面向对象的编程语言。是 [C 编程](c-programming-language-tutorial)的扩展。

我们的 C++ 教程包含了 C++ 的所有主题，比如第一个例子、控制语句、对象和类、[继承](cpp-inheritance)、[构造函数](cpp-constructor)、析构函数、this、静态、多态、抽象、抽象类、接口、名字空间、封装、数组、字符串、异常处理、File IO 等。

## 什么是 C++

C++ 是一种通用、区分大小写、自由形式的编程语言，支持面向对象、过程和泛型编程。

C++ 是一种中级语言，因为它封装了高级和低级语言特性。

* * *

## 面向对象编程

C++ 支持面向对象编程，C++ 中使用的面向对象编程的四大支柱( [OOPs](cpp-oops-concepts) )是:

1.  遗产
2.  多态性
3.  包装
4.  抽象

* * *

## C++ 标准库

标准 C++ 编程分为三个重要部分:

*   核心库包括数据类型、变量和文本等。
*   标准库包括一组操作字符串、文件等的函数。
*   标准模板库(STL)包括一组操作数据结构的方法。

* * *

## C++ 的用法

借助 C++ 编程语言，我们可以开发不同类型的安全和健壮的应用程序:

*   窗口应用程序
*   客户端-服务器应用程序
*   设备驱动程序
*   嵌入式固件等

## C++ 程序

在本教程中，所有的 C++ 程序都是用 C++ 编译器给出的，这样您就可以轻松地更改 C++ 程序代码。

文件:main.cpp

```
#include using namespace std;
int main() {
   cout << "Hello C++ Programming";
   return 0;
} 
```

第一个 C++ 程序的详细解释将在接下来的章节中给出。

* * *

## C++ 索引

* * *

**C++ 教程**

*   [C++ 教程](cpp-tutorial)
*   [什么是 C++](what-is-cpp)
*   [C vs C++](c-vs-cpp)
*   [C++ 历史](cpp-history)
*   [C++ 特性](cpp-features)
*   [C++ 安装](cpp-installation)
*   [C++ 程序](cpp-program)
*   [C++ cout，cin，end](cpp-basic-input-output)
*   [C++ 变量](cpp-variable)
*   [C++ 数据类型](cpp-data-types)
*   [C++ 关键词](cpp-keywords)
*   [C++ 运算符](cpp-operators)

**C++ 控制语句**

*   [C++ if-else](cpp-if-else)
*   [C++ 开关](cpp-switch)
*   [C++ For 循环](cpp-for-loop)
*   [C++ While 循环](cpp-while-loop)
*   [C++ 边做边循环](cpp-do-while-loop)
*   [C++ 中断语句](cpp-break-statement)
*   [C++ 继续语句](cpp-continue-statement)
*   [C++ Goto 语句](cpp-goto-statement)
*   [C++ 注释](cpp-comments)

**C++ 函数**

*   [C++ 函数](cpp-functions)
*   [按值调用&参考](call-by-value-and-call-by-reference-in-cpp)
*   [C++ 递归](cpp-recursion)
*   [C++ 存储类](cpp-storage-classes)

**C++ 数组**

*   [C++ 数组](cpp-arrays)
*   [C++ 数组转函数](cpp-passing-array-to-function)
*   [多维数组](cpp-multidimensional-array)

**C++ 指针**

*   [C++ 指针](cpp-pointers)

**C++ 对象类**

*   [C++ OOPs 概念](cpp-oops-concepts)
*   [C++ 对象类](cpp-object-and-class)
*   [C++ 构造函数](cpp-constructor)
*   [C++ 破坏者](cpp-destructor)
*   [C++ 这个指针](cpp-this-pointer)
*   [C++ 静态](cpp-static)
*   [C++ 结构](cpp-structs)
*   [C++ 枚举](cpp-enumeration)
*   [C++ 好友功能](cpp-friend-function)

**C++ 继承**

*   [C++ 继承](cpp-inheritance)
*   [C++ 聚合](cpp-aggregation)

**C++ 多态性**

*   [C++ 多态性](cpp-polymorphism)
*   [C++ 重载](cpp-overloading)
*   [C++ 覆盖](cpp-function-overriding)
*   [C++ 虚拟函数](cpp-virtual-function)

**C++ 抽象**

*   [C++ 接口](interfaces-in-cpp)
*   [C++ 数据抽象](data-abstraction-in-cpp)

**C++ 命名空间**

*   [C++ 命名空间](cpp-namespaces)

**C++ 模板**

*   [C++ 模板](cpp-templates)

**C++ 字符串**

*   [C++ 字符串](cpp-strings)

**C++ 异常**

*   [C++ 异常处理](cpp-exception-handling)
*   [C++ 尝试/捕捉](cpp-try-catch)
*   [C++ 用户自定义](cpp-user-defined-exceptions)

**C++ 文件&流**

*   [C++ 文件&流](cpp-files-and-streams)

**C++ 程序**

*   [c++ 程序](cpp-programs)
*   [斐波那契数列](fibonacci-series-in-cpp)
*   [质数](prime-number-program-in-cpp)
*   [回文号](palindrome-program-in-cpp)
*   [阶乘](factorial-program-in-cpp)
*   [T1】阿姆斯壮号 T3】](armstrong-number-in-cpp)
*   [位数之和](sum-of-digits-program-in-cpp)
*   [反向编号](cpp-program-to-reverse-number)
*   [互换号](cpp-program-to-swap-two-numbers-without-third-variable)
*   [矩阵乘法](matrix-multiplication-in-cpp)
*   [十进制到二进制](cpp-program-to-convert-decimal-to-binary)
*   [字符中的数字](cpp-program-to-convert-number-in-characters)
*   [【字母三角】](cpp-program-to-print-alphabet-triangle)
*   [数字三角](cpp-program-to-print-number-triangle)
*   [斐波那契三角](cpp-program-to-generate-fibonacci-triangle)

**C++ STL 教程**

*   [C++ STL 算法](cpp-algorithm)
*   [算法相邻 _ 查找()功能](cpp-algorithm-adjacent_find-function)
*   [算法任意 _of()函数](cpp-algorithm-any_of-function)
*   [算法复制()功能](cpp-algorithm-copy-function)
*   [算法复制 _if()功能](cpp-algorithm-copy_if-function)
*   [算法计数()功能](cpp-algorithm-count-function)
*   [算法 count_if()函数](cpp-algorithm-count_if-function)
*   [算法等于()函数](cpp-algorithm-equal-function)
*   [算法查找()功能](cpp-algorithm-find-function)
*   [算法 find_end()函数](cpp-algorithm-find_end-function)
*   [算法 find_first_of()函数](cpp-algorithm-find_first_of-function)
*   [算法 find_if()函数](cpp-algorithm-find_if-function)
*   [算法 find_if_not()函数](cpp-algorithm-find_if_not-function)
*   [每个()函数的算法](cpp-algorithm-for_each-function)
*   [算法移动()功能](cpp-algorithm-move-function)
*   [算法 all_of()函数](cpp-algorithm-all_of-function)
*   [算法 copy_backward()功能](cpp-algorithm-copy_backward-function)
*   [算法 copy_n()函数](cpp-algorithm-copy_n-function)
*   [算法搜索()功能](cpp-algorithm-search-function)
*   [算法是 _ 排列()函数](cpp-algorithm-is_permutation-function)
*   [算法不匹配()功能](cpp-algorithm-mismatch-function)
*   [算法 move_backward()功能](cpp-algorithm-move_backward-function)
*   [算法 none_of()函数](cpp-algorithm-none_of-function)
*   [算法搜索 _n()功能](cpp-algorithm-search_n-function)
*   [算法交换()功能](cpp-algorithm-swap-function)
*   [算法填充()功能](cpp-algorithm-fill-function)
*   [算法 iter_swap()函数](cpp-algorithm-iter_swap-function)
*   [算法 replace_copy_if()功能](cpp-algorithm-replace_copy_if-function)
*   [算法 replace_copy()功能](cpp-algorithm-replace_copy-function)
*   [算法 replace_if()功能](cpp-algorithm-replace_if-function)
*   [算法替换()功能](cpp-algorithm-replace-function)
*   [算法 swap_ranges()函数](cpp-algorithm-swap_ranges-function)
*   [算法变换()函数](cpp-algorithm-transform-function)
*   [算法 fill_n()函数](cpp-algorithm-fill_n-function)
*   [算法生成 _n()函数](cpp-algorithm-generate_n-function)
*   [算法生成()函数](cpp-algorithm-generate-function)
*   [算法移除()功能](cpp-algorithm-remove-function)
*   [算法是 _ 分区()函数](cpp-algorithm-is_partitioned-function)
*   [算法 random_shuffle()函数](cpp-algorithm-random_shuffle-function)
*   [算法 remove_copy_if()功能](cpp-algorithm-remove_copy_if-function)
*   [算法 remove_copy()功能](cpp-algorithm-remove_copy-function)
*   [算法分区 _ 复制()功能](cpp-algorithm-partition_copy-function)
*   [算法分区 _ 点()功能](cpp-algorithm-partition_point-function)
*   [算法分区()功能](cpp-algorithm-partition-function)
*   [算法 remove_if()功能](cpp-algorithm-remove_if-function)
*   [算法 reverse_copy()功能](cpp-algorithm-reverse_copy-function)
*   [算法反向()功能](cpp-algorithm-reverse-function)
*   [算法 rotate_copy()功能](cpp-algorithm-rotate_copy-function)
*   [算法旋转()功能](cpp-algorithm-rotate-function)
*   [算法洗牌()功能](cpp-algorithm-shuffle-function)
*   [算法稳定 _ 分区()函数](cpp-algorithm-stable_partition-function)
*   [算法唯一 _copy()函数](cpp-algorithm-unique_copy-function)
*   [算法唯一()函数](cpp-algorithm-unique-function)
*   [算法是 _ sorted _ 直到()函数](cpp-algorithm-is_sorted_until-function)
*   [算法是 _sorted()函数](cpp-algorithm-is_sorted-function)
*   [算法下界()函数](cpp-algorithm-lower_bound-function)
*   [算法第 n _ element()函数](cpp-algorithm-nth_element-function)
*   [算法 partial_sort_copy()函数](cpp-algorithm-partial_sort_copy-function)
*   [算法 partial_sort()函数](cpp-algorithm-partial_sort-function)
*   [算法排序()功能](cpp-algorithm-sort-function)
*   [算法稳定 _ 排序()功能](cpp-algorithm-stable_sort-function)
*   [算法 binary_search()函数](cpp-algorithm-binary_search-function)
*   [算法 equal_range()函数](cpp-algorithm-equal_range-function)
*   [算法包括()功能](cpp-algorithm-includes-function)
*   [算法 inplace_merge()函数](cpp-algorithm-inplace_merge-function)
*   [算法合并()功能](cpp-algorithm-merge-function)
*   [算法集 _ 并集()函数](cpp-algorithm-set_union-function)
*   [算法上限()函数](cpp-algorithm-upper_bound-function)

**C++ STL 比特集**

*   [C++ 比特集](post/cpp-bitset)
*   [bitset all()功能](post/cpp-bitset-all-function)
*   [位设置任意()函数](post/cpp-bitset-any-function)
*   [位组计数()功能](post/cpp-bitset-count-function)
*   [位组翻转()功能](post/cpp-bitset-flip-function)
*   [bitset none()函数](post/cpp-bitset-none-function)
*   [位集运算符[]](post/cpp-bitset-operator[]-function)
*   [位组复位()功能](post/cpp-bitset-reset-function)
*   [位组设置()功能](post/cpp-bitset-set-function)
*   [位组大小()功能](post/cpp-bitset-size-function)
*   [位组测试()功能](post/cpp-bitset-test-function)
*   [位设置为 _string()函数](post/cpp-bitset-to_string-function)
*   [位设置为 _ullong()功能](post/cpp-bitset-to_ullong-function)
*   [位设置为 _ulong()功能](post/cpp-bitset-to_ulong-function)

c++ STL deque

*   c++ deque
*   [德格赋值()功能](post/cpp-deque-assign-function)
*   [德格侵位()功能](post/cpp-deque-emplace-function)
*   [德格侵位 _ 后退()功能](post/cpp-deque-emplace_back-function)
*   [德格侵位 _ 前置()功能](post/cpp-deque-emplace_front-function)
*   [德格插入()功能](post/cpp-deque-insert-function)
*   [德格推回()功能](post/cpp-deque-push_back-function)
*   [德格推 _ 锋()功能](post/cpp-deque-push_front-function)
*   [德格 pop_back()功能](post/cpp-deque-pop_back-function)
*   [德格 pop_front()功能](post/cpp-deque-pop_front-function)
*   [德客互换()功能](post/cpp-deque-swap-function)
*   [德清()功能](post/cpp-deque-clear-function)
*   [德清空()功能](post/cpp-deque-empty-function)
*   [德清擦除()功能](post/cpp-deque-erase-function)
*   [德格 max_size()功能](post/cpp-deque-max_size-function)
*   [德格调整大小()功能](post/cpp-deque-resize-function)
*   [德格收缩到配合()功能](post/cpp-deque-shrink_to_fit-function)
*   [德格大小()功能](post/cpp-deque-size-function)
*   [德格 at()功能](post/cpp-deque-at-function)
*   [德格运算符[]()功能](post/cpp-deque-operator[]()-function)
*   [德格运算符=()功能](post/cpp-deque-operator=()-function)
*   [德清回()功能](post/cpp-deque-back-function)
*   [德清 begin()功能](post/cpp-deque-begin-function)
*   [德格 cbegin()功能](post/cpp-deque-cbegin-function)
*   [德清结束()功能](post/cpp-deque-end-function)
*   [德清 cend()功能](post/cpp-deque-cend-function)
*   [德格 rbegin()功能](post/cpp-deque-rbegin-function)
*   [德格 crbegin()功能](post/cpp-deque-crbegin-function)
*   deque renda()函数
*   [德格克伦德()功能](post/cpp-deque-crend-function)

**C++ STL 列表**

*   [C++ 列表](post/cpp-list)
*   [列表插入()功能](post/cpp-list-insert-function)
*   [列表推回()功能](post/cpp-list-push_back-function)
*   [列表推送 _ 前置()功能](post/cpp-list-push_front-function)
*   [列表弹回()功能](post/cpp-list-pop_back-function)
*   [列表 pop_front()功能](post/cpp-list-pop_front-function)
*   [列表清空()功能](post/cpp-list-empty-function)
*   [列表大小()功能](post/cpp-list-size-function)
*   [列表 max_size()功能](post/cpp-list-max_size-function)
*   [列表前置()功能](post/cpp-list-front-function)
*   [列表后退()功能](post/cpp-list-back-function)
*   [列表交换()功能](post/cpp-list-swap-function)
*   [列表反转()功能](post/cpp-list-reverse-function)
*   [列表排序()功能](post/cpp-list-sort-function)
*   [列表合并()功能](post/cpp-list-merge-function)
*   [列表拼接()功能](post/cpp-list-splice-function)
*   [列出唯一()功能](post/cpp-list-unique-function)
*   [列表调整大小()功能](post/cpp-list-resize-function)
*   [列表分配()功能](post/cpp-list-assign-function)
*   [列表侵位()功能](post/cpp-list-emplace-function)
*   [列表定位 _ 后退()功能](post/cpp-list-emplace_back-function)
*   [列表侵位 _ 前置()功能](post/cpp-list-emplace_front-function)

**C++ STL 地图**

*   [C++ 地图](post/cpp-map)
*   [地图 at()功能](post/cpp-map-at-function)
*   [地图开始()功能](post/cpp-map-begin-function)
*   [地图 cbegin()功能](post/cpp-map-cbegin-function)
*   [地图 cend()功能](post/cpp-map-cend-function)
*   [地图 crbegin()功能](post/cpp-map-crbegin-function)
*   [地图垛口()功能](post/cpp-map-crend-function)
*   [地图清空()功能](post/cpp-map-empty-function)
*   [地图结束()功能](post/cpp-map-end-function)
*   [地图 max_size()功能](post/cpp-map-max_size-function)
*   [地图操作符[]](post/cpp-map-operator[]-function)
*   [地图 rbegin()功能](post/cpp-map-rbegin-function)
*   [地图渲染()功能](post/cpp-map-rend-function)
*   [地图大小()功能](post/cpp-map-size-function)
*   [地图清除()功能](post/cpp-map-clear-function)
*   [地图侵位()功能](post/cpp-map-emplace-function)
*   [地图侵位 _ 提示()功能](post/cpp-map-emplace_hint-function)
*   [地图擦除()功能](post/cpp-map-erase-function)
*   [地图查找()功能](post/cpp-map-find-function)
*   [地图插入()功能](post/cpp-map-insert-function)
*   [地图操作符=()](post/cpp-map-operator=()-function)
*   [地图互换()功能](post/cpp-map-swap-function)

**C++ STL 数学**

*   [数学 cos()函数](cpp-math-cos-function)
*   [数学 sin()函数](cpp-math-sin-function)
*   [数学 tan()函数](cpp-math-tan-function)
*   [数学 acos()函数](cpp-math-acos-function)
*   [数学 asin()函数](cpp-math-asin-function)
*   [数学 atan()函数](cpp-math-atan-function)
*   [数学 atan2()函数](cpp-math-atan2-function)
*   [数学 cosh()函数](cpp-math-cosh-function)
*   [数学 sinh()函数](cpp-math-sinh-function)
*   [数学 tanh()函数](cpp-math-tanh-function)
*   [数学 acosh()函数](cpp-math-acosh-function)
*   [数学 asinh()函数](cpp-math-asinh-function)
*   [数学 atanh()函数](cpp-math-atanh-function)
*   [数学 exp()函数](cpp-math-exp-function)
*   [数学 frexp()函数](cpp-math-frexp-function)
*   [数学 Idexp()函数](cpp-math-idexp-function)
*   [数学日志()功能](cpp-math-log-function)
*   [数学 log10()函数](cpp-math-log10-function)
*   [数学 modf()函数](cpp-math-modf-function)
*   [数学 exp2()函数](cpp-math-exp2-function)
*   [数学 expm1()函数](cpp-math-expm1-function)
*   [数学 log1p()函数](cpp-math-log1p-function)
*   [数学 log2()函数](cpp-math-log2-function)
*   [数学 logb()函数](cpp-math-logb-function)
*   [数学 scalbn()函数](cpp-math-scalbn-function)
*   [数学 scalbln()函数](cpp-math-scalbln-function)
*   [数学 ilogb()函数](cpp-math-ilogb-function)
*   [数学字帖()功能](cpp-math-copysign-function)
*   [数学 nextafter()函数](cpp-math-nextafter-function)
*   [数学 next 朝向()函数](cpp-math-nexttoward-function)
*   [数学 fdim()函数](cpp-math-fdim-function)
*   [数学 fmax()函数](cpp-math-fmax-function)
*   [数学 fmin()函数](cpp-math-fmin-function)
*   [数学幂()函数](cpp-math-pow-function)
*   [数学 sqrt()函数](cpp-math-sqrt-function)
*   [数学 cbrt()函数](cpp-math-cbrt-function)
*   [数学海波()函数](cpp-math-hypot-function)
*   [数学上限()函数](cpp-math-ceil-function)
*   [数学地板()功能](cpp-math-floor-function)
*   [数学圆()函数](cpp-math-round-function)
*   [数学 lround()函数](cpp-math-lround-function)
*   [数学 llround()函数](cpp-math-llround-function)
*   [数学 fmod()函数](cpp-math-fmod-function)
*   [数学 trunc()函数](cpp-math-trunc-function)
*   [数学 rint()函数](cpp-math-rint-function)
*   [数学 lrint()函数](cpp-math-lrint-function)
*   [数学打印()功能](cpp-math-llrint-function)
*   [数学 nearbyint()函数](cpp-math-nearbyint-function)
*   [数学余数()函数](cpp-math-remainder-function)
*   [数学 remquo()函数](cpp-math-remquo-function)
*   [数学晶圆厂()功能](cpp-math-fabs-function)
*   [数学 abs()函数](cpp-math-abs-function)
*   [数学 fma()函数](cpp-math-fma-function)
*   [数学 FP classifier()函数](cpp-math-fpclassify-function)
*   [数学是 inite()函数](cpp-math-isfinite-function)
*   [数学 isinf()函数](cpp-math-isinf-function)
*   [数学 isnan()函数](cpp-math-isnan-function)
*   [数学正常()函数](cpp-math-isnormal-function)
*   [数学 signbit()函数](cpp-math-signbit-function)
*   [数学建模器()函数](cpp-math-isgreater-function)
*   [数学是 isgreaterequal()函数](cpp-math-isgreaterequal-function)
*   [数学少()函数](cpp-math-less-function)
*   [数学等于()函数](cpp-math-islessequal-function)
*   [数学更大()函数](cpp-math-islessgreater-function)
*   [数学 isunordered()函数](cpp-math-isunordered-function)
*   [数学 erf()函数](cpp-math-erf-function)
*   [数学 erfc()函数](cpp-math-erfc-function)
*   [数学 tgamma()函数](cpp-math-tgamma-function)
*   [数学 lgamma()函数](cpp-math-lgamma-function)

**C++ STL 优先级 _ 队列**

*   [C++ 优先级 _ 队列](post/cpp-priority_queue)
*   [优先级 _ 队列就位()功能](post/cpp-priority_queue-emplace-function)
*   [priority_queue empty()功能](post/cpp-priority_queue-empty-function)
*   [优先级 _ 队列 pop()功能](post/cpp-priority_queue-pop-function)
*   [优先级 _ 队列推送()功能](post/cpp-prioriy_queue-push-function)
*   [priority_queue size()函数](post/cpp-priority_queue-size-function)
*   [优先级 _ 队列交换()功能](post/cpp-priority_queue-swap-function)
*   [priority_queue top()功能](post/cpp-priority_queue-top-function)

**C++ STL 栈**

*   [C++ 堆栈](cpp-stack)
*   [堆叠就位()功能](cpp-stack-emplace-function)
*   [栈空()功能](cpp-stack-empty-function)
*   [堆叠弹出()功能](cpp-stack-pop-function)
*   [栈推()功能](cpp-stack-push-function)
*   [堆叠大小()功能](cpp-stack-size-function)
*   [栈顶()功能](cpp-stack-top-function)

**C++ STL 队列**

*   [C++ 队列](cpp-queue)
*   [队列返回()功能](cpp-queue-back-function)
*   [队列就位()功能](cpp-queue-emplace-function)
*   [队列清空()功能](cpp-queue-empty-function)
*   [队列前()功能](cpp-queue-front-function)
*   [队列弹出()功能](cpp-queue-pop-function)
*   [队列推送()功能](cpp-queue-push-function)
*   [队列大小()功能](cpp-queue-size-function)

**C++ STL 多集**

*   [C++ 多集](cpp-multiset)
*   [多集构造器](cpp-multiset-constructor)
*   [多段毁灭者](cpp-multiset-destructor)
*   [多集 begin()功能](cpp-multiset-begin-function)
*   [多集结束()功能](cpp-multiset-end-function)
*   [多集运算符=](cpp-multiset-operator=-function)
*   [多集 rbegin()函数](cpp-multiset-rbegin-function)
*   [多集渲染()功能](cpp-multiset-rend-function)
*   [多集 cbegin()功能](cpp-multiset-cbegin-function)
*   [多集 cend()功能](cpp-multiset-cend-function)
*   [多集 max_size()功能](cpp-multiset-max_size-function)
*   [多集大小()功能](cpp-multiset-size-function)
*   [多集 crbegin()功能](cpp-multiset-crbegin-function)
*   [多组圆齿()功能](cpp-multiset-crend-function)
*   [多集空()功能](cpp-multiset-empty-function)
*   [多集插入()功能](cpp-multiset-insert-function)
*   [多集清除()功能](cpp-multiset-clear-function)
*   [多集侵位()功能](cpp-multiset-emplace-function)
*   [多集擦除()功能](cpp-multiset-erase-function)
*   [多集交换()功能](cpp-multiset-swap-function)
*   [多集侵位 _ 提示()功能](cpp-multiset-emplace_hint-function)
*   [多集查找()功能](cpp-multiset-find-function)
*   [多组键 _comp()功能](cpp-multiset-key_comp-function)
*   [多集值 _comp()函数](cpp-multiset-value_comp-function)
*   [多集计数()功能](cpp-multiset-count-function)
*   [多集等范围()功能](cpp-multiset-equal_range-function)
*   [多集下界()函数](cpp-multiset-lower_bound-function)
*   [多集上限()函数](cpp-multiset-upper_bound-function)
*   [多集 get _ 分配器()函数](cpp-multiset-get_allocator-function)
*   [多集运算符==](cpp-multiset-non-member-operator==)
*   [多集运算符！=](cpp-multiset-non-member-operator!=)
*   [多集运算符<](cpp-multiset-non-member-operator-less-than)
*   [多集运算符< =](cpp-multiset-non-member-operator-less-than=)
*   [多集运算符>](cpp-multiset-non-member-operator-greater-than)
*   [多集运算符> =](cpp-multiset-non-member-operator-greater-than=)
*   [多集交换()功能](cpp-multiset-non-member-swap-function)

**c++ STL multiap**

*   [C++ 多用途](post/cpp-multimap)
*   [多 map crbegin()功能](post/cpp-multimap-crbegin-function)
*   [多 ap crend()功能](post/cpp-multimap-crend-function)
*   [多地图开始()功能](post/cpp-multimap-begin-function)
*   [多地图 cbegin()功能](post/cpp-multimap-cbegin-function)
*   [多地图 cend()功能](post/cpp-multimap-cend-function)
*   [多点结束()功能](post/cpp-multimap-end-function)
*   [多地图 rbegin()功能](post/cpp-multimap-rbegin-function)
*   [多地图渲染()功能](post/cpp-multimap-rend-function)
*   [多地图清除()功能](post/cpp-multimap-clear-function)
*   [多点就位()功能](post/cpp-multimap-emplace-function)
*   [多点清空()功能](post/cpp-multimap-empty-function)
*   [多点擦除()功能](post/cpp-multimap-erase-function)
*   [多地图插入()功能](post/cpp-multimap-insert-function)
*   [多 ap 交换()功能](post/cpp-multimap-swap-function)
*   [多 map equal_range()功能](post/cpp-multimap-equal_range-function)
*   [多映射运算符==](post/cpp-multimap-non-member-operator==-function)
*   [多地图操作员！=](post/cpp-multimap-non-member-operator!=-function)
*   [多地图操作员<](post/cpp-multimap-non-member-operator<-function)
*   [多地图操作员< =](post/cpp-multimap-non-member-operator<=-function)
*   [多地图操作员>](post/cpp-multimap-non-member-operator>-function)
*   [多地图操作员> =](post/cpp-multimap-non-member-operator>=-function)
*   [多 ap 交换()功能](post/cpp-multimap-non-member-swap-function)

**C++ STL 集**

*   [C++ 设置](cpp-set)
*   [设置建造师](cpp-set-constructor)
*   [设置析构器](cpp-set-destructor)
*   [设置运算符=()功能](cpp-set-operator=()-function)
*   [设置 begin()功能](cpp-set-begin-function)
*   [设置 cbegin()功能](cpp-set-cbegin-function)
*   [设置结束()功能](cpp-set-end-function)
*   [设置 cend()功能](cpp-set-cend-function)
*   [设置 rbegin()功能](cpp-set-rbegin-function)
*   [设置 rend()功能](cpp-set-rend-function)
*   [设置 crbegin()功能](cpp-set-crbegin-function)
*   [设置垛口()功能](cpp-set-crend-function)
*   [设置空()功能](cpp-set-empty-function)
*   [设置大小()功能](cpp-set-size-function)
*   [设置 max_size()功能](cpp-set-max_size-function)
*   [设置插入()功能](cpp-set-insert-function)
*   [设置擦除()功能](cpp-set-erase-function)
*   [设置 Swap()功能](cpp-set-swap-function)
*   [设置清除()功能](cpp-set-clear-function)
*   [设置炮位()功能](cpp-set-emplace-function)
*   [设置侵位 _ 提示()功能](cpp-set-emplace_hint-function)
*   [设置 key_comp()功能](cpp-set-key_comp-function)
*   [设定值 _comp()功能](cpp-set-value_comp-function)
*   [设置 find()功能](cpp-set-find-function)
*   [设置计数()功能](cpp-set-count-function)
*   [设置下界()函数](cpp-set-lower_bound-function)
*   [设置上限()函数](cpp-set-upper_bound-function)
*   [设置 equal_range()功能](cpp-set-equal_range-function)
*   [设置 get _ 分配器()功能](cpp-set-get_allocator-function)
*   [设置运算符==](cpp-set-non-member-operator==)
*   [集合符！=](cpp-set-non-member-operator!=)
*   [设置操作员<](cpp-set-non-member-operator-less-than)
*   [设置操作员< =](cpp-set-non-member-operator-less-than=)
*   [设置操作员>](cpp-set-non-member-operator-greater-than)
*   [设置操作员> =](cpp-set-non-member-operator-greater-than=)
*   [设置交换()功能](cpp-set-non-member-swap-function)

**C++ 标准字符串**

*   [字符串比较()功能](cpp-string-compare-function)
*   [字符串长度()函数](cpp-string-length-function)
*   [字符串交换()功能](cpp-string-swap-function)
*   字符串 substr()函数
*   [字符串大小()函数](cpp-string-size-function)
*   [字符串调整大小()功能](cpp-string-resize-function)
*   [字符串替换()功能](cpp-string-replace-function)
*   [字符串追加()功能](cpp-string-append-function)
*   [字符串 at()功能](cpp-string-at-function)
*   [字符串查找()功能](cpp-string-find-function)
*   [字符串 find_first_of()函数](cpp-string-find-first-of-function)
*   [字符串 find_first_not_of()函数](cpp-string-find-first-not-of-function)
*   [字符串 find_last_of()函数](cpp-string-find-last-of-function)
*   [字符串 find_last_not_of()函数](cpp-string-find-last-not-of-function)
*   [字符串插入()功能](cpp-string-insert-function)
*   [字符串 max_size()函数](cpp-string-max-size-function)
*   [字符串 push_back()功能](cpp-string-push-back-function)
*   [字符串 pop_back()功能](cpp-string-pop-back-function)
*   [设置分配()功能](cpp-string-assign-function)
*   [字符串复制()功能](cpp-string-copy-function)
*   [串回()功能](cpp-string-back-function)
*   [字符串 begin()函数](cpp-string-begin-function)
*   [串容()功能](cpp-string-capacity-function)
*   [字符串 cbegin()函数](cpp-string-cbegin-function)
*   [字符串 cend()功能](cpp-string-cend-function)
*   [串清()功能](cpp-string-clear-function)
*   [字符串 crbegin()函数](cpp-string-crbegin-function)
*   [字符串数据()功能](cpp-string-data-function)
*   [字符串空()功能](cpp-string-empty-function)
*   [字符串擦除()功能](cpp-string-erase-function)
*   [弦锋()功能](cpp-string-front-function)
*   [字符串运算符+=()](cpp-string-operator+=()-function)
*   [字符串运算符=()](cpp-string-operator=()-function)
*   [字符串运算符[]()](cpp-string-operator[]()-function)
*   [字符串 rfind()功能](cpp-string-rfind-function)
*   [字符串结束()功能](cpp-string-end-function)
*   [字符串渲染()功能](cpp-string-rend-function)
*   [字符串收缩到适合()功能](cpp-string-shrink-to-fit-function)
*   [字符串 c_str()函数](cpp-string-c-str-function)
*   [串垛口()功能](cpp-string-crend-function)
*   [字符串 rbegin()函数](cpp-string-rbegin-function)
*   [字符串保留()功能](cpp-string-reserve-function)
*   string get _ 分配器()函数

**C++ STL 向量**

*   [C++ 向量](cpp-vector)
*   [向量在()函数中](cpp-vector-at-function)
*   [矢量后退()功能](cpp-vector-back-function)
*   [矢量前端()功能](cpp-vector-front-function)
*   [矢量交换()功能](cpp-vector-swap-function)
*   [矢量推回()功能](cpp-vector-push-back-function)
*   [矢量弹回()功能](cpp-vector-pop-back-function)
*   [向量空()函数](cpp-vector-empty-function)
*   [矢量插入()功能](cpp-vector-insert-function)
*   [矢量擦除()功能](cpp-vector-erase-function)
*   [矢量调整大小()功能](cpp-vector-resize-function)
*   [矢量清零()功能](cpp-vector-clear-function)
*   [向量大小()函数](cpp-vector-size-function)
*   [向量容量()函数](cpp-vector-capacity-function)
*   [向量赋值()函数](cpp-vector-assign-function)
*   [向量运算符=()函数](cpp-vector-operator=()-function)
*   [向量算子[]()函数](cpp-vector-operator[]()-function)
*   [矢量结束()功能](cpp-vector-end-function)
*   [矢量定位()功能](cpp-vector-emplace-function)
*   [矢量定位 _ 后退()功能](cpp-vector-emplace-back-function)
*   [矢量渲染()功能](cpp-vector-rend-function)
*   [向量 rbegin()函数](cpp-vector-rbegin-function)
*   [向量开始()函数](cpp-vector-begin-function)
*   [向量最大大小()函数](cpp-vector-max-size-function)
*   [矢量 cend()函数](cpp-vector-cend-function)
*   [向量 cbegin()函数](cpp-vector-cbegin-function)
*   [向量 crbegin()函数](cpp-vector-crbegin-function)
*   [矢量克伦德()函数](cpp-vector-crend-function)
*   [矢量数据()功能](cpp-vector-data-function)
*   [向量收缩到拟合()函数](cpp-vector-shrink-to-fit-function)

**面试问题**

*   [面试问题](cpp-interview-questions)

* * *

## 先决条件

学习 C++ 之前，必须具备 C 的基础知识。

## 观众

我们的 C++ 教程旨在帮助初学者和专业人士。

## 问题

我们保证您在这个 C++ 教程中不会发现任何问题。但是如果有任何错误，请在联系表格中发布问题。