# C++ 基本输入/输出

> 原文：<https://www.javatpoint.com/cpp-basic-input-output>

C++ 的 I/O 操作是使用流的概念。流是字节序列或数据流。它使表演变得很快。

如果字节从主存储器流向打印机、显示屏或网络连接等设备，这称为**输出操作。**

如果字节从打印机、显示屏或网络连接等设备流向主存储器，这称为**输入操作。**

* * *

## 输入输出库头文件

让我们看看 C++ 编程中常用的头文件有:

| 头文件 | 功能和说明 |
| <iostream></iostream> | 用于定义 **cout、cin 和 cerr** 对象，分别对应标准输出流、标准输入流和标准误差流。 |
| <iomanip></iomanip> | 它用于声明对执行格式化输入/输出有用的服务，如**设置精度和设置。** |
| <fstream></fstream> | 它用于为用户控制的文件处理声明服务。 |

* * *

## 标准输出流(cout)

**cout** 是**牡蛎**类的预定义对象。它与标准输出设备相连，通常是显示屏。cout 与流插入操作符(< <)一起使用，在控制台上显示输出

让我们看看标准输出流(cout)的简单示例:

```
#include <iostream>
using namespace std;
int main( ) {
   char ary[] = "Welcome to C++ tutorial";
   cout << "Value of ary is: " << ary << endl;
}

```

输出:

```
Value of ary is: Welcome to C++ tutorial

```

* * *

## 标准输入流(cin)

**cin** 是**团队**类的预定义对象。它与标准输入设备相连，通常是键盘。cin 与流提取操作符(> >)结合使用，从控制台读取输入。

让我们看看标准输入流(cin)的简单例子:

```
#include <iostream>
using namespace std;
int main( ) {
  int age;
   cout << "Enter your age: ";
   cin >> age;
   cout << "Your age is: " << age << endl;
}

```

输出:

```
Enter your age: 22
Your age is: 22

```

* * *

## 标准端线

**endl** 是**牡蛎**类的预定义对象。它用于插入新的行字符并刷新流。

让我们看看标准结束线(endl)的简单示例:

```
#include <iostream>
using namespace std;
int main( ) {
cout << "C++ Tutorial";   
cout << " Javatpoint"<<endl; 
cout << "End of line"<<endl; 
} 

```

输出:

```
C++ Tutorial Javatpoint 
End of line

```