# C++ 函数

> 原文：<https://www.javatpoint.com/cpp-functions>

C++ 语言中的函数在其他编程语言中也称为过程或子程序。

为了执行任何任务，我们可以创建函数。一个函数可以被多次调用。它提供了模块化和代码可重用性。

* * *

## C 语言中函数的优势

功能有很多优点。

**1)代码可重用性**

通过在 C++ 中创建函数，可以多次调用它。所以我们不需要一遍又一遍地写同样的代码。

**2)代码优化**

它使代码得到优化，我们不需要写太多代码。

假设，你要检查 3 个数字(531，883 和 781)是否是质数。不使用函数，需要写 3 遍素数逻辑。所以，有代码的重复。

但是如果你使用函数，你只需要写一次逻辑，你可以重用它几次。

* * *

## 函数的类型

C 编程中有两种类型的函数:

**1。库函数:**是 C++ 头文件中声明的函数，如 ceil(x)、cos(x)、exp(x)等。

**2。用户自定义函数:**是由 C++ 程序员创建的函数，以便他/她可以多次使用。它降低了大程序的复杂性，优化了代码。

![CPP Functions 1](img/35866ade4cd9700bf7804b8a47bd251a.png)

## 函数声明

用 C++ 语言创建函数的语法如下:

```
return_type function_name(data_type parameter...)
{  
//code to be executed  
}

```

* * *

## C++ 函数示例

让我们看看 C++ 函数的简单例子。

```
#include <iostream>
using namespace std;
void func() {  
   static int i=0; //static variable  
   int j=0; //local variable  
   i++;  
   j++;  
   cout<<"i=" << i<<" and j=" <<j<<endl;  
}  
int main()
{
 func();  
 func();  
 func();  
}

```

输出:

```
i= 1 and j= 1
i= 2 and j= 1
i= 3 and j= 1

```