# C++ 中的值调用和引用调用

> 原文：<https://www.javatpoint.com/call-by-value-and-call-by-reference-in-cpp>

在 C 语言中，将值或数据传递给函数有两种方式:按值调用和按引用调用。原始值不会在值调用中修改，但会在引用调用中修改。

![CPP Call by value and call by reference in cpp 1](img/5ecb914a6c071b7b1fce87428b9d2b6d.png)

让我们逐个理解 C++ 语言中的按值调用和按引用调用。

* * *

## C++ 中的值调用

在按值调用中，**初始值不被修改。**

在按值调用中，传递给函数的值由函数参数本地存储在堆栈内存位置。如果您更改函数参数的值，它只会针对当前函数进行更改。它不会改变调用方方法(如 main()中的变量值。

让我们通过下面给出的例子来理解 C++ 语言中的值调用的概念:

```
#include <iostream>
using namespace std;
void change(int data);
int main()
{
int data = 3;
change(data);
cout << "Value of the data is: " << data<< endl;
return 0;
}
void change(int data)
{
data = 5;
}

```

输出:

```
Value of the data is: 3

```

* * *

## C++ 中的引用调用

在按引用调用中，原始值被修改，因为我们传递引用(地址)。

这里，值的地址在函数中传递，因此实际的和形式的参数共享相同的地址空间。因此，在函数内部改变的值，在函数内部和外部都有反映。

**注意:**要通过引用理解调用，必须具备指针的基础知识。

让我们通过下面给出的例子来理解 C++ 语言中引用调用的概念:

```
#include<iostream>
using namespace std;  
void swap(int *x, int *y)
{
 int swap;
 swap=*x;
 *x=*y;
 *y=swap;
}
int main() 
{  
 int x=500, y=100;  
 swap(&x, &y);  // passing value to function
 cout<<"Value of x is: "<<x<<endl;
 cout<<"Value of y is: "<<y<<endl;
 return 0;
}  

```

输出:

```
Value of x is: 100
Value of y is: 500   

```

* * *

## C++ 中按值调用和按引用调用的区别

| 号码 | 按值调用 | 引用调用 |
| one | 值的副本被传递给函数 | 值的地址被传递给函数 |
| Two | 函数内部所做的更改不会反映在其他函数上 | 在函数内部所做的更改也会反映在函数外部 |
| three | 实际参数和形式参数将在不同的内存位置创建 | 实际参数和形式参数将在相同的内存位置创建 |