# C++ 存储类

> 原文：<https://www.javatpoint.com/cpp-storage-classes>

存储类用于定义 C++ 程序中变量和/或函数的生存期和可见性。

生存期指的是变量保持活动状态的时间，可见性指的是变量可访问的程序模块。

有五种类型的存储类，可以在 C++ 程序中使用

1.  自动的
2.  注册
3.  静态
4.  外部
5.  易变的

| 存储类 | 关键字 | 一生 | 能见度 | 基础资料 |
| 自动的 | 汽车 | 功能块 | 当地的 | 垃圾 |
| 注册 | 注册 | 功能块 | 当地的 | 垃圾 |
| 易变的 | 易变的 | 班级 | 当地的 | 垃圾 |
| 外部 | 走读生 | 整个程序 | 全球的 | 零 |
| 静态 | 静电 | 整个程序 | 当地的 | 零 |

* * *

## 自动存储类

它是所有局部变量的默认存储类。auto 关键字自动应用于所有局部变量。

```
{ 
auto int y;
float y = 3.45;
}

```

上面的例子用同一个存储类定义了两个变量，auto 只能在函数中使用。

* * *

## 寄存器存储类

寄存器变量在寄存器中分配内存，而不是内存。其大小与寄存器大小相同。它比其他变量具有更快的访问速度。

建议仅使用寄存器变量进行快速访问，例如在计数器中。

注意:我们无法获得寄存器变量的地址。

```
register int counter=0;  

```

* * *

## 静态存储类

静态变量只初始化一次，并且一直存在到程序结束。它在多个函数调用之间保持其值。

静态变量的默认值为 0，由编译器提供。

```
#include <iostream>
using namespace std;
void func() {  
   static int i=0; //static variable  
   int j=0; //local variable  
   i++;  
   j++;  
   cout<<"i=" << i<<" and j=" <<j<<endl;  
}  
int main()
{
 func();  
 func();  
 func();  
}

```

输出:

```
i= 1 and j= 1
i= 2 and j= 1
i= 3 and j= 1

```

* * *

## 外部存储类

外部变量对所有程序都是可见的。如果两个或多个文件共享同一个变量或函数，则使用它。

```
extern int counter=0;  

```