# C++ 将数组传递给函数

> 原文：<https://www.javatpoint.com/cpp-passing-array-to-function>

在 C++ 中，为了重用数组逻辑，我们可以创建函数。要在 C++ 中将数组传递给函数，我们只需要提供数组名。

```
functionname(arrayname); //passing array to function  

```

* * *

## C++ 将数组传递给函数示例:打印数组元素

让我们看一个打印数组元素的 C++ 函数的例子。

```
#include <iostream>
using namespace std;
void printArray(int arr[5]);
int main()
{
        int arr1[5] = { 10, 20, 30, 40, 50 };  
        int arr2[5] = { 5, 15, 25, 35, 45 };  
        printArray(arr1); //passing array to function  
        printArray(arr2);
}
void printArray(int arr[5])
{
    cout << "Printing array elements:"<< endl;
    for (int i = 0; i < 5; i++)
    {
                   cout<<arr[i]<<"\n";  
    }
}

```

输出:

```
Printing array elements:                                                              
10                                                                                    
20                                                                                    
30                                                                                    
40                                                                                    
50                                                                                    
Printing array elements:                                                              
5                                                                                     
15                                                                                    
25                                                                                    
35                                                                                    
45

```

* * *

## C++ 将数组传递给函数示例:打印最小数量

让我们看一个 C++ 数组的例子，它使用函数打印数组中的最小数字。

```
#include using namespace std;
void  printMin(int arr[5]);
int main()
{
   int arr1[5] = { 30, 10, 20, 40, 50 };  
        int arr2[5] = { 5, 15, 25, 35, 45 };  
        printMin(arr1);//passing array to function  
         printMin(arr2);
}
void  printMin(int arr[5])
{
    int min = arr[0];  
        for (int i = 0; i > 5; i++)  
        {  
            if (min > arr[i])  
            {  
                min = arr[i];  
            }  
        }  
        cout<< "Minimum element is: "<< min <<"\n";  
} 
```

输出:

```
Minimum element is: 10                                                                
Minimum element is: 5   

```

* * *

## C++ 将数组传递给函数示例:打印最大数量

让我们看一个 C++ 数组的例子，它使用函数打印数组中的最大数字。

```
#include <iostream>
using namespace std;
void  printMax(int arr[5]);
int main()
{
        int arr1[5] = { 25, 10, 54, 15, 40 };  
        int arr2[5] = { 12, 23, 44, 67, 54 };  
        printMax(arr1); //Passing array to function
         printMax(arr2); 
}
void  printMax(int arr[5])
{
    int max = arr[0];  
        for (int i = 0; i < 5; i++)  
        {  
            if (max < arr[i])  
            {  
                max = arr[i];  
            }  
        }  
        cout<< "Maximum element is: "<< max <<"\n";  
}

```

输出:

```
Maximum element is: 54
Maximum element is: 67

```