# C++ 对象和类

> 原文：<https://www.javatpoint.com/cpp-object-and-class>

因为 C++ 是一种面向对象的语言，所以程序是用 C++ 中的对象和类来设计的。

* * *

## C++ 对象

在 C++ 中，对象是一个真实世界的实体，例如，椅子、汽车、笔、手机、笔记本电脑等。

换句话说，对象是具有状态和行为的实体。这里，状态意味着数据，行为意味着功能。

对象是运行时实体，它是在运行时创建的。

对象是类的实例。该类的所有成员都可以通过对象访问。

让我们看一个使用 s1 作为引用变量创建学生类对象的例子。

```
Student s1;  //creating an object of Student    

```

在本例中，Student 是类型，s1 是引用 Student 类实例的引用变量。

* * *

## C++ 类

在 C++ 中，类是一组相似的对象。它是创建对象的模板。它可以有字段、方法、构造函数等。

让我们看一个只有三个字段的 C++ 类的例子。

```
class Student  
 {  
     public:
     int id;  //field or data member   
     float salary; //field or data member
     String name;//field or data member  
 }  

```

* * *

## C++ 对象和类示例

让我们看一个有两个字段的类的例子:id 和 name。它创建类的实例，初始化对象并打印对象值。

```
#include <iostream>
using namespace std;
class Student {
   public:
      int id;//data member (also instance variable)    
      string name;//data member(also instance variable)    
};
int main() {
    Student s1; //creating an object of Student 
    s1.id = 201;  
    s1.name = "Sonoo Jaiswal"; 
    cout<<s1.id<<endl;
    cout<<s1.name<<endl;
    return 0;
}

```

输出:

```
201
Sonoo Jaiswal

```

* * *

## C++ 类示例:通过方法初始化和显示数据

让我们看看 C++ 类的另一个例子，在这个例子中，我们通过方法初始化和显示对象。

```
#include <iostream>
using namespace std;
class Student {
   public:
       int id;//data member (also instance variable)    
       string name;//data member(also instance variable)    
       void insert(int i, string n)  
        {  
            id = i;  
            name = n;  
        }  
       void display()  
        {  
            cout<<id<<"  "<<name<<endl;  
        }  
};
int main(void) {
    Student s1; //creating an object of Student 
    Student s2; //creating an object of Student
    s1.insert(201, "Sonoo");  
    s2.insert(202, "Nakul");  
    s1.display();  
    s2.display();
    return 0;
}

```

输出:

```
201  Sonoo
202  Nakul

```

* * *

## C++ 类示例:存储和显示员工信息

让我们看看 C++ 类的另一个例子，在这个例子中，我们使用方法来存储和显示员工信息。

```
#include <iostream>
using namespace std;
class Employee {
   public:
       int id;//data member (also instance variable)    
       string name;//data member(also instance variable)
       float salary;
       void insert(int i, string n, float s)  
        {  
            id = i;  
            name = n;  
            salary = s;
        }  
       void display()  
        {  
            cout<<id<<"  "<<name<<"  "<<salary<<endl;  
        }  
};
int main(void) {
    Employee e1; //creating an object of Employee 
    Employee e2; //creating an object of Employee
    e1.insert(201, "Sonoo",990000);  
    e2.insert(202, "Nakul", 29000);  
    e1.display();  
    e2.display();  
    return 0;
}

```

输出:

```
201  Sonoo  990000
202  Nakul  29000

```