# C++ 构造函数

> 原文：<https://www.javatpoint.com/cpp-constructor>

在 C++ 中，构造函数是一种在创建对象时自动调用的特殊方法。一般用于初始化新对象的数据成员。C++ 中的构造函数与类或结构同名。

C++ 中可以有两种类型的构造函数。

*   默认构造函数
*   参数化构造函数

* * *

## C++ 默认构造函数

没有参数的构造函数称为默认构造函数。它在创建对象时被调用。

让我们看看 C++ 默认构造函数的简单例子。

```
#include <iostream>
using namespace std;
class Employee
 {
   public:
        Employee()  
        {  
            cout<<"Default Constructor Invoked"<<endl;  
        }  
};
int main(void) 
{
    Employee e1; //creating an object of Employee 
    Employee e2; 
    return 0;
}

```

输出:

```
Default Constructor Invoked 
Default Constructor Invoked

```

* * *

## C++ 参数化构造函数

具有参数的构造函数称为参数化构造函数。它用于为不同的对象提供不同的值。

让我们看看 C++ 参数化构造函数的简单例子。

```
#include <iostream>
using namespace std;
class Employee {
   public:
       int id;//data member (also instance variable)    
       string name;//data member(also instance variable)
       float salary;
       Employee(int i, string n, float s)  
        {  
            id = i;  
            name = n;  
            salary = s;
        }  
       void display()  
        {  
            cout<<id<<"  "<<name<<"  "<<salary<<endl;  
        }  
};
int main(void) {
    Employee e1 =Employee(101, "Sonoo", 890000); //creating an object of Employee 
    Employee e2=Employee(102, "Nakul", 59000); 
    e1.display();  
    e2.display();  
    return 0;
}

```

输出:

```
101  Sonoo  890000
102  Nakul  59000

```