# C++ 破坏者

> 原文：<https://www.javatpoint.com/cpp-destructor>

析构函数的工作原理与构造函数相反；它会破坏类的对象。在一个类中只能定义一次。像构造函数一样，它是自动调用的。

析构函数的定义类似于构造函数。它必须与类同名。但是它的前缀是波浪号(~)。

#### 注意:C++ 析构函数不能有参数。此外，修饰符不能应用于析构函数。

## C++ 构造函数和析构函数示例

让我们看一个 C++ 中构造函数和析构函数的例子，它是自动调用的。

```
#include <iostream>
using namespace std;
class Employee
 {
   public:
        Employee()  
        {  
            cout<<"Constructor Invoked"<<endl;  
        }  
        ~Employee()  
        {  
            cout<<"Destructor Invoked"<<endl;  
        }
};
int main(void) 
{
    Employee e1; //creating an object of Employee 
    Employee e2; //creating an object of Employee
    return 0;
}

```

输出:

```
Constructor Invoked
Constructor Invoked
Destructor Invoked
Destructor Invoked

```