# C++ 这个指针

> 原文：<https://www.javatpoint.com/cpp-this-pointer>

在 C++ 编程中，**这个**是指类的当前实例的关键字。这个关键字在 C++ 中可以有 3 种主要用法。

*   可以使用**将当前对象作为参数传递给另一个方法。**
*   可以使用**引用当前类实例变量。**
*   可以使用**来声明索引器。**

* * *

## C++ 这个指针示例

让我们看看 C++ 中引用当前类字段的这个关键字的例子。

```
#include <iostream>
using namespace std;
class Employee {
   public:
       int id; //data member (also instance variable)    
       string name; //data member(also instance variable)
       float salary;
       Employee(int id, string name, float salary)  
        {  
             this->id = id;  
            this->name = name;  
            this->salary = salary; 
        }  
       void display()  
        {  
            cout<<id<<"  "<<name<<"  "<<salary<<endl;  
        }  
};
int main(void) {
    Employee e1 =Employee(101, "Sonoo", 890000); //creating an object of Employee 
    Employee e2=Employee(102, "Nakul", 59000); //creating an object of Employee
    e1.display();  
    e2.display();  
    return 0;
}

```

输出:

```
101  Sonoo  890000
102  Nakul  59000

```