# c++ struts

> 原文：<https://www.javatpoint.com/cpp-structs>

在 C++ 中，类和结构是用来创建类实例的蓝图。结构用于轻量级对象，如矩形、颜色、点等。

与类不同，C++ 中的结构是值类型而不是引用类型。如果您有在创建结构后不打算修改的数据，这很有用。

**C++ 结构**是不同数据类型的集合。它类似于保存不同类型数据的类。

## 结构的句法

```
struct structure_name
{
     // member declarations.
} 

```

在上面的声明中，通过在 **struct 关键字**前面加上标识符(结构名)来声明一个结构。在花括号内，我们可以声明不同类型的成员变量。**考虑以下情况:**

```
struct Student
{
    char name[20];
     int id;
     int age;
}

```

在上面的例子中，Student 是一个包含三个变量名称、id 和年龄的结构。声明结构时，不分配内存。当一个结构的变量被创建时，内存就被分配了。让我们理解这个场景。

## 如何创建结构实例？

结构变量可以定义为:

**学生年代；**

这里，s 是**学生**类型的结构变量。创建结构变量时，将分配内存。学生结构包含一个字符变量和两个整数变量。因此，一个字符变量的内存是 1 字节，两个整数是 2*4 = 8。s 变量占用的总内存是 9 字节。

## 如何访问结构的变量:

结构的变量可以通过简单地使用结构的实例后跟点(。)运算符，然后是结构的字段。

**例如:**

```
s.id = 4;

```

在上面的语句中，我们通过使用**点(。)**运算符，并将值 4 赋给 id 字段。

## C++ 结构示例

让我们看一个结构矩形的简单例子，它有两个数据成员宽度和高度。

```
#include <iostream>  
using namespace std;  
 struct Rectangle    
{    
   int width, height;    

 };    
int main(void) {  
    struct Rectangle rec;  
    rec.width=8;  
    rec.height=5;  
   cout<<"Area of Rectangle is: "<<(rec.width * rec.height)<<endl;  
 return 0;  
}  

```

**输出:**

```
Area of Rectangle is: 40

```

## C++ 结构示例:使用构造函数和方法

让我们看另一个结构的例子，我们使用构造函数初始化数据和方法来计算矩形的面积。

```
#include <iostream>  
using namespace std;  
 struct Rectangle    {    
   int width, height;    
  Rectangle(int w, int h)    
    {    
        width = w;    
        height = h;    
    }    
  void areaOfRectangle() {     
    cout<<"Area of Rectangle is: "<<(width*height); }    
 };    
int main(void) {  
    struct Rectangle rec=Rectangle(4,6);  
    rec.areaOfRectangle();  
   return 0;  
}  

```

**输出:**

```
Area of Rectangle is: 24

```

**结构 v/s 级**

| 结构 | 班级 |
| 如果未显式声明访问说明符，则默认情况下，访问说明符将是公共的。 | 如果未显式声明访问说明符，则默认情况下，访问说明符将是私有的。 |
| 结构语法:

结构结构 _ 名称
{
//结构主体。
 | 类语法:

类类名
{
//类体。
 |
| 该结构的实例被称为“结构变量”。 | 该类的实例被称为“类的对象”。 |