# C++ 数学函数

> 原文：<https://www.javatpoint.com/cpp-math-functions>

C++ 提供了一些基本的数学函数，使用这些函数所需的头文件是<math.h></math.h>

## 三角函数

| 方法 | 描述 |
| [cos(x)](cpp-math-cos-function) | 它计算 x 的余弦值。 |
| [sin(x)](cpp-math-sin-function) | 它计算 x 的正弦值。 |
| [tan(x)](cpp-math-tan-function) | 它计算 x 的正切值。 |
| [acos(x)](cpp-math-acos-function) | 它求 x 的反余弦。 |
| [asin(x)](cpp-math-asin-function) | 它找到了 x 的逆正弦。 |
| [阿坦(x)](cpp-math-atan-function) | 它求 x 的反正切。 |
| [atan2(x，y)](cpp-math-atan2-function) | 它找到坐标 x 和 y 的反正切。 |

## 双曲函数

| 方法 | 描述 |
| [cosh(x)](cpp-math-cosh-function) | 它计算 x 的双曲余弦。 |
| [sinh(x)](cpp-math-sinh-function) | 它计算 x 的双曲正弦。 |
| [tanh(x)](cpp-math-tanh-function) | 它计算 x 的双曲正切值。 |
| [acosh(x)](cpp-math-acosh-function) | 它求 x 的弧双曲余弦。 |
| 正在使用一个精确的描述法解释为 1231 例 | 它找到了 x 的双曲正弦曲线。 |
| [阿坦(x)](cpp-math-atanh-function) | 它找到了 x 的双曲正切值。 |

## 指数函数

| 方法 | 描述 |
| [exp(x)](cpp-math-exp-function) | 它计算指数 e 的 x 次方。 |
| [frexp(value_type x，int* exp)](cpp-math-frexp-function) | 它将一个数分解成有效数和 2，再升到幂指数。 |
| [Idexp(float x，int e)](cpp-math-idexp-function) | 它计算 x 和 2 的乘积乘以 e 的幂。 |
| [log(x)](cpp-math-log-function) | 它计算 x 的自然对数。 |
| [log10(x)](cpp-math-log10-function) | 它计算 x 的普通对数。 |
| [modf()](cpp-math-modf-function) | 它把一个数分成整数和小数部分。 |
| [exp2(x)](cpp-math-exp2-function) | 它计算 x 的 2 次幂。 |
| [露出 1(x)](cpp-math-expm1-function) | 它计算幂 x 减 1 的指数。 |
| [log1p(x)](cpp-math-log1p-function) | 它计算 x 加 1 的自然对数。 |
| [log2(x)](cpp-math-log2-function) | 它计算 x 的以 2 为底的对数。 |
| [logb(x)](cpp-math-logb-function) | 它计算 x 的对数。 |
| [scalbn( x，n)](cpp-math-scalbn-function) | 它计算 x 和 FLT_RADX 的乘积与 n 的幂。 |
| [scalbln( x，n)](cpp-math-scalbln-function) | 它计算 x 和 FLT_RADX 的乘积与 n 的幂。 |
| [伊洛 gb(x)](cpp-math-ilogb-function) | 它返回 x 的指数部分。 |

## 浮点操作函数

| 方法 | 描述 |
| [copysign(x，y)](cpp-math-copysign-function) | 它返回 x 的大小和 y 的符号。 |
| [nextafter(x，y)](cpp-math-nextafter-function) | 它表示 x 在 y 方向上的下一个可表示值。 |
| [下一个朝向(x，y)](cpp-math-nexttoward-function) | 它表示 x 在 y 方向上的下一个可表示值。 |

## 最大值、最小值和差值函数

| 方法 | 描述 |
| [FDI(x，y)](cpp-math-fdim-function) | 它计算 x 和 y 之间的正差。 |
| [fmx(x，y)](cpp-math-fmax-function) | 它返回两个数字 x 和 y 中较大的一个。 |
| [fmin()](cpp-math-fmin-function) | 它返回两个数字 x 和 y 中较小的一个。 |

## 电源功能

| 方法 | 描述 |
| [幂(x，y)](cpp-math-pow-function) | 它计算 x 的幂 y。 |
| [sqrt(x)](cpp-math-sqrt-function) | 它计算 x 的平方根。 |
| [cbrt(x)](cpp-math-cbrt-function) | 它计算 x 的立方根。 |
| [海波(x，y)](cpp-math-hypot-function) | 它找到直角三角形的斜边。 |

## 最近整数运算

| 方法 | 描述 |
| [天花板(x)](cpp-math-ceil-function) | 它将 x 的值向上舍入。 |
| [楼层(x)](cpp-math-floor-function) | 它向下舍入 x 的值。 |
| [圆形(x)](cpp-math-round-function) | 它舍入 x 的值。 |
| [lro(x)](cpp-math-lround-function) | 它将 x 的值四舍五入并转换为长整数。 |
| [llround(x)](cpp-math-llround-function) | 它舍入 x 的值，并转换为长整型。 |
| [fmod(n，d)](cpp-math-fmod-function) | 它计算除法 n/d 的余数。 |
| [truc(x)](cpp-math-trunc-function) | 它将 x 值四舍五入为零。 |
| [rint(x)](cpp-math-rint-function) | 它使用舍入模式舍入 x 的值。 |
| [lrint(x)](cpp-math-lrint-function) | 它使用舍入模式舍入 x 的值，并转换为长整数。 |
| [llrint(x)](cpp-math-llrint-function) | 它取整 x 值并转换为长整型。 |
| [nearbyint(x)](cpp-math-nearbyint-function) | 它将 x 值舍入到一个附近的整数值。 |
| [余数(n，d)](cpp-math-remainder-function) | 它计算 n/d 的余数。 |
| 现状() | 它同时计算余数和商。 |

## 其他功能

| 方法 | 描述 |
| [晶圆厂(x)](cpp-math-fabs-function) | 它计算 x 的绝对值。 |
| [abs(x)](cpp-math-abs-function) | 它计算 x 的绝对值。 |
| [fma(x，y，z)](cpp-math-fma-function) | 它计算表达式 x*y+z。 |

## 宏函数

| 方法 | 描述 |
| [FP classifier(x)](cpp-math-fpclassify-function) | 它返回与其中一个宏常量匹配的类型值。 |
| [isfinite(x)](cpp-math-isfinite-function) | 它检查 x 是否有限。 |
| [isinf()](cpp-math-isinf-function) | 它检查 x 是否为无穷大。 |
| [isnan（）](cpp-math-isnan-function) | 它检查 x 是否是 nan。 |
| [为正常值(x)](cpp-math-isnormal-function) | 它检查 x 是否正常。 |
| [符号位(x)](cpp-math-signbit-function) | 它检查 x 的符号是否为负。 |

## 比较宏函数

| 方法 | 描述 |
| [是精（x，y）](cpp-math-isgreater-function) | 它决定了 x 是否大于 y。 |
| [is greater requeal(x，y)](cpp-math-isgreaterequal-function) | 它确定 x 是否大于或等于 y。 |
| [减(x，y)](cpp-math-less-function) | 它决定 x 是否小于 y。 |
| [岛屿哪个(x，y)](cpp-math-islessequal-function) | 它确定 x 是否小于或等于 y。 |
| [伊斯兰大(x，y)](cpp-math-islessgreater-function) | 它决定 x 是否小于或大于 y。 |
| [为奇数(x，y)](cpp-math-isunordered-function) | 它检查 x 是否可以进行有意义的比较。 |

## 误差和伽玛函数

| 方法 | 描述 |
| [erf(x)](cpp-math-erf-function) | 它计算 x 的误差函数值。 |
| [erfc(x)](cpp-math-erfc-function) | 它计算 x 的互补误差函数值。 |
| [tgamma(x)](cpp-math-tgamma-function) | 它计算 x 的伽马函数值。 |
| [lgamma(x)](cpp-math-lgamma-function) | 它计算 x 的伽玛函数的对数。 |