# C++ 中的接口(抽象类)

> 原文：<https://www.javatpoint.com/interfaces-in-cpp>

抽象类是 C++ 中实现抽象的方式。C++ 中的抽象是隐藏内部细节并只显示功能的过程。抽象可以通过两种方式实现:

1.  **抽象类**
2.  **界面**

抽象类和接口都可以有抽象所必需的抽象方法。

* * *

## C++ 抽象类

在 C++ 中，通过将类的至少一个函数声明为<> strong >纯虚函数，使类变得抽象。纯虚函数是通过在其声明中放置“= 0”来指定的。它的实现必须由派生类提供。

让我们看一个 C++ 中抽象类的例子，它有一个抽象方法 draw()。它的实现由派生类提供:矩形和圆形。两个类都有不同的实现。

```
#include <iostream>
using namespace std;
 class Shape  
{  
    public: 
    virtual void draw()=0;  
};  
 class Rectangle : Shape  
{  
    public:
     void draw()  
    {  
        cout < <"drawing rectangle..." < <endl;  
    }  
};  
class Circle : Shape  
{  
    public:
     void draw()  
    {  
        cout <<"drawing circle..." < <endl;  
    }  
};  
int main( ) {
    Rectangle rec;
    Circle cir;
    rec.draw();  
    cir.draw(); 
   return 0;
}

```

输出:

```
drawing rectangle...
drawing circle...

```