# C++ 命名空间

> 原文：<https://www.javatpoint.com/cpp-namespaces>

C++ 中的名称空间被用来组织太多的类，以便于处理应用程序。

为了访问命名空间的类，我们需要使用 namespacename::classname。我们可以使用**使用**关键字，这样我们就不必一直使用完整的名称。

在 C++ 中，全局命名空间是根命名空间。全局::std 将始终引用 C++ 框架的命名空间“std”。

* * *

## C++ 命名空间示例

让我们看看包含变量和函数的名称空间的简单例子。

```
#include <iostream>
using namespace std;
namespace First {  
    void sayHello() { 
        cout<<"Hello First Namespace"<<endl;        
    }  
}  
namespace Second  {  
       void sayHello() { 
           cout<<"Hello Second Namespace"<<endl; 
       }  
} 
int main()
{
 First::sayHello();
 Second::sayHello();
return 0;
}

```

输出:

```
Hello First Namespace
Hello Second Namespace

```

* * *

## C++ 命名空间示例:通过使用关键字

让我们看另一个命名空间的例子，我们使用“使用”关键字，这样我们就不必使用完整的名称来访问命名空间程序。

```
#include <iostream>
using namespace std;
namespace First{
   void sayHello(){
      cout << "Hello First Namespace" << endl;
   }
}
namespace Second{
   void sayHello(){
      cout << "Hello Second Namespace" << endl;
   }
}
using namespace First;
int main () {
   sayHello();
   return 0;
}

```

输出:

```
Hello First Namespace	

```