# C 字符串

> 原文：<https://www.javatpoint.com/cpp-strings>

在 C++ 中，string 是 **std::string** 类的一个对象，表示字符序列。我们可以对字符串执行许多操作，如连接、比较、转换等。

* * *

## C++ 字符串示例

让我们看看 C++ 字符串的简单例子。

```
#include <iostream>
using namespace std;
int main( ) {
    string s1 = "Hello";  
        char ch[] = { 'C', '+', '+'};  
        string s2 = string(ch);  
        cout<<s1<<endl;  
        cout<<s2<<endl;  
}

```

输出:

```
Hello
C++

```

* * *

## C++ 字符串比较示例

让我们看看使用 strcmp()函数进行字符串比较的简单示例。

```
#include #include <cstring>
using namespace std;
int main ()
{
  char key[] = "mango";
  char buffer[50];
  do {
     cout<<"What is my favourite fruit? ";
     cin>>buffer;
  } while (strcmp (key,buffer) != 0);
 cout<<"Answer is correct!!"<<endl;
  return 0;
} 
```

输出:

```
What is my favourite fruit? apple
What is my favourite fruit? banana
What is my favourite fruit? mango
Answer is correct!!

```

* * *

## C++ 字符串连接示例

让我们看看使用 strcat()函数进行字符串连接的简单示例。

```
#include <iostream>
#include <cstring>
using namespace std;
int main()
{
    char key[25], buffer[25];
    cout << "Enter the key string: ";
    cin.getline(key, 25);
    cout << "Enter the buffer string: ";
     cin.getline(buffer, 25);
    strcat(key, buffer); 
    cout << "Key = " << key << endl;
    cout << "Buffer = " << buffer<<endl;
    return 0;
}

```

输出:

```
Enter the key string: Welcome to
Enter the buffer string:  C++ Programming.
Key = Welcome to C++ Programming.
Buffer =  C++ Programming.

```

* * *

## C++ 字符串复制示例

让我们看看使用 strcpy()函数复制字符串的简单示例。

```
#include <iostream>
#include <cstring>
using namespace std;
int main()
{
    char key[25], buffer[25];
    cout << "Enter the key string: ";
    cin.getline(key, 25);
    strcpy(buffer, key);
    cout << "Key = "<< key << endl;
    cout << "Buffer = "<< buffer<<endl;
    return 0;
}

```

输出:

```
Enter the key string: C++ Tutorial
Key = C++ Tutorial
Buffer = C++ Tutorial

```

* * *

## C++ 字符串长度示例

让我们看看使用 strlen()函数查找字符串长度的简单示例。

```
#include <iostream>
#include <cstring>
using namespace std;
int main()
{
    char ary[] = "Welcome to C++ Programming";
    cout << "Length of String = " << strlen(ary)<<endl;
    return 0;
}

```

输出:

```
Length of String = 26

```

## C++ 字符串函数

| 功能 | 描述 |
| [int compare(常量字符串&字符串)](cpp-string-compare-function) | 它用于比较两个字符串对象。 |
| [int length()](cpp-string-length-function) | 它用于查找字符串的长度。 |
| [虚空互换(弦&弦)](cpp-string-swap-function) | 它用于交换两个字符串对象的值。 |
| 字符串子字符串(int pos，int n) | 它创建一个由 n 个字符组成的新字符串对象。 |
| [int size()](cpp-string-size-function) | 它以字节为单位返回字符串的长度。 |
| [空隙调整大小(int n)](cpp-string-resize-function) | 它用于调整字符串长度，最多 n 个字符。 |
| [字符串&替换(int pos，int len，字符串&字符串)](cpp-string-replace-function) | 它替换字符串中从字符位置 pos 开始并跨越 len 字符的部分。 |
| [字符串&追加(常量字符串&字符串)](cpp-string-append-function) | 它在另一个字符串对象的末尾添加新字符。 |
| [在(国际位置)](cpp-string-at-function)充电& | 它用于在指定位置访问单个字符。 |
| [int find(字符串&字符串，int pos，int n)](cpp-string-find-function) | 它用于查找参数中指定的字符串。 |
| [int find_first_of(字符串&字符串，int pos，int n)](cpp-string-find-first-of-function) | 它用于查找指定序列的第一个匹配项。 |
| [int find_first_not_of(字符串&字符串，int pos，int n )](cpp-string-find-first-not-of-function) | 它用于在字符串中搜索与字符串中指定的任何字符都不匹配的第一个字符。 |
| [int find_last_of(字符串&字符串，int pos，int n)](cpp-string-find-last-of-function) | 它用于在字符串中搜索指定序列的最后一个字符。 |
| [int find_last_not_of(字符串&字符串，int pos)](cpp-string-find-last-not-of-function) | 它搜索与指定序列不匹配的最后一个字符。 |
| [弦&插()](cpp-string-insert-function) | 它在位置位置所指示的字符之前插入一个新字符。 |
| [int max_size()](cpp-string-max-size-function) | 它找到字符串的最大长度。 |
| [无效推回(char ch)](cpp-string-push-back-function) | 它在字符串的末尾添加一个新的字符 ch。 |
| [空弹回()](cpp-string-pop-back-function) | 它删除字符串的最后一个字符。 |
| [弦&赋()](cpp-string-assign-function) | 它为字符串赋值。 |
| [int copy(字符串& str)](cpp-string-copy-function) | 它将字符串的内容复制到另一个字符串中。 |
| [char & back()](cpp-string-back-function) | 它返回最后一个字符的引用。 |
| [迭代器 begin()](cpp-string-begin-function) | 它返回第一个字符的引用。 |
| [int capacity()](cpp-string-capacity-function) | 它返回为字符串分配的空间。 |
| const_iterator cbegin() | 它指向字符串的第一个元素。 |
| const_iterator cend() | 它指向字符串的最后一个元素。 |
| 清空() | 它从字符串中移除所有元素。 |
| const_reverse_iterator crbegin() | 它指向字符串的最后一个字符。 |
| const_char*数据() | 它将字符串的字符复制到一个数组中。 |
| 布尔空（） | 它检查字符串是否为空。 |
| 字符串和擦除() | 它将删除指定的字符。 |
| [char & front()](cpp-string-front-function) | 它返回第一个字符的引用。 |
| [字符串&运算符+=()](cpp-string-operator+=()-function) | 它在字符串末尾追加一个新字符。 |
| [字符串&运算符=()](cpp-string-operator=()-function) | 它为字符串分配一个新值。 |
| char 运算符[](pos) | 它在指定位置检索一个字符。 |
| int rfnd() | 它搜索字符串的最后一次出现。 |
| [迭代器 end()](cpp-string-end-function) | 它引用字符串的最后一个字符。 |
| [reverse_iterator rend()](cpp-string-rend-function) | 它指向字符串的第一个字符。 |
| [空隙收缩配合()](cpp-string-shrink-to-fit-function) | 它减少了容量，使其等于字符串的大小。 |
| [char* c_str()](cpp-string-c-str-function) | 它返回指向包含空终止字符序列的数组的指针。 |
| [const _ reverse _ iterator crend()](cpp-string-crend-function) | 它引用字符串的第一个字符。 |
| [reverse_iterator rbegin()](cpp-string-rbegin-function) | 它引用字符串的最后一个字符。 |
| 无效储备 | 它要求改变容量。 |
| 分配器 _ type get _ 分配器()； | 它返回与字符串关联的已分配对象。 |