# C++ 尝试/捕获

> 原文：<https://www.javatpoint.com/cpp-try-catch>

在 C++ 编程中，异常处理是使用 try/catch 语句执行的。C++ **尝试块**用于放置可能发生异常的代码。**捕捉块**用于处理异常。

* * *

## 没有 try/catch 的 C++ 示例

```
#include <iostream>
using namespace std;
float division(int x, int y) {
   return (x/y);
}
int main () {
   int i = 50;
   int j = 0;
   float k = 0;
      k = division(i, j);
      cout << k << endl;
   return 0;
}

```

输出:

```
Floating point exception (core dumped)  

```

* * *

## C++ 尝试/捕获示例

```
#include <iostream>
using namespace std;
float division(int x, int y) {
   if( y == 0 ) {
      throw "Attempted to divide by zero!";
   }
   return (x/y);
}
int main () {
   int i = 25;
   int j = 0;
   float k = 0;
   try {
      k = division(i, j);
      cout << k << endl;
   }catch (const char* e) {
      cerr << e << endl;
   }
   return 0;
}

```

输出:

```
Attempted to divide by zero!

```