# C++ 用户定义的异常

> 原文：<https://www.javatpoint.com/cpp-user-defined-exceptions>

新的异常可以通过覆盖和继承**异常**类功能来定义。

## C++ 用户定义的异常示例

让我们看看用户定义异常的简单例子，其中 **std::exception** 类用于定义异常。

```
#include <iostream>
#include <exception>
using namespace std;
class MyException : public exception{
    public:
        const char * what() const throw()
        {
            return "Attempted to divide by zero!\n";
        }
};
int main()
{
    try
    {
        int x, y;
        cout << "Enter the two numbers : \n";
        cin >> x >> y;
        if (y == 0)
        {
            MyException z;
            throw z;
        }
        else
        {
            cout << "x / y = " << x/y << endl;
        }
    }
    catch(exception& e)
    {
        cout << e.what();
    }
}

```

输出:

```
Enter the two numbers :
10
2
x / y = 5  

```

输出:

```
Enter the two numbers :
10
0
Attempted to divide by zero!

```

-->

**注意:**在上例中 what()是异常类提供的公共方法。它用于返回异常的原因。