# C++ 文件和流

> 原文：<https://www.javatpoint.com/cpp-files-and-streams>

在 [C++ 编程](https://www.javatpoint.com/cpp-tutorial)中，我们使用的是 **iostream** 标准库，它分别提供了 **cin** 和 **cout** 的输入读取和输出写入方法。

为了读写文件，我们使用了标准的 C++ 库 **fstream** 。让我们看看在 fstream 库中定义的数据类型是:

| 数据类型 | 描述 |
| fstab stream-串流:串流:串流:串流:串流:串流:串流:串流:串流:串流:串流:串流:串流:串流:串流:串流:串流:串流:串流:串流:串流:串流:串流 | 它用于创建文件、向文件中写入信息以及从文件中读取信息。 |
| ifstream 车 | 它用于从文件中读取信息。 |
| ofstream(联邦快递) | 它用于创建文件并将信息写入文件。 |

* * *

## C++ FileStream 示例:写入文件

让我们看看使用 C++ FileStream 编程写入文本文件 **testout.txt** 的简单示例。

```
#include <iostream>
#include <fstream>
using namespace std;
int main () {
  ofstream filestream("testout.txt");
  if (filestream.is_open())
  {
    filestream << "Welcome to javaTpoint.\n";
    filestream << "C++ Tutorial.\n";
    filestream.close();
  }
  else cout <<"File opening is fail.";
  return 0;
}

```

**输出:**

```
The content of a text file testout.txt is set with the data:
Welcome to javaTpoint.
C++ Tutorial.

```

* * *

## C++ FileStream 示例:从文件中读取

让我们看看使用 C++ FileStream 编程读取文本文件 **testout.txt** 的简单示例。

```
#include <iostream>
#include <fstream>
using namespace std;
int main () {
  string srg;
  ifstream filestream("testout.txt");
  if (filestream.is_open())
  {
    while ( getline (filestream,srg) )
    {
      cout << srg <<endl;
    }
    filestream.close();
  }
  else {
      cout << "File opening is fail."<<endl; 
    }
  return 0;
}

```

#### 注意:在运行代码之前，需要创建一个名为**“testout . txt”**的文本文件，文本文件的内容如下:
欢迎使用 javaTpoint。
C++ 教程。

**输出:**

```
Welcome to javaTpoint.
C++ Tutorial.

```

* * *

## C++ 读写示例

让我们来看看将数据写入文本文件 **testout.txt** 然后使用 C++ FileStream 编程从文件中读取数据的简单示例。

```
#include <fstream>
#include <iostream>
using namespace std;
int main () {
   char input[75];
   ofstream os;
   os.open("testout.txt");
   cout <<"Writing to a text file:" << endl;
   cout << "Please Enter your name: "; 
   cin.getline(input, 100);
   os << input << endl;
   cout << "Please Enter your age: "; 
   cin >> input;
   cin.ignore();
   os << input << endl;
   os.close();
   ifstream is; 
   string line;
   is.open("testout.txt"); 
   cout << "Reading from a text file:" << endl; 
   while (getline (is,line))
   {
   cout << line << endl;
   }	
   is.close();
   return 0;
}

```

**输出:**

```
Writing to a text file:  
 Please Enter your name: Nakul Jain    
Please Enter your age: 22  
 Reading from a text file:   Nakul Jain  
 22

```

* * *