# C++ int 到字符串

> 原文：<https://www.javatpoint.com/cpp-int-to-string>

**将整数转换为字符串有三种方式:**

![C++ int to string](img/fd3d21c52eeeba1135bb851bb9ff088c.png)

*   **通过使用 stringstream 类**
*   **通过使用 to_string()方法**
*   **通过使用 boost .词法分析**

### 使用 stringstream 类将整数转换为字符串。

stringstream 类是在<sstream>头文件中定义的流类。它是一个流类，用于对基于字符串的流执行输入输出操作。</sstream>

**以下是用于插入或提取数据的运算符:**

*   **运算符> > :** 它从流中提取数据。
*   **运算符< <:>它将数据插入流中。T3】**

**我们通过一个例子来理解算子的概念。**

*   **在下面的语句中，< <插入操作符将 100 插入到流中。**
    流光 1<<100；
*   **在下面的语句中，> >提取操作符从流中提取数据，并将其存储在“I”变量中。**
    流光 1>>I；

让我们通过一个例子来理解。

```

#include <iostream>
#include<sstream>
using namespace std;
int main() {
  int k;
  cout<<"Enter an integer value";
  cin>>k;
  stringstream ss;
  ss<<k;
  string s;
  ss>>s;
  cout<<"\n"<<"An integer value is : "<<k<<"\n";
  cout<<"String representation of an integer value is : "<<s; 
}

```

**输出**

![C++ int to string](img/b5ff8e9ee2109416e6d9b982b6664a84.png)

在上例中，我们创建了 **k** 变量，想要将 k 的值转换成字符串值。我们使用了 stringstream 类，该类用于将 k 整数值转换为字符串值。我们也可以反过来实现，也就是说，仅通过使用 stringstream 类也可以将字符串转换为整数值。

**我们通过一个例子来了解一下字符串转换为数字的概念。**

```

#include <iostream>
#include<sstream>
using namespace std;
int main()
{
  string number ="100";
  stringstream ss;
  ss<<number;
  int i;
  ss>>i;
  cout<<"The value of the string is : "<<number<<"\n";
  cout<<"Integer value of the string is : "<<i;

}

```

**输出**

![C++ int to string](img/66fc0a7ddb391a1739c14a0d121a8ee4.png)

### 使用 to_string()方法将整数转换为字符串。

**to_string()** 方法接受单个整数，并将整数值或其他数据类型值转换为字符串。

**我们通过一个例子来了解一下:**

```

#include <iostream>
#include<string>
using namespace std;
int main()
{
 int i=11;
 float f=12.3;
string str= to_string(i);
string str1= to_string(f);
cout<<"string value of integer i is :"<<str<<"\n";
cout<<"string value of f is : "<< str1;
}

```

**输出**

![C++ int to string](img/e951b8df13b7a6e516bfce97495dfa4d.png)

### 使用 boost .词法转换将整数转换为字符串。

boost .词法转换提供了一个转换操作符，即 boost .词法转换，它将字符串值转换为整数值或其他数据类型值，反之亦然。

**我们通过一个例子来了解一下整数到字符串的转换。**

```

#include <iostream>
#include <boost/lexical_cast.hpp>
using namespace std;
int main()
{
 int i=11;
 string str = boost::lexical_cast<string>(i);
cout<<"string value of integer i is :"<<str<<"\n";

}

```

**输出**

![C++ int to string](img/6d8495bce32e0542f8bc1b90241e8a7b.png)

在上面的例子中，我们已经使用词法转换()函数将“I”变量的值转换为字符串值。

让我们通过一个例子来理解字符串到整数的转换。

```

#include <iostream>
#include <boost/lexical_cast.hpp>
using namespace std;
int main()
{
string s="1234";
 int k = boost::lexical_cast<int>(s);
cout<<"Integer value of string s is : "<<k<<"\n";
}

```

**输出**

![C++ int to string](img/071e514e7b6f571192715d0cc6153839.png)

在上面的例子中，我们已经使用词法转换()函数将字符串值转换为整数值。