# C++ vs Python

> 原文：<https://www.javatpoint.com/cpp-vs-python>

### 什么是 C++？

C++ 是比雅尼·斯特劳斯特鲁普于 1979 年开发的高级通用编程语言。它是一种扩展的 C 编程语言，即带类的 C。面向对象编程的概念最初是在 C++ 语言中引入的。C++ 也是一种面向对象的编程语言。

它是为系统编程和嵌入式系统设计的，但后来，它被用于开发各种应用程序，如桌面应用程序、视频游戏、电子商务等服务器、网络搜索或 SQL 服务器以及电话交换机等性能关键型应用程序。

### Python 是什么？

Python 是吉多·范·罗苏姆于 1991 年开发的一种通用高级编程语言。开发 python 语言的主要目的是它的简单性。它包含像缩进这样的特性，这使得代码更易读，它还包含使这种语言更强大的库函数。

它被宣布为 IEEE 2018 年顶级编程语言中的顶级语言。由于它的流行和简单性，使得 python 在行业中更加强大。

### C++ 和 Python 的区别

![C++ vs Python](img/f824c9806c2f3e8d314edd78114aee36.png)

### 定义

C++ 是一种高级和面向对象的编程语言，允许您进行过程性编程，非常接近 CPU，并提供对硬件的完全控制。

Python 是一种解释的高级通用编程语言，用于开发所有类型的项目。

### 学习的便利性

初学者的主要因素之一是容易学习。如果编程语言很难，那么程序员就很难学习。python 的语法类似于英语。因此，它非常容易学习。另一方面，C++ 是基于面向对象的概念来处理内存分配的，如果我们用 C++ 写错了程序，那么也会破坏系统。

### 速度

C++ 比 python 编程语言更快。Python 是用 C 编程语言编写的，所以内存管理在 python 中非常困难。在 C++ 中，我们可以将内存分配给变量，并且可以在代码中不再使用变量时释放内存。

### 内存管理

在 C++ 中，我们需要将内存分配给新的变量，并在不再需要该变量时释放内存。如果我们不这样做，那么它会导致内存泄漏。因此，我们可以说 C++ 不提供内置的垃圾收集和动态内存管理。另一方面，python 提供了内置的垃圾收集和动态内存管理机制，即它自己分配和释放内存。

### 汇编

Python 是一种解释的编程语言，因此在编译时需要一个解释器。另一方面，C++ 是一种预编译的编程语言，因此在编译时不需要任何解释器。

### 可读性

C++ 语法复杂，读写困难。它遵循编程规则，比如我们需要在语句末尾使用花括号和分号。另一方面，python 不遵循这些编程规则。它使用缩进规则，类似于英语；这种缩进让程序员更容易理解代码。

### 变量声明

在 C++ 中，我们需要在使用变量之前通过提及变量的类型和名称来声明变量。因此，C++ 是一种静态类型的编程语言。另一方面，python 是一种动态类型的编程语言，这意味着我们不需要在使用该变量之前声明该变量。

**C++ 程序**

```

#include <iostream>
using namespace std;
int main()
{
    int a=20;
    std::cout << "value of a is : " <<a<< std::endl;
    return 0;
}

```

**Python 程序**

```

# python program
#integer assignment
a=20
print(a)

```

在上面两个程序中，输出将是 20。以上两个程序的区别在于，在 C++ 中，我们需要用变量的类型来声明变量，而在 python 中，我们不需要声明变量。

### 功能

在 C++ 中，函数根据预定义的定义接受并返回值类型。例如，假设我们有一个函数 int add(int a，int b)，那么这个函数将只接受整数值作为参数并返回整数类型值。另一方面，在 python 中，参数的类型及其返回值的类型没有限制。

**我们用表格的形式总结一下上面的区别。**

| C++ | 计算机编程语言 |
| 这是一种高级的预编译编程语言，允许您进行过程编程。 | 它是一种高级的解释编程语言，用于开发所有类型的项目。 |
| 因为语法复杂，不容易学。 | 它很容易学习，因为它不遵循任何编程规则。它遵循缩进规则，这与英语非常相似。 |
| 它不包含垃圾收集器。 | 它包含垃圾收集器。 |
| 它是一种预编译的编程语言，因此在编译过程中不需要解释器。 | 它是一种解释的编程语言，所以它需要一个解释器来运行程序。 |
| 它是一种静态类型的编程语言。 | 它是一种动态类型的编程语言。 |
| 变量是通过提及变量的类型来声明的。 | 它不需要声明变量。 |
| 接受值作为参数并返回值的类型的函数将取决于函数的定义。 | 该函数对参数的类型和返回类型没有任何限制。 |
| 安装很容易。 | 在 Windows 上安装 python 并不容易。 |
| 循环内的变量不能在循环外访问。 | 循环内部的变量也可以在循环外部访问。 |
| 与 Python 相比，它有很长的代码行。 | 与 C++ 相比，它包含的代码行更少。 |
| 它支持过程式和面向对象的编程。 | 它支持过程式、面向对象和函数式编程。 |
| 它包含 52 个关键词。 | 它包含 33 个关键词。 |
| 在 C++ 中，程序员需要手动分配新变量，并在不再需要时解除分配。 | Python 执行分配。 |

* * *