# C++ 中两个数的 LCM

> 原文：<https://www.javatpoint.com/lcm-of-two-numbers-in-cpp>

LCM 代表**最小公倍数**，用来得到两个数(n1 和 n2)的最小公倍数，公倍数要能被给定的个数整除。一个公倍数是两个数字的公倍数。两个数的 LCM 的表示，如 LCM (a，b)或 lcm (a，b)。

![LCM of two numbers in C++](img/f991719bd6704ec5eea04934e92a357a.png)

例如，两个正数的 LCM，因为 LCM (12，24)是 24。因为数字 12 和 24 都除以 24，没有留下任何余数。类似地，3 和 4 的 LCM 是 12，因为两个数的最小公倍数都是 12。

### 两个数的 LCM 算法

**步骤 1:** 从用户 n1 和 n2 获取两个输入

**第二步:**将 n1 和 n2 的最小公倍数存入 max 变量。

**第三步:**验证 max 变量是否可被 n1 和 n2 整除，将 max 打印为两个数的 LCM。

**第 4 步:**否则，每次迭代最大值更新 1，跳转到第 3 步检查最大变量的可除性。

**第五步:**终止程序。

### 使用 if 语句和 while 循环获取两个数的 LCM 的程序

**Program1.cpp**

```

#include 
using namespace std;
int main()
{
	int n1, n2, max_num, flag = 1;
	cout << " Enter two numbers: \n";
	cin >> n1 >> n2;	

	// use ternary operator to get the large number
	max_num = (n1 > n2) ? n1 : n2;

	while (flag)  
	{
		// if statement checks max_num is completely divisible by n1 and n2.
		if(max_num % n1 == 0 && max_num % n2 == 0)
		{
			cout << " The LCM of " <
```

**输出**

```
Enter two numbers:
30
50
 The LCM of 30 and 50 is 150

```

### 使用 while 循环获取两个数的 LCM 的程序

**Program2.cpp**

```

#include using namespace std;

int main()
{
	// declare variables
	int num1, num2, lcm, gcd, temp;
	cout <> num1;
	cout <> num2;

	// assign num1 and num2 values to int a and b
	int a = num1;
	int b = num2;	
	// use while loop to define the condition
	while (num2 != 0)
	{
		temp = num2;
		num2 = num1 % num2;
		num1 = temp;
	}

	// assign num1 to gcd variable
	gcd = num1;
	lcm = (a * b) / gcd;
	cout << "\n LCM of " << a << " and " << b << " = " << lcm;
	return 0;
} 
```

**输出**

```
Enter the first number: 15
 Enter the second number: 10

 LCM of 15 and 10 = 30

```

### 使用 GCD 获取两个数的 LCM 的程序

**Program3.cpp**

```

#include 
using namespace std;

// definition of getGCD() function
int getGCD( int n1, int n2)
{
// here if statement checks the given number is not equal to 0.
if ( n1 == 0 || n2 == 0)
return 0;

// if n1 equal to n2, return n1
if (n1 == n2)
return n1;

// if n1 is greater than n2, execute the followed statement
if ( n1 > n2)
return getGCD (n1 - n2, n2);

return getGCD (n1, n2 - n1);
}

// definition of getLCM() function
int getLCM (int n1, int n2)
{
/* divide the multiplication of n1 and n2 by getGCD() function to return LCM. */	
return (n1 * n2) / getGCD (n1,n2);
}

int main()
{
// declare local variables	
int n1, n2;
cout << " Enter two positive numbers: ";
cin >> n1 >> n2; // get numbers from user

// print the LCM(n1, n2)
cout << " \n LCM of " <
```

**输出**

```
Enter two positive numbers: 50
60

 LCM of 50 and 60 is 300

```

### 用递归函数求两个数的 LCM 的程序

**程序 4.cpp**

```

# include 
using namespace std;

// define the getGCD()  function and pass n1 and n2 parameter
int getGCD( int n1, int n2)
{
	if (n1 == 0)
	{
		return n2;		
	}

return getGCD(n2 % n1, n1);
}

// define the getLCM function to return the LCM
int getLCM( int n1, int n2)
{
	return (n1 / getGCD(n1, n2)) * n2;
}

int main()
{
	// declare local variable
	int num1, num2;
	cout << " Enter two numbers: " <<endl cin="">> num1 >> num2;
	cout << " LCM of two numbers " <</endl>
```

**输出**

```
Enter two numbers:
12
36
 LCM of two numbers 12 and 36 is 36

```

### 使用函数和 while 循环获取多个数组元素的 LCM 的程序

**Program5.cpp**

```

#include using namespace std;
int lcm_num (int n1, int n2)
{
	int max;
	max = (n1 > n2) ? n1 : n2;
	while (true)
	{
		if (max % n1 == 0 && max % n2 ==0)
		return max;
		max++;
	}
}

// definition of lcm_array() function
int lcm_array (int arr[], int num)
{
	int i;
	int lcm = lcm_num( arr[0], arr[1]);

	// use for loop to get the lcm
	for (i = 2; i < num; i++)
	{
		lcm = lcm_num(lcm , arr[i]);
	}
	return lcm;

}

int main()
{	
	// declare integer array
	int arr[] = {10, 5, 15, 30};
	int num = sizeof(arr) / sizeof(arr[0]); // get the number of elements
	cout << " LCM of multiple array elements is: " << lcm_array(arr, num);
} 
```

**输出**

```
LCM of multiple array elements is: 30

```

* * *