# C++ 向量

> 原文：<https://www.javatpoint.com/cpp-vector>

向量是一个实现动态数组的序列容器类，这意味着在追加元素时大小会自动改变。向量将元素存储在连续的内存位置，并在运行时根据需要分配内存。

## 向量和数组的区别

数组遵循静态方法，这意味着它的大小在运行时不能改变，而 vector 实现动态数组意味着它在追加元素时会自动调整自身的大小。

## 句法

考虑一个向量“v1”。语法应该是:

```
vector<object_type> v1;

```

## 例子

让我们看一个简单的例子。

```
#include<iostream>
#include<vector>
using namespace std;
int main()
{
vector<string> v1;
v1.push_back("javaTpoint ");
v1.push_back("tutorial");
for(vector<string>::iterator itr=v1.begin();itr!=v1.end();++itr)
cout<<*itr;
return 0; 
}

```

**输出:**

```
javaTpoint tutorial

```

在这个例子中，向量类被用来显示字符串。

## C++ 向量函数

| 功能 | 描述 |
| [at()](cpp-vector-at-function) | 它提供对元素的引用。 |
| [后退()](cpp-vector-back-function) | 它引用了最后一个元素。 |
| [前()](cpp-vector-front-function) | 它引用了第一个元素。 |
| [互换()](cpp-vector-swap-function) | 它在两个向量之间交换元素。 |
| [push_back()](cpp-vector-push-back-function) | 它在末尾添加了一个新元素。 |
| [pop_back()](cpp-vector-pop-back-function) | 它从向量中移除最后一个元素。 |
| [空()](cpp-vector-empty-function) | 它确定向量是否为空。 |
| [插入()](cpp-vector-insert-function) | 它在指定位置插入新元素。 |
| [擦除()](cpp-vector-erase-function) | 它删除指定的元素。 |
| [调整大小()](cpp-vector-resize-function) | 它修改向量的大小。 |
| [晴()](cpp-vector-clear-function) | 它从向量中移除所有元素。 |
| [尺寸()](cpp-vector-size-function) | 它决定了向量中的元素数量。 |
| [容量()](cpp-vector-capacity-function) | 它决定了矢量的当前容量。 |
| [分配()](cpp-vector-assign-function) | 它给向量赋值。 |
| [运算符=()](cpp-vector-operator=()-function) | 它向向量容器分配新值。 |
| [运算符[]()](cpp-vector-operator[]()-function) | 它访问指定元素。 |
| [end()](cpp-vector-end-function) | 它指的是向量中的过去式元素。 |
| [炮位()](cpp-vector-emplace-function) | 它在位置位置之前插入一个新元素。 |
| [就位 _ 后退()](cpp-vector-emplace-back-function) | 它在末尾插入一个新元素。 |
| [rend()](cpp-vector-rend-function) | 它指向向量第一个柠檬前面的元素。 |
| [rbegin（）](cpp-vector-rbegin-function) | 它指向向量的最后一个元素。 |
| [begin()](cpp-vector-begin-function) | 它指向向量的第一个元素。 |
| [max_size()](cpp-vector-max-size-function) | 它决定了向量可以容纳的最大大小。 |
| [cend()](cpp-vector-cend-function) | 它指的是向量中的过去最后一个元素。 |
| [cbegin（）](cpp-vector-cbegin-function) | 它指的是向量的第一个元素。 |
| crbegin() | 它指的是向量的最后一个字符。 |
| [信徒()](cpp-vector-crend-function) | 它指的是向量第一个元素之前的元素。 |
| [数据()](cpp-vector-data-function) | 它将向量的数据写入数组。 |
| [收缩到合适的程度()](cpp-vector-shrink-to-fit-function) | 它减少了容量，使其等于向量的大小。 |