# C++ 列表

> 原文：<https://www.javatpoint.com/post/cpp-list>

*   列表是一个连续的容器，而向量是一个不连续的容器，即列表将元素存储在一个连续的内存中，向量存储在一个不连续的内存中。
*   向量中间的插入和删除是非常昂贵的，因为它需要花费大量的时间来移动所有的元素。Linklist 克服了这个问题，它是使用列表容器实现的。
*   列表支持双向，并为插入和删除操作提供了一种有效的方法。
*   遍历在列表中很慢，因为列表元素是按顺序访问的，而 vector 支持随机访问。

## 列表模板

```

#include<iostream>
#include<list>
using namespace std;
int main()
{
   list<int> l;
}

```

它创建一个整型值的空列表。

**列表也可以用参数初始化。**

```

#include<iostream>
#include<list>
using namespace std;
int main()
{
   list<int> l{1,2,3,4};
}

```

**列表可以通过两种方式初始化。**

```

list<int>  new_list{1,2,3,4};
or
list<int> new_list = {1,2,3,4};

```

## C++ 列表函数

以下是该列表的成员函数:

| 方法 | 描述 |
| [插入()](cpp-list-insert-function) | 它在迭代器指向的位置之前插入新元素。 |
| [push_back()](cpp-list-push_back-function) | 它在向量的末尾添加一个新元素。 |
| [push_front()](cpp-list-push_front-function) | 它在前面增加了一个新的元素。 |
| [pop_back()](cpp-list-pop_back-function) | 它删除最后一个元素。 |
| [pop_front()](cpp-list-pop_front-function) | 它删除第一个元素。 |
| [空()](cpp-list-empty-function) | 它检查列表是否为空。 |
| [尺寸()](cpp-list-size-function) | 它查找列表中存在的元素数量。 |
| [max_size()](cpp-list-max_size-function) | 它会找到列表的最大大小。 |
| [前()](cpp-list-front-function) | 它返回列表的第一个元素。 |
| [后退()](cpp-list-back-function) | 它返回列表的最后一个元素。 |
| [互换()](cpp-list-swap-function) | 当两个列表的类型相同时，它交换两个列表。 |
| [反转()](cpp-list-reverse-function) | 它反转列表的元素。 |
| [排序()](cpp-list-sort-function) | 它以递增的顺序对列表中的元素进行排序。 |
| [合并()](cpp-list-merge-function) | 它合并了两个排序列表。 |
| [拼接()](cpp-list-splice-function) | 它在调用列表中插入一个新列表。 |
| [独特()](cpp-list-unique-function) | 它从列表中删除所有重复的元素。 |
| [调整大小()](cpp-list-resize-function) | 它改变列表容器的大小。 |
| [分配()](cpp-list-assign-function) | 它向列表容器分配一个新元素。 |
| [炮位()](cpp-list-emplace-function) | 它在指定位置插入新元素。 |
| [就位 _ 后退()](cpp-list-emplace_back-function) | 它在向量的末尾插入一个新元素。 |
| [炮位 _ 正面()](cpp-list-emplace_front-function) | 它在列表的开头插入一个新元素。 |