# C++ 队列

> 哎哎哎:# t0]https://www . javatppoint . com/CPP-queue

在计算机科学中，我们致力于开发各种各样的程序。每个都有自己的领域和用途。基于程序创建的目的和环境，我们有大量的数据结构可供选择。其中之一就是“排队”。在讨论这种数据类型之前，让我们先看看它的语法。

## 句法

```

template<class T, class Container = deque<T> > class queue;

```

这种数据结构基于先进先出技术，先进先出代表先进先出。第一次插入的元素将在第一次提取，以此类推。有一个名为“前”的元素，它是最前面的元素，也就是第一个位置，还有一个名为“后”的元素，它是最后一个位置的元素。在正常队列中，元素的插入在后端进行，删除是从前端完成的。

应用程序区域中的队列被隐含为容器适配器。

容器应该支持以下操作列表:

*   空的
*   大小
*   推回
*   流行前沿
*   前面
*   背部

## 模板参数

**T** :该参数指定容器适配器将要容纳的元素的类型。

**容器**:参数指定容器的内部对象，队列的元素保存在该对象中。

## 成员类型

下面给出了队列成员类型的列表以及对它们的简短描述。

| 成员类型 | 描述 |
| 值类型 | 指定了元素类型。 |
| 容器类型 | 指定了基础容器类型。 |
| 大小类型 | 它指定元素的大小范围。 |
| 参考 | 它是容器的引用类型。 |
| 常量 _ 引用 | 它是常量容器的引用类型。 |

## 功能

在函数的帮助下，对象或变量可以在编程领域中使用。队列提供了大量可以在程序中使用或嵌入的功能。下面列出了相同的内容:

| 功能 | 描述 |
| (构造函数) | 该函数用于构建队列容器。 |
| [空](cpp-queue-empty-function) | 该函数用于测试队列是否为空。如果队列为空，函数返回 true，否则返回 false。 |
| [尺寸](cpp-queue-size-function) | 函数返回队列容器的大小，这是存储在队列中的元素数量的度量。 |
| [前](cpp-queue-front-function) | 该函数用于访问队列的前端元素。元素起着非常重要的作用，因为所有的删除操作都是在前元素上执行的。 |
| [后退](cpp-queue-back-function) | 该函数用于访问队列的后面元素。该元件起着非常重要的作用，因为所有的插入操作都是在后部元件上进行的。 |
| [推](cpp-queue-push-function) | 该函数用于在队列的后端插入一个新元素。 |
| [流行](cpp-queue-pop-function) | 该函数用于删除元素；队列中的元素从前端删除。 |
| [就位](cpp-queue-emplace-function) | 该函数用于在当前尾部元素上方的队列中插入新元素。 |
| 交换 | 该函数用于交换两个参考容器中的内容。 |
| 关系运算符 | 非成员函数指定队列所需的关系运算符。 |
| 使用分配器 | 顾名思义，非成员函数使用队列分配器。 |

### 一个简单的程序来展示基本队列函数的使用。

```

#include <iostream>
#include <queue>
using namespace std;
void showsg(queue <int> sg)
{
	queue <int> ss = sg;
	while (!ss.empty())
	{
		cout << '\t' << ss.front();
		ss.pop();
	}
	cout << '\n';
}

int main()
{
	queue <int> fquiz;
	fquiz.push(10);
	fquiz.push(20);
	fquiz.push(30);

	cout << "The queue fquiz is : ";
	showsg(fquiz);

	cout << "\nfquiz.size() : " << fquiz.size();
	cout << "\nfquiz.front() : " << fquiz.front();
	cout << "\nfquiz.back() : " << fquiz.back();

	cout << "\nfquiz.pop() : ";
	fquiz.pop();
	showsg(fquiz);

	return 0;
}

```

**输出:**

```
The queue fquiz is : 	10	20	30

fquiz.size() : 3
fquiz.front() : 10
fquiz.back() : 30
fquiz.pop() : 	20	30

```