# C++ 算法函数

> 原文：<https://www.javatpoint.com/cpp-algorithm>

该库定义了大量的函数，这些函数特别适合一次用于大量的元素，或者说一个范围。现在让我们直接来看看这些函数。

## 非修改顺序操作:

| 功能 | 描述 |
| [所有 _ 的](cpp-algorithm-all_of-function) | 下面的函数测试范围内所有元素的条件。 |
| [任意 _ 个](cpp-algorithm-any_of-function) | 以下函数测试该范围的某些或任何元素的条件 |
| [无 _ 个](cpp-algorithm-none_of-function) | 以下函数检查是否没有任何元素符合条件。 |
| [对于 _ 每个](cpp-algorithm-for_each-function) | 该函数对该范围的所有元素应用一个操作。 |
| [找到](cpp-algorithm-find-function) | 该函数在该范围内找到一个值。 |
| [查找 _if](cpp-algorithm-find_if-function) | 该函数查找范围内的元素。 |
| [find_if_not](cpp-algorithm-find_if_not-function) | 该函数在该范围内找到一个元素，但方式与上面的相反。 |
| [find_end](cpp-algorithm-find_end-function) | 函数用于返回范围的最后一个元素。 |
| [查找第一个](cpp-algorithm-find_first_of-function) | 该函数查找满足条件并出现在第一个元素中的元素。 |
| [相邻 _ 查找](cpp-algorithm-adjacent_find-function) | 该函数搜索范围内相等和相邻的元素。 |
| [计数](cpp-algorithm-count-function) | 该函数返回该范围内某个值的计数。 |
| [计数 _if](cpp-algorithm-count_if-function) | 该函数返回满足条件的值的计数。 |
| [不匹配](cpp-algorithm-mismatch-function) | 该函数按顺序返回第一个不匹配的值。 |
| [相等](cpp-algorithm-equal-function) | 该函数用于检查两个范围的所有元素是否相等。 |
| [是 _ 排列](cpp-algorithm-is_permutation-function) | 该函数检查引用的范围是否是其他范围的置换。 |
| [搜索](cpp-algorithm-search-function) | 该函数在一个范围内搜索子序列。 |
| [搜索 _n](cpp-algorithm-search_n-function) | 该函数在范围内搜索元素的出现。 |

## 修改序列操作

| 功能 | 描述 |
| [复制](cpp-algorithm-copy-function) | 该函数复制元素的范围。 |
| [copy_n](cpp-algorithm-copy_n-function) | 该函数复制该范围的 n 个元素 |
| [复制 _if](cpp-algorithm-copy_if-function) | 如果满足某个条件，该函数将复制该范围的元素。 |
| [复制 _ 向后](cpp-algorithm-copy_backward-function) | 该函数以向后的顺序复制元素 |
| [移动](cpp-algorithm-move-function) | 该函数移动元素的范围。 |
| [向后移动](cpp-algorithm-move_backward-function) | 该函数以向后的顺序移动元素的范围 |
| [互换](cpp-algorithm-swap-function) | 该函数交换两个对象的值。 |
| [交换范围](cpp-algorithm-swap_ranges-function) | 该函数交换两个范围的值。 |
| [iter_swap](cpp-algorithm-iter_swap-function) | 该函数交换被引用的两个迭代器的值。 |
| [变换](cpp-algorithm-transform-function) | 该函数转换一个范围内的所有值。 |
| [更换](cpp-algorithm-replace-function) | 该函数将范围内的值替换为特定值。 |
| [更换 _if](cpp-algorithm-replace_if-function) | 如果满足某个条件，该函数将替换该范围的值。 |
| [替换 _ 复制](cpp-algorithm-replace_copy-function) | 该函数通过用元素替换来复制值的范围。 |
| [替换 _ 复制 _if](cpp-algorithm-replace_copy_if-function) | 如果满足某个条件，该函数通过用元素替换来复制值的范围。 |
| [填充](cpp-algorithm-fill-function) | 该函数用一个值填充该范围内的值。 |
| [填充 _n](cpp-algorithm-fill_n-function) | 该函数填充序列中的值。 |
| [生成](cpp-algorithm-generate-function) | 该函数用于生成该范围的值。 |
| [生成 _n](cpp-algorithm-generate_n-function) | 该函数用于生成序列的值。 |
| [移除](cpp-algorithm-remove-function) | 该函数从范围中移除值。 |
| [移除 _if](cpp-algorithm-remove_if-function) | 如果满足某个条件，该函数将移除该范围的值。 |
| [删除 _ 复制](cpp-algorithm-remove_copy-function) | 该函数通过移除范围的值来复制它们。 |
| [移除 _ 复制 _ 如果](cpp-algorithm-remove_copy_if-function) | 如果满足某个条件，该函数将通过删除来复制该范围的值。 |
| [独特](cpp-algorithm-unique-function) | 该函数标识该范围的唯一元素。 |
| [唯一 _ 副本](cpp-algorithm-unique_copy-function) | 该函数复制该范围的唯一元素。 |
| [倒车](cpp-algorithm-reverse-function) | 该函数反转范围。 |
| [反向 _ 复制](cpp-algorithm-reverse_copy-function) | 该函数通过反转数值来复制范围。 |
| [旋转](cpp-algorithm-rotate-function) | 该函数向左旋转范围的元素。 |
| [旋转 _ 复制](cpp-algorithm-rotate_copy-function) | 该函数复制向左旋转的区域的元素。 |
| [随机 _ 洗牌](cpp-algorithm-random_shuffle-function) | 该函数随机打乱范围。 |
| [洗牌](cpp-algorithm-shuffle-function) | 该函数在生成器的帮助下随机调整范围。 |

## 划分

| 功能 | 描述 |
| [被 _ 分割](cpp-algorithm-is_partitioned-function) | 该函数用于推断范围是否被划分。 |
| [分区](cpp-algorithm-partition-function) | 该函数用于划分范围。 |
| [稳定 _ 分区](cpp-algorithm-stable_partition-function) | 该函数将范围分成两个稳定的部分。 |
| [分区 _ 副本](cpp-algorithm-partition_copy-function) | 该函数复制分区后的范围。 |
| [分区 _ 点](cpp-algorithm-partition_point-function) | 该函数返回一个范围的分区点。 |

## 整理

| 功能 | 描述 |
| [排序](cpp-algorithm-sort-function) | 该函数对一个范围内的所有元素进行排序。 |
| [稳定 _ 排序](cpp-algorithm-stable_sort-function) | 该函数对范围内的元素进行排序，保持相对相等的顺序。 |
| [部分 _ 排序](cpp-algorithm-partial_sort-function) | 该函数对该范围的元素进行部分排序。 |
| [partial_sort_copy](cpp-algorithm-partial_sort_copy-function) | 该函数在对区域进行排序后复制该区域的元素。 |
| [被 _ 排序](cpp-algorithm-is_sorted-function) | 该函数检查该范围是否已排序。 |
| [被 _ 排序 _ 直到](cpp-algorithm-is_sorted_until-function) | 该函数会检查范围中的哪个元素被排序。 |
| [第 n _ 元素](cpp-algorithm-nth_element-function) | 函数对范围内的元素进行排序。 |

## 二进位检索

| 功能 | 描述 |
| [下限](cpp-algorithm-lower_bound-function) | 返回范围的下限元素。 |
| [上限](cpp-algorithm-upper_bound-function) | 返回范围的上限元素。 |
| [等范围](cpp-algorithm-equal_range-function) | 该函数返回相等元素的子范围。 |
| [二进制 _ 搜索](cpp-algorithm-binary_search-function) | 该函数测试范围内的值是否存在于排序的序列中。 |

## 合并

| 功能 | 描述 |
| [合并](cpp-algorithm-merge-function) | 该函数合并了两个按排序顺序排列的区域。 |
| [inplace_merge](cpp-algorithm-inplace_merge-function) | 该函数合并两个连续的排序区域。 |
| [包括](cpp-algorithm-includes-function) | 该函数搜索排序后的范围是否包括另一个范围。 |
| [set_union](cpp-algorithm-set_union-function) | 该函数返回已排序的两个范围的并集。 |
| 集合交集 | 该函数返回已排序的两个范围的交集。 |
| 设置差异 | 该函数返回两个排序范围的差。 |
| set _ 对称 _ 差异 | 该函数返回两个排序范围的对称差。 |

## 许多

| 功能 | 描述 |
| 推送堆 | 该函数在堆中推送新元素。 |
| 弹出堆 | 该函数在堆中弹出新元素。 |
| make _ 堆 | 该函数用于创建堆。 |
| 排序堆 | 该函数对堆进行排序。 |
| is_heap | 该函数检查该范围是否为堆。 |
| is _ heap _ 直到 | 该函数检查范围的哪个位置是堆。 |

## 最小/最大

| 功能 | 描述 |
| 部 | 返回范围的最小元素。 |
| 最大 | 返回范围的最大元素。 |
| 上下限 | 返回范围中最小和最大的元素。 |
| 最小元素 | 返回范围的最小元素。 |
| 最大元素 | 返回范围的最大元素。 |
| 最小最大元素 | 返回范围中最小和最大的元素。 |

## 其他功能

| 功能 | 描述 |
| 词典学 _comapre | 该函数执行字典式小于比较。 |
| 下一个置换 | 该函数用于将范围转换为下一个置换。 |
| perv _ 置换 | 该函数用于将范围转换为先前的排列。 |