# C++ 输入迭代器

> 原文：<https://www.javatpoint.com/cpp-input-iterator>

*   输入迭代器是用于从容器中读取值的迭代器。
*   取消对输入迭代器的引用允许我们从容器中检索值。
*   它不会改变容器的值。
*   它是一个单向迭代器。
*   它可以增加，但不能减少。
*   可用于输入迭代器的运算符是递增运算符(++)、递减运算符(-)、取消引用运算符(*)，而不是相等运算符(！=)和等号运算符(==)。
*   输入迭代器由**迭代**产生。
*   前向迭代器、双向迭代器和随机访问迭代器都是有效的输入迭代器。

| 财产 | 有效表达式 |
| 输入迭代器是可复制构造、可复制赋值和可析构的。 | x b(a)；
b = a； |
| 可以通过使用等式或不等式运算符进行比较。 | a = = b；
一个！= b； |
| 可以取消引用。 | * a； |
| 它可以递增。 | ++ a； |

其中“X”是输入迭代器类型，“a”和“b”是迭代器类型的对象。

## 输入迭代器的特点:

*   **等式/不等式运算符**:输入迭代器可以使用等式或不等式运算符进行比较。只有当两个迭代器都指向同一个位置时，这两个迭代器才相等，否则不相等。假设‘A’和‘B’是两个迭代器:

```

A ==B;   // equality operator
A!=B;   // inequality operator

```

**我们来看一个简单的例子:**

```

#include <iostream>
#include<vector>
#include<iterator>
using namespace std;
int main()
{
    vector<int> v{1,2,3,4,5};
    vector<int>::iterator itr,itr1;
    itr=v.begin();
    itr1=v.begin()+1;
    if(itr==itr1)
    std::cout << "Both the iterators are equal" << std::endl;
    if(itr!=itr1)
    std::cout << "Both the iterators are not equal" << std::endl;
    return 0;
}

```

**输出:**

```
Both the iterators are not equal

```

在上面的例子中，itr 和 itr1 是两个迭代器。这两个迭代器都是向量类型的。“itr”是指向向量第一个位置的迭代器对象，“itr1”是指向向量第二个位置的迭代器对象。因此，两个迭代器都指向同一个位置，所以条件 itr1！=itr 返回真值并打印“**两个迭代器不相等**”。

*   **取消对迭代器的引用**:我们可以通过使用取消引用操作符(*)来取消对迭代器的引用。假设“A”是一个迭代器:

```

*A     //  Dereferencing 'A' iterator by using *.

```

**我们来看一个简单的例子:**

```

             #include <iostream>
          #include<vector>
         #include<iterator>
         using namespace std;
        int main()
      {
           vector<int> v{11,22,33,44};
           vector<int>::iterator it;
           it = v.begin();
         cout<<*it;
          return 0;
}

```

**输出:**

```
11

```

在上面的例子中，“它”是一个迭代器对象，指向向量“v”的第一个元素。取消迭代器的引用*它返回迭代器“it”所指向的值。

*   **可交换**:指向两个不同位置的两个迭代器可以交换。

**我们来看一个简单的例子:**

```

#include <iostream>
#include<vector>
#include<iterator>
using namespace std;
int main()
{
    vector<int> v{11,22,33,44};
    vector<int>::iterator it,it1,temp;
    it = v.begin();
    it1 = v.begin()+1;
    temp=it;
    it=it1;
    it1=temp;
    cout<<*it<<" ";
    cout<<*it1;
    return 0;
}

```

**输出:**

```
22 11

```

在上面的例子中，“it”和“it1”迭代器通过使用第三个迭代器的对象进行交换，即 **temp** 。