# C++ 中的阿姆斯特朗数

> 原文：<https://www.javatpoint.com/armstrong-number-in-cpp>

在准备写 C++ 程序检查数字是不是阿姆斯特朗之前，我们先来了解一下什么是阿姆斯特朗数字。

**阿姆斯特朗数**是一个等于其位数的立方之和的数。例如，0、1、153、370、371 和 407 是阿姆斯特朗数。

让我们试着理解为什么 **371** 是一个阿姆斯特朗数。

```
371 = (3*3*3)+(7*7*7)+(1*1*1)  
where:  
(3*3*3)=27  
(7*7*7)=343  
(1*1*1)=1  
So:  
27+343+1=371  

```

让我们看看检查阿姆斯特朗号的 C++ 程序。

```
#include <iostream>
using namespace std;
int main()
{
int n,r,sum=0,temp;  
cout<<"Enter the Number=  ";  
cin>>n;  
temp=n;  
while(n>0)  
{  
r=n%10;  
sum=sum+(r*r*r);  
n=n/10;  
}  
if(temp==sum)  
cout<<"Armstrong Number."<<endl;  
else  
cout<<"Not Armstrong Number."<<endl; 
return 0;
}

```

输出:

```
Enter the Number= 371
Armstrong Number.

```

```
Enter the Number= 342   
Not Armstrong Number.	

```