# 寻找四个数中最大值的 C++ 程序

> 原文：<https://www.javatpoint.com/cpp-program-to-find-greatest-of-four-numbers>

在本教程中，我们将编写一个 C++ 程序来查找四个数字中最大的一个。

**例如**

a = 10，b = 50，c = 20，d = 25

最大的数字是 b 50

a = 35，b = 50，c = 99，d = 2

最大的数字是 c 99

**接近 1**

该方法是在四个数字中寻找最大值的传统方法。if 条件检查 a 是否大于 b，然后使用 if-else 检查 b，另一个 if-else 检查 c，最后一个 else 将 d 打印为最大值。

**算法**

*   开始
*   输入四个数字
*   如果 A > B 那么
    如果 A > C 那么
    如果 A > D 那么
    A 最大
    否则
    D 最大
*   否则如果 B > C 那么
    如果 B > D 那么
    B 是最伟大的
    否则
    D 是最伟大的
*   否则，如果 C > D，那么
    C 是最大的
*   否则
    D 是最伟大的

**C++ 代码**

```

#include using namespace std;
void find_greatest(int a, int b, int c, int d)
{
    if (a > b) {
        if (a > c) {
            if (a > d) {
                cout << "a is greatest";
            }
            else {
                cout << "d is greatest";
            }
        }
    }
    else if (b > c) {
        if (b > d) {
            cout << "b is greatest";
        }
        else {
            cout << "d is greatest";
        }
    }
    else if (c > d) {
        cout << "c is greatest";
    }
    else {
        cout << "d is greatest";
    }
}

int main()
{
    int a = 10, b = 50, c = 20, d = 25;
    cout << "a=" << a << " b=" << b << " c=" << c << " d=" << d;
    cout << "\n";
    find_greatest(a, b, c, d);
    a = 35, b = 50, c = 99, d = 2;
    cout << "\n";
    cout << "a=" << a << " b=" << b << " c=" << c << " d=" << d;
    cout << "\n";
    find_greatest(a, b, c, d);

    return 0;
} 
```

**输出**

```
a=10 b=50 c=20 d=25
b is greatest
a=35 b=50 c=99 d=2
c is greatest

```

**接近 2**

这种方法使用内置的 max 函数。

以下是 max 函数的语法

**模板常量表达式常量 T & max(常量 T & a，常量 T&b)；**

这里，a 和 b 是要比较的数字。

**返回:**两个值中较大的一个。

**例如**

**std :: max(2，5)** 将返回 5

因此，要找出 4 个数字的最大值，我们可以使用 max 函数的链式，如下所示-

**int x = max(a，max(b，max(c，d)))；**

**C++ 代码**

```

#include using namespace std;
void find_greatest(int a, int b, int c, int d)
{
    int x = max(a, max(b, max(c, d)));
    if (x == a)
        cout << "a is greatest";
    if (x == b)
        cout << "b is greatest";
    if (x == c)
        cout << "c is greatest";
    if (x == d)
        cout << "d is greatest";
}

int main()
{
    int a = 10, b = 50, c = 20, d = 25;
    cout << "a=" << a << " b=" << b << " c=" << c << " d=" << d;
    cout << "\n";
    find_greatest(a, b, c, d);
    a = 35, b = 50, c = 99, d = 2;
    cout << "\n";
    cout << "a=" << a << " b=" << b << " c=" << c << " d=" << d;
    cout << "\n";
    find_greatest(a, b, c, d);

    return 0;
} 
```

**输出**

```
a=10 b=50 c=20 d=25
b is greatest
a=35 b=50 c=99 d=2
c is greatest

```

* * *