# C++ 中的快速输入输出

> 原文：<https://www.javatpoint.com/fast-input-and-output-in-cpp>

在竞争性编程中，快速执行、输入和输出非常重要。有时我们只需要在数组中输入五个数字，另一次可以有一万个。这些是快速输入/输出进入画面的情况。

![Fast input and output in C++](img/65ad8b2924a597b1b4016143abb4024b.png)

现在让我们讨论一些有益于避免 TLE 的有用技巧-

*   对于取值作为输入，C++ 中的通用格式是-
    **STD::CIN>>x；// x 要输入的值**
    CIN 适用于一系列输入，但使用起来很方便-
    **scanf('%d '，&x)；// x 是要输入的值**
    同样，在控制台上进行打印，我们使用-
    **Std::cout<<x；// x 是要打印的值**
    cout 也适用于有限的数字。最佳做法是使用-
    **printf("%d "，x)；// x 是要打印的值**
*   以获得与 CIN/库特相同的扫描/打印速度。在主函数中添加下面的行-
    **IOs _ base::sync _ with _ stdio(false)-**当在程序中的 cin/cout 之前调用时，它切换所有 C++ 与其各自的 C 流的所有同步。我们将此函数设为 false(之前为真)，以避免任何同步。
    T4】CIN。tie(空)- 该功能有助于在进行任何输入之前清除所有标准::cout。在控制台定期更新的交互式控制台程序中，这是有益的，但是对于较大的值，也会减慢程序的速度。空指返回空指针。
*   包括一个包含所有其他库的头文件。它是 GNU C++ 库的标准头文件。包含下面的头文件可以节省为数据结构添加特定库的时间和精力。例如，为了声明一个地图，我们需要一个<map>头文件。这种额外的努力减少了，也节省了时间。
    **#包含**
    这是一个常见的 C++ 程序模板在应用提示时的样子:</map>

```

#include // GNU header 
using namespace std;
int main()
{
ios_base::sync_with_stdio(false);
cin.tie(NULL); // flushes cout
    return 0;
} 
```

*   建议使用“\n”来代替 endl 进入新行。
    **“\ n”-**进入新线
    **endl -** 进入新线并冲流
    因此，
    **cout<T11】endl = cout<<“\ n”<<冲流**

**“n”和 endl 的区别**

| 恩德尔 | \n |
| 操作者 | 性格；角色；字母 |
| 不占用内存 | 占用 1 字节的内存 |
| endl 是一个关键字。所以当存储在字符串中时，它不会给出意义 | \n 可以存储在字符串中 |
| 仅 C++ 支持 | 两者都支持 |

* * *