# C++ 中的复制省略

> 原文：<https://www.javatpoint.com/copy-elision-in-cpp>

复制省略被定义为一种优化技术，用于避免不必要的对象复制。一般来说，所有的编译器都使用复制省略技术。优化技术不适用于绑定到引用的临时对象。

它也被称为复制省略。

让我们借助一个例子来理解抄写省略的必要性。

**代码**

```

#include using namespace std;
class A
{
public:	
	A(const char* str = "\0") //default constructor
	{
		cout << " Default Constructor called" << endl;
	}	

	A(const A &a) //copy constructor
	{
		cout << "Copy constructor called" << endl;
	}
};

int main()
{
	A a1 = "copy me"; // Create object of class A
	return 0;
} 
```

**输出**

```
Default Constructor called

```

### 观察

程序输出*默认构造函数*。发生这种情况是因为当我们创建对象 a1 时，一个参数构造函数被转换为将我复制到一个 temp 对象，而该 temp 对象被复制到对象 a1。

这就是陈述-

**A a1 =“复制我”**

转换为

**A a1(“复制我”)**

### 如何避免不必要的开销？

许多编译器都避免了这种开销问题。

现代编译器打破了拷贝初始化的说法

**A a1 =“复制我”**

去，

直接初始化的声明。

**A a1(“复制我”)**

进而调用复制构造函数。

* * *