# Perl 教程

> 原文：<https://www.javatpoint.com/perl-tutorial>

![Perl Programming Tutorial](img/c1aaba859c7c92a091c2d18b174e9cd2.png)

Perl 教程提供了 Perl 的基本和高级概念。我们的 Perl 编程教程是为初学者和专业人士设计的。

Perl 是运行 JavaScript 应用程序的跨平台环境和库，用于创建网络和服务器端应用程序。

我们的 Perl 教程包括 Perl 的所有主题，例如安装、示例、运算符、运算符类型、控制语句、循环、注释、数组、字符串、转义字符、命名空间、哈希、正则表达式、函数和子程序、文件处理、错误处理。等等

* * *

## Perl 索引

* * *

**Perl 教程**

*   [Perl 教程](perl-tutorial)
*   [Perl 简介](perl-introduction)
*   [Perl 安装](perl-installation)
*   [Perl 第一个例子](perl-first-example)
*   [Perl print() & say()](perl-print-and-say)
*   [Perl STDIN](perl-stdin)
*   perl 版本
*   [Perl 数据类型](perl-data-types)
*   [Perl 变量](perl-variables)
*   [Perl 标量](perl-scalars)
*   [Perl 操作符](perl-operators)
*   [Perl 运算符类型](perl-operator-types)

**Perl 控制声明**

*   [Perl if-else](perl-if-else)
*   [Perl 开关](perl-switch)

*   [Perl goto](perl-goto-statement)
*   [Perl 注释](perl-comments)
*   [Perl 最后声明](perl-last-statement)
*   [Perl 下一个语句](perl-next-statement)
*   [Perl 重做语句](perl-redo-statement)
*   [循环的 Perl】](perl-for-loop)
*   [Perl while 循环](perl-while-loop)
*   [Perl 边做边循环](perl-do-while-loop)

**Perl 数组**

*   [Perl 数组](perl-array)
*   [带循环的 Perl 数组](perl-array-with-loops)
*   [多维数组](perl-multidimensional-array)

**Perl 字符串**

*   perl 字符串
*   [Perl 转义字符](perl-string-escaping-characters)

**Perl 命名空间**

*   [模块&名称空间](perl-modules-and-namespaces)

**Perl 哈希**

*   [Perl 哈希](perl-hashes)

**Perl Regex**

*   [Perl 正则表达式](perl-regular-expression)
*   [Perl split()和 join()](perl-split-function)

**Perl 函数**

*   [功能&子程序](perl-functions-and-subroutines)

**Perl 文件处理**

*   [Perl 文件处理](perl-file-handling)
*   [Perl chop() vs chomp()](perl-chop-vs-chomp)

**Perl 目录**

*   [Perl 目录](perl-directories)

**Perl 错误处理**

*   [Perl 错误处理](perl-error-handling)

**Perl 高级**

*   [Perl DBI(数据库)](perl-dbi)
*   [面向 Perl 对象](perl-object-oriented)
*   [Perl 日期时间](perl-date-time)
*   [Perl 套接字编程](perl-socket-programming)
*   [Perl 命令参数](perl-command-line-arguments)
*   [Perl 创建 Excel](perl-create-excel-file)

**Perl 面试**

*   [Perl 面试问题](perl-interview-questions)

* * *

## 先决条件

在学习 Perl 之前，您必须具备 JavaScript 和任何编程语言的基本知识。

## 观众

我们的 Perl 教程旨在帮助初学者和专业人士。

## 问题

我们保证您在这个 Perl 编程教程中不会发现任何问题。但是如果有任何错误，请在联系表格中发布问题。