# Perl print()和 say()

> 原文：<https://www.javatpoint.com/perl-print-and-say>

Perl print()函数是 Perl 用户最常用的函数之一。它将打印一个字符串、一个数字、一个变量或它得到的任何东西作为参数。

Perl 打印语法如下:

```
print "";

```

## Perl 打印示例

让我们看一个简单的 Perl Print()函数的例子。

```
#!/usr/bin/perl
print "Welcome to JavaTpoint!!";
print "This is our Perl tutorial!!";

```

输出:

```
Welcome to JavaTpoint!! This is our Perl tutorial!!

```

上面的输出打印了同一行中的两个句子。要以不同的行打印它们，我们可以在打印功能中使用“\n”新行字符。

## 带“\n”的 Perl 打印示例

“\n”字符用于打印新行。它用在打印功能的末尾。

```
#!/usr/bin/perl
print "Welcome to JavaTpoint!!\n";
print "This is our Perl tutorial!!\n";

```

输出:

```
Welcome to JavaTpoint!! 
This is our Perl tutorial!!

```

## 带变量的 Perl 打印示例

要打印变量值，需要在打印函数中传递变量。

```
#!/usr/bin/perl
$site = 'JavaTpoint';
print "Welcome to $site!!\n";
print "$site provides you all type of tutorials!!\n";

```

输出:

```
Welcome to JavaTpoint!!
JavaTpoint provides you all type of tutorials!!

```

这里，我们定义了一个变量$site。我们已经在字符串中传递了这个变量，该字符串在输出中输出它的值。

## 带单引号和双引号的 Perl 打印示例

Perl 打印函数不在单引号内插入内容。这意味着它按原样打印单引号内的字符。它既不计算变量？它也不解释转义字符。

当上面的例子在单引号中运行时，您会注意到以下变化。

```
#!/usr/bin/perl
$site = 'JavaTpoint';
print 'Welcome to $site!!\n';
print '$site provides you all type of tutorials!!\n';

```

输出:

```
Welcome to $site!! \n$site provides you all type of tutorials!!\n

```

在输出中，变量$site 按原样打印。不会评估其值。新的行字符也不会被解释。

## Perl say()

旧的 perl 版本不支持 say()函数。它的作用类似于 print()函数，唯一的区别是它会在末尾自动添加一个新行，而不会提到(\n)。

#### 注意:要使用 say()函数，您需要在脚本中提到版本。不用版本，你呢？我将在输出中得到错误。

Perl say()语法如下:

```
say "";

```

### Perl say()示例

让我们看一个简单的 perl say 函数的例子。

```
#!/usr/bin/perl
use 5.010;
say "Welcome to JavaTpoint!!";
say "This is our Perl tutorial!!";

```

输出:

```
Welcome to JavaTpoint!! This is our Perl tutorial!!	

```

上面的输出打印了不同行中的两个句子，而没有使用新的行字符。这里我们使用了 5.010 来支持 say 函数。