# Perl STDIN

> 原文： [https://www.javatpoint.com/perl-stdin](https://www.javatpoint.com/perl-stdin)

在 Perl 编程中，我们可以使用<stdin>从标准控制台获取输入。它代表标准输入。可以用<>缩写。所以，</stdin>

```
my $name = ; 
```

相当于:

```
my $name = <>;

```

## 用户使用<stdin>的 Perl 输入</stdin>

让我们看一个使用标准输入<stdin>从用户那里获取数据的例子。</stdin>

键入:

```
use 5.010;
use strict;
use warnings;
say "Enter your Name:";
my $name = ;
say "Welcome $name at JavaTpoint."; 
```

这里，$name 是一个标量变量。变量使用 **my** 关键字声明。运行此脚本后，它会询问您的姓名。在控制台中键入您的姓名，然后按回车键。

输出:

```
Enter your Name:
John
Welcome John
  at JavaTpoint.

```

正如您在上面的输出中看到的，在打印名称后会添加一个新行。为了克服这个问题，添加如下所示的带有$name 的 **chomp** 函数。

```
use 5.010;
use strict;
use warnings;
say "Enter your Name:";
my $name = ;
chomp $name;
print "Welcome $name at JavaTpoint.\n"; 
```

输出:

```
Enter your Name:
John
Welcome John at JavaTpoint.

```