# Perl 数据类型

> 原文：<https://www.javatpoint.com/perl-data-types>

Perl 语言是一种松散类型的语言，Perl 解释器自己选择数据类型。因此，在 Perl 编程中不需要指定数据类型。

Perl 中基本上有三种数据类型:

*   **标量** : Perl 标量是单个数据项。它们是简单的变量，前面有一个($)符号。标量可以是数字、引用(变量的地址)或字符串。
*   **数组** : Perl 数组是标量的有序列表。它们前面有(@)符号，并通过以 0 开头的索引号进行访问。
*   **哈希** : Perl 哈希是键值对的无序集合。它们前面有一个(%)符号，使用键访问。

* * *

## Perl 文字

在 Perl 中，有两种不同类型的标量常数:

1.  数值文字
2.  字符串文字

* * *

## Perl 数字文字

Perl 数字文字是数字。Perl 在内部将数字存储为有符号整数或浮点值。

**可以为 Perl 数值文字分配以下类型的格式:**

| 数字 | 类型 |
| Five hundred and twenty-six | 整数 |
| Five point five | 浮点 |
| 5e10 | 科学符号 |
| 5.5E | 科学符号 |
| 5_549_63 | 大量 |
| 010101 | 二进制数 |
| 0175 | 八进制数 |
| AF0230 | 十六进制数 |

看上面的表格，

*   整数是一组连续的数字。
*   浮点数中间包含一个小数。数字(234.00)右侧包含“0”值的数字也是浮点数。
*   包含指数符号(E 或 E)的数字是科学符号。
*   数字文本中不允许使用逗号，但可以使用下划线(_)代替逗号。Perl 将在使用该值时删除下划线。
*   0 和 1 的组合代表基数为 2 的二进制数。
*   带前导 0 的数字属于八进制数，基数为 8。
*   包含字母(a，b，c，d，e，f)的数字是以 16 为基数的十六进制数。

* * *

## Perl 字符串文字

Perl 字符串文字包含空字符串、ASCII 文本、高位 ASCII 或二进制数据。字符串中包含数据没有限制。它们被单引号(′)或双引号(″)包围。

双引号字符串中允许变量插值，但单引号字符串中不允许。此外，只有双引号字符串支持以反斜杠(\)开头的特殊字符。

**字符串中的转义字符**

| 特性 | 目的 |
| \n | 降级换行符 |
| \r | 降级回车 |
| \ t | 降级水平选项卡 |
| \v | 降级垂直选项卡 |
| \Q | 所有非字母数字字符后反斜杠 |
| \a | 降级警报 |
| \f | 降级表单源 |
| \b | 降级退格 |
| \u | 将下一个字符改为大写 |
| \U | 将以下所有字符更改为大写 |
| \l | 将下一个字符改为小写 |
| \L | 将以下所有字符更改为小写 |
| \E | 表示\U，\L，\Q |
| \cX | 控制字符，X 是一个变量 |
| \ 0nn | 创建八进制格式的数字 |
| \xnn | 创建十六进制格式的数字 |
| \\ | 降级反斜杠 |
| \' | 降级单引号 |
| \" | 降级双引号 |