# Perl 变量

> 原文：<https://www.javatpoint.com/perl-variables>

变量是存储值的地方。它们可以在整个程序中被操纵。创建变量时，它们会保留一些内存空间。

有三种类型的变量:

*   由$
*   由@定义的数组
*   由%定义的哈希

同一变量可以用于程序中的所有这三种类型的变量。例如，$name、@name 和%name，这三个变量在一个程序中将被认为是不同的。

* * *

## Perl 变量声明

等号(=)用于给变量赋值。(=)的左边是变量名，右边是变量值。

```
$name = "Anastasia"; 
$rank = "9th";
$marks = 756.5;

```

这里我们已经创建了三个变量$name、$rank 和$marks。

* * *

## Perl 使用严格的

如果你在程序中使用**使用严格的**语句，那么你必须在使用它之前声明你的变量。这是强制性的。否则你会得到一个错误。

$a 和$b 是 perl 排序函数中使用的特殊变量。没有必要声明这两个变量。所以建议除了联系**排序外，不要使用这两个变量。**

变量可以使用 **my，our，use vars，state 和$person::name** (显式包名)来声明。虽然，它们都有不同的含义。

```
use 5.010;
use strict;
my $x = 23;
say $x;
state $name = "Anastasia"; 
say $name;
our $rank = "9th";
say $rank;
use vars qw($marks);
$marks = 756.5;
say $marks;
$Person::name = 'John';
say $Person::name;
$a = 1224365;
say $a;
 $b = "Welcome at JavaTpoint";
say $b;  

```

输出:

```
23
Anastasia
9th
756.5
John
1224365
Welcome at JavaTpoint

```

看上面的输出，最后两个变量是$a 和$b，所以我们没有定义它们。然而他们的输出被显示出来。