# Perl 运算符

> 原文：<https://www.javatpoint.com/perl-operators>

perl 运算符是一系列用作语法的符号。运算符是一种函数，其操作数是参数。

* * *

## Perl 运算符优先级

Perl 优先就像数学中的 BODMAS。加法和减法总是在乘法和除法之后。

例如，

```
8 + 4 - 5 * 6 / 3 = 2

```

在这里，答案将是 2 与 BODMAS 规则。首先计算(6 / 3 = 2)，然后将商 2 乘以 5，接着是减法和加法。

**示例:**

```
use 5.010;
use strict;
use warnings;
my $result1 = 8 + 4 - 5 * 6 / 3 ;
say $result1;
my $result2 = 12 * 3 + 2 ** 2 << 1;
say $result2;

```

输出:

```
2
80

```

* * *

## Perl 运算符优先级表

| 经营者 | 描述 |
| ++, - | 自动递增，自动递减 |
| -, ~, ! | 有一个操作数的运算符 |
| ** | 幂运算 |
| =~, !~ | 模式匹配运算符 |
| *，/，%，x | 乘法、除数、余数、重复 |
| +, -, . | 加法、减法、连接 |
| <> | 移位运算符 |
| -e-r | 文件状态运算符 |
| ，> =，lt，le，gt，ge | 不等式比较运算符 |
| ==、！=<=>、eq、nq、cmp | 相等比较运算符 |
| & | 按位“与” |
| &#124;, ^ | 按位“或”与“异或” |
| && | 逻辑“与” |
| &#124;&#124; | 逻辑或 |
| 。。 | 列出范围运算符 |
| ？以及: | 条件运算符 |
| =, +=, -=, *= | 赋值运算符 |
| , | 逗点算符 |
| 不 | 低优先级逻辑非 |
| 和 | 低优先级逻辑“与” |
| 或，异或 | 低优先级逻辑或和异或 |

* * *

## Perl 运算符关联性

运算符的关联性有助于您决定是从(从左到右)还是(从右到左)计算公式。

操作顺序很重要。有时双方都一样，但有时会产生巨大的差异。

例如，

```
7 + 4 + 2 = 13

```

无论从左到右，这个问题的答案都是一样的。

3′2′3

这个问题的答案将是(9∫∫3)从左到右(3∫∫8)。这两个答案有很大的不同。

**示例:**

```
use 5.010;
use strict;
use warnings;
my $result = 3 ** 2 ** 3;
say $result;

```

输出:

```
6561

```

* * *

## Perl 关联表

| 经营者 | 描述 |
| ++, - | 方向顺序在这里不适用 |
| -, ~, ! | 从右向左 |
| ** | 从右向左 |
| =~, !~ | 从左到右 |
| *，/，%，x | 从左到右 |
| +, -, . | 从左到右 |
| <> | 从左到右 |
| -e-r | 方向顺序在这里不适用 |
| ，> =，lt，le，gt，ge | 从左到右 |
| ==、！=<=>、eq、ne、cmp | 从左到右 |
| & | 从左到右 |
| &#124;, ^ | 从左到右 |
| && | 从左到右 |
| &#124;&#124; | 从左到右 |
| .. | 从左到右 |
| ？以及: | 从右向左 |
| =, +=, -=, *= | 从右向左 |
| , | 从左到右 |
| 不 | 从左到右 |
| 和 | 从左到右 |
| 或，异或 | 从左到右 |

* * *

## Perl Arity

运算符的 arity 可以定义为它所操作的操作数的数量。

一个**空值**运算符对零操作数进行运算，一个**一元**运算符对一个操作数进行运算，一个**二进制**运算符对两个操作数进行运算，一个**列表**运算符对操作数列表进行运算。

例如，

```
3 + 3 ? 2

```

算术运算符通常是左关联的。这里，(3 + 3)首先求值，然后转到第二个(-)运算符。

**示例:**

```
use 5.010;
use strict;
use warnings;
my $result = ( 5 - 2 + 10 ) * 2;
say $result;

```

输出:

```
26

```

* * *

## Perl 固定性

运算符固定性可以定义为其相对于操作数的位置。

例如，

*   Infix operator appears between its operands..

    3 + 2

    这里，+运算符出现在操作数 3 和 2 之间

*   Prefix operator appears before its operands.

    ！$a，- 3x

    这里！and -运算符出现在操作数$a 和$ 3 之前。

*   Postfix operator appears after its operands,.

    $x ++

    这里，++ 运算符出现在操作数$x 之后。

*   Circumfix operators surround its operands. Such as hash constructor and quoting operators..

    (qq[...])

*   Postcircumfix operators follow certain operands and surround some operands.

    $hash{$a}