# Perl if-else 语句

> 原文：<https://www.javatpoint.com/perl-if-else>

Perl 语言中的 if 语句用于根据条件执行操作。通过使用 if-else 语句，可以执行条件为真或假的操作。Perl 支持各种类型的 if 语句:

*   如果
*   如果-否则
*   否则如果

* * *

## Perl If 示例

如果条件为真，则使用 Perl 单 if 语句来执行代码。if 语句的语法如下:

```

if(expression){  
//code to be executed  
}

```

#### Perl 中 if 语句的流程图

![if statement in perl](img/9a2591b2da9698b5020c0f5017fa0434.png)

让我们看一个简单的 Perl 语言 if 语句的例子。

```

$a = 10;
if( $a %2==0 ){
    printf "Even Number\n";
}
}

```

输出:

```
Even Number

```

这里，输出是偶数，因为我们给出的输入是 10。

* * *

## Perl If-else 示例

Perl if-else 语句用于在条件为真或假时执行代码。if-else 语句的语法如下:

```

if(expression){
//code to be executed if condition is true
}else{
//code to be executed if condition is false
}

```

#### Perl 中 if-else 语句的流程图

![if-else statement in Perl](img/106e39a57c3c6be39b89207f0adc6090.png)

让我们来看一个简单的例子，在 Perl 语言中使用 if-else 语句的偶数和奇数。

```

$a = 10;
if( $a %2==0 ){
    printf "Even Number\n";
}else{ 
    printf "Odd Number\n";
}

```

输出:

```
Even Number

```

这里，输入是偶数，因此输出是偶数。

* * *

## 用户输入的 Perl If-else 示例

在本例中，我们将使用标准输入( <stdin>/ <>)从用户处获取输入。</stdin>

```

print "Enter a Number?\n";
$num = <>;
if( $num %2==0 ){
    printf "Even Number\n";
}else{ 
    printf "Odd Number\n";
}

```

输出:

```
Enter a Number?
5
Odd Number

```

```
Enter a Number?
4
Even Number

```

在第一个输出中，用户输入了奇数 5。因此输出是奇数。

在第二个输出中，用户输入了偶数 4。因此输出是均匀的。

* * *

## Perl If else-if 示例

Perl if else-if 语句从多个条件中执行一个代码。if else-if 语句的语法如下:

```

if(condition1){
//code to be executed if condition1 is true
}else if(condition2){
//code to be executed if condition2 is true
}
else if(condition3){
//code to be executed if condition3 is true
}
...
else{
//code to be executed if all the conditions are false
}

```

#### Perl 中 if else-if 语句的流程图

![if-else-if statement in Perl](img/4762c8331f37ad28677764fb8330c9de.png)

下面给出了 Perl 语言中 if else-if 语句的例子。

```

print "Enter a Number to check grade\n";
$num = <>;
if( $num < 0 || $num > 100){
    printf "Wrong Number\n";
}elsif($num >= 0 && $num < 50){ 
    printf "Fail\n";
}elsif($num >= 0 && $num < 60){ 
    printf "D Grade\n";
}elsif($num >= 60 && $num < 70){ 
    printf "C Grade\n";
}elsif($num >= 70 && $num < 80){ 
    printf "B Grade\n";
}elsif($num >= 80 && $num < 90){ 
    printf "A Grade\n";
}elsif($num >= 90 && $num <= 100){ 
    printf "A+ Grade\n";
}

```

输出:

```
Enter a Number to check grade
66
C Grade

```

```
Enter a Number to check grade
2
Wrong Number

```