# Perl 最后一条语句

> 原文：<https://www.javatpoint.com/perl-last-statement>

Perl 中的最后一个**语句就像 c 语言中的 **break** 语句一样，在循环内部使用，可以立即退出循环。换句话说，最后一个条件迭代循环。**

最后一条语句的 Perl 语法如下:

```

last;

```

* * *

## Perl 最后一条语句示例

下面是一个简单的例子，展示了 Perl 的最后一条语句。

```

use warnings;
use strict;
my ($key, $value);
my %rate = ("shoes" => 550,
 "boots" => 1200,
 "jaggi" => 800,
 "jacket" => 1500);
print("Please enter an item to know the price:\n");
$key = <STDIN>;
chomp($key);
$value = 0;
# searching
foreach(keys %rate){
    if($_ eq $key){
       $value = $rate{$_};
       last;    }
}
# result
if($value > 0){
   print("$key costs is Rs. $value \n");
}else{
   print("$key is not in our list. We apologise!!\n");
}

```

输出:

```
Please enter an item to know the price:
boots
boots costs is Rs. 1200

```

```
Please enter an item to know the price:
top
top is not in our list. We apologise!!

```

在上面的程序中

*   当用户提供密钥时，散列元素通过循环运行，每个散列密钥与用户提供的密钥进行比较。
*   如果找到匹配，我们使用最后一条语句退出循环，否则继续搜索。
*   找到匹配结果时，会显示。

* * *

## 带有标签的 Perl 最后一条语句

仅使用 Perl 最后一条语句，您只能退出最里面的循环。如果要退出嵌套循环，请在外部循环中放置一个标签，并将标签传递给最后一条语句。

如果用最后一条语句指定了 LABEL，执行将脱离遇到 LABEL 的循环，而不是当前封闭的循环。

带有 LABEL 的最后一条语句的 Perl 语法如下所示:

```

last LABEL;

```

* * *

## 带有标签示例的 Perl 最后一条语句

```

use warnings;
use strict;
my ($key, $value);
my %rate = ("shoes" => 550,
 "boots" => 1200,
 "jaggi" => 800,
 "jacket" => 1500);
 $value = 0;
print("Please enter an item to know the price:\n");
OUTER: while(<STDIN>){
$key = $_;
 chomp($key);
# searching
INNER: foreach(keys %rate){
    if($_ eq $key){
       $value = $rate{$_};
       last outer;
    }
}
 print("$key is not in our list. We apologise!!\n") if($value ==0);
# result
}
   print("$key costs is Rs. $value \n");

```

输出:

```
Please enter an item to know the price:
jaggi
boots costs is Rs. 800

```

```
Please enter an item to know the price:
jeans
jeans is not in our list. We apologise!!

```

上述程序的工作方式相同，只是如果找不到匹配项，它会要求用户再次输入搜索关键字。

使用了两个标签 OUTER 和 INNER。

在 foreach 循环内部，如果找到匹配，我们将退出这两个循环，因为 OUTER 标签被传递给最后一个语句。