# Perl 下一条语句

> 原文：<https://www.javatpoint.com/perl-next-statement>

Perl next 语句就像 c 语言中的 continue 语句一样，它帮助您跳到数组的下一个元素，或者跳过中间的所有元素。

下面给出了 Perl 下一条语句的语法:

```

next;

```

* * *

## Perl 下一条语句示例

```

@array = (a..z);
print("@array\n");
for ($index = 0; $index < @array; $index++) {
    if ($index == 0 || $index == 4 || $index == 8 || $index == 14 || $index == 20) {
        next;
    }
    $array[$index] = "-";
}
print("@array\n");

```

输出:

```
a b c d e f g h i j k l m n o p q r s t u v w x y z
a - - - e - - - i - - - - - o - - - - - u - - - - - 

```

在上面的程序中，我们声明了一个数组，从(a-z)。

字母数组按原样打印。

for 循环用于所有元音，next 语句用于所有元音。

我们已经为除元音之外的其余数组元素指定了(-)符号。

现在由于下一个声明，只有元音元素将被打印，其他元素将被替换为(-)符号。

* * *

## 带标签的 Perl 下一条语句

下一个标签允许您将控制转移到相邻循环之外的封闭循环。

如果用 next 语句指定了 label，执行将跳到用 label 标识的下一个迭代。

下面给出了 Perl 下一条语句的语法:

```

next LABEL;

```

* * *

## 带有标签的 Perl 下一条语句示例

```

OUTER: for ($i = 0; $i < 3; $i++) {
                for ($j = 0; $j < 3; $j++) {
                    print("inner: $i,$j\n");
                    if ($j == 1) {
                        next OUTER;
                    }
                }
                print("outer: $i,$j\n\n");
            }

```

输出:

```
Inner: 0,0
Inner: 0,1
Inner: 1,0
Inner: 1,1
Inner: 2,0
Inner: 2,1

```

在上面的程序中，next 标签跳转到外部循环，并像 next 运算符一样执行 for 循环。