# 面向循环的 Perl

> 原文：<https://www.javatpoint.com/perl-for-loop>

Perl for loop 也被称为 **C 风格 for loop。for 循环多次迭代语句或程序的一部分。**

它有三个参数:

*   **初始化:**这个部分先执行，只执行一次。它初始化并声明循环变量。
*   **条件:**for 循环执行，直到条件为真。当条件为假时，循环执行停止，循环外的执行终止。
*   **增量/减量:**循环变量的增量或减量，只要它满足循环条件。当条件不满足时，循环终止并打印输出。

Perl 语言中 for 循环的语法如下:

```

for(initialization;condition;incr/decr){
//code to be executed
}

```

#### Perl 中 for 循环的流程图

![for loop in perl language flowchart](img/06ee6b7fa1cd0f4f4241e9f643e59c94.png)

* * *

**循环的 Perl 示例:**

让我们看看 for 循环的简单程序，它打印了表 1。

```

for( $a = 1; $a <= 10; $a++ ){
    print " $a\n";
}

```

输出:

```
1
2
3
4
5
6
7
8
9
10

```

* * *

## 循环的嵌套 Perl

在本例中，一个 for 循环嵌套在另一个 for 循环中。内部循环完全执行，而外部循环只执行一次。这意味着如果循环运行 3 次，外部循环将执行 3 次，而内部循环将执行 9 次。

**示例:**

```

for( $i = 1; $i <= 3; $i++ ){
    for( $j = 1; $j <= 3; $j++ ){
    print " $i $j\n";
}
}

```

输出:

```
1 1
1 2
1 3
2 1
2 2
2 3
3 1
3 2
3 3

```

* * *

## 无限循环的 Perl

If 双分号(；；)用于 for 循环，循环将执行无限次。您可以使用**ctrl+c**停止执行

```

for( ; ; )
{
   printf "Infinite For Loop\n";
}

```

输出:

```
Infinite For Loop
Infinite For Loop
Infinite For Loop
Infinite For Loop
Infinite For Loop
Ctrl+c

```