# 带循环的 Perl 数组

> 原文：<https://www.javatpoint.com/perl-array-with-loops>

Perl 数组元素可以在循环中访问。可以使用不同类型的循环。

我们将展示使用以下循环的阵列访问:

*   foreach 循环
*   for 循环
*   while 循环
*   直到循环

* * *

## 带 foreach 循环的 Perl 数组

在 foreach 循环中，控制变量设置在数组的元素上。这里，我们指定$i 作为控制变量并打印它。

```

@num = qw(10 20 30 40 50);
foreach $i (@num) {
  print "$i\n";
}

```

输出:

```
10
20
30
40
50

```

* * *

## 带 for 循环的 Perl 数组

一个控制变量将作为给定数组的索引传递给循环。

```

@num = qw(10 20 30 40 50);
for($i = 0; $i < 5; $i++){
  print "@num[$i]\n";
}

```

输出:

```
10
20
30
40
50

```

* * *

## 带 while 循环的 Perl 数组

只要条件为真，while 循环就会执行。

```

$i = 5;
while ($i > 0) {
  print "$i\n";
  $i--;
}

```

输出:

```
5
4
3
2
1

```

* * *

## 带有直到循环的 Perl 数组

直到循环像 while 循环一样工作，但是它们是彼此相反的。只要条件为真，while 循环就运行，而只要条件为假，直到循环就运行。一旦条件为假，直到循环终止。

直到循环可以作为表达式修饰符写在等式的右边。

```

@your_name = "John";
print "@your_name\n" until $i++ > 4;

```

输出:

```
John
John
John
John
John

```

在上面的程序中，一旦$i 根据条件大于 4，循环迭代就停止。