# Perl 字符串转义字符

> 原文：<https://www.javatpoint.com/perl-string-escaping-characters>

所有特殊字符或符号，如@、#、$、& /、\，都不能正常打印。他们需要一个前转义字符反斜杠(\)来打印。

* * *

## 显示电子邮件地址

所有电子邮件地址都包含(@)符号。如前所述，符号不会正常打印在字符串中。他们需要额外的关注。在@符号前使用反斜杠(\)打印电子邮件地址。

```

use strict;
use warnings;
my $site  = "javatpoint\@gmail.com";
print "$site\n";

```

输出:

```
[email protected]

```

* * *

## 双引号字符串中嵌入 Perl $符号

如果要在字符串中打印($)符号，请在$符号前使用反斜杠(\)。

```

use strict;
use warnings;
my $msg1 = 'Ana';
print "We have defined \$msg1 as $msg1\n";

```

输出:

```
We have defined $msg1 as Ana

```

* * *

## Perl 转义字符

如果要在字符串中打印(\)符号，请在\符号前使用反斜杠(\)。

```

use strict;  
use warnings;  
print "The \\n is a new line chracter in programming languages.\n"; 

```

输出:

```
Everyone has to follow this rule whether its a boy\girl

```

* * *

## Perl 转义双引号

如果要在字符串中打印双引号，请在双引号处使用反斜杠(\)。

```

use strict;
use warnings;
my $x = 'tutorials';
print "Our site \"javaTpoint\" provides all type of \"$x\"\n";

```

输出:

```
Our site "javaTpoint" provides all type of "tutorials?

```

* * *

## 双 q 运算符

“qq”运算符用括号替换字符串周围的双引号。这意味着("")在这个字符串中不再是必不可少的。它将简单地用 qq 打印字符串。

但是如果你想要一个括号在一个字符串里面，那么你需要使用花括号{}包围这个字符串。

如果字符串中需要大括号，那么使用方括号[]将字符串括起来。

```

#use of qq
use strict;
use warnings;
my $x = 'tutorials';
print qq(Our site "javaTpoint" provides all type of "$x"\n);
#use of {} brackets
print qq{Our site (javaTpoint) provides all type of "$x"\n};
#use of [] brackets
print qq[Our site (javaTpoint} provides all type of "$x"\n];

```

输出:

```
Our site "javaTpoint" provides all type of "tutorials"
Our site (javaTpoint) provides all type of "tutorials"
Our site (javaTpoint} provides all type of "tutorial"

```

* * *

## 单 q 运算符

单个“q”运算符作为字符串中的单引号(')使用。像单引号一样，它也不插入变量。

```

#use of q
use strict;
use warnings;
my $x = 'tutorials';
print q(Our site "javaTpoint" provides all type of "$x"\n);
print"\n";
#use of () brackets
print q(Our site "javaTpoint" provides all type of "$x"\n);
print"\n";
#use of {} brackets
print q{Our site )javaTpoint( provides all type of "$x"\n};
print"\n";
#use of {} brackets
print q[Our site )javaTpoint} provides all type of "$x"\n];

```

输出:

```
Our site "javaTpoint" provides all type of "$x"\n
Our site "javaTpoint" provides all type of "$x" \n
Our site )javaTpoint( provides all type of "$x" \n
Our site )javaTpoint} provides all type of "$x" \n

```