# 带 Excel 文件的 Perl

> 原文：<https://www.javatpoint.com/perl-create-excel-file>

Perl 几乎没有可以处理 excel 文件的模块。它能够处理所有类型的电子表格。在 Perl 的帮助下，您可以非常容易地创建或读取 excel 文件。

* * *

## 创建 Excel 文件

要创建一个 excel 文件，我们将使用 Perl 模块 **Excel::Writer::XLSX** 。excel 文件扩展名为**(。xlsx)** 适用于本模块。

我们正在用上面的模块创建一个 excel 文件 **myExcel.xlsx** 。首先我们需要加载模块。在**新的**构造函数中，我们将传递我们正在创建的文件名。新构造函数的输出存储在**$工作簿中。**

excel 文件由一张或多张工作表组成。数据可以在这些表上找到。我们通过调用$workbook 对象的 **add_worksheet()** 方法来创建工作表。其返回值存储在**$工作表中。**

**write** 方法将数据添加到工作表中。每个调用都有两个参数。在 excel 中，行用 1 标记，列用字母 A、B、C 等标记。

最后我们关闭文件。但是这在 Perl 中不是必需的，因为它会在脚本结束时自动关闭文件。

```
#!/usr/bin/perl
use strict;
use warnings; 
use Excel::Writer::XLSX;
my $workbook= Excel::Writer::XLSX->new( 'myExcel.xlsx' );
my $worksheet = $workbook->add_worksheet();
$worksheet->write( "A1", "Excel file generated!" );
$worksheet->write( "A2", "This is the second row" );
$workbook->close;

```

输出:

![Perl With excel file 1](img/b8b3457592bd7a3ff091b7c0207e0824.png)

* * *

## 在 Excel 中添加公式

现在，我们将使用乘法来打印 2 的表格。列 A 将打印 2 的表格。

```
#!/usr/bin/perl
use strict;
use warnings;
use Excel::Writer::XLSX;
my $workbook  = Excel::Writer::XLSX->new( 'myExcel.xlsx' );
my $worksheet = $workbook->add_worksheet();
$worksheet->write( "A1", 2 );
$worksheet->write( "A2", "=A1*2" );
$worksheet->write( "A3", "=A1*3" );
$worksheet->write( "A4", "=A1*4" );
$worksheet->write( "A5", "=A1*5" );
$worksheet->write( "A6", "=A1*6" );
$worksheet->write( "A7", "=A1*7" );
$worksheet->write( "A8", "=A1*8" );
$worksheet->write( "A9", "=A1*9" );
$worksheet->write( "A10", "=A1*10" );
$workbook->close;

```

输出:

![Perl With excel file 2](img/c5f2bdc516352d3f19b1b7d54aef6fb0.png)