# Scala的特点

> 原文：<https://www.javatpoint.com/features-of-scala>

scala 有以下特性:

*   类型推断
*   单例对象
*   不变
*   懒惰计算
*   案例类和模式匹配
*   并发控制
*   字符串插值
*   高阶函数
*   特征
*   丰富的收藏集

* * *

### 类型推理

在 Scala 中，您不需要显式地提到数据类型和函数返回类型。Scala 足够聪明，可以推断出数据的类型。函数的返回类型由函数中最后一个表达式的类型决定。

### 单例对象

在 Scala 中，没有静态变量或方法。Scala 使用 singleton object，它本质上是一个在源文件中只有一个对象的类。Singleton 对象是通过使用 object 而不是 class 关键字声明的。

### 不变

Scala 使用不变性概念。默认情况下，每个声明的变量都是不可变的。不可变意味着你不能修改它的值。您还可以创建可变变量，这些变量可以更改。

不可变数据有助于管理需要管理数据的并发控制。

### 懒惰计算

在 Scala 中，计算默认是懒惰的。Scala 只在表达式是必需的时候才计算它们。您可以使用 lazy 关键字声明一个 lazy 变量。它用于提高性能。

### 案例类和模式匹配

Scala case 类只是常规类，默认情况下是不可变的，可以通过模式匹配进行分解。

case 类中列出的所有参数都是公共的，默认情况下是不可变的。

案例类支持模式匹配。所以，你可以写更多的逻辑代码。

### 并发控制

Scala 提供了包含参与者模型的标准库。您可以使用 actor 编写并发代码。Scala 提供了另一个处理并发的平台和工具，称为 Akka。Akka 是一个独立的开源框架，提供基于参与者的并发性。Akka 参与者可以是分布式的，也可以与软件事务内存相结合。

### 字符串插值

自 Scala 2.10.0 以来，Scala 提供了一种从数据创建字符串的新机制。这叫做字符串插值。字符串插值允许用户将变量引用直接嵌入到已处理的字符串中。Scala 提供了三种字符串插值方法:s、f 和 raw。

### 高阶函数

高阶函数是以函数为参数或返回函数的函数。换句话说，我们可以说与另一个函数一起工作的函数叫做高阶函数。

高阶函数允许您创建函数组合、lambda 函数或匿名函数等。

### 特征

特性就像一个带有部分实现的接口。在 Scala 中，trait 是抽象和非抽象方法的集合。你可以创造一种特质，它可以有所有的抽象方法，也可以有一些抽象的和一些非抽象的方法。

特征被编译成带有相应实现类的 Java 接口，这些实现类保存在特征中实现的任何方法。

### 丰富的收藏集

Scala 提供了丰富的集合库。它包含收集数据的类和特征。这些集合可以是可变的，也可以是不可变的。你可以根据你的要求使用它。Scala.collection.mutable 包包含所有的可变集合。使用此包时，您可以添加、删除和更新数据。

Scala.collection .不可变包包含所有不可变集合。它不允许您修改数据。