# Scala 变量和数据类型

> 原文：<https://www.javatpoint.com/scala-variable-and-data-types>

变量是一个用来指代内存位置的名称。您可以在 scala 中创建可变的和不可变的变量。让我们看看如何声明变量。

* * *

## 可变变量

您可以使用 **var** 关键字创建可变变量。它允许您在声明变量后更改值。

```

var data = 100
data = 101 	// It works, No error.

```

在上面的代码中， **var** 是关键字，数据是变量名。它包含整数值 100。Scala 是一种推断语言的类型，所以你没有？不需要显式指定数据类型。您还可以明确地提到变量的数据类型，正如我们在下面使用的那样。

### 变量的另一个例子

```

var data:Int = 100	// Here, we have mentioned Int followed by : (colon)

```

* * *

## 不可变变量

```

val data = 100
data = 101 // Error: reassignment to val

```

上面的代码抛出了一个错误，因为我们改变了不可变变量的内容，这是不允许的。因此，如果您想更改内容，建议使用 **var** 代替**var**。

* * *

## Scala 中的数据类型

scala 中的数据类型在存储和长度方面与 java 非常相似，只是在 scala 中没有原始数据类型的概念，每种类型都是一个对象，并且以大写字母开头。数据类型表如下。你会进一步看到它们的用途。

| 数据类型 | 缺省值 | 大小 |
| 布尔代数学体系的 | 错误的 | 对还是错 |
| 字节 | Zero | 8 位有符号值(-2 <sup>7</sup> 至 2 <sup>7</sup> -1) |
| 短的 | Zero | 16 位有符号值(-2 <sup>15</sup> 至 2 <sup>15</sup> -1) |
| 茶 | \u0000 ' | 16 位无符号 Unicode 字符(0 到 2 <sup>16</sup> -1) |
| （同 Internationalorganizations）国际组织 | Zero | 32 位有符号值(-2 <sup>31</sup> 至 2 <sup>31</sup> -1) |
| 长的 | 0L | 64 位有符号值(-2 <sup>63</sup> 至 2 <sup>63</sup> -1) |
| 浮动 | 0.0F | 32 位 IEEE 754 单精度浮点 |
| 两倍 | 0.0D | 64 位 IEEE 754 双精度浮点 |
| 线 | 空 | 一连串的字符 |

* * *