# Scala 条件表达式

> 原文：<https://www.javatpoint.com/scala-conditional-expressions>

Scala 提供 if 语句来测试条件表达式。它测试布尔条件表达式，该表达式可以是真的也可以是假的。Scala 使用各种类型的 if else 语句。

*   如果语句
*   If-else 语句
*   嵌套 if-else 语句
*   If-else-if 梯形语句

* * *

## Scala if 语句

scala if 语句用于测试 scala 中的条件。If 块仅在条件为真时执行，否则跳过 if 块的执行。

**语法**

```
if(condition){
	// Statements to be executed
}

```

### 流程图

![Scala If statement 1](img/26341eeb24410e6c2d2244c8dde302b4.png)

* * *

## Scala 示例:If 语句

```
var age:Int = 20;
if(age > 18){
    println ("Age is greate than 18")
}

```

输出:

```
Age is greate than 18

```

* * *

## Scala If-Else 语句

scala if-else 语句测试条件。如果条件为真，如果块执行，否则块执行。

**语法**

```
if(condition){
	// If block statements to be executed
} else {
	// Else bock statements to be executed
}

```

### 流程图

![Scala If statement 2](img/3b8dc1f5bf3b7296a7372e307df4ca41.png)

* * *

## Scala if-else 示例

```
var number:Int = 21
if(number%2==0){
    println("Even number")
}else{
    println("Odd number")
}

```

输出:

```
Odd number

```

* * *

## Scala 如果-否则-如果阶梯语句

scala if-else-if 梯形在多个条件语句中执行一个条件。

**语法**

```
if (condition1){  
//Code to be executed if condition1 is true  
} else if (condition2){  
//Code to be executed if condition2 is true  
} else if (condition3){  
//Code to be executed if condition3 is true  
}  
...  
else {  
//Code to be executed if all the conditions are false  
}  

```

### 流程图

![Scala If statement 3](img/3cc3a55830dd1f57de47b43c5ff350ac.png)

* * *

## Scala If-Else-If 阶梯示例

```
var number:Int = 85
if(number>=0 && number<50){
    println ("fail")
}
else if(number>=50 && number<60){
    println("D Grade")
}
else if(number>=60 && number<70){
    println("C Grade")
}
else if(number>=70 && number<80){
    println("B Grade")
}
else if(number>=80 && number<90){
    println("A Grade")
}
else if(number>=90 && number<=100){
    println("A+ Grade")
}
else println ("Invalid")

```

输出:

```
A Grade

```

* * *

## Scala If 语句作为三元运算符的更好选择

在 scala 中，您可以将 if 语句结果分配给函数。Scala 没有 C/C++ 那样的三元运算符概念，但是提供了更强大的 *if* ，可以返回值。让我们看一个例子

**例**

```
object MainObject {
   def main(args: Array[String]) {
      val result = checkIt(-10)
      println (result)
   }
    def checkIt (a:Int)  =  if (a >= 0) 1 else -1	// Passing a if expression value to function
}

```

输出:

```
-1

```