# Scala 模式匹配

> 原文：<https://www.javatpoint.com/scala-pattern-matching>

模式匹配是 scala 的一个特性。它的工作原理与其他编程语言中的 switch case 相同。它与模式中可用的最佳案例相匹配。

我们来看一个例子。

* * *

## Scala 模式匹配示例

```
object MainObject {
   def main(args: Array[String]) {
        var a = 1
        a match{
            case 1 => println("One")
            case 2 => println("Two")
            case _ => println("No")
        }
        }
}

```

在上面的例子中，我们实现了一个模式匹配。

这里，使用名为 *a* 的变量进行匹配。此变量与最佳可用案例相匹配，并打印输出。下划线(_)用于最后一种情况，使其成为默认情况。

输出:

```
One

```

匹配表达式也可以返回大小写值。在下一个示例中，我们将定义一个方法，该方法与任何类型数据的案例相匹配。Any 是 scala 中的一个类，它是所有数据类型的超级类，处理所有类型的数据。我们来看一个例子。

## Scala 模式匹配示例 2

```
object MainObject {
   def main(args: Array[String]) {
        var result = search ("Hello")
        print(result)
    }
    def search (a:Any):Any = a match{
        case 1  => println("One")
        case "Two" => println("Two")
        case "Hello" => println("Hello")
        case _ => println("No")

        }
}

```

输出:

```
Hello

```