# Scala休息

> 原文：<https://www.javatpoint.com/scala-break>

Break 用于中断循环或程序执行。它跳过当前执行。在内部循环中，它中断内部循环的执行。

在 scala 中，没有 break 语句，但是可以通过使用 break 方法和导入*Scala . util . control . breaks . _*包来实现。我们来看一个例子。

* * *

## Scala 中断示例

```

import scala.util.control.Breaks._					// Importing  package
object MainObject {
   def main(args: Array[String]) {
        breakable { 								// Breakable method to avoid exception
            for(i<-1 to 10 by 2){
                if(i==7) 
                    break							// Break used here
                else
                    println(i)
            }
        }
    }
}

```

输出:

```
1
3
5

```

* * *

## Scala 中断示例:中断内部循环

可以使用 break 语句终止嵌套循环中内部循环的执行。

我们来看一个例子。

```

import scala.util.control.Breaks._
object MainObject {
   def main(args: Array[String]) {
        for(i <- 1 to 3){
            breakable { 
                for(j <- 1 to 3){
                    if(i == 2 & j == 2 ) 
                       break
                    println(i+" "+j)
                }
            }
        }
    }
}

```

输出:

```
1 1
1 2
1 3
2 1
3 1
3 2
3 3

```