# Scala 对象和类

> 原文：<https://www.javatpoint.com/scala-object-and-class>

与 java 不同，scala 是一种纯面向对象的编程语言。它允许我们创建对象和类，以便您可以开发面向对象的应用程序。

* * *

## 目标

对象是真实世界的实体。它包含状态和行为。笔记本电脑、汽车、手机都是现实世界的物件。对象通常有两个特征:

**1)状态**:对象的数据值称为其状态。

**2)行为**:对象执行的功能称为其行为。

scala 中的对象是类的实例。它也被称为运行时实体。

* * *

## 班级

类是模板或蓝图。它也被称为相似类型对象的集合。

在 scala 中，一个类可以包含:

1.  数据成员
2.  成员方法
3.  构造器
4.  街区
5.  嵌套类
6.  超级类信息等。

您必须初始化类中的所有实例变量。没有默认范围。如果不指定访问范围，它就是公共的。必须有一个定义了 main 方法的对象。它为你的程序提供了起点。在这里，我们创建了一个类的例子。

* * *

## 类的 Scala 示例

```
class Student{
    var id:Int = 0;	        				// All fields must be initialized
    var name:String = null;
}
object MainObject{
    def main(args:Array[String]){
        var s = new Student()				// Creating an object
        println(s.id+" "+s.name);
    }
}

```

输出:

```
0 null

```

* * *

## 类的 Scala 示例 2

在 scala 中，您也可以像这样创建类。这里，构造函数是在类定义中创建的。这称为主构造函数。

```
class Student(id:Int, name:String){		// Primary constructor
    def show(){
        println(id+" "+name)
    }
}
object MainObject{
    def main(args:Array[String]){
        var s = new Student(100,"Martin")	// Passing values to constructor
        s.show()				// Calling a function by using an object
    }
}

```

输出:

```
100 Martin

```

* * *

## Scala 维护学生记录的类示例

```
class Student(id:Int, name:String){
    def getRecord(){
        println(id+" "+name);
    }
}

object MainObject{
    def main(args: Array[String]){
        var student1 = new Student(101,"Raju");
        var student2 = new Student(102,"Martin");
        student1.getRecord();
        student2.getRecord();
    }
}

```

输出:

```
101 Raju
102 Martin

```

* * *

## 匿名对象

在 scala 中，您可以创建匿名对象。没有引用名的对象称为匿名对象。当您不想进一步重用匿名对象时，最好创建它。

* * *

## Scala 匿名对象示例

```
class Arithmetic{
    def add(a:Int, b:Int){
        var add = a+b;
        println("sum = "+add);
    }
}

object MainObject{
    def main(args:Array[String]){
        new Arithmetic().add(10,10);

    }
}

```

输出:

```
Sum = 20

```