# Scala 单例对象和伴随对象

> 原文：<https://www.javatpoint.com/scala-singleton-and-companion-object>

* * *

## Scala 单例对象

单例对象是用 object 关键字而不是用 class 声明的对象。不需要任何对象来调用在 singleton 对象中声明的方法。

在 scala 中，没有静态的概念。所以 scala 创建了一个单独的对象来为你的程序执行提供入口点。
如果不创建 singleton 对象，代码会编译成功，但不会产生任何输出。单例对象内部声明的方法是全局可访问的。单例对象可以扩展类和特征。

### Scala 单例对象示例

```

object Singleton{
    def main(args:Array[String]){
        SingletonObject.hello()         // No need to create object.
    }
}

object SingletonObject{
    def hello(){
        println("Hello, This is Singleton Object")
    }
}

```

输出:

```
Hello, This is Singleton Object

```

* * *

## Scala 伴随对象

在 scala 中，当你有一个与 singleton 对象同名的类时，它被称为伴随类，而 singleton 对象被称为伴随对象。

伴随类及其伴随对象都必须在同一个源文件中定义。

### Scala 伴随对象示例

```

class ComapanionClass{
    def hello(){
        println("Hello, this is Companion Class.")
    }
}
object CompanoinObject{
    def main(args:Array[String]){
        new ComapanionClass().hello()
        println("And this is Companion Object.")
    }
}

```

输出:

```
Hello, this is Companion Class.
And this is Companion Object.

```