# Scala 构造函数

> 原文：<https://www.javatpoint.com/scala-constructor>

在 scala 中，构造函数不是特殊的方法。Scala 提供了主构造函数和任意数量的辅助构造函数。我们已经在下面的例子中详细解释了每一个。

## Scala 默认主构造函数

在 scala 中，如果没有指定主构造函数，编译器会创建一个构造函数，称为主构造函数。类主体的所有语句都被视为构造函数的一部分。它也被称为默认构造函数。

* * *

## Scala 默认主构造函数示例

```

class Student{
println("Hello from default constructor");
}

```

输出:

```
Hello from default constructor

```

* * *

## Scala 主构造函数

Scala 用类的定义提供了主构造函数的概念。如果代码只有一个构造函数，则不需要显式定义构造函数。它有助于优化代码。您可以使用零个或多个参数创建主构造函数。

* * *

## Scala 主构造函数示例

```

class Student(id:Int, name:String){
    def showDetails(){
        println(id+" "+name);
    }
}

object MainObject{
    def main(args:Array[String]){
        var s = new Student(101,"Rama");
        s.showDetails()
    }
}

```

输出:

```
101 Rama

```

* * *

## Scala 二级(辅助)构造器

您可以在一个类中创建任意数量的辅助构造函数。您必须从辅助构造函数内部调用主构造函数。此关键字用于从其他构造函数调用构造函数。当调用其他构造函数时，将它作为构造函数的第一行。

* * *

## Scala 二级构造函数示例

```

class Student(id:Int, name:String){
    var age:Int = 0
    def showDetails(){
        println(id+" "+name+" "+age)
    }
    def this(id:Int, name:String,age:Int){
        this(id,name)		// Calling primary constructor, and it is first line
        this.age = age
    }
}

object MainObject{
    def main(args:Array[String]){
        var s = new Student(101,"Rama",20);
        s.showDetails()
    }
}

```

输出:

```
101 Rama 20

```

* * *

## Scala 示例:构造函数重载

在 scala 中，可以重载构造函数。我们来看一个例子。

```

class Student(id:Int){
    def this(id:Int, name:String)={
        this(id)
        println(id+" "+name)
    }
    println(id)
}

object MainObject{
    def main(args:Array[String]){
        new Student(101)
        new Student(100,"India")
    }
}

```

输出:

```
101
100
100 India

```