# Scala 方法重载

> 原文：<https://www.javatpoint.com/scala-method-overloading>

Scala 提供了方法重载特性，允许我们定义同名但具有不同参数或数据类型的方法。它有助于优化代码。

### 使用不同参数的 Scala 方法重载示例

在下面的示例中，我们定义了两个具有不同参数数量但具有相同数据类型的 add 方法。

```

class Arithmetic{
    def add(a:Int, b:Int){
        var sum = a+b
        println(sum)
    }
    def add(a:Int, b:Int, c:Int){
        var sum = a+b+c
        println(sum)
    }
}

object MainObject{
    def main(args:Array[String]){
        var a  = new Arithmetic();
        a.add(10,10);
        a.add(10,10,10);
    }
}

```

输出:

```
20
30

```

* * *

## 使用不同数据类型的 Scala 方法重载示例

在下面的示例中，我们创建了两个 add 方法，它们具有相同数量的参数，但数据类型不同。

```

class Arithmetic{
    def add(a:Int, b:Int){
        var sum = a+b
        println(sum)
    }
    def add(a:Double, b:Double){
        var sum = a+b
        println(sum)
    }
}
object MainObject{
    def main(args:Array[String]){
        var b = new Arithmetic()
        b.add(10,10)
        b.add(10.0,20.0)

    }
}

```

输出:

```
20
30.0

```