# Scala这个

> 原文：<https://www.javatpoint.com/scala-this>

在 scala 中，这是一个关键字，用于引用当前对象。您可以使用这个关键字来调用实例变量、方法和构造函数。

### Scala这个例子

在下面的例子中，*这个*用来调用实例变量和主构造函数。

```

class ThisExample{
    var id:Int = 0
    var name: String = ""
    def this(id:Int, name:String){
        this()
        this.id = id
        this.name = name
    }
    def show(){
        println(id+" "+name)
    }
}

object MainObject{
    def main(args:Array[String]){
        var t = new ThisExample(101,"Martin")
        t.show()
    }
}

```

输出:

```
101 Martin

```

* * *

## 使用*这个*关键字调用 Scala 构造函数

在下面的示例中，这用于调用构造函数。它说明了我们如何从其他构造函数调用构造函数。在调用其他构造函数时，必须确保这必须是构造函数中的第一条语句，否则编译器将引发错误。

```

class Student(name:String){
    def this(name:String, age:Int){
        this(name)
        println(name+" "+age)
    }    
}

object MainObject{
    def main(args:Array[String]){
        var s = new Student("Rama",100)
    }
} 

```

输出:

```
Rama 100

```