# Scala 方法重写

> 原文：<https://www.javatpoint.com/scala-method-overriding>

当子类具有与父类中定义的相同名称的方法时，这被称为方法重写。当子类想要为父类中定义的方法提供特定的实现时，它会重写父类中的方法。

在 scala 中，必须使用 override 关键字或 override 注释来重写父类中的方法。

* * *

## Scala 方法覆盖示例 1

```
class Vehicle{
    def run(){
        println("vehicle is running")
    }
}

class Bike extends Vehicle{
     override def run(){
        println("Bike is running")
    }
}

object MainObject{
    def main(args:Array[String]){
        var b = new Bike()
        b.run()
    }
}

```

输出:

```
Bike is running

```

* * *

## 方法重写的真实例子

### 流程图

![Scala Inheritance 3](img/caa7048e60a0c2df4d6700d81793a041.png)

* * *

## Scala 方法覆盖示例 2

这个例子展示了子类如何覆盖父类的方法。

```
class Bank{  
        def getRateOfInterest()={
            0
        }  
    }  

    class SBI extends Bank{  
        override def getRateOfInterest()={
         8
        }  
    }  

    class ICICI extends Bank{  
        override def getRateOfInterest()={
            7
        }  
    }  

    class AXIS extends Bank{  
        override def getRateOfInterest()={
            9
        }  
    }  

    object MainObject{  
        def main(args:Array[String]){  
            var s=new SBI();  
            var i=new ICICI();  
            var a=new AXIS();  
            println("SBI Rate of Interest: "+s.getRateOfInterest());  
            println("ICICI Rate of Interest: "+i.getRateOfInterest());  
            println("AXIS Rate of Interest: "+a.getRateOfInterest());  
        }  
    }  

```

输出:

```
SBI Rate of Interest: 8
ICICI Rate of Interest: 7
AXIS Rate of Interest: 9

```