# Scala 字段覆盖

> 原文：<https://www.javatpoint.com/scala-field-overriding>

在 scala 中，您也可以覆盖字段，但是它有一些需要遵循的规则。下面是一些说明如何覆盖字段的示例。

* * *

### Scala 字段覆盖示例 1

```
class Vehicle{
    var speed:Int = 60

}
class Bike extends Vehicle{
   var speed:Int = 100
    def show(){
        println(speed)
    }
}
object MainObject{
    def main(args:Array[String]){
        var b = new Bike()
        b.show()
    }
}

```

输出:

```
Error - variable speed needs 'override' modifier

```

在 scala 中，当您重写超类的方法或字段时，必须使用 override 关键字或 override 注释。如果不这样做，编译器会报告错误并停止程序的执行。

* * *

## Scala 字段覆盖示例 2

```
class Vehicle{
     val speed:Int = 60

}
class Bike extends Vehicle{
   override val speed:Int = 100		// Override keyword
    def show(){
        println(speed)
    }
}
object MainObject{
    def main(args:Array[String]){
        var b = new Bike()
        b.show()
    }
}

```

输出:

```
100

```

在 scala 中，您只能覆盖那些在两个类中都使用 val 关键字声明的变量。下面是一些演示整个过程的有趣例子。

* * *

## Scala 字段覆盖示例 3

```
class Vehicle{
     var speed:Int = 60
}
class Bike extends Vehicle{
   override var speed:Int = 100
    def show(){
        println(speed)
    }
}
object MainObject{
    def main(args:Array[String]){
        var b = new Bike()
        b.show()
    }
}

```

输出:

```
variable speed cannot override a mutable variable

```

* * *

## Scala 字段覆盖示例 4

```
class Vehicle{
     val speed:Int = 60

}

class Bike extends Vehicle{
   override var speed:Int = 100
    def show(){
        println(speed)
    }
}

object MainObject{
    def main(args:Array[String]){
        var b = new Bike()
        b.show()
    }
}

```

输出:

```
Error - variable speed needs to be a stable, immutable value

```