# 线比例

> 哎哎哎:# t0]https://www . javatppoint . com/scale-traits

特性就像一个带有部分实现的接口。在 scala 中，trait 是抽象和非抽象方法的集合。你可以创造一种特质，它可以有所有的抽象方法，也可以有一些抽象的和一些非抽象的方法。

在特性中使用 val 或 var 关键字声明的变量在实现该特性的类中内部实现。使用 val 或 var 声明但未初始化的任何变量都被视为抽象变量。

特征被编译成带有相应实现类的 Java 接口，这些实现类保存在特征中实现的任何方法。

## Scala特质示例

```

trait Printable{
    def print()
}

class A4 extends Printable{
    def print(){
        println("Hello")
    }
}

object MainObject{
    def main(args:Array[String]){
        var a = new A4()
        a.print()
    }
}

```

输出:

```
Hello

```

* * *

如果一个类扩展了一个特性，但是没有实现该特性中声明的成员，那么它必须被声明为抽象的。我们来看一个例子。

## Scala特质示例

```

trait Printable{
    def print()
}

abstract class A4 extends Printable{			// Must declared as abstract class
   def printA4(){
       println("Hello, this is A4 Sheet")
   }
}

```

* * *

## Scala 特性示例:在一个类中实现多个特性

如果一个类实现了多个特征，它将扩展第一个特征，类，抽象类。with 关键字用于扩展其余的特征。

利用性状可以获得多重遗传。

```

trait Printable{
    def print()
}

trait Showable{
   def show()
}

class A6 extends Printable with Showable{
    def print(){
        println("This is printable")
    }
    def show(){
        println("This is showable");
    }
}

object MainObject{
    def main(args:Array[String]){
        var a = new A6()
        a.print()
        a.show()
    }
}

```

输出:

```
This is printable
This is showable

```

* * *

## 具有抽象和非抽象方法的特征

你也可以像在抽象类中一样在特征中定义方法。也就是说，你也可以把特质当作抽象类。在 scala 中，特性几乎和抽象类一样，只是不能有构造函数。您不能扩展多个抽象类，但可以扩展多个特性。

### Scala特质示例

```

trait Printable{
    def print()			// Abstract method
    def show(){			// Non-abstract method
        println("This is show method")
    }
}

class A6 extends Printable{
    def print(){
        println("This is print method")
    }
}

object MainObject{
    def main(args:Array[String]){
        var a = new A6()
        a.print()
        a.show()
    }
}

```

输出:

```
This is print method
This is show method

```