# 标量阵列

> 原文：<https://www.javatpoint.com/scala-array>

数组是可变值的集合。它是一种基于索引的数据结构，从 0 索引开始到 n-1，其中 n 是数组的长度。

Scala 数组可以是通用的。这意味着，你可以有一个数组[T]，其中 T 是类型参数或抽象类型。Scala 数组与 Scala 序列兼容——你可以在需要序列的地方传递一个数组。它还支持所有的序列操作。

下图表示数组的结构，其中第一个索引为 0，最后一个索引为 9，数组长度为 10。

![Scala Array 1](img/e6a2427540e375b3a62f11017ddb03bf.png)

* * *

### 数组的标量类型

1.  一维数组
2.  多维数组

* * *

## 标量一维数组

一维数组用于以线性顺序存储元素。数组元素存储在连续的内存空间中。所以，如果你有一个数组的任何索引，你可以很容易地遍历数组的所有元素。

#### 一维数组的语法

```

var arrayName : Array[arrayType] = new Array[arrayType](arraySize);   or
var arrayName = new Array[arrayType](arraySize)  or
var arrayName : Array[arrayType] = new Array(arraySize);   or
var arrayName = Array(element1, element2 ... elementN)

```

* * *

## Scala 数组示例:一维

```

class ArrayExample{
    var arr = Array(1,2,3,4,5)     	// Creating single dimensional array
    def show(){
        for(a
```

输出:

```
1
2
3
4
5
Third Element  = 3

```

* * *

## Scala 示例 2:一维

在本例中，我们使用 new 关键字创建了一个数组，该关键字用于初始化数组的内存。整个数组元素被设置为默认值，您可以稍后在代码中指定它。

```

class ArrayExample{
    var arr = new Array[Int](5)     	// Creating single dimensional array
    def show(){
        for(a
```

输出:

```
0
0
0
0
0
Third Element before assignment = 0
Third Element after assignment = 10

```

* * *

## 标量将数组传递给函数

您可以在函数调用期间将数组作为参数传递给函数。以下示例说明了我们如何将数组传递给函数的过程。

```

class ArrayExample{
    def show(arr:Array[Int]){
        for(a
```

输出:

```
1
2
3
4
5
6
Third Element = 3

```

* * *

## Scala 数组示例:使用 Foreach 循环进行迭代

还可以通过使用 foreach 循环来迭代数组元素。我们来看一个例子。

```

class ArrayExample{
    var arr = Array(1,2,3,4,5)     	// Creating single dimensional array
    arr.foreach((element:Int)=>println(element))       // Iterating by using foreach loop
}

object MainObject{
    def main(args:Array[String]){
        new ArrayExample()
    }
}

```

输出:

```
1
2
3
4
5

```