# Scala字符串

> 原文：<https://www.javatpoint.com/scala-string>

在 scala 中，字符串是字符的组合，或者我们可以说它是一个字符序列。它是基于索引的数据结构，使用线性方法将数据存储到内存中。字符串在 scala 中像 java 一样是不可变的。您可以操作字符串，并可以应用方法来获得所需结果，但不能更改原始字符串对象。

* * *

## 标量字符串示例

这是一个简单的字符串示例，其中我们创建了一个字符串变量。

```
class StringExample{
    var s1 = "Scala string example"
    def show(){
        println(s1)
    }
}

object MainObject{
    def main(args:Array[String]){
        var s = new StringExample()
        s.show()
    }
}

```

输出:

```
Scala string example

```

* * *

## Scala 不可变字符串示例 1

在这个例子中，我们创建了一个字符串变量，并试图修改字符串对象。让我们看看会发生什么。

```
class StringExample{
    var s1 = "Scala string example"
    "This is "+s1        	// Modifying string object
    def show(){
        println(s1)			
    }
}

object MainObject{
    def main(args:Array[String]){
        var s = new StringExample()
        s.show()
    }
}

```

输出:

```
Scala string example

```

* * *

## Scala 不可变字符串示例 2

在这个例子中，我们正在修改字符串，并将其分配给一个变量，这样我们就可以保留对修改后的字符串的引用。在这里，修改后会创建一个新的字符串对象。s1 变量现在引用新的字符串对象。旧的字符串对象在内存中仍然可用，但是没有任何引用。

```
class StringExample{
    var s1 = "Scala string example"
    s1 = "This is "+s1        
    def show(){
        println(s1)
    }
}

object MainObject{
    def main(args:Array[String]){
        var s = new StringExample()
        s.show()
    }
}

```

输出:

```
This is Scala string example 

```

* * *

## Scala 字符串比较示例

在 scala 中，可以使用== (equal)方法比较两个字符串对象。以下程序描述了如何使用等号运算符。它返回真或假的布尔值。

```
class StringExample{
    var s1 = "Scala string example"
    var s2 = "Hello Scala"
    var s3 = "Hello Scala"
    def show(){
        println(s1 == s2)
        println(s2 == s3)
    }
}

object MainObject{
    def main(args:Array[String]){
        var s = new StringExample()
        s.show()
    }
}

```

输出:

```
false
true

```