# 标量字符串方法

> 原文：<https://www.javatpoint.com/scala-string-methods>

* * *

## Scala 字符串等于()方法示例

您也可以使用 equal()方法来比较两个字符串对象。如果两个字符串对象相等，则返回 true，否则返回 false。

```

class StringExample{
    var s1 = "Scala string example"
    var s2 = "Hello Scala"
    var s3 = "Hello Scala"
    def show(){
        println(s1.equals(s2))
        println(s2.equals(s3))
    }
}

object MainObject{
    def main(args:Array[String]){
        var s = new StringExample()
        s.show()
    }
}

```

输出:

```
false
true

```

* * *

## Scala compareTo()方法示例

compareTo()方法按字典顺序比较给定字符串和当前字符串。它返回正数、负数或 0。

如果第一个字符串大于第二个字符串，则返回正数(字符值的差值)。如果第一个字符串小于第二个字符串，则返回负数，如果第一个字符串等于第二个字符串，则返回 0。

```

s1 > s2 => positive number  
s1 < s2 => negative number  
s1 == s2 => 0  

```

```

class StringExample{
    var s1 = "Scala string example"
    var s2 = "Hello Scala"
    var s3 = "Hello Scala"
    def show(){
        println(s1.compareTo(s2))
        println(s2.compareTo(s3))
    }
}

object MainObject{
    def main(args:Array[String]){
        var s = new StringExample()
        s.show()
    }
}

```

输出:

```
11
0

```

* * *

## 使用+(加号)运算符的 Scala 连接示例

在 scala 中，您可以使用+运算符连接字符串。下面给出了一个使用+运算符连接两个字符串的例子。

```

class StringExample{
    var s1 = "This is "+"Scala string example"
    def show(){
        println(s1)
    }
}

object MainObject{
    def main(args:Array[String]){
        var s = new StringExample()
        s.show()
    }
}

```

输出:

```
This is Scala string example

```

* * *

## Scala 字符串 concat()方法示例

除了+运算符之外，还可以使用 concat()方法来连接两个字符串。它是字符串类的预定义方法。

```

class StringExample{
    var s1 = "This is "
    var s2 = "Scala string example"
    def show(){
        println(s1.concat(s2))
    }
}

object MainObject{
    def main(args:Array[String]){
        var s = new StringExample()
        s.show()
    }
}

```

输出:

```
This is Scala string example

```

* * *

## Scala 子串()方法示例

substring()方法用于从字符串中获取子字符串。通过指定开始和结束索引作为参数，您可以根据您的需求获取子字符串。它是字符串类的预定义方法。

```

class StringExample3{
    var s1 = "Scala string example"
    def show(){
        println(s1.substring(0,5))
    }  
}

object MainObject{
    def main(args:Array[String]){
        var s = new StringExample3()
        s.show()
    }
}

```

输出:

```
Scala

```