# Scala尝试接球

> 原文：<https://www.javatpoint.com/scala-try-catch>

Scala 提供了 try 和 catch 块来处理异常。try 块用于封闭可疑代码。catch 块用于处理 try 块中出现的异常。根据需要，您可以在程序中使用任意数量的 try catch 块。

## Scala 尝试捕获示例

在下面的程序中，我们将可疑代码包含在 try block 中。在 try block 之后，我们使用了一个 catch 处理程序来捕获异常。如果发生任何异常，catch 处理程序将处理它，并且程序不会异常终止。

```
class ExceptionExample{
    def divide(a:Int, b:Int) = {
        try{
            a/b
        }catch{
            case e: ArithmeticException => println(e)
        }
        println("Rest of the code is executing...")
    }
}
object MainObject{
    def main(args:Array[String]){
        var e = new ExceptionExample()
        e.divide(100,0)

    }
}

```

输出:

```
java.lang.ArithmeticException: / by zero
Rest of the code is executing...

```

* * *

## Scala 尝试捕获示例 2

在这个例子中，我们的 catch 处理程序中有两种情况。第一种情况将只处理算术类型的异常。第二种情况有 Throwable 类，它是异常层次结构中的一个超级类。第二种情况能够处理程序中的任何类型的异常。有时候不知道异常的类型，可以用 super 类。

```
class ExceptionExample{
    def divide(a:Int, b:Int) = {
        try{
            a/b
            var arr = Array(1,2)
            arr(10)
        }catch{
            case e: ArithmeticException => println(e)
            case ex: Throwable =>println("found a unknown exception"+ ex)
        }
        println("Rest of the code is executing...")
    }
}
object MainObject{
    def main(args:Array[String]){
        var e = new ExceptionExample()
        e.divide(100,10)

    }
}

```

输出:

```
found a unknown exceptionjava.lang.ArrayIndexOutOfBoundsException: 10
Rest of the code is executing...

```