# Scala 抛出关键字

> 原文：<https://www.javatpoint.com/scala-throws-keyword>

Scala 提供了 throws 关键字来声明异常。可以用方法定义声明异常。它向调用方函数提供该方法可能引发此异常的信息。它有助于调用者函数处理并把代码封装在 try-catch 块中，以避免程序的异常终止。在 scala 中，您可以使用抛出关键字或抛出注释来声明异常。

## Scala抛出例子

```

class ExceptionExample4{
    @throws(classOf[NumberFormatException])
    def validate()={
        "abc".toInt
    }
}

object MainObject{
    def main(args:Array[String]){
        var e = new ExceptionExample4()
        try{
            e.validate()
        }catch{
            case ex : NumberFormatException => println("Exception handeled here")
        }
        println("Rest of the code executing...")
    }
}

```

输出:

```
Exception handeled here
Rest of the code executing...

```