# Scala 自定义异常

> 原文：<https://www.javatpoint.com/scala-custom-exception>

在 scala 中，您可以创建自己的异常。它也被称为自定义异常。声明自定义异常类时，必须扩展异常类。您可以在自定义类中创建自己的异常消息。我们来看一个例子。

## Scala 自定义异常示例

```
class InvalidAgeException(s:String) extends Exception(s){}
class ExceptionExample{
    @throws(classOf[InvalidAgeException])
    def validate(age:Int){
        if(age<18){
            throw new InvalidAgeException("Not eligible")
        }else{
            println("You are eligible")
        }
    }
}
object MainObject{
    def main(args:Array[String]){
        var e = new ExceptionExample()
        try{
            e.validate(5)
        }catch{
            case e : Exception => println("Exception Occured : "+e)
        }
    }
}

```

输出:

```
Exception Occured : InvalidAgeException: Not eligible

```