# Scala ListSet

> 原文：<https://www.javatpoint.com/scala-listset>

在 scala 中，ListSet 类使用基于列表的数据结构实现不可变的集合。元素以相反的插入顺序存储在内部，这意味着最新的元素位于列表的开头。它保持插入顺序。

该集合仅适用于少量元素。您可以通过调用构造函数或应用函数 ListSet.empty 来创建空的 ListSet。它的迭代和遍历方法访问元素的顺序与元素首次插入的顺序相同。

* * *

## Scala 列表集示例

```

import scala.collection.immutable._
object MainObject{
    def main(args:Array[String]){
        var listset = ListSet(4,2,8,0,6,3,45)
        listset.foreach((element:Int) => println(element+" "))
    }
}

```

输出:

```
4 
2 
8 
0 
6 
3 
45

```

* * *

### Scala 列表集示例:创建列表集并添加元素

```

import scala.collection.immutable._
object MainObject{
    def main(args:Array[String]){
        var listset:ListSet[String] = new ListSet()                 // Creating empty ListSet by using constructor
        var listset2:ListSet[String] = ListSet.empty                // Creating an empty listset
        println("listset: "+listset)
        println("listset2: "+listset2)
        println("After adding new elements:")
        listset+="India"            // Adding new element
        listset2+="Russia"          // Adding new element
        println("listset: "+listset)
        println("listset2: "+listset2)
    }
}

```

输出:

```
listset: ListSet()
listset2: ListSet()
After adding new elements:
listset: ListSet(India)
listset2: ListSet(Russia)

```