# 序列比例

> 原文：<https://www.javatpoint.com/scala-seq>

Seq 是一个特征，它代表了保证不变的索引序列。您可以使用元素的索引来访问元素。它保持元素的插入顺序。

序列支持许多方法来查找元素或子序列的出现。它返回一个列表。

* * *

## Scala 序列示例

在下面的例子中，我们正在创建 Seq 并从 Seq 访问元素。

```

import scala.collection.immutable._
object MainObject{
    def main(args:Array[String]){
        var seq:Seq[Int] = Seq(52,85,1,8,3,2,7)
        seq.foreach((element:Int) => print(element+" "))
        println("\nAccessing element by using index")
        println(seq(2))
    }
}

```

输出:

```
52 85 1 8 3 2 7 
Accessing element by using index
1

```

您也可以使用反向方法以相反的顺序访问元素。下面我们已经列出了一些常用的方法和它们的描述。

* * *

### 序列的常用方法

| 方法 | 描述 |
| def 包含[A1 >: A](elem: A1):布尔值 | 检查给定元素是否出现在该序列中。 |
| def copyToArray(xs: Array[A]，start: Int，len: Int):单位 | 它将 seq 元素复制到数组中。 |
| 用[B]定义结束(即:geneq[B]):布尔值 | 它测试这个序列是否以给定的序列结束。 |
| 定义标题:A | 它选择这个 seq 集合的第一个元素。 |
| 定义索引任务(elem: A): Int | 它找到这个不可变序列中第一次出现的值的索引。 |
| def isEmpty: Boolean | 它测试这个序列是否为空。 |
| def lastIndexOf(elem: A): Int | 它找到这个不可变序列中最后一个值的索引。 |
| def 反向:序列[A] | 它以相反的顺序返回带有元素的新序列。 |

* * *

## Scala 序列示例

在这个例子中，我们应用了 Seq trait 的一些预定义方法。

```

import scala.collection.immutable._
object MainObject{
    def main(args:Array[String]){
        var seq:Seq[Int] = Seq(52,85,1,8,3,2,7)
        seq.foreach((element:Int) => print(element+" "))
        println("\nis Empty: "+seq.isEmpty)
        println("Ends with (2,7): "+ seq.endsWith(Seq(2,7)))
        println("contains 8: "+ seq.contains(8))
        println("last index of 3 : "+seq.lastIndexOf(3))
        println("Reverse order of sequence: "+seq.reverse)
    }
}

```

输出:

```
52 85 1 8 3 2 7 
is Empty: false
Ends with (2,7): true
contains 8: true
last index of 3 : 4
Reverse order of sequence: List(7, 2, 3, 8, 1, 85, 52)

```