# 标量向量

> 原文：<https://www.javatpoint.com/scala-vector>

Vector 是一种通用的、不可变的数据结构。它提供对元素的随机访问。它有利于大量元素的收集。

它扩展了抽象类 AbstractSeq 和 IndexedSeq 的特性。

* * *

## 标量向量示例

```

import scala.collection.immutable._
object MainObject{
    def main(args:Array[String]){
        var vector:Vector[Int] = Vector(5,8,3,6,9,4) //Or
        var vector2 = Vector(5,2,6,3)
        var vector3 = Vector.empty
        println(vector)
        println(vector2)
        println(vector3)
    }
}

```

输出:

```
Vector(5, 8, 3, 6, 9, 4)
Vector(5, 2, 6, 3)
Vector(

```

* * *

## 标量向量示例

在下面的例子中，我们创建了一个向量。您也可以添加新元素并合并两个向量。

```

import scala.collection.immutable._
object MainObject{
    def main(args:Array[String]){
        var vector = Vector("Hocky","Cricket","Golf")
        var vector2 = Vector("Swimming")
        print("Vector Elements: ")
        vector.foreach((element:String) => print(element+" "))
        var newVector  = vector :+ "Racing" 							// Adding a new element into vector
        print("\nVector Elements after adding: ")
        newVector.foreach((element:String) => print(element+" "))
        var mergeTwoVector = newVector ++ vector2   					// Merging two vector
        print("\nVector Elements after merging: ")
        mergeTwoVector.foreach((element:String) => print(element+" "))
        var reverse = mergeTwoVector.reverse       	 					// Reversing vector elements
        print("\nVector Elements after reversing: ")
        reverse.foreach((element:String) => print(element+" "))
        var sortedVector = mergeTwoVector.sorted    					// Sorting vector elements
        print("\nVector Elements after sorting: ")
        sortedVector.foreach((element:String) => print(element+" "))
    }
}

```

输出:

```
Vector Elements: Hocky Cricket Golf 
Vector Elements after adding: Hocky Cricket Golf Racing 
Vector Elements after merging: Hocky Cricket Golf Racing Swimming 
Vector Elements after reversing: Swimming Racing Golf Cricket Hocky 
Vector Elements after sorting: Cricket Golf Hocky Racing Swimming

```