# Scala列表

> 原文：<https://www.javatpoint.com/scala-list>

列表用于存储有序元素。它扩展了线性序列特性。这是一个不可变链表的类。这个类适合后进先出(LIFO)，类似堆栈的访问模式。

它维护元素的顺序，也可以包含重复的元素。

* * *

## Scala 列表示例

在本例中，我们创建了两个列表。这里，两个列表创建列表的语法不同。

```

import scala.collection.immutable._
object MainObject{
    def main(args:Array[String]){
       var list = List(1,8,5,6,9,58,23,15,4)
        var list2:List[Int] = List(1,8,5,6,9,58,23,15,4)
        println(list)
        println(list2)
    }
}

```

输出:

```
List(1, 8, 5, 6, 9, 58, 23, 15, 4)
List(1, 8, 5, 6, 9, 58, 23, 15, 4)

```

* * *

## Scala 列表示例:应用预定义方法

```

import scala.collection.immutable._
object MainObject{
    def main(args:Array[String]){
        var list = List(1,8,5,6,9,58,23,15,4)
        var list2 = List(88,100)
        print("Elements: ")
        list.foreach((element:Int) => print(element+" "))		// Iterating using foreach loop
        print("\nElement at 2 index: "+list(2))  			// Accessing element of 2 index
        var list3 = list ++ list2                   			// Merging two list
        print("\nElement after merging list and list2: ")
        list3.foreach((element:Int)=>print(element+" "))    
        var list4 = list3.sorted                   			// Sorting list
        print("\nElement after sorting list3: ")
        list4.foreach((element:Int)=>print(element+" "))  
        var list5 = list3.reverse                  			// Reversing list elements
        print("\nElements in reverse order of list5: ")
        list5.foreach((element:Int)=>print(element+" "))  

    }
}

```

输出:

```
Elements: 1 8 5 6 9 58 23 15 4 
Element at 2 index: 5
Element after merging list and list2: 1 8 5 6 9 58 23 15 4 88 100 
Element after sorting list3: 1 4 5 6 8 9 15 23 58 88 100 
Elements in reverse order of list5: 100 88 4 15 23 58 9 6 5 8 1

```