# Scala河

> 原文：<https://www.javatpoint.com/scala-stream>

Stream 是一个惰性列表。它只在需要的时候计算元素。这是 scala 的一个特性。Scala 支持惰性计算。它提高了程序的性能。

* * *

## Scala 流示例

在下面的程序中，我们创建了一个流。

```

object MainObject{
    def main(args:Array[String]){
        val stream = 100 #:: 200 #:: 85 #:: Stream.empty
        println(stream)
    }
}

```

输出:

```
Stream(100, ?)

```

在输出中，您可以看到第二个元素没有被计算。这里，显示一个问号来代替元素。Scala 直到需要时才计算列表。

* * *

### Scala 流示例:应用预定义的方法

在下面的例子中，我们使用了一些预定义的方法，比如用于迭代流元素的 toStream。

```

import scala.collection.immutable._
object MainObject{
    def main(args:Array[String]){
        var stream = 100 #:: 200 #:: 85 #:: Stream.empty
        println(stream)
        var stream2 = (1 to 10).toStream
        println(stream2)
        var firstElement = stream2.head
        println(firstElement)
        println(stream2.take(10))
        println(stream.map{_*2})
    }
}

```

输出:

```
Stream(100, ?)
Stream(1, ?)
1
Stream(1, ?)
Stream(200, ?)

```