# Scala地图

> 原文：<https://www.javatpoint.com/scala-maps>

Map 用于存储元素。它以键和值对的形式存储元素。在 scala 中，您可以通过两种方式创建 map，一种是使用逗号分隔的对，另一种是使用 rocket 运算符。

* * *

## Scala地图示例

在下面的例子中，我们有两种方法来创建地图。

```

object MainObject{
    def main(args:Array[String]){
        var map = Map(("A","Apple"),("B","Ball"))
        var map2 = Map("A"->"Aple","B"->"Ball")
        var emptyMap:Map[String,String] = Map.empty[String,String] 
        println(map)
        println(map2)
        println("Empty Map: "+emptyMap)
    }
}

```

输出:

```
Map(A -> Apple, B -> Ball)
Map(A -> Aple, B -> Ball)
Empty Map: Map()

```

* * *

### Scala 映射示例:添加和移除元素

您可以在地图中添加和删除新元素。Scala 为您提供了许多预定义的方法。您可以使用它们在地图上执行操作。在下面的示例中，我们创建了一个新的地图。

```

object MainObject{
    def main(args:Array[String]){
        var map = Map("A"->"Apple","B"->"Ball")             // Creating map
        println(map("A"))              				 // Accessing value by using key
        var newMap = map+("C"->"Cat")       			  // Adding a new element to map
        println(newMap)
        var removeElement = newMap - ("B")     			  // Removing an element from map
        println(removeElement)
    }
}

```

输出:

```
Apple
Map(A -> Apple, B -> Ball, C -> Cat)
Map(A -> Apple, C -> Cat)

```