# Scala HashMap

> 原文：<https://www.javatpoint.com/scala-hashmap>

HashMap 用于存储元素。它使用哈希代码存储元素并返回一个映射。

* * *

## 哈希表示例

在这个例子中，我们已经创建了一个 HashMap。

```

import scala.collection.immutable._
object MainObject{
    def main(args:Array[String]){
        var hashMap = new HashMap()
        var hashMap2 = HashMap("A"->"Apple","B"->"Ball","C"->"Cat")
        println(hashMap)
        println(hashMap2)
    }
}

```

输出:

```
Map()
Map(A -> Apple, B -> Ball, C -> Cat)

```

* * *

### Scala HashMap 示例:添加和访问元素

在下面的例子中，我们已经创建了一个 HashMap。这个程序添加元素和访问元素。

```

import scala.collection.immutable._
object MainObject{
    def main(args:Array[String]){
        var hashMap = HashMap("A"->"Apple","B"->"Ball","C"->"Cat")
        hashMap.foreach {
            case (key, value) => println (key + " -> " + value)		// Iterating elements
        }
        println(hashMap("B"))				// Accessing value by using key
        var newHashMap = hashMap+("D"->"Doll")
        newHashMap.foreach {
            case (key, value) => println (key + " -> " + value)
        }

    }
}

```

输出:

```
A -> Apple
B -> Ball
C -> Cat
Ball
A -> Apple
B -> Ball
C -> Cat
D -> Doll

```