# ListMap 比例

> 哎哎哎:# t0]https://www . javatppoint . com/scale-list map

这个类通过使用基于列表的数据结构来实现不可变映射。它保持插入顺序并返回列表映射。这个系列适合小元素。

您可以通过调用其构造函数或使用 ListMap.empty 方法来创建空的 ListMap。

* * *

## Scala 列表映射示例

在这个例子中，我们已经创建了一个空的列表映射和非空的列表映射。

```

import scala.collection.immutable._
object MainObject{
    def main(args:Array[String]){
        var listMap = ListMap("Rice"->"100","Wheat"->"50","Gram"->"500")    // Creating listmap with elements
        var emptyListMap = new ListMap()            // Creating an empty list map
        var emptyListMap2 = ListMap.empty           // Creating an empty list map
        println(listMap)
        println(emptyListMap)
        println(emptyListMap2)
    }
}

```

输出:

```
ListMap(Rice -> 100, Wheat -> 50, Gram -> 500)
ListMap()
ListMap()

```

* * *

### Scala 列表映射示例:应用基本操作

```

import scala.collection.immutable._
object MainObject{
    def main(args:Array[String]){
        var listMap = ListMap("Rice"->"100","Wheat"->"50","Gram"->"500")    // Creating listmap with elements
        listMap.foreach{
            case(key,value)=>println(key+"->"+value)
        }
        println(listMap("Gram"))
        var newListMap = listMap+("Pulses"->"550")
        newListMap.foreach {
            case (key, value) => println (key + " -> " + value)
        }   
    }
}

```

输出:

```
Rice->100
Wheat->50
Gram->500
500
Rice -> 100
Wheat -> 50
Gram -> 500
Pulses -> 550

```