# 元组比例

> 原文：<https://www.javatpoint.com/scala-tuples>

元组是有序形式的元素集合。如果不存在元素，则称为空元组。您可以使用元组来存储任何类型的数据。您也可以存储类似类型或混合类型的数据。您可以使用它从函数中返回多个值

* * *

## 标量元组示例

在下面的例子中，我们已经创建了不同类型元素的元组。

```
object MainObject{
    def main(args:Array[String]){
        var tuple = (1,5,8,6,4)     				// Tuple of integer values
        var tuple2 = ("Apple","Banana","Gavava")    	// Tuple of string values
        var tuple3 = (2.5,8.4,10.50)    			// Tuple of float values
        var tuple4 = (1,2.5,"India")    			// Tuple of mix type values
        println(tuple)
        println(tuple2)
        println(tuple3)
        println(tuple4)
    }
}

```

输出:

```
(1,5,8,6,4)
(Apple,Banana,Gavava)
(2.5,8.4,10.5)
(1,2.5,India)

```

* * *

### Scala 元组示例:访问元组元素

在这个例子中，我们使用索引来访问元组元素。这里，我们使用 productIterator 来迭代元组元素。

```
object MainObject{
    def main(args:Array[String]){
        var tupleValues = (1,2.5,"India")
        println("iterating values: ")
        tupleValues.productIterator.foreach(println)    // Iterating tuple values using productIterator
        println("Accessing values: ")
        println(tupleValues._1) // Fetching first value
        println(tupleValues._2) // Fetching second value
    }
}

```

输出:

```
iterating values: 
1
2.5
India
Accessing values: 
1
2.5

```