# Scala 文件处理

> 原文：<https://www.javatpoint.com/scala-file-handling>

Scala 提供了预定义的方法来处理文件。您可以创建、打开、写入和读取文件。Scala 为文件处理提供了一个完整的包 **scala.io** 。

在本章中，我们将详细讨论所有这些文件操作。

* * *

## 创建文件示例

Scala 不提供文件写入方法。因此，您必须使用 Java PrintWriter 或 FileWriter 方法。

```
import java.io._
val fileObject = new File("ScalaFile.txt" )		// Creating a file
val printWriter = new PrintWriter(fileObject)		// Passing reference of file to the printwriter
printWriter.write("Hello, This is scala file")	// Writing to the file
printWriter.close()				// Closing printwriter

```

上面的代码将创建一个文本文件 ScalaFile.txt .创建文件后 printwriter 用于将内容写入这个文件。

### Scala 读取文件示例:读取每个字符

```
import scala.io.Source

object MainObject{
  def main(args:Array[String]){
    val filename = "ScalaFile.txt"
    val fileSource = Source.fromFile(filename)
    while(fileSource.hasNext){
      println(fileSource.next)
    }
    fileSource.close()
  }
}

```

输出:

```
H
e
l
l
o
,

T
h
i
s

i
s

s
c
a
l
a

f
i
l
e

```

Scala 提供文件读取方法。在上面的代码中，我们已经导入了 scala.io 包，并且使用 Source 类来访问文件相关的方法，比如 fromFile()。

使用 close()方法读取或写入文件后，必须关闭文件引用。

* * *

### Scala 读取文件示例:读取每一行

```
import scala.io.Source
object MainObject{
  def main(args:Array[String]){
    val filename = "ScalaFile.txt"
    val fileSource = Source.fromFile(filename)
    for(line<-fileSource.getLines){
      println(line)
    }
    fileSource.close()
  }
}

```

输出:

```
Hello, This is scala file

```

除了所有类型的文件处理操作，您还需要使用 java.io 包来访问文件方法。