# Ruby的特性

> 原文：<https://www.javatpoint.com/ruby-features>

Ruby 语言有很多特性。其中一些解释如下:

![Features of Ruby](img/40c89645838e5a8a46e4165976d36c16.png)

*   面向对象的
*   灵活性
*   表达特征
*   混入类
*   目视现象
*   动态打字和鸭式打字
*   异常处理
*   垃圾收集工
*   轻便的
*   关键词
*   语句分隔符
*   可变常数
*   命名规格
*   关键字参数
*   方法名
*   单一方法
*   缺少方法
*   区分大小写

### 面向对象的

Ruby 是纯面向对象的编程语言。每个值都是一个对象。每个对象都有一个类，每个类都有一个超级类。每个代码都有它们的属性和动作。Ruby 受到 Smalltalk 语言的影响。适用于对象的规则适用于整个 Ruby。

* * *

### 灵活性

Ruby 是一种灵活的语言，因为您可以轻松地移除、重新定义或添加现有的部分。它允许它的用户随意改变它的部分。

* * *

### 混入类

Ruby 只有单一继承的特性。Ruby 有类也有模块。模块有方法，但没有实例。相反，可以将一个模块混合到一个类中，该类将该模块的方法添加到该类中。它类似于继承，但更灵活。

* * *

### 目视现象

Ruby 一般比较喜欢英文关键词，一些标点符号用来修饰 Ruby。它不需要变量声明。

* * *

### 动态打字和鸭式打字

Ruby 是一种动态编程语言。Ruby 程序不编译。所有的类、模块和方法定义都是由运行时的代码构建的。

Ruby 变量是松散类型的语言，这意味着任何变量都可以容纳任何类型的对象。当对一个对象调用一个方法时，Ruby 只查找名称，而不考虑对象的类型。这是鸭子打字。它允许你创建假装成其他类的类。

* * *

### 可变常数

在 Ruby 中，常数并不是真正的常数。如果一个已经初始化的常量将在脚本中被修改，它只会触发一个警告，但不会停止你的程序。

* * *

### 命名规格

Ruby 为其变量、方法、常量和类定义了一些命名约定。

*   **常量:**以大写字母开头。
*   **全局变量:**以美元符号($)开头。
*   **实例变量:**以(@)符号开头。
*   **类变量:**以符号(@@)开头。
*   **方法名:**允许以大写字母开头。

### 关键字参数

像 Python 一样，Ruby 方法也可以使用关键字参数来定义。

* * *

### 方法名

方法允许以问号(？)或感叹号(！).按照惯例，回答问题的方法以问号结尾，指示该方法可以更改对象状态的方法以感叹号结尾。

* * *

### 单一方法

Ruby singleton 方法是针对每个对象的方法。它们仅在您定义的对象上可用。

* * *

### 缺少方法

如果一个方法丢失了，Ruby 用丢失方法的名字调用**方法 _missing** 方法。

* * *

### 语句分隔符

单行中的多条语句必须在中间包含分号，但不能在行尾包含分号。

* * *

### 关键词

在 Ruby 中，大约有 42 个关键字不能用于其他目的。它们被称为保留词。

* * *

### 区分大小写

Ruby 是一种区分大小写的语言。小写字母和大写字母是不同的。