# Ruby运算符

> 原文：<https://www.javatpoint.com/ruby-operators>

Ruby 有一套内置的现代运算符。运算符是用于执行不同操作的符号。例如，+，-，/，*，等等。

* * *

## 操作员类型:

*   一元运算符
*   算术运算符
*   按位运算符
*   逻辑算子
*   三元算子
*   赋值运算符
*   比较运算符
*   距离操作手

* * *

## 一元运算符

一元运算符需要运行一个操作数。

| 操作员 | 描述 |
| ！ | 布尔非 |
| ~ | 逐位补码 |
| + | 一元加号 |

**例**

在 hello.rb 文件中，编写以下代码。

```
#!/usr/bin/ruby -w 

 puts("Unary operator") 
 puts(~5) 
 puts(~-5) 
 puts(!true) 
 puts(!false) 

```

输出:

![Ruby operators 1](img/c975fb925f0f08e3edcd25b3bf4b1ef1.png)

* * *

## 算术运算符

Airthmetic 运算符将数值作为操作数，并在单个值中返回它们。

| 操作员 | 描述 |
| + | 将运算符两边的值相加。 |
| - | 从运算符的两边减去值。 |
| / | 用右侧操作数除左侧操作数。 |
| * | 将运算符两边的值相乘。 |
| ** | 右侧操作数成为左侧操作数的指数。 |
| % | 用返回余数的右侧操作数除左侧操作数。 |

**例**

在 hello.rb 文件中，编写以下代码。

```
#!/usr/bin/ruby -w 

 puts("add operator") 
 puts(10 + 20)    
 puts("subtract operator") 
 puts(35 - 15)  
 puts("multiply operator") 
 puts(4 * 8) 
 puts("division operator") 
 puts(25 / 5) 
 puts("exponential operator") 
 puts(5 ** 2) 
 puts("modulo operator") 
 puts(25 % 4) 

```

输出:

![Ruby operators 2](img/b2fb06671e4a63eea81194fb2ba14352.png)

* * *

## 按位运算符

按位运算符处理位操作数。

| 操作员 | 描述 |
| & | 逻辑积算符 |
| &#124; | 或运算符 |
| << | 左移操作符 |
| > >
 | 右移位运算符 |
| ^ | 异或运算符 |
| ~ | 求补算符 |

* * *

## 逻辑算子

逻辑运算符处理位操作数。

| 操作员 | 描述 |
| && | 逻辑积算符 |
| &#124;&#124; | 或运算符 |

* * *

## 三元算子

三元运算符首先检查给定的条件是真还是假，然后执行该条件。

| 操作员 | 描述 |
| ？： | 条件表达式 |

**例**

在 hello.rb 文件中，编写以下代码。

```
#!/usr/bin/ruby -w 

 puts("Ternary operator") 
 puts(2<5 ? 5:2) 
 puts(5<2 ? 5:2) 

```

输出:

![Ruby operators 3](img/b23b665fc32c0f5de157619bc9de513c.png)

* * *

## 赋值运算符

赋值运算符给操作数赋值。

| 操作员 | 描述 |
| = | 简单赋值运算符 |
| += | 添加赋值运算符 |
| -= | 减法赋值运算符 |
| *= | 乘法赋值运算符 |
| /= | 除法赋值运算符 |
| %= | 模数赋值运算符 |
| **= | 指数赋值算子 |

* * *

## 比较运算符

比较运算符比较两个操作数。

| 操作员 | 描述 |
| == | 相等算子 |
| ！= | 不等运算符 |
| > | 左操作数大于右操作数
 |
| <
 | 右操作数大于左操作数 |
| >= | 左操作数大于或等于右操作数 |
| <= | 右操作数大于或等于左操作数 |
| <=> | 组合比较运算符 |
| 。eql？ | 检查操作数的相等性和类型 |
| 平等？ | 检查对象标识 |

**例**

在 hello.rb 文件中，编写以下代码。

```
#!/usr/bin/ruby -w 

 puts("Comparison operator") 
 puts(2 == 5) 
 puts(2 != 5) 
 puts(2 > 5) 
 puts(2 < 5) 
 puts(2 >= 5) 
 puts(2 <= 5) 

```

输出:

![Ruby operators 4](img/927d9d1a58886eec7b67095f41e1d6e7.png)

* * *

## 距离操作手

范围运算符创建一个连续值的范围，该范围由开始值、结束值和中间值的范围组成。

该(..)创建一个包含最后一项和(...)创建一个不包括最后一项的范围。

例如，对于范围 1..5，输出范围将从 1 到 5。

对于 1 的范围...输出范围从 1 到 4。

| 操作员 | 描述 |
| .. | 范围包括最后一项 |
| ... | 范围不包括最后一项 |

* * *