# Ruby类和对象

> 原文：<https://www.javatpoint.com/ruby-class-and-object>

在这里，我们将了解 Ruby 对象和类。在面向对象编程语言中，我们使用对象和类来设计程序。

对象既是物理实体也是逻辑实体，而类只是逻辑实体。

* * *

## Ruby对象

对象是所有 Ruby 对象的默认根。Ruby 对象继承自 **BasicObject** (它是 Ruby 中所有类的父类)，允许创建替代对象层次结构。

对象混合在内核模块中，这使得内置的内核函数可以全局访问。

* * *

## 创建对象

Ruby 中的对象是通过调用类的**新**方法创建的。它是一种独特类型的方法，并且在 Ruby 库中预定义。

Ruby 对象是类的实例。

**语法:**

```

objectName = className.new

```

**示例:**

我们有一个名为 **Java** 的类。现在，让我们创建一个对象 **java** 并用下面的命令来使用它，

```

java = Java.new("John")

```

![Ruby Class and object 1](img/908713475a2425d1c080a8ca950da2c1.png)

* * *

## Ruby类

每个 Ruby 类都是类**类**的一个实例。Ruby 中的类是一级对象。

Ruby 类总是以关键字 **class** 开头，后跟类名。按照惯例，对于类名，我们使用 CamelCase。类名应该总是以大写字母开头。定义类以**结束**关键字结束。

**语法:**

```

class ClassName
	codes...
end

```

**示例:**

![Ruby Class and object 2](img/b322eb632bd541ff16e0b67e120af547.png)

在上例中，我们使用 class 关键字创建了一个类 **Home** 。 **@love** 是一个实例变量，可用于类 Home 的所有方法。

* * *