# Ruby目录

> 原文：<https://www.javatpoint.com/ruby-directories>

类目录将目录流作为对象，表示基础文件系统中的目录。

目录由目录类处理。

* * *

## 创建目录

使用 mkdir 命令创建目录。如果需要，您可以授予目录权限。

**语法:**

```
Dir.mkdir "dirName" , permission

```

**示例:**

```
Dir.mkdir "project"

```

我们在我们的系统中创建了一个目录“项目”。

* * *

## 检查目录是否存在

检查目录是否存在？方法。

**语法:**

```
puts Dir.exists? "dirName"

```

**示例:**

```
#!/usr/bin/ruby 

puts Dir.exists? "project" 
puts Dir.exists? "pproject" 

```

输出:

![Ruby directories 1](img/cf8ecb61de246a50e2f26aa752443a12.png)

正确目录名显示为真，错误的目录名显示为假。

* * *

## 当前工作目录

要知道当前工作目录使用的是 pwd 方法。

**语法:**

```
puts Dir.pwd

```

**示例:**

```
puts Dir.pwd 

```

输出:

![Ruby directories 2](img/b29d1c52456effec1d7007c4226a73b7.png)

* * *

## 删除目录

要删除目录，可以使用 rmdir、unlink 或 delete 方法。它们对 Ruby 目录执行相同的功能。

**语法:**

```
Dir.rmdir "dirName"

```

**示例:**

```
#!/usr/bin/ruby 

Dir.rmdir "project" 
puts Dir.exists? "project"

```

输出:

![Ruby directories 3](img/e509f340945ebe88b490b9709fe4c60a.png)

exists 方法返回 false，因为此目录不再存在。

* * *