# Ruby 正则表达式

> 原文：<https://www.javatpoint.com/ruby-regular-expression>

正则表达式也被拼写为**正则表达式**，它包含一个正则表达式，用于匹配字符串的模式。在 Ruby 中，一个模式写在正斜杠字符之间。它们描述字符串的内容。Ruby 正则表达式更类似于 Perl 正则表达式。

**语法:**

```
/search string/

```

Ruby 1.9 使用 **Oniguruma** 正则表达式库，但是 Ruby 2.0 使用 **Onigmo** 正则表达式库。Onigmo 是 Oniguruma 的一个分叉库，增加了一些新特性。

* * *

## = &bsim;和#match 运算符

模式匹配是通过使用= &bsim;和#match 运算符来实现的。

**=&bsim；**

这是基本的匹配模式。这里使用了两个操作数。一个是正则表达式，另一个是字符串。正则表达式与字符串匹配。

如果找到匹配，运算符返回第一个匹配的索引，否则返回零。

**示例:**

![Ruby Regular expression 1](img/56e04b85cbc54595d378d4dace8a9aa6.png)

* * *

## #匹配

此运算符在匹配时返回一个匹配数据对象，否则返回零。

![Ruby Regular expression 2](img/7d373358c57982d7783f891b7010cd56.png)

* * *

## 元字符和转义

元字符在模式中有特定的含义。为了匹配字符串，它们被反斜杠(\\\)或转义。一些元字符是(，，(。), (?), (+), (-), (*), [,], {,}.

如果匹配，则返回特定的字符串。

**示例:**

![Ruby Regular expression 3](img/883e2695221104ffe57d5acaebc5f7bc.png)

* * *

## 字符类

元字符在模式中有特定的含义。为了匹配字符串，它们被反斜杠(\\\)或转义。

字符类用方括号括起来。

**【ab】**

这里，[ab]是 a 或 b 的意思。它是/ab/的 oppoite，意思是 a 和 b

**示例:**

![Ruby Regular expression 4](img/cd82b5bbe6446136f3b10ece153b02e8.png)

**【a-d】**

这里，[a-d]相当于[abcd]。连字符(-)字符类代表字符范围。

**示例:**

![Ruby Regular expression 5](img/0e99c153f3c9a3361433ddcd3e11d8ae.png)

**[ &有；a-d]〔t1〕**

&Hat;符号代表范围内不存在的任何其他字符。

**示例:**

![Ruby Regular expression 6](img/852070714012f5984f45ca0d4a65eae8.png)

* * *

## 重复

到目前为止定义的字符只匹配一个字符。借助 repeat 元字符，我们可以指定它们需要出现多少次。这些元字符被称为**量词。**

*   *:零次或更多次
*   +:一次或多次
*   ？:零次或一次(可选)
*   {n}:正好 n 次
*   {n，}: n 次或更多次
*   {，m}: m 次或更少
*   {n，m}:至少 n 次，最多 m 次

**示例:**

![Ruby Regular expression 7](img/d6d0b9b05234e79e0e27abc8f165d20c.png)

* * *

## 分组

分组使用括号将术语分组在一起。把这些术语组合在一起就成了一个整体。

**示例:**

![Ruby Regular expression 8](img/133729048351bd2394d6480cdae50b96.png)

在这个例子中，第一个模式匹配一个元音后跟两个字符。

在第二种模式中，它匹配一个元音后跟一个单词字符，两次。

**(？：..)**

此表达式提供分组而不捕获。它组合术语而不创建反向引用。

**示例:**

![Ruby Regular expression 9](img/908344666d9df3ef235bb7e9c137a24d.png)