# 转到数据类型

> 原文：<https://www.javatpoint.com/go-data-types>

变量可以是不同的类型，如 int、float、struct、slice，也可以是接口类型。

声明变量的一般形式使用关键字 var:

语法:-

```
var identifier type

```

**例**

```
var a int
var b bool
var str string

```

当变量用 var 声明时，它会自动将其初始化为为其类型定义的零值。类型定义了一组值以及可以对这些值进行的一组操作。

**GO 简单数据类型示例**

```
package main
import "fmt"
func main() {
   var i int
   var f float64
   var b bool
   var s string
   fmt.Printf("%T %T %T %T\n",i,f,b,s) // Prints type of the variable
   fmt.Printf("%v   %v      %v  %q     \n", i, f, b, s) //prints initial value of the variable
}

```

输出:

```
int float64 bool string
0   0           false  ""    

```

* * *

## 转到构造和数据类型

Go 源代码存储在中。去归档。文件名由小写字母组成。如果文件名有几个部分，应该用下划线“_”隔开。

Go 文件有一个像 c 一样区分大小写的名称或标识符

**例如:** a、ax123、I 等。

标识符是特殊的。它被称为空白标识符。它可以用在变量声明中。

它就像普通的标识符，但是它的值被丢弃了，所以它不能在代码中再使用了。

变量、类型或函数可能没有名称，甚至会增强灵活性，因此称为匿名。

以下是 Go-code 的 25 个关键词:

| 破裂 | 系统默认值 | 功能 | 连接 | 挑选 |
| 情况 | 推迟 | 去 | 地图 | 结构体 |
| 陈 | 其他 | 转到 | 包裹 | 转换 |
| 常数 | 失败 | 如果 | 范围 | 类型 |
| 继续 | 为 | 进口 | 返回 | 定义变量 |

程序由关键字、常量、变量、运算符、类型和函数组成。

下列分隔符用在诸如括号( )、括号[ ]和大括号{ }等结构中。

以下标点符号。, ;:和...被使用。

| 附加 | 弯曲件 | 字节 | 帽子 | 关闭 | 复杂的 | 复杂 64 | 复杂 128 | uint16 |
| 复制 | 错误的 | 浮动 32 | float64 | 乳内动脉移植 | （同 Internationalorganizations）国际组织 | int8 | int16 | uint32 |
| int32 | int64 | 极微小 | 低输入联网（low-entry networking 的缩写） | 制造 | 新的 | 无 | 恐慌 | uint64 |
| 打印 | 印本 | 真实的 | 恢复 | 线 | 真实的 | 无符号整型 | uint8 | Uintptr |

Next Topic[Go Package](go-package-import-visibility)