# 转到打包、导入和可见性

> 原文：<https://www.javatpoint.com/go-package-import-visibility>

## 包装

软件包用来对我们的程序进行分类，以便于维护。每个档案都属于某个包裹。每个 Go 应用程序必须有*“主”*包，以便进行编译。

一个应用程序可以由不同的包组成。很多不同的。go 文件可以属于一个主包。

我们可以用任何名字保存 Go 程序，但它必须有主包。包名应该用小写字母书写。

如果一个包被更改并重新编译，所有使用这个包的客户端程序也必须重新编译！

## 导入

一个 Go 程序通过**导入关键字链接到不同的包。**

包名用双引号""括起来。导入从编译的包中加载公共声明，它不插入源代码。

我们可以通过单独的语句导入多个包，如:

```

import "fmt"
	 import "os"

```

或者:

```

import "fmt"; import "os"

```

我们也可以用更短的方式比如:

```

import (
	 "fmt"
	 "os"
)

```

它甚至可以更短:

```

import("fmt"; "os"

```

## 能见度

标识符可以是变量、常量、函数、类型或结构字段。我们可以用小写或大写字母来声明标识符。

如果我们用小写字母声明标识符，它将只在包中可见。但是如果我们用大写字母声明包，它将在包的内部和外部可见，这也称为导出。

圆点。操作员用于访问标识符，例如包装。年龄，其中包装是包装名称，年龄是标识符。