# Go 开关

> 原文：<https://www.javatpoint.com/go-switch>

Go **开关语句**从多个条件中执行一个语句。它类似于 if-else-if 链语句。

语法:

```

switch  var1 {
case val1:
.....
case val2
.....
default:
.....
}

```

Go 中的 switch 语句更加灵活。在上面的语法中，var1 是可以是任何类型的变量，val1，val2，...是 var1 的可能值。

在 switch 语句中，一个案例中可以测试多个值，这些值以逗号分隔列表的形式呈现

**像:**例 val1、val2、val3:

如果有匹配的案例，则执行相应的案例语句。这里，break 关键字是隐式的。所以自动掉线不是 Go switch 语句的默认行为。

对于 Go switch 语句中的 fall-through，使用分支末尾的关键字“fall-through”。

**Go 开关示例:**

```

package main
import "fmt"
func main() {
   fmt.Print("Enter Number: ")
  var input int
  fmt.Scanln(&input)
   switch (input) {
  case 10:
      fmt.Print("the value is 10")
    case 20:
      fmt.Print("the value is 20")
    case 30:
      fmt.Print("the value is 30")
    case 40:
      fmt.Print("the value is 40")
    default:
      fmt.Print(" It is not 10,20,30,40 ")
   }
}

```

输出:

```
Enter Number: 20
the value is 20

```

**或**

输出:

```
Enter Number: 35
 It is not 10,20,30,40

```

**Go 切换失败示例**

```

import "fmt"
func main() {
   k := 30
   switch k {
   case 10:
      fmt.Println("was <= 10"); fallthrough;
   case 20:
      fmt.Println("was <= 20"); fallthrough;
   case 30:
      fmt.Println("was <= 30"); fallthrough;
   case 40:
      fmt.Println("was <= 40"); fallthrough;
   case 50:
      fmt.Println("was <= 50"); fallthrough;
   case 60:
      fmt.Println("was <= 60"); fallthrough;
   default:
      fmt.Println("default case")
   }
}

```

输出:

```
was <= 30
was <= 40
was <= 50
was <= 60
default case

```