# 转到循环

> 原文：<https://www.javatpoint.com/go-for>

Go for 语句用于多次重复一组语句。这是 go 语言中唯一的循环。

Go 中 for 循环有两种变体:计数器控制迭代和条件控制迭代。

当循环执行结束时，在循环中创建的对象会被销毁。

**进行循环计数器控制的迭代示例:**

```

package main
import "fmt"
func main() {
   for a := 0; a < 11; a++ {
      fmt.Print(a,"\n")
   }
}

```

输出:

```
0
1
2
3
4
5
6
7
8
9
10

```

如上例所示，循环从初始化阶段开始，变量为 I(I:= 0)；这种情况只发生一次。其后是条件检查 i (i < 10)。条件检查在每次迭代中执行。当条件变为假时，for 循环停止。

**嵌套循环示例:**

```

package main
import "fmt"
func main() {
   for a := 0; a < 3; a++ {
      for b := 3;b > 0; b-- {
         fmt.Print(a," ",b,"\n")
      }
   }
}

```

输出:

```
0 3
0 2
0 1
1 3
1 2
1 1
2 3
2 2
2 1

```

**转到无限循环**

在无限 for 循环中，条件语句是不存在的，如:

```

for i:=0; ; i++ 

```

**或**

```

for { }

```

转到**不定式 For Loop 示例:**

```
package main
import "fmt"
func main() {
   for true  {
      fmt.Printf("This loop will run forever.\n");
   }
}

```

输出:

```
This loop will run forever.
This loop will run forever.
This loop will run forever.
This loop will run forever.
This loop will run forever.
This loop will run forever.
This loop will run forever.

```

**进入条件控制迭代**

没有头的 for 循环用于条件控制的迭代。它类似于其他语言中的 while-loop。

语法:

```

for condition { }

```

**时尚中的循环示例:**

```

package main
import "fmt"
func main() {
   sum := 1
   for sum < 100 {
      sum += sum
      fmt.Println(sum)
   }
}

```

输出:

```
2
4
8
16
32
64
128

```