# Go Break 语句

> 原文：<https://www.javatpoint.com/go-break>

break 语句用于脱离它所在的最内部结构。它可以用于 for 循环(计数器、条件等)。)，而且还换了一个开关。在该结构结束后继续执行。

语法:-

```

break;

```

**Go Break 语句示例:**

```

package main
import "fmt"
func main() {
   var  a int = 1
   for a < 10{
      fmt.Print("Value of a is ",a,"\n")
      a++;
      if a > 5{
         /* terminate the loop using break statement */
         break;
      }
   }
}

```

输出:

```
Value of a is 1
Value of a is 2
Value of a is 3
Value of a is 4
Value of a is 5

```

Break 语句也可以应用于内部循环，并且控制流会中断到外部循环。

**带内环的 Go Break 语句:**

```

package main
import "fmt"
func main() {
   var a int
   var b int
   for a = 1; a <= 3; a++ {
      for b = 1; b <= 3; b++ {
         if (a == 2 && b == 2) {
            break;
         }
         fmt.Print(a, " ", b, "\n")
     }
   }
}

```

输出:

```
1 1
1 2
1 3
2 1
3 1
3 2
3 3

```