# Go 数组

> 原文：<https://www.javatpoint.com/go-array>

在围棋中，数组是一种同构的数据结构(固定类型)，具有固定的长度。类型可以是整数、字符串或自定义类型。

数组中的项目可以通过它们的索引来访问，它从零开始。数组中的项数称为数组的长度或大小。它是固定的，必须在数组变量的声明中声明。

**语法:**

```
var identifier [len]type

```

**示例:**

```
var arr_name [5]int

```

### Go 数组示例

```
package main
import "fmt"
func main() {
   var x [5]int
   var i, j int
   for i = 0; i < 5; i++ {
      x[i] = i + 10
   }
   for j = 0; j < 5; j++ {
      fmt.Printf("Element[%d] = %d\n", j, x[j])
   }
}

```

输出:

```
Element[0] = 10
Element[1] = 11
Element[2] = 12
Element[3] = 13
Element[4] = 14

```

* * *

## 转到多维数组

多维数组只是一维数组的列表。

**Sytax:**

```
var arrayName [ x ][ y ] variable_type

```

**示例:**

```
a = [3][4]int

```

**初始化二维数组**

```
a = [2][3]int{  
   {2, 4, 6} ,   /*  initializers for row indexed by 0 */
   {8, 10, 12} ,   /*  initializers for row indexed by 1 */
}

```

**访问二维数组**

```
int val = a[1][2]

```

* * *

## 转到多维数组示例

```
package main
import "fmt"
func main() {
   /* an array with 3 rows and 3 columns*/
   var a = [3][3]int{ {1,2,3}, {4,5,6}, {7,8,9}}
   var i, j int
   /* output each array element's value */
   for  i = 0; i < 3; i++ {
      for j = 0; j < 3; j++ {
         fmt.Print(a[i][j] )
      }
      fmt.Println()
   }
}

```

输出:

```
123
456
789

```