# 转到命令行参数

> 原文：<https://www.javatpoint.com/go-command-line-arguments>

当我们需要用一些参数执行一个程序时，我们通常使用命令行参数。从控制台传递的参数可以被 Go 程序接收，并且可以用作输入。

操作系统。Args 用于获取参数。操作系统的索引 0。Args 包含程序的路径。

操作系统。Args[1:]保存提供的参数。

## 转到命令行参数示例 1

```
package main

import (
	"fmt"
	"os"
)
func main() {
	var s, arg string
	for i := 1; i < len(os.Args); i++ {
		s += arg + os.Args[i]+" "
	}
	fmt.Println(s)
}

```

**运行程序的命令:**

```
go build ProgramName.go
./ProgramName Tom Dick Harry

```

**输出:**

```
Tom Dick Harry 

```

## 转到命令行参数示例 2

```
package main
import "os"
import "fmt"
func main() {
	arumentWithPath := os.Args //returns all arguments including path
	arumentSlice:= os.Args[1:] //returns all elements after path
	arumentAt2 := os.Args[2] //returns specified argument only 
	fmt.Println(arumentWithPath)
	fmt.Println(arumentSlice)
	fmt.Println(arumentAt2)
}

```

输出:

```
[/private/var/folders/by/w452m9913bj8_rmgzgjsvw9w0000gn/T/___cmd_go Tom Dick Harry]
[Tom Dick Harry]
Dick

```