# 转到 Regex

> 原文：<https://www.javatpoint.com/go-regex>

Go Regex 包用于搜索字符串。要搜索字符串，我们需要提供字符串的模式。

我们需要将模式编译到 regex 对象中，这样我们就可以通过它调用方法。

regex 对象可以通过使用 compile()和 mustcompile()函数来检索。现在我们可以使用函数来查找字符串，比如 FindString()、FindStringSubmatch()、FindStringIndex()等。

### 转到 Regex 示例 1

```
package main

import (
	"fmt"
	"regexp"
)

func main() {
	re := regexp.MustCompile(".com")
	fmt.Println(re.FindString("google.com"))
	fmt.Println(re.FindString("abc.org"))
	fmt.Println(re.FindString("fb.com"))
}

```

输出:

```
.com

.com

```

FindString()方法返回一个文本最匹配的字符串。如果没有找到匹配项，则返回空字符串。

### 转到正则表达式示例 2

```
package main

import (
	"fmt"
	"regexp"
)

func main() {
	re := regexp.MustCompile(".com")
	fmt.Println(re.FindStringIndex("google.com"))
	fmt.Println(re.FindStringIndex("abc.org"))
	fmt.Println(re.FindStringIndex("fb.com"))
}

```

输出:

```
[6 10]
[]
[2 6]

```

### 转到 Regex 示例 3

我们还可以使用 FindStringSubmatch()方法，该方法返回一段字符串，其中包含最左边匹配的文本和匹配项。如果没有找到匹配项，返回值为空字符串。

```
package main

import (
	"fmt"
	"regexp"
)

func main() {
	re := regexp.MustCompile("f([a-z]+)ing")
	fmt.Println(re.FindStringSubmatch("flying"))
	fmt.Println(re.FindStringSubmatch("abcfloatingxyz"))
}

```

输出:

```
[flying ly]
[floating loat]

Process finished with exit code 0

```