# 前往界面

> 原文：<https://www.javatpoint.com/go-interface>

Go 有不同的方法来实现面向对象的概念。Go 没有类和继承。通过它强大的界面来满足这些需求。

接口为对象提供行为:*如果某个东西可以做到这一点，那么它可以在这里使用。*

接口定义了一组抽象方法，并且不包含任何变量。

语法:

```
type Namer interface {
			 Method1(param_list) return_type
			 Method2(param_list) return_type
			 ...
}

```

其中 Namer 是接口类型。

通常，接口的名称是由方法名加上[e]r 后缀组成的，如 Printer、Reader、Writer、Logger、Converter 等。

*   类型不必明确声明它实现了接口:接口是隐式满足的。多种类型可以实现同一个接口。
*   实现接口的类型也可以具有其他功能。
*   一个类型可以实现许多接口。
*   接口类型可以包含对实现该接口的任何类型的实例的引用

### 前往界面示例

```
package main
import (
   "fmt"
)
type vehicle interface {
   accelerate()
}
func foo(v vehicle)  {
   fmt.Println(v)

}
type car struct {
   model string
   color string
}
func (c car) accelerate()  {
   fmt.Println("Accelrating?")

}
type toyota struct {
  model string
   color string
   speed int
}
func (t toyota) accelerate(){
   fmt.Println("I am toyota, I accelerate fast?")
}
func main() {
   c1 := car{"suzuki","blue"}
   t1:= toyota{"Toyota","Red", 100}
   c1.accelerate()
   t1.accelerate()
   foo(c1)
   foo(t1)
}

```

输出:

```
Accelrating...
I am toyota, I accelerate fast...
{suzuki blue}
{Toyota Red 100}

```