# 去比赛

> 原文：<https://www.javatpoint.com/go-race>

当两个或多个 goroutines 试图访问同一资源时，Go 中会出现争用情况。当一个变量试图读写资源而不考虑其他例程时，可能会发生这种情况。

## 围棋比赛条件示例

```
package main
import (
   "sync"
   "time"
   "math/rand"
   "fmt"
)
var wait sync.WaitGroup
var count int
func  increment(s string)  {
   for i :=0;i<10;i++ {
      x := count
      x++;
      time.Sleep(time.Duration(rand.Intn(4))*time.Millisecond)
      count = x;
      fmt.Println(s, i,"Count: ",count)

   }
   wait.Done()

}
func main(){
   wait.Add(2)
   go increment("foo: ")
   go increment("bar: ")
   wait.Wait()
   fmt.Println("last count value " ,count)
}

```

输出:

```
foo:  0 Count:  1
bar:  0 Count:  1
foo:  1 Count:  2
foo:  2 Count:  3
foo:  3 Count:  4
bar:  1 Count:  2
foo:  4 Count:  5
foo:  5 Count:  6
foo:  6 Count:  7
bar:  2 Count:  3
bar:  3 Count:  4
bar:  4 Count:  5
foo:  7 Count:  8
foo:  8 Count:  9
bar:  5 Count:  6
bar:  6 Count:  7
foo:  9 Count:  10
bar:  7 Count:  8
bar:  8 Count:  9
bar:  9 Count:  10
last count value  10

```

正如您在上面的例子中看到的，count 资源由 2 个 go 例程访问。每个例程迭代 10 次。在这种情况下，计数变量最后应该是 20。但事实并非如此，因为它是在模拟比赛状态。