# 转到频道

> 原文：<https://www.javatpoint.com/go-channel>

该通道充当管道，我们通过它将类型化的值从一个 Goroutine 发送到另一个 Goroutine。它保证了同步，因为在任何给定时间只有一个 Goroutine 可以访问数据项。数据的所有权在不同的 Goroutine 之间传递。因此，通过设计，它避免了共享内存的陷阱，防止了竞争条件。

### Go 频道示例

```
package main
import "fmt"
import "time"
func worker(done chan bool) {
   fmt.Print("working...")
   time.Sleep(time.Second)
   fmt.Println("done")
   done <- true
}
func main() {
   done := make(chan bool, 1)
   go worker(done)
   <-done
}

```

输出:

```
working...done

```