# 转到文件输入/输出

> 原文：<https://www.javatpoint.com/go-file-io>

在 go os.file 对象用于文件操作。os。文件对象也称为文件句柄。

os 包中的打开功能用于打开 Go 中的文件。io/ioutil 包中的 ReadFile()用于读取文件。此方法返回读取字节的[]字节数组。文件。WriteString 方法可用于写入文件。

我们在打开文件后立即使用 defer file.close()来确保函数一完成文件就被关闭。如果文件不存在或者程序没有足够的权限打开文件，那么

inputFile，inputError = os。Open("input.dat ")会导致错误。

**转到文件输入/输出示例**

```

package main
import (
   "os"
   "log"
   "io/ioutil"
   "fmt"
)
func main() {
   file, err := os.Create("file.txt")
   if err != nil {
      log.Fatal(err)
   }
   file.WriteString("Hi... there")
   file.Close()
   stream, err:= ioutil.ReadFile("file.txt")
   if err != nil {
      log.Fatal(err)
   }
   readString := string(stream)
   fmt.Println(readString)
}

```

输出:

```
Hi... there

```