# 转到随机数生成

> 原文：<https://www.javatpoint.com/go-random-number>

我们可以使用 rand 对象生成随机数。我们应该为 rand 对象提供一些种子，这样生成的数字就不一样了。如果我们不提供种子，那么编译器总是产生相同的结果。

### 转到随机数生成

```
package main

import "fmt"
import (
	"math/rand"
	//"time"
	"time"
)
func main() {
	fmt.Print(rand.Intn(100))  //will produce random integer between 0 to 100
	fmt.Println()

	fmt.Print(rand.Float64())	// will produce random number between 0 to 1
	fmt.Println()

	rand.Seed(time.Now().Unix())  // seeding do that random number will produced
	myrand := random(1, 20)

	fmt.Println(myrand)

}

func random(min, max int) int {
	return rand.Intn(max - min) + min
}

```

输出:

```
81
0.9405090880450124
17

```