# Rust 编程语言教程

> 原文：<https://www.javatpoint.com/rust-tutorial>

![Rust Tutorial](img/3251c3f43c9537ea5078954441a6a690.png)

我们的 Rust 编程语言是为初学者和专业人士设计的。Rust 编程语言旨在提供更好的内存安全性，但它仍在维护过程中。

## 什么是Rust？

*   Rust 是由 Mozilla 员工***【Graydon Hoare】在 2006 年*** 开发的系统编程语言。他将这种语言描述为一种**“安全、并发和实用的语言”**，支持功能性和命令性范例。
*   rust 的语法类似于 C++ 语言。
*   Rust 是**自由开源软件**，即任何人都可以自由使用软件，源代码公开共享，这样人民也可以改进软件的设计。
*   在 2016 年、2017 年和 2018 年的堆栈溢出开发者调查中，Rust 被宣布为 ***“最受喜爱的编程语言”*** 之一。
*   没有像 calloc 或 malloc 那样的直接内存管理。这意味着，内存由 Rust 内部管理。

## Rust是为了

出于多种原因，Rust 语言是许多人的理想选择。

让我们看看:

*   **开发人员团队:** Rust 证明对“开发人员团队”相当有用。低级编程代码包含需要测试人员大量测试的 bug。但是，在 Rust 的情况下，如果程序包含 bug，编译器会拒绝编译代码。通过与编译器并行工作，开发人员可以专注于程序的逻辑，而不是专注于错误。
*   **学生:**使用 Rust，很多人可以学习如何开发操作系统。Rust 团队正试图让普通人更容易理解系统概念，尤其是那些对编程不熟悉的人。
*   **公司:**大大小小的公司用 Rust 完成各种任务。这些任务包括命令行工具、网络服务、DevOps 工具、嵌入式设备、音频和视频分析和转码、加密货币、生物信息学、搜索引擎、物联网应用程序、机器学习，甚至火狐网络浏览器的重要部分。
*   **开源开发者:** Rust 是一种开源语言，意思是源代码可供人民使用。因此，他们可以使用源代码来改进 Rust 的设计。

* * *

## Rust 编程语言索引

* * *

**Rust教程**

*   [什么是Rust](rust-tutorial)
*   [锈蚀特征](rust-features)
*   [除锈安装](rust-installation)
*   [第一个Rust程序](first-rust-program)

**控制报表**

*   [Rust，否则](rust-if-statement)
*   [如果在信件中Rust](rust-if-in-a-let-statement)
*   [锈环](rust-loop)
*   [循环时Rust](rust-while-loop)
*   [线圈Rust](rust-for-loop)

**Rust所有权**

*   [什么是所有权](rust-ownership)
*   [参考文献&借用](rust-references-and-borrowing)
*   [锈片](rust-slices)

**Rust结构**

*   [什么是结构](rust-struct)
*   [更新语法](rust-struct-update-syntax)
*   [方法语法](rust-struct-method-syntax)

**Rust枚举**

*   [什么是枚举](rust-enum)
*   [匹配运算符](rust-enum-control-flow-with-match-operator)
*   [如果让操作员](rust-enum-control-flow-with-if-let-operator)

**Rust模块**

*   [Rust模块](rust-modules)
*   [Rust文件系统](rust-module-filesystem)
*   [用 pub 控制能见度](rust-making-a-function-public)
*   [锈用关键词](rust-module-use-keyword)

**Rust系列**

*   [锈菌载体](rust-vector)
*   [锈弦](rust-string)

**Rust错误处理**

*   [Rust错误处理](rust-error-handling)
*   [不可恢复的错误](rust-unrecoverable-errors)
*   [可恢复误差](rust-recoverable-errors)

**仿制药&特性**

*   [锈菌仿制药](rust-generic)
*   [锈病性状](rust-trait)
*   [Rust寿命](rust-lifetime)

**Rust智能指针**

*   [智能指针](rust-smart-pointers)
*   [锈箱<T>T1】](rust-box-t)
*   [右弦锈](rust-deref-trait)
*   [锈滴性状](rust-drop-trait)
*   [拉斯特 Rc(T)](rust-rc-t)
*   [拉斯特反应釜(T)](rust-refcell-t)

* * *

## 为什么是 Rust？

Rust 在不使用垃圾收集器的情况下保证了内存安全。通过避免垃圾收集器，Rust 提供了许多好处，例如清理资源和没有内存管理开销。Rust 通过所有权和借贷制度避免了垃圾收集器的使用。

* * *

## 先决条件

在学习 Rust 之前，你必须具备 C++ 的基础知识。

## 观众

我们的 Rust 教程旨在帮助初学者和专业人士。

## 问题

我们保证您在本 Rust 教程中不会发现任何问题。但是如果有任何错误，请在联系表格中发布问题。

* * *