# Rust的特征

> 原文：<https://www.javatpoint.com/rust-features>

Rust 是一种系统编程语言。Rust 提供以下功能:

![Rust Features](img/a82bec09b265d183dca5c0be9a4a887f.png)

1.  零成本抽象
2.  错误消息
3.  移动语义
4.  没有数据竞争的线程
5.  模式匹配
6.  保证内存安全
7.  高效的 C 绑定
8.  安全内存空间分配
9.  最短时间

## 1.零成本抽象

在 Rust 中，我们可以在不影响代码运行时性能的情况下添加抽象。它提高了代码质量和代码的可读性，而没有任何运行时性能成本。

## 2.错误消息

在 C++ 编程中，与 GCC 相比，错误消息有了很大的改进。为了清晰起见，Rust更进一步。错误信息会以(格式、颜色)显示，并在我们的程序中提示拼写错误。

## 3.类型推断

Rust 提供了类型推断的特性，这意味着它会自动确定表达式的类型。

## 4.移动语义

Rust 提供了此功能，当源对象是临时对象时，它允许用移动操作替换复制操作。

## 5.没有数据竞争的线程

数据竞争是两个或多个线程访问同一内存位置的情况。由于所有权制度，Rust 提供了没有数据竞争的线程特性。所有权系统只将不同对象的所有者传递给不同的线程，两个线程永远不能拥有具有写访问权限的同一个变量。

## 6.模式匹配

Rust 提供了模式匹配的特性。在模式匹配中，Rust 中的模式与“匹配”表达式结合使用，以便对程序的控制流进行更多的控制。以下是一些模式的组合:

*   文字
*   数组、枚举、结构或元组
*   变量
*   通配符
*   占位符

## 7.保证内存安全

Rust 通过使用所有权的概念来保证内存安全。所有权是 C 的内存控制和 java 的垃圾*收集*之间的中间地带。在 Rust 程序中，内存空间由变量拥有，暂时由其他变量借用。这允许 Rust 在编译时提供内存安全，而不依赖垃圾收集器。

## 8.高效的 C 绑定

Rust 提供了*“高效的 C 绑定”*的特性，这意味着 Rust 语言能够在与自己对话时与 C 语言进行互操作。Rust 提供了一个“外来函数接口”来与 C API 进行通信，同时利用其**所有权**系统来保证内存安全。

## 9.安全内存空间分配

在 Rust 中，内存管理是手动的，也就是说，程序员可以明确控制何时何地分配和释放内存。在 C 语言中，我们使用 malloc 函数分配内存，然后初始化它，但是 Rust 通过单个 **'~'** 运算符拒绝这两个操作。该运算符将智能指针返回到 int。智能指针是一种特殊的值，它控制对象何时被释放。智能指针是*“智能”*，因为它们不仅能追踪物体的位置，还知道如何清理。

* * *