# While 循环

> 原文：<https://www.javatpoint.com/rust-while-loop>

“while-loop”是一个条件循环。当程序需要评估一个条件时，使用条件循环。当条件为真时，它执行循环，否则它终止循环。

## “while 循环”的语法

```

 while condition
{
 //block statements;
}

```

*   在上面的语法中，while 循环计算条件。如果条件为真，则执行 block 语句，否则将终止循环。Rust 提供了这种内置构造，可以与“loop”、“if”、“else”或“break”语句结合使用。

**while 循环流程图**

![Rust While loop](img/a755e0ee847e4872575a5576114c0a23.png)

**我们来看一个简单的例子**

```

 fn main()
{
  let mut i=1;
  while i<=10
{
   print!("{}", i);
   print!(" ");
   i=i+1;
}
}

```

**输出:**

```
1 2 3 4 5 6 7 8 9 10

```

在上面的例子中，“I”是一个可变变量，这意味着“I”的值可以修改。while 循环一直执行到“I”的值小于 10 或等于 10。

**我们来看一个简单的例子**

```

 fn main()
{
  let array=[10,20,30,40,50,60];
  let mut i=0;
  while i<6
  {
    print!("{}",array[i]);
    print!(" ");
    i=i+1;
  }
}

```

**输出:**

```
10 20 30 40 50 60

```

在上面的示例中，数组的元素已经使用 while 循环进行了迭代。

## while 循环的缺点:

*   如果索引长度不正确，While 循环会导致问题。
*   它也很慢，因为编译器会添加运行时代码，以便在这个循环的每次迭代中执行条件检查。

* * *