# For 循环

> 原文：<https://www.javatpoint.com/rust-for-loop>

循环的**是一个条件循环，即循环运行特定次数。rust 语言中 for 循环的行为与其他语言略有不同。执行 for 循环，直到条件为真。**

## for 循环的语法

```

for var in expression
{
    //block statements
} 

```

在上面的语法中，一个表达式可以被转换成一个迭代器，它遍历数据结构的元素。在每次迭代中，从迭代器中获取值。当没有剩余的值可以提取时，循环结束。

**让？让我们看一个简单的例子。**

```

 fn main()
{

  for i in 1..11
  {
    print!("{} ",i);
  } 
}

```

**输出:**

```
1 2 3 4 5 6 7 8 9 10

```

在上面的例子中，1..11 是一个表达式，迭代器将迭代这些值。上限是排他的，因此循环将打印 1 到 10 个值。

**让？让我们看一个简单的例子。**

```

 fn main()
{
let mut result;
for i in 1..11
{
result=2*i;
println!("2*{}={}",i,result);
}
}

```

**输出:**

```
2*1=2
2*2=4
2*3=6
2*4=8
2*5=10
2*6=12
2*7=14
2*8=16
2*9=18
2*10=20

```

在上例中，for 循环打印了表 2。

**让？让我们看另一个简单的例子。**

```

 fn main()
{

  let fruits=["mango","apple","banana","litchi","watermelon"];
   for a in fruits.iter()
  {
    print!("{} ",a);
  } 
}

```

**输出:**

```
mango apple banana litchi watermelon 

```

在上例中，iter()方法用于访问水果变量的每个元素。一旦到达数组的最后一个元素，循环就结束了。

## while 循环和 for 循环之间的差异:

如果数组的索引长度在运行时增加，那么 while 循环会显示错误，但是在 for 循环的情况下不会出现这种情况。因此，我们可以说 for 循环增加了代码的安全性并消除了错误的可能性。

* * *