# 什么是结构？

> 原文：<https://www.javatpoint.com/rust-struct>

结构是用户定义的数据类型，由不同数据类型的变量组成。通过在结构名称前使用 struct 关键字来定义结构。结构成员包含在花括号中。在花括号内，定义了结构成员的名称和类型，结构成员也被称为**字段**。

## 结构的语法:

```

 struct Student
{
member-variable1;
member-variable2;
.
.
}

```

在上面的语法中，结构是使用关键字 struct 定义的。结构包含不同类型的变量。

**如何声明一个结构的实例**

```

 let user = Student{
// key:value pairs;
}

```

在上面的声明中，用户是学生结构的一个实例。它是通过使用结构名和花括号来定义的。花括号包含键:值对，其中键是字段的名称，值是我们想要存储在键字段中的数据。

**我们来创建一个员工结构:**

```

 struct Employee{
employee_name : String,
employee_id: u64,
employee_profile: String,
active: bool,
}

```

**员工结构实例:**

```

 let employee = Employee{
employee_name : String::from("Akshay Gupta"),
employee_id: 12,
employee_profile : String::from("Computer Engineer"),
active : true,
};

```

## 如何访问 Structure 的特定成员变量？

我们可以通过使用点符号来访问结构的特定成员变量。假设我们想要访问 employee 结构的 employee_name 变量，那么它看起来像:

```

 employee.employee_name;

```

#### 注意:如果我们想通过使用点符号来改变特定字段的值，那么我们必须使一个实例可变，因为 Rust 不允许特定字段可变。

```

 let mut employee = Employee{
employee_name : String::from("Akshay Gupta"),
employee_id: 12,
employee_profile : String::from("Computer Engineer"),
active : true,
};
employee.employee_name = String :: from("Akhil Gupta"); 

```

**在函数体中创建实例:**

```

 fn create_employee(name:String, profile:String)
{
Employee{
employee_name:name,
employee_id:12,
employee_profile:profile,
active:true,
}
}

```

在上面的例子中，Employee 结构的实例是在函数体中隐式创建的。create_employee()函数使用给定的名称和配置文件返回 employee 结构的实例。

当传递给函数的参数和字段具有相同的名称时，使用字段初始化简写。

当变量和字段具有相同的名称时，Rust 提供了使用字段初始化速记的灵活性。不需要重复字段和变量。

```

 fn create_employee(employee_name:String, employee_profile:String)
{
Employee{
employee_name,
employee_id:12,
employee_profile,
active:true,
}
}

```

在上例中，参数和字段的名称是相同的。所以不需要写**employee _ name:employee _ name**，可以直接写成 **employee_name** 。

* * *