# 更新语法

> 原文：<https://www.javatpoint.com/rust-struct-update-syntax>

使用结构更新语法从其他实例创建新实例。

当新实例使用旧实例的大部分值时，我们可以使用 struct update 语法。考虑两个员工，员工 1 和员工 2。

*   首先，创建雇员结构的实例雇员 1:

```

 let employee1 = Employee{
employee_name : String::from("Akshay Gupta"),
employee_id: 12,
employee_profile : String::from("Computer Engineer"),
active : true,
};

```

*   其次，创建员工 2 的实例。employee2 实例的某些值与 employee1 相同。有两种方法可以声明 employee2 实例。

第一种方法是在不更新语法的情况下声明 employee2 实例。

```

 let employee2 = Employee{
employee_name : String::from("Akhil Gupta"),
employee_id: 11,
employee_profile : employee1.employee_profile,
active : employee1.active,
};

```

第二种方法是使用语法更新来声明 employee2 实例。

```

 let employee2 = Employee{
employee_name : String::from("Akhil Gupta"),
employee_id: 11,
..employee1
};

```

语法“..”指定其余字段未显式设置，并且它们与给定实例中的字段具有相同的值。

**我们来看一个简单的结构示例:**

```

 struct Triangle
{
base:f64,
height:f64,
}

fn main()
{
let triangle= Triangle{base:20.0,height:30.0};
print!("Area of a right angled triangle is {}", area(&triangle));
}

fn area(t:&Triangle)->f64
{
0.5 * t.base * t.height
}

```

**输出:**

```
Area of a right angled triangle is 300

```

在上面的例子中，创建了一个三角形的结构，它包含两个变量，即直角三角形的底部和高度。三角形的实例是在 main()方法中创建的。

* * *