# 方法语法

> 原文：<https://www.javatpoint.com/rust-struct-method-syntax>

方法类似于函数，因为它们在函数名的开头和后面都包含 **fn** 关键字。方法还包含参数和返回值。但是，当方法在结构上下文中声明时，方法语法与正常函数不同。这些方法的第一个参数总是 **self** ，它代表调用函数的实例。

## 定义方法

让我们在结构上下文中声明方法时定义该方法。

```

 struct Square
{
a : u32,
}
impl Square
{
fn area(&self)->u32
{
self.a * self.a
}
}

fn main()
{
let square = Square{a:10};
print!("Area of square is {}", square.area());
}

```

**输出:**

```
Area of square is 100

```

当方法在结构上下文中声明时，我们在实现块(即 impl 块)中定义方法。

```

 impl Square
{
fn area(&self)->u32
{
self.a * self.a
}
}

```

第一个参数是在签名中和身体的任何地方都是自我。

这里，我们使用方法语法来调用 area()函数。方法语法是后跟点运算符、方法名、参数和任何参数的实例。

```

 square.area();

```

**其中**方块为实例，面积()为函数名。

#### 注意:如果我们想改变调用方法的实例，那么我们使用&mut self 而不是&self 作为第一个参数。

**方法语法的优势:**

与函数相比，使用方法语法的主要优势在于，与实例相关的所有数据都放在 impl 块中，而不是放在我们提供的不同位置。

* * *