# 什么是Rust枚举？

> 原文：<https://www.javatpoint.com/rust-enum>

枚举是一种自定义数据类型，它包含一些确定的值。它是用枚举名称前的枚举关键字定义的。它也由方法组成。

## 枚举的语法:

```

 enum enum_name
{
  variant1,
 variant2,
.
.
}

```

在上面的语法中，enum_name 是枚举和变量 1、变量 2，..是与枚举名称相关的枚举值。

## 例如:

```

 enum Computer_language
{
   C,
   C++,
   Java,
} 

```

在上面的例子中，computer_language 是枚举名，C、C++、Java 是 computer_language 的值。

## 枚举值

让我们创建每个变体的实例。看起来像是:

```

 let c = Computer_language :: C;
let cplus = Computer_language :: C++;
let java = Computer_language :: Java;

```

在上面的场景中，我们创建了三个实例，即 C、cplus、java，分别包含值 C、C++、Java。枚举的每个变体都在其标识符下用空格命名，并使用双冒号。这很有用，因为 Computer_language::C，Computer_language::C++，Computer_language::Java 属于同一类型，即 Computer_language。

*   我们还可以在特定的实例上定义一个函数。让我们定义接受 Computer_language 类型实例的函数；然后它看起来像:

```
 fn language_type(language_name::Computer_language);

```

该函数可以由任何一种变体调用:

```

  language_type(Computer_language :: C++);

```

**我们通过一个例子来了解一下。**

```

 #[derive(Debug)]
enum Employee {
    Name(String),
    Id(i32),
    Profile(String),
}
fn main() {

    let n = Employee::Name("Hema".to_string());
    let i = Employee::Id(2);
    let p = Employee::Profile("Computer Engineer".to_string());
    println!(" {:?} s {:?} b {:?}", n,i,p);
}

```

**输出:**

```
Name("Hema") s Id(2) b Profile("Computer Engineer")

```

在上面的示例中，Employee 是一个自定义数据类型，它包含三个变量，如名称(字符串)、标识(i32)、配置文件(字符串)。“:？”用于打印每个变量的实例。

* * *