# 匹配运算符

> 原文：<https://www.javatpoint.com/rust-enum-control-flow-with-match-operator>

**匹配运算符**允许我们将一个值与一系列模式进行比较，并在找到匹配时执行代码。模式可以是文字值、变量名、通配符和许多其他东西。

**我们通过一个简单的例子来理解匹配运算符:**

```

 enum Computerlanguage
{
  C,
  Cplus,
  Java,
  Csharp,
}
fn language(language:Computerlanguage)
{
 match language
 {
   Computerlanguage::C=> println!("C language"),
   Computerlanguage::Cplus=> println!("C++ language"),
   Computerlanguage::Java=> println!("Java language"),
   Computerlanguage::Csharp=> println!("C# language"),
 }
}
fn main()
{
 language(Computerlanguage::C);
 language(Computerlanguage::Cplus);
 language(Computerlanguage::Java);
 language(Computerlanguage::Csharp);
}

```

**输出:**

```
C language
C++ language
Java language
C# language

```

在上面的例子中，Computerlanguage 是一个自定义数据类型，由四个变体组成，分别是 C、Cplus、Java、Csharp。匹配运算符将语言的值与匹配运算符块中给出的表达式进行匹配。

## 与选项<t>匹配</t>

**选项< T >** 是在我们想从**的一些**情况中得到 T 的内值时使用的。

**选项< T >由两个变量组成:**

*   **无:**表示故障或缺值。
*   **Some(值):**它是一个用 t 包装值的元组结构

**我们通过一个例子来了解一下:**

```

 fn main()
{
 even_number(2);
 even_number(3);
}
fn even_number(n:i32)
{
 let num=n;
  match checked_even(n)
  {
    None=>println!("None"),

	Some(n)=>
	{
	if n==0
	{
	println!("{} is a even number",num);
	}
	else
	{
	println!("{} is a odd number",num);
	}},
  }
}
fn checked_even(number:i32)->Option<i32>
{

  Some(number%2)

}

```

**输出:**

```
2 is a even number
3 is a odd number

```

## 匹配是详尽的

在 Rust 中，匹配是详尽的，也就是说，我们应该用尽所有可能的情况来使代码有效。假设我们忘记写“无”的情况，那么 Rust 编译器将显示“模式‘无’未覆盖”的错误。

**我们通过一个例子来理解这个案例:**

```

 fn main()
{
 Some(5);
}
fn Value(n:Option<i32>)
{
  match n
  {
    Some(n)=>println!("{}is a Number",n),
  }
}

```

**输出:**

![Rust Enum Match Operator](img/79919a859b779cbccadeb3030e7f7ef3.png)

* * *