# 公开运作

> 原文：<https://www.javatpoint.com/rust-making-a-function-public>

“pub”关键字用在声明的开头，以便外部函数可以访问该函数。

**以下是隐私规则:**

*   如果任何函数或模块是公共的，那么它可以被任何父模块访问。
*   如果任何函数或模块是私有的，那么它可以被它的直接父模块或父模块的子模块访问。

**我们通过一个简单的例子来了解一下:**

```

 mod outer
{
   pub fn a()
   {
     println!("function a");        
   }
   fn b()
   {
      println!("function b");
   }

mod inner
{
  pub fn c()
  {
    println!("function c");
  }
  fn d()
  {
    println!("function d");
  }
}
}
fn main()
{
  outer::a();
  outer::b();
  outer::inner::c();
  outer::inner::d();
}

```

**输出:**

![Rust Making a functioning public](img/0023c75201570ceab20b592acac657a6.png)

在上面的例子中，main()函数是根模块，而外部模块是我们项目的当前根模块。因此，main()函数可以访问外部模块。

对 *outer::a()* 的调用不会导致任何错误，因为函数 a()是公共的，但是当 main()函数试图访问 *outer::b()* 函数时，它会导致编译错误，因为它是一个私有函数。

main()函数无法访问内部模块，因为它是私有的。内部模块没有子模块，因此只能由其父模块(即外部模块)访问。

* * *