# 程序结构

> 原文：<https://www.javatpoint.com/cobol-program-structure>

在定义 COBOL 的程序结构之前，必须了解 COBOL 程序的语法。

**COBOL 语法**

COBOL 是一种遵循类似英语语法的高级语言，用于描述程序中的一切。

**例如:**在 COBOL 程序中，一个条件可以表示为 x IS GREATER beyond y 或者更简洁地表示为 x GREATER y 或者 x > y，它还通过去掉重复的条件和变量来缩写复杂的条件。例如，a > b AND a > c OR a = d 可以缩短为 a > b AND c OR = d，为了支持这种类似英语的语法，COBOL 使用了 300 多个关键词。

### COBOL 程序结构

COBOL 使用它的编译器在执行前把程序翻译成目标程序。为了执行 COBOL 程序而不出错，我们必须将划分按正确的顺序排列。

COBOL 程序包含一种称为结构化 COBOL 编程的逻辑结构。它遵循一种有组织的方式来进行编程。您必须遵循模块化编程方法，这是过程编程方法的一个子集。

COBOL 程序遵循一个分层结构，该结构由不同的部分组成，如划分、部分、段落、句子和字符。

层次关系的存在不需要所有组件都存在。分部是组件的最顶层，可能包含一个或多个部分。同样，一个部分可能包含一个或多个段落。一个段落可能包含一个或多个句子，以此类推。

参见下图，了解 COBOL 程序的层次结构:

![COBOL Program Structure](img/9fa36632eb567658267111dbd9a90448.png)

让我们看看这些组件的简短描述:

**分部**

这是 COBOL 程序最顶层的组件，也是最重要的一个。它是部分、段落、句子或字符块的集合。这通常包含一个或多个部分，这些部分后来被分成段落。分割线的起点是分割线名称，分割线的终点是下一个分割线的起点或节目的终点。分部是系统定义的词，所有分部都应该在 a 区

COBOL 程序可以分为以下四个部分:

*   识别部
*   环境部分
*   数据部分
*   过程部分

**段**

区段是程序逻辑的逻辑细分。节是 COBOL 程序层次结构中段落的集合。它可能包含一个或多个段落。

**段落**

段落是一个部分的子部分，它已经是 COBOL 程序层次结构中的一个部分的子部分。它是用户定义或预定义的名称，后跟一个句点。它可能包含一个或多个句子。

**句子**

句子是一个或多个语句的组合。一个句子可能包含一个或多个语句。句子只出现在程序部分。一个句子必须以句号结尾。

**报表**

语句类似于命令，用于执行 COBOL 程序的某些处理。这些 COBOL 语句可以分为不同的类别，并进一步细分为不同的变体。一条语句可能包含一个或多个字符。

**字符**

字符是 COBOL 语言中最基本和不可分割的单元。它包括拉丁字母、数字和特殊字符。这些是 COBOL 程序层次结构中最低的组件，不能再分了。

* * *