# 文件处理

> 原文：<https://www.javatpoint.com/cobol-file-handling>

COBOL 也像 C/C++ 语言一样支持文件处理，但是文件概念不同于 C 或 C++。在 COBOL 中，我们不能使用简单的文本文件。COBOL 使用 PS 和 VSAM 文件(物理顺序)。我们将在这里讨论 PS 文件。

为了理解 COBOL 中文件处理的概念，必须知道基本术语。这些术语仅有助于理解文件处理的基础。让我们理解以下术语:

*   田
*   记录
*   实际记录
*   逻辑记录
*   文件

![COBOL File Handling](img/4959da4728c1b048b39ce663be368511.png)
![COBOL File Handling](img/8cfc1d672d9918def2b83aa12c9febdb.png)

## 田

该字段用于指示存储的关于元素的数据。它表示上例中给出的单个元素，如学生证、姓名、分数、总分数和百分比。任何字段中的字符数称为字段大小。例如，学生姓名可以有十个字符。字段可以具有以下属性:

**主键**

主键是对每个记录唯一的字段，用于标识特定的记录。例如，在上面的例子中，学生 id 是主键。

**辅助键**

辅助关键字是用于搜索相关数据的唯一或非唯一字段。例如，在上面的示例中，当学生 id 不可用时，学生姓名是辅助密钥。

**描述符**

字段用于描述实体。例如，在上面的学生成绩文件示例中，给记录增加意义的分数和百分比字段是描述符。

## 记录

记录是用于描述实体的一组字段。一条记录由一个或多个字段组合而成。例如，在上面的学生分数文件中，学生 id、姓名、分数、总分数和百分比构成一条记录。记录大小定义为记录中所有字段的总大小。文件中记录的大小可以是固定长度，也可以是可变长度。

物理记录:这是存在的外部设备信息。它也被称为区块。

逻辑记录:这是程序的信息。在 COBOL 程序中一次只能管理一条记录。

## 文件

该文件是相关记录的集合。例如，上述学生的分数文件由所有学生的记录组成。

* * *