# 内部排序

> 原文：<https://www.javatpoint.com/cobol-internal-sort>

顺序文件在数据处理应用程序中非常常用。这些文件中的记录通常需要按升序或降序排列，以便正确、方便和快速地访问。

对文件中的数据进行排序或合并两个或多个文件是几乎所有应用程序的常见要求。排序是一种用于以升序或降序排列记录的技术，以便能够执行顺序处理。

COBOL 中有两种对文件进行排序的技术:

**外部排序:**这是借助 JCL 中的 Sort 实用程序对文件进行排序。

**内部排序:**该方法对 COBOL 程序内的文件进行排序。COBOL 提供了对文件进行排序的 SORT 动词。

## 排序动词

排序动词接受来自非顺序文件或内部过程的输入，并以请求的顺序向文件或内部过程产生输出。在对记录进行排序之前或之后，您可以添加、更新或删除记录。

SORT 动词使用三个文件在 COBOL 中执行排序:

*   **输入文件:**这是要按升序或降序排序的文件。
*   **工作文件:**该文件保存分类过程中的记录。为了执行排序操作，所有输入文件的记录都被转移到工作文件。该文件需要在 SD(排序文件描述级别)条目下的文件部分中定义。
*   **输出文件:**输出文件是将存储排序过程最终结果的结果文件。意味着，该文件是排序谓词的最终输出。

### 语法:

```

SORT work-file ON ASCENDING KEY rec-key1
   [ON DESCENDING KEY rec-key2]
USING input-file GIVING output-file.

```

SORT 动词执行以下操作:

*   它以输入模式打开输入文件，以输入输出模式打开工作文件，以输出模式打开输出文件。
*   它将记录从输入文件传输到工作文件，用于排序操作。
*   根据您的要求，按升序或降序对排序文件进行排序。
*   它将排序后的记录从工作文件传输到输出文件。
*   关闭输入和输出文件，并删除工作文件。

## 合并动词

合并动词用于比较两个或多个有序文件中的记录，并按顺序组合它们。您可以在记录合并后添加、更新或删除记录。

SORT 动词使用四个文件在 COBOL 中执行排序:

*   输入文件:执行合并操作需要两个输入文件。
*   工作文件
*   输出文件

### 语法:

```

MERGE work-file ON ASCENDING KEY rec-key1
   [ON DESCENDING KEY rec-key2]

USING input-1, input-2 GIVING output-file.

```

合并谓词执行以下操作:

*   它以输入模式打开输入文件，以输入输出模式打开工作文件，以输出模式打开输出文件。
*   它将记录从输入文件传输到合并过程的工作文件。
*   它会合并文件。
*   它将合并的记录从工作文件传输到输出文件。
*   关闭输入和输出文件，并删除工作文件。

* * *