# Pro*C 教程

> 原文：<https://www.javatpoint.com/proc>

![Pro*C Tutorial](img/7f4b1db2685bf60050bdd726da1c8766.png)

**在本教程中，我们将涵盖以下主题:**

*   [什么是 Pro*C](#WhatIs)
*   [编译 Pro*C 程序](#Compiling)
*   [Pro * C 编译器的需求](#Need)
*   [要求](#Requirements)
*   [目录结构](#Directory)
*   [限制](#Restrictions)
*   [嵌入式 SQL 语句](#Embedded)
*   [Pro*C 语法](#Syntax)
*   [主机变量](#HostVariables)
*   [数据类型等价](#DatatypeEquivalencing)
*   [动态与静态 SQL 语句](#vs)
*   [交易](#Transactions)
*   [错误处理](#Error)
*   [程序](#Program)

* * *

## 什么是 Pro*C？

Pro*C 意味着创建一个嵌入了 [SQL](https://www.javatpoint.com/sql-tutorial) 语句的程序。我们可以在 Pro*C 的帮助下访问 Oracle 数据库。C 编程语言通过操作或检索 Oracle 数据库中的数据，为数据处理提供了灵活性。因此，我们可以说 Pro*C 允许 [C 编程语言](https://www.javatpoint.com/c-programming-language-tutorial)将 [C 程序](https://www.javatpoint.com/c-programs)与 Oracle 数据库连接起来，按照我们的要求进行操作。

* * *

## 如何才能编译 Pro*C 程序？

Oracle 软件提供了 PROC 编译器(Oracle Precompiler)，这个编译器采用了内嵌 SQL 语句的 C 程序。

### 什么是 Oracle 预编译器？

oracle 预编译器是一种编程工具，允许用户将 SQL 语句嵌入高级源程序中。这个编译器将源程序作为输入，用 oracle 运行时库调用替换嵌入的 SQL 语句，这个修改后的程序现在可以编译、链接和执行了。

Pro*C 程序编译的全过程如下:

![Pro*C Tutorial](img/df718ffb48f5c065223f46a2efd410d6.png)

*   首先，我们创建一个包含 SQL 语句的 C 程序，然后我们用扩展名保存这个文件。个人电脑。给你。‘PC’表示该程序是一个 Pro*C 程序。
*   创建程序后，我们使用 [Oracle](https://www.javatpoint.com/oracle-tutorial) 提供的 PROC 编译器编译程序。PROC 编译器生成。所有的 SQL 语句都被 Oracle 运行时库中已经预定义的函数替换。
*   PROC 编译器创建的文件会被 C 编译器再次编译，Pro*C 支持，在 Windows 中，PROC 编译器支持 Microsoft Visual [C++](https://www.javatpoint.com/cpp-tutorial) 编译器。
*   C 编译器将创建一个. exe 文件。
*   现在，最后，我们运行。exe 文件。

* * *

## 为什么我们需要 Pro*C 编译器？

*   Pro*C 编译器允许您在 C 程序中嵌入 SQL 语句，它还提供了所需的用户界面。
*   与许多其他开发工具不同，Pro*C 允许您自定义应用程序。它创建的用户界面结合了最新的窗口和鼠标技术。有时我们可能无法从其他开发工具生成报告，但是我们可以通过从 oracle 数据库中检索数据来实现这一点。

* * *

## 要求

Pro*C 的主要要求是安装 Pro*C 软件。当我们安装 Oracle 数据库时，我们必须确保选择了 Pro*C 组件。如果我们要检查 oracle 的安装是否包含 Pro*C 组件，就是通过检查 Oracle 的 prect 目录。

* * *

## 目录结构

当我们安装 Oracle 时，会在硬盘上为 Oracle 产品创建一个目录结构。主 oracle 目录将包含专业版所需的子目录和文件

当我们在甲骨文中安装 Pro*C 时，那么甲骨文通用安装程序会在 ORACLE_BASE\ORACLE_HOME 目录中创建一个名为预计算的目录。这个子目录，即预计算，包含可执行文件、库文件和下面给出的一些示例程序:

**预计算目录结构**

| 目录 | 描述 |
| **\admin** | 它包含配置文件。 |
| **\演示\为什么** | 它包含了 Pro*C 的示例程序 |
| **\演示\sql** | 它包含示例程序的 sql 脚本。 |
| **\doc\proc** | 它包含 pro*c 的文档文件。 |
| **\帮助\进程** | 它包含 Pro*C 的帮助文件。 |
| **\lib\msvc** | 它包含专业版的库文件 |
| **\ Meg** | 它包含消息文件。 |
| **\misc\proc** | 它包含 Pro*C 的杂项文件。 |
| **\公共** | 它包含头文件。h 分机。 |

* * *

## 限制

所有 [Windows 操作系统](https://www.javatpoint.com/windows)都可以在文件和目录名中包含空格，但 Oracle Pro*C 预编译器不预编译文件名中包含空格的文件。

例如，如果文件名为**第一个 program.pc，**，则该文件名无效。

* * *

## 嵌入式 SQL 语句

这里，嵌入式 SQL 意味着将 SQL 语句放在源程序中。因为我们把语句放在 C 程序里面，所以 C 程序也被称为宿主程序，我们使用的语言被称为宿主语言。专业版提供了在程序中嵌入 SQL 语句的能力。

嵌入式 SQL 语句有两种类型:

*   **可执行语句**
*   **指令**

**可执行语句**

可执行语句是允许您操作 Oracle 数据库中的数据的 SQL 语句。这些语句称为 Oracle 运行时库。它还允许您的程序连接到 Oracle 数据库、定义查询、操作数据和处理事务。这些语句写在可以放置 C 可执行语句的地方。

**指令**

指令或声明性语句是既不调用 Oracle 运行时库也不对 Oracle 数据进行操作的 SQL 语句。它用于声明甲骨文对象、SQL 对象。这些语句可以写在可以声明 C 变量的地方。

* * *

## 专业语法

在 C 程序中，所有的 SQL 语句都必须以 EXEC SQL 开头，并应以分号结尾；。我们可以在程序中的任何地方编写 SQL 语句，但是有一个限制，声明性语句不应该在可执行语句之后。

假设我们想根据学生的 id 从数据库中检索他们的分数，那么它的程序可以写成:

```

{ 
int marks;
EXEC SQL select marks INTO : marks from student where student_id=6;
printf("The marks of the student is : %d", marks);
}

```

**预处理器指令**

在用 C 语言处理 Pro*C 时，我们可以使用的预处理器指令是#include 和#if。但是，Pro*C 不知道#define 指令。让我们通过下面给出的一个简单场景来理解这一点:

```

#define employee_id
int salary;
EXEC SQL select salary into : salary from employee where employee_id=5;

```

上述代码无效，因为 Pro*C 不能使用#define 指令。

* * *

## 主机变量

宿主变量是与嵌入式 SQL 语句一起使用的宿主语言的变量。主机变量是 Oracle 和 C 程序之间通信的关键。这些变量的声明方式与我们在 C 程序中进行声明的方式类似，我们的程序和 Oracle 都可以引用这些变量。

宿主变量可以放在使用 SQL 表达式的地方，这些变量在 BEGIN DECLARE SECTION 和 END DECLARE SECTION 之间声明。当我们编写 SQL 语句时，主机变量的前缀是“:”冒号。

以下是 Oracle 支持的 C 数据类型列表:

*   茶
*   char[n]
*   （同 Internationalorganizations）国际组织
*   短的
*   长的
*   漂浮物
*   两倍
*   VARCHAR[n]

#### 两颗北极指极星

指针变量也可以在 SQL 语句中用作宿主变量。让我们通过一个简单的例子来理解。

```

int *age;
EXEC SQL SELECT age into :age from student; 

```

在上面的代码中，我们声明了一个整数类型的指针变量，即*age。声明后，我们执行 SELECT 语句，从学生表中检索年龄值，然后将年龄值存储在主机变量中，即年龄。结果将存储在*age 中，而不是 age 中。

#### 结构

Pro*C 中也使用了 c 结构，结构的成员变量可以作为宿主程序中的宿主变量。当我们在 SQL 语句中提供结构的名称时，每个主机变量必须以:冒号作为前缀。

```

struct student
{
int student_id;
char name[20]; 
}s1;
EXEC SQL INSERT INTO stud(student id, name) values(:s1);

```

在上面的代码中，我们创建了一个名为 student 的结构，它包含两个变量，即 student_id 和 name。创建结构后，我们声明变量，即 student 类型的 s1。然后，我们使用 insert 命令在数据库中插入这两个变量的值。

#### 数组

数组可以在嵌入式 SQL 语句中用作宿主变量。让我们通过一个简单的例子来理解这一点:

```

int student_number[10];
EXEC SQL INSERT INTO student(student id) VALUES(:student_number);

```

在上面的代码中，我们创建了一个整数类型的一维数组。我们实现了 SQL INSERT 命令，它将一次性插入所有 10 个元组。

让我们看看另一个使用二维数组的例子。

```

char student_name[10][7];
EXEC SQL INSERT INTO student(student nme) VALUES(:student_name);

```

在 Pro*C 中，数组只能是一维的。但是，Pro*C 成功预编译了上述代码，因为它将二维视为一维字符数组，而不是二维字符数组。

```

short indicator_variable;
EXEC SQL SELECT column_name INTO : host_variable:indicator_variable from table_name;

```

如上例所示，我们可以在 SELECT 语句中使用指示器变量来确定输出主机变量是否包含空值或截断值。下表显示了 Oracle 可以给出的指标变量的可能值及其说明:

| Oracle 返回的值 | 描述 |
| **-1** | 这意味着列的值为空，那么宿主变量的值将是不确定的。 |
| **0** | 完整的列值被分配给宿主变量。 |
| **> 0** | 截断的值被分配给宿主变量。 |
| **-2** | 截断的值被分配给宿主变量。 |

如果我们想在一个结构中创建一个宿主变量的指示器变量，我们可以简单地通过在一个结构中创建每个宿主变量的指示器变量来实现。要在 SQL 语句中添加指示器变量的名称，我们需要编写一个结构的指示器变量的名称，该名称必须以“:”冒号为前缀，并且必须紧跟在宿主变量之后。

* * *

## 数据类型等价

这是一个非常重要的特性，因为它增加了应用程序的灵活性。这意味着您可以根据 Oracle 如何解释输入数据和格式化输出数据的要求进行定制。

Oracle 包含两种数据类型:

*   内部数据类型
*   外部数据类型

**内部数据类型:**甲骨文使用这些数据类型来定义数据如何存储在列中。

**外部数据类型:**Oracle 使用这些数据类型来格式化输出数据，然后这些输出数据将存储在主机变量中。

让我们看看如何等价数据类型。

在逐个变量的基础上，我们使用 var 语句进行等值。var 语句的语法如下:

```

EXEC SQL VAR <host_variable> IS <data_type> [(<length>)]; 

```

例如，我们希望从学生表中检索学生姓名；然后，我们需要将这些学生姓名传递给接受 C 风格字符串的函数(最后一个字符必须是终止字符' \0 ')。要将主机变量等效为字符串外部数据类型，我们使用以下代码:

```

char names[12];
EXEC SQL VAR names IS STRING(12);

```

该列，即学生姓名，包含 11 个字符。由于**学名**一栏包含 11 个字符，所以我们需要分配 12 个字符(学名 11 个字符加上终止符(\0))。我们使用为接口提供 C 风格字符串的字符串数据类型。Oracle 将自动添加' \0 '字符。

到目前为止，我们等效内置数据类型，也就是说，在上面的例子中，我们将 char 数组等效为 Oracle 外部数据类型(字符串)。我们还可以通过使用 TYPE 命令来等效用户定义的数据类型。**类型**语句的语法如下:

```

EXEC SQL TYPE <user-defined_datatype> IS <type_name> [<length>][Reference]

```

* * *

## 动态与静态 SQL 语句

静态 SQL 语句主要用于固定应用程序，但有时程序需要动态创建 SQL 语句。要创建动态 SQL 语句，首先，我们需要将 SQL 语句存储在一个字符串变量中。存储该语句后，我们使用 PRESENT 语句将字符串转换为 SQL 语句。最后，我们使用 execute 语句执行该语句。让我们通过一个例子来理解这个场景。

```

char *s = "INSERT INTO student VALUES(12, 'Peter', 3)";
EXEC SQL PREPARE q FROM :s;
EXEC SQL EXECUTE q;

```

* * *

## 处理

Oracle Pro*C 也遵循 SQL 标准定义的事务概念。事务是一系列语句，Oracle 使用这些语句要么使所有更改永久化，要么撤消事务开始以来所做的所有更改。我们使用两个语句，即执行 SQL COMMIT 和执行 SQL ROLLBACK。EXEC SQL COMMIT 语句用于使事务开始以来的所有更改永久化。EXEC SQL ROLLBACK 用于撤消事务开始以来的所有更改。如果我们开始下一个事务时没有编写语句 EXEC SQL COMMIT，那么在这个事务中所做的所有更改都将被丢弃。

* * *

## 错误处理

c 编程提供了我们在源程序中使用的内置错误处理机制。错误处理是一种提供源程序状态的机制。我们需要一些处理错误的机制，所以 Pro*C 包含下面给出的两个错误处理概念:

*   SQL 通信区
*   无论何时声明

#### 的组成

SQL 通信区是我们的程序用来检查错误的数据结构或区域。该数据结构包含 Oracle 使用的一些预定义变量。这些变量包含在运行时传递的程序状态信息。

sqlca 的结构如下:

```

struct sqlca {
char sqlcaid[8];
long sqlabc;
long sqlcode;
struct {
unsigned short sqlerrml;
char sqlerrmc[70];
} sqlerrm;
char sqlerrp[8];
long sqlerrd[6];
char sqlwarn[8];
char sqlext[8];
};

```

#### 组件

**以下是 SQLCA 的组成部分:**

*   **sqlcaid:** 初始化为“SQLCA”的字符数组，用于确定 SQL 通讯区域。
*   **sqlcabac:**声明为整数类型，以字节为单位保存 SQLCA 结构的长度。
*   **sqlcode:** 声明为整数类型，存储最近执行的 SQL 语句的状态代码。状态决定了 SQL 语句的结果，其结果可以有以下几种方式:

| 结果 | 描述 |
| **0** | 该语句已成功执行，没有错误。 |
| **> 0** | 执行语句时出现一些错误。例如，当我们在 Where 子句中使用 SELECT 命令时，在 Where 子句条件中没有找到这样的行。 |
| **< 0** | 在这种情况下，由于数据库、系统、应用程序或网络错误，语句不会被执行。 |

*   **sqlerrm:** 定义为 sqlca 内部的结构。

**该字段包含两个部分:**

**sqlerrml:** 声明为整数类型，保存存储在 sqlerrmc 中的文本消息的长度。

**sqlerrmc:** 它被声明为一个字符串，保存与存储在 sqlcode 中的错误代码相关的文本消息。

*   **sqlerrp:** 声明为字符串，但保留供将来使用。
*   **sqlerrd:** 声明为包含六个元素的整数数组。

| 菲尔茨 | 描述 |
| **sqlerrp[0]** | 它是为将来使用而保留的。 |
| **sqlerrp[1]** | 它是为将来使用而保留的。 |
| **sqlerrp[2]** | 它包含由 SQL 语句处理的行数。 |
| **sqlerrp[3]** | 它是为将来使用而保留的。 |
| **sqlerrp[4]** | 它包含最近执行的语句中错误开始的字符位置。 |
| **sqlerrp[5]** | 它是为将来使用而保留的。 |

*   **sqlwarn:** 它被声明为具有八个元素的字符数组。这些元素在 sqlca 中用作警告标志。如果设置了标志，则 Oracle 会为元素分配“W”。

| 菲尔茨 | 描述 |
| **sqlwarn[0]** | 只有当另一个标志的值被设置时，它才被设置。 |
| **sqlwarn[1]** | 当 Oracle 为输出主机变量分配截断值时，会设置该值。 |
| **sqlwarn[2]** | 在计算最大值、最小值、AVG 值或总和等 SQL 聚合时，如果不考虑空列值，则会设置该值。 |
| **sqlwarn[3]** | 当使用 SELECT 语句检索的列数不等于 INTO 子句中指定的主机变量数时，将设置该值。 |

*   **sqlext:** 声明为字符串，保留以备将来使用。

#### 无论何时声明

where 语句用于错误处理。它执行隐式错误检查和处理。where 语句的语法如下:

```

EXEC SQL WHENEVER <condition> <action>;

```

当执行无论何时语句时，Oracle 将自动为无论何时语句中提到的条件检查 SQLCA。如果在 sqlca 中发现这样的情况，那么将执行在 why 语句中给出的操作。

条件可以是未找到、错误、警告，动作可以是继续、转到标签、停止、执行例行程序。

条件可以是以下类型:

*   **SQLWARNING:** 如果 oracle 返回警告，那么 sqlwarn[0]将被设置。
*   **SQLERROR:** 如果 oracle 返回错误，那么 sqlcode 的值将为负。
*   **未找到:**如果 Oracle 无法根据 SELECT 语句的 WHERE 子句中提到的条件找到该行，那么 sqlcode 的值将为正数。

如果 Oracle 发现任何上述情况，则可以采取以下操作:

*   **CONTINUE:** 如果可能，程序将继续执行下一条语句。
*   **DO:** 在此动作中，控制将转移到程序中的错误处理功能。当控制到达错误处理函数的末尾时，控制将转移到失败的 SQL 语句之后的语句。
*   **DO BREAK:** 这个 BREAK 语句主要用在我们的程序中，可以作为循环中的一个动作。当无论何时语句中存在的条件得到满足时，我们的程序就退出循环。
*   **DO CONTINUE:** 这个 CONTINUE 语句主要用在我们的程序中，可以作为循环中的动作。当 When 语句中的条件满足时，我们的程序继续循环中的下一次迭代。
*   **GOTO:** 程序控制转移到标记的语句。
*   **STOP:** 我们的程序停止运行。当满足“无论何时”条件时，调用 exit()函数停止程序的执行。

* * *

## 创建程序的步骤

**以下是创建和运行程序所需的步骤:**

*   首先，我们需要安装 Oracle 数据库，和微软的 Visual C++。在 Visual C++ 中，我们将创建包含嵌入式 SQL 语句的 C 程序。这个程序将连接到一个 oracle 数据库。
*   oracle 数据库包含内置的 PROC 组件。要检查 proc 是否已成功安装，请打开 **cmd** 并键入“PROC”命令。

![Pro*C Tutorial](img/1ef4361f7ea0bbbae8d375c4e915301f.png)

在命令提示符下输入 **proc** 命令后，我们按回车键:

![Pro*C Tutorial](img/86a39f6b200bc14eb32f831e851d0352.png)

上面的屏幕显示 proc 已经成功安装。

*   现在，我们将用 Visual C++ 创建一个 C 程序。打开 Visual C++。当我们打开 Visual C++ 时，将出现如下所示的图像:

![Pro*C Tutorial](img/be0ac274458d85da0b748612a533f00c.png)

*   点击出现在顶部菜单的文件。将鼠标移到新建上，然后单击项目。
    ![Pro*C Tutorial](img/6025378acda49655b18e1e610b49ab6d.png)
*   当我们点击项目时，屏幕显示如下:

![Pro*C Tutorial](img/bac9e1f7fef11a434593d406aa3dccdb.png)

在上面的屏幕中，单击出现在左侧 Visual C++ 类别下的常规，然后单击空项目。现在，我们需要为这个空项目提供名称。

![Pro*C Tutorial](img/7eb364201c4c1d9068236bbf70994ce5.png)

在上面的屏幕中，我们可以观察到我们已经将我们的项目命名为 Demo。

*   在为我们的项目提供名称后，我们单击“确定”按钮。
    ![Pro*C Tutorial](img/6aee60ae4d4d0223a08c13764e266854.png)

在上面的屏幕中，我们可以看到我们项目的工作空间已经创建。在最左侧，我们可以看到项目的层次结构，它包含外部依赖项、头文件、资源文件和源文件。

*   现在，我们必须添加甲骨文的库文件，所以右键单击头文件，然后将鼠标光标放在添加上，然后单击现有项目。

![Pro*C Tutorial](img/c87b0667f7341d9ad92dc63474c22985.png)

*   移动到包含 precomp 作为子目录的 oracle 文件夹。点击预计算。

![Pro*C Tutorial](img/3beaadf160785a76bbeccfe1bcc7b7b2.png)

当我们单击预计算文件夹时，将出现如下所示的屏幕:

![Pro*C Tutorial](img/bd60f1a54e7c85d2963bb8b74936dfa1.png)

点击 lib 文件夹，如上图所示。

现在添加两个对象库文件，即 orasql19，另一个是 orasqx19，它位于 msvc 文件夹中。

![Pro*C Tutorial](img/ce6532ef1b1a833d9ad60b126bd3e3d4.png)
![Pro*C Tutorial](img/25d3f7f2228af8b63ba3d15c0c648679.png)

当我们添加以上两个库文件时，我们的解决方案资源管理器窗口看起来像:

![Pro*C Tutorial](img/437d3758735164562959b0168e8a0e99.png)

在上面的屏幕中，突出显示的区域显示两个库文件都已成功添加到我们的项目中。

*   现在，我们在项目中添加源代码。为此，右键单击源文件，将鼠标光标保持在添加上，然后单击**新项目**。
    T3】
*   单击“新建”项目后，屏幕显示如下:

![Pro*C Tutorial](img/28ecc83b25b71213cfca2a91f0816ef6.png)

在上面的屏幕中，单击出现在最左侧的代码，然后单击 C++ 文件。我们还首先提供了扩展名为. pc 的文件名。

*   向源文件提供名称后，我们单击添加按钮。

![Pro*C Tutorial](img/d763a2657fb26fc81c575330a85db6cc.png)

在上面的屏幕中，我们可以观察到已经为我们添加的文件创建了工作空间。

*   以下是 **pc** 文件的代码:

```

exec sql begin declare section;
char user_name[20],password[20];
exec sql end declare section;
exec sql include sqlca;
#include<stdio.h>
#include<conio.h>
#include<stdlib.h>
void main()
{
printf("Enter the user name");
scanf("%s",user_name);
printf("Enter the password");
scanf("%s",password);
exec sql connect :user_name identified by :password;
if(sqlca.sqlcode==0)
printf("Success");
else
printf("Error code:%d\n Error message:%s",sqlca.sqlcode,sqlca.sqlerrm.sqlerrmc);
getch();
}

```

*   打开 cmd，移动到那个文件夹，即 **E:\Demo\Demo** 存放 first.pc 文件的地方。

![Pro*C Tutorial](img/eed82c06d1c3c5f1b4fc8e0fdb4ef209.png)

*   现在，我们使用 proc 编译器预编译 first.pc 程序，如下图所示:

![Pro*C Tutorial](img/8897cd2ccd74abdbc0322a01aaf67fa6.png)
![Pro*C Tutorial](img/7a294fb8ab396e1c85eaaf7402d3d9b2.png)

在上面的屏幕中，我们可以观察到 first.c 是在 Oracle 预编译器编译 first.pc 之后创建的。

*   现在，我们在 Visual C++ 中添加第一个. C 文件。要添加此文件，请右键单击源文件，然后将鼠标光标保持在“添加”上，然后单击“现有”项目。下面的屏幕显示在 Visual C++ 中添加了 first.c 文件。

![Pro*C Tutorial](img/30c232bd001e87fc59f4dca481565717.png)

*   在编译 first.pc 之后，first.c 的代码将是:

```

/* Result Sets Interface */
#ifndef SQL_CRSR
# define SQL_CRSR
struct sql_cursor
{
unsigned int curocn;
void *ptr1;
void *ptr2;
unsigned int magic;
};
typedef struct sql_cursor sql_cursor;
typedef struct sql_cursor SQL_CURSOR;
#endif /* SQL_CRSR */

/* Thread Safety */
typedef void * sql_context;
typedef void * SQL_CONTEXT;

/* Object support */
struct sqltvn
{
unsigned char *tvnvsn; 
unsigned short tvnvsnl; 
unsigned char *tvnnm;
unsigned short tvnnml; 
unsigned char *tvnsnm;
unsigned short tvnsnml;
};
typedef struct sqltvn sqltvn;

struct sqladts
{
unsigned int adtvsn; 
unsigned short adtmode; 
unsigned short adtnum; 
sqltvn adttvn[1]; 
};
typedef struct sqladts sqladts;

static struct sqladts sqladt = {
1,1,0,
};

/* Binding to PL/SQL Records */
struct sqltdss
{
unsigned int tdsvsn; 
unsigned short tdsnum; 
unsigned char *tdsval[1]; 
};
typedef struct sqltdss sqltdss;
static struct sqltdss sqltds =
{
1,
0,
};

/* File name & Package Name */
struct sqlcxp
{
unsigned short fillen;
char filnam[9];
};
static const struct sqlcxp sqlfpn =
{
8,
"first.pc"
};

static unsigned int sqlctx = 18667;

static struct sqlexd {
unsigned int sqlvsn;
unsigned int arrsiz;
unsigned int iters;
unsigned int offset;
unsigned short selerr;
unsigned short sqlety;
unsigned int occurs;
const short *cud;
unsigned char *sqlest;
const char *stmt;
sqladts *sqladtp;
sqltdss *sqltdsp;
void **sqphsv;
unsigned int *sqphsl;
int *sqphss;
void **sqpind;
int *sqpins;
unsigned int *sqparm;
unsigned int **sqparc;
unsigned short *sqpadto;
unsigned short *sqptdso;
unsigned int sqlcmax;
unsigned int sqlcmin;
unsigned int sqlcincr;
unsigned int sqlctimeout;
unsigned int sqlcnowait;
int sqfoff;
unsigned int sqcmod;
unsigned int sqfmod;
void *sqhstv[4];
unsigned int sqhstl[4];
int sqhsts[4];
void *sqindv[4];
int sqinds[4];
unsigned int sqharm[4];
unsigned int *sqharc[4];
unsigned short sqadto[4];
unsigned short sqtdso[4];
} sqlstm = {12,4};

/* SQLLIB Prototypes */
extern void sqlcxt (void **, unsigned int *,
struct sqlexd *, const struct sqlcxp *);
extern void sqlcx2t(void **, unsigned int *,
struct sqlexd *, const struct sqlcxp *);
extern void sqlbuft(void **, char *);
extern void sqlgs2t(void **, char *);
extern void sqlorat(void **, unsigned int *, void *);

/* Forms Interface */
static const int IAPSUCC = 0;
static const int IAPFAIL = 1403;
static const int IAPFTL = 535;
extern void sqliem(unsigned char *, signed int *);

typedef struct { unsigned short len; unsigned char arr[1]; } VARCHAR;
typedef struct { unsigned short len; unsigned char arr[1]; } varchar;

/* cud (compilation unit data) array */
static const short sqlcud0[] =
{12,4130,178,0,0,
5,0,0,0,0,0,27,14,0,0,4,4,0,1,0,1,97,0,0,1,97,0,0,1,10,0,0,1,10,0,0,
};

/* exec sql begin declare section; */ 

char user_name[20],password[20];
/* exec sql end declare section; */ 

/* exec sql include sqlca;
*/ 
#ifndef SQLCA
#define SQLCA 1
struct sqlca
{
/* ub1 */ char sqlcaid[8];
/* b4 */ int sqlabc;
/* b4 */ int sqlcode;
struct
{
/* ub2 */ unsigned short sqlerrml;
/* ub1 */ char 
sqlerrmc[70];
} sqlerrm;
/* ub1 */ char sqlerrp[8];
/* b4 */ int 
sqlerrd[6];
/* ub1 */ char sqlwarn[8];
/* ub1 */ char sqlext[8];
};

#ifndef SQLCA_NONE 
#ifdef 
SQLCA_STORAGE_CLASS
SQLCA_STORAGE_CLASS struct sqlca sqlca
#else
struct sqlca sqlca
#endif
#ifdef SQLCA_INIT
= {
{'S', 'Q', 'L', 'C', 'A', ' ', ' ', ' '},
sizeof(struct sqlca),
0,
{ 0, {0}},
{'N', 'O', 'T', ' ', 'S', 'E', 'T', ' '},
{0, 0, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0}
}
#endif
;
#endif
#endif
/* end SQLCA */

#include<stdio.h>
#include<conio.h>
#include<stdlib.h>
void main()
{
printf("Enter the user name");
scanf("%s",user_name);
printf("Enter the password");
scanf("%s",password);
/* exec sql connect :user_name identified by :password; */ 

{
struct sqlexd sqlstm;
sqlstm.sqlvsn = 12;
sqlstm.arrsiz = 4;
sqlstm.sqladtp = &sqladt;
sqlstm.sqltdsp = &sqltds;
sqlstm.iters = (unsigned int )10;
sqlstm.offset = (unsigned int )5;
sqlstm.cud = sqlcud0;
sqlstm.sqlest = (unsigned char *)&sqlca;
sqlstm.sqlety = (unsigned short)4352;
sqlstm.occurs = (unsigned int )0;
sqlstm.sqhstv[0] = ( void *)user_name;
sqlstm.sqhstl[0] = (unsigned int )20;
sqlstm.sqhsts[0] = ( int )20;
sqlstm.sqindv[0] = ( void *)0;
sqlstm.sqinds[0] = ( int )0;
sqlstm.sqharm[0] = (unsigned int )0;
sqlstm.sqadto[0] = (unsigned short )0;
sqlstm.sqtdso[0] = (unsigned short )0;
sqlstm.sqhstv[1] = ( void *)password;
sqlstm.sqhstl[1] = (unsigned int )20;
sqlstm.sqhsts[1] = ( int )20;
sqlstm.sqindv[1] = ( void *)0;
sqlstm.sqinds[1] = ( int )0;
sqlstm.sqharm[1] = (unsigned int )0;
sqlstm.sqadto[1] = (unsigned short )0;
sqlstm.sqtdso[1] = (unsigned short )0;
sqlstm.sqphsv = sqlstm.sqhstv;
sqlstm.sqphsl = sqlstm.sqhstl;
sqlstm.sqphss = sqlstm.sqhsts;
sqlstm.sqpind = sqlstm.sqindv;
sqlstm.sqpins = sqlstm.sqinds;
sqlstm.sqparm = sqlstm.sqharm;
sqlstm.sqparc = sqlstm.sqharc;
sqlstm.sqpadto = sqlstm.sqadto;
sqlstm.sqptdso = sqlstm.sqtdso;
sqlstm.sqlcmax = (unsigned int )100;
sqlstm.sqlcmin = (unsigned int )2;
sqlstm.sqlcincr = (unsigned int )1;
sqlstm.sqlctimeout = (unsigned int )0;
sqlstm.sqlcnowait = (unsigned int )0;
sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}

if(sqlca.sqlcode==0)
printf("Success");
else
printf("Error code:%d\n Error message:%s",sqlca.sqlcode,sqlca.sqlerrm.sqlerrmc);
getch();
}

```

**运行**

我们可以通过简单地点击出现在顶部菜单的**调试**，然后点击**开始调试**来运行我们的程序。

![Pro*C Tutorial](img/0637bd1e0a1f6819739f0fc20892c3c4.png)

* * *