# Verilog 教程

> 原文：<https://www.javatpoint.com/verilog>

Verilog 是一种硬件描述语言。它是一种用于描述数字系统的语言，如网络交换机、微处理器、存储器或触发器。我们可以在任何层面上用 HDL 来描述任何数字硬件。HDL 中描述的设计独立于技术，非常易于设计和调试，通常比原理图更有用，尤其是对于大型电路。

### 什么是 Verilog？

Verilog 是一种硬件描述语言(HDL)，用于描述数字系统，如网络交换机或微处理器或存储器或触发器。

![Verilog Tutorial](img/b8e8bc925228897d4ea4243a3cbe2ab7.png)

**Verilog** 的开发是为了简化流程，让 HDL 更加健壮灵活。如今，Verilog 是整个半导体行业使用和实践的最流行的高密度脂蛋白。

开发 HDL 是为了通过允许工程师描述所需硬件的功能，并让自动化工具将该行为转换为实际的[硬件](https://www.javatpoint.com/hardware)元素，如组合门和时序逻辑，来增强设计过程。

Verilog 就像任何其他硬件描述语言一样。它允许设计者以自下而上或自上而下的方法设计设计。

*   **自下而上设计:**电子设计的传统方法是自下而上。每个设计都是在门级使用标准门进行的。这种设计提供了一种设计新的结构和层次设计方法的方法。
*   **自上而下的设计:**它允许早期测试、不同技术的轻松更改以及结构化的系统设计，并提供了许多其他好处。

### Verilog抽象级别

Verilog 支持多种抽象级别的设计，例如:

*   行为水平
*   寄存器传输级别
*   门级

### 行为水平

行为层通过并发算法来描述系统行为。每个算法都是顺序的，这意味着它由一组一个接一个执行的指令组成。功能、任务和块是主要元素。不考虑设计的结构实现。

### 寄存器-传输级别

使用寄存器传输级的设计通过操作和寄存器之间的数据传输来指定电路的特性。

RTL 代码的现代定义是“任何可合成的代码都称为 RTL 代码”。

### 门级

系统的特性由逻辑链路及其在逻辑层的时序属性来描述。所有信号都是离散信号。它们只能有确定的逻辑值(` 0 '、` 1 '、` x '、` z ')。

可用的操作是预定义的逻辑原语(基本门)。门级建模可能不是逻辑设计的正确想法。门级代码使用合成工具等工具生成，他的网表用于门级模拟和后端。

### Verilog 的历史

*   Verilog HDL 的历史可以追溯到 20 世纪 80 年代，当时一家名为 Gateway Design Automation 的公司开发了一种逻辑模拟器 Verilog-XL 和一种硬件描述语言。
*   Cadence Design Systems 于 1989 年收购了 Gateway，并由此获得了该语言和模拟器的权利。1990 年，Cadence 将该语言纳入公共领域，意图使其成为一种标准的非专有语言。
*   Verilog HDL 现在由一个非盈利制作组织 Accellera 维护，该组织由开放 Verilog 国际(OVI)和 VHDL 国际合并而成。OVI 的任务是让这种语言通过 IEEE 标准化程序。
*   1995 年 12 月，Verilog HDL 成为 IEEE 标准。1364-1995.2001 年出版了一个显著修订的版本:IEEE 标准。1364-2001.2005 年进行了进一步修订，但这只是增加了一些小的改动。
*   Accellera 还开发了一个新的标准，SystemVerilog，它扩展了 Verilog。
*   SystemVerilog 于 2005 年成为 IEEE 标准(1800-2005)。

### Verilog 有什么用？

Verilog 创建了一个抽象层次，有助于隐藏其实现和技术的细节。

例如，D 触发器的设计需要了解如何安排晶体管以实现正边沿触发的 FF，以及将值锁存到触发器上所需的上升、下降和 CLK Q 时间等许多面向技术的细节。

功耗、时序以及驱动网络和其他触发器的能力也需要对晶体管的物理特性有更透彻的了解。

Verilog 帮助我们将注意力集中在行为上，剩下的事情留待以后解决。

## 先决条件

在学习 Verilog 之前，你应该对 VLSI 设计语言有一个基本的了解。

*   你应该知道逻辑图是如何工作的，布尔代数，逻辑门，组合和时序电路，运算符等。
*   您应该了解静态时序分析概念，如建立时间、保持时间、关键路径、时钟频率限制等。
*   专用集成电路和现场可编程门阵列基础以及合成和仿真概念。

## 观众

我们的 Verilog 教程旨在帮助初学者、设计工程师和验证工程师，他们愿意学习如何在 Verilog HDL 中建模数字系统，以实现自动合成。到本教程结束时，您将获得 Verilog 的中级专业知识。

## 问题

我们向您保证，您不会发现 Verilog 教程有任何问题。但如有错误，请将问题贴在联系单上。

* * *